USE master
GO

IF EXISTS(SELECT * FROM sys.databases where [name] = 'JProCo' AND is_cdc_enabled = 1)
BEGIN
  EXEC JProco.sys.sp_cdc_Disable_db
END

go

if exists (select * from sys.sysdatabases where name = 'JProCo')
begin
  alter database JProCo set single_user with rollback immediate
  drop database JProCo
end
go

create database JProCo
go


USE [master]
GO
ALTER DATABASE [JProCo] MODIFY FILE ( NAME = N'JProCo', SIZE = 152400KB )
GO
ALTER DATABASE [JProCo] MODIFY FILE ( NAME = N'JProCo_log', SIZE = 45600KB )
GO

use JProCo
go

SET NOCOUNT ON;

CREATE TABLE PayRates
(EmpID int PRIMARY KEY,
YearlySalary smallMoney NULL,
MonthlySalary smallMoney NULL,
HourlyRate SmallMoney NULL)
GO

INSERT INTO PayRates VALUES (1,75000,null,null)
INSERT INTO PayRates VALUES (2,78000,null,null)
INSERT INTO PayRates VALUES (3,null,null,45)
INSERT INTO PayRates VALUES (4,null,6500,null)
INSERT INTO PayRates VALUES (5,null,5800,null)
INSERT INTO PayRates VALUES (6,52000,null,null)
INSERT INTO PayRates VALUES (7,null,6100,null)
INSERT INTO PayRates VALUES (8,null,null,32)
INSERT INTO PayRates VALUES (9,null,null,18)
INSERT INTO PayRates VALUES (10,Null,null,17)
INSERT INTO PayRates VALUES (11,115000,null,null)
INSERT INTO PayRates VALUES (12,null,null,21)
INSERT INTO PayRates VALUES (13,72000,null,null)

CREATE TABLE MgmtTraining
(
ClassID int PRIMARY KEY IDENTITY(1,1),
ClassName varchar(50) NOT NULL,
ClassDurationHours int NULL,
ApprovedDate Datetime null
)
GO

INSERT INTO MgmtTraining VALUES('Embracing Diversity',12, NULL)
INSERT INTO MgmtTraining VALUES('Interviewing',6,NULL)
INSERT INTO MgmtTraining VALUES('Difficult Negotiations',30,NULL)
GO

CREATE TABLE CurrentProducts
(
ProductID INT PRIMARY KEY IDENTITY(1,1),
ProductName nvarchar(max) NOT NULL,
RetailPrice MONEY NULL,
OriginationDate DateTime NULL,
ToBeDeleted bit Null)
GO
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Day West Coast',61.483,38938.5646985891,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Days West Coast',110.6694,39356.988458488,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 3 Days West Coast',184.449,39940.6721053332,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 5 Days West Coast',245.932,38778.2077153155,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Week West Coast',307.415,37088.8056875052,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Weeks West Coast',553.347,39627.8615597411,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Day East Coast',80.859,39177.3511948613,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Days East Coast',145.5462,38512.4112605625,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 3 Days East Coast',242.577,37710.2077066043,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 5 Days East Coast',323.436,38453.1906832043,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Week East Coast',404.295,38237.5524674277,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Weeks East Coast',727.731,39775.8331876042,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Day Mexico',105.059,37316.0710966305,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Days Mexico',189.1062,39498.9878692529,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 3 Days Mexico',315.177,38176.2430949518,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 5 Days Mexico',420.236,38240.3767755875,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Week Mexico',525.295,39903.8725296664,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Weeks Mexico',945.531,37339.5951645408,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Day Canada',85.585,38093.675084451,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Days Canada',154.053,39018.4242087035,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 3 Days Canada',256.755,38637.879998218,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 5 Days Canada',342.34,37117.2442517722,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Week Canada',427.925,38054.3068714327,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Weeks Canada',770.265,39433.852135422,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Day Scandinavia',116.118,39483.8537014876,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Days Scandinavia',209.0124,38496.4173770375,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 3 Days Scandinavia',348.354,38877.023904561,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 5 Days Scandinavia',464.472,39391.076613303,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 1 Week Scandinavia',580.59,38052.0438109738,0)
INSERT INTO dbo.CurrentProducts VALUES ('Underwater Tour 2 Weeks Scandinavia',1045.062,39899.5905334781,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Day West Coast',74.622,38536.6577839802,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Days West Coast',134.3196,39908.6100706344,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 3 Days West Coast',223.866,37843.0664539112,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 5 Days West Coast',298.488,37821.9679534215,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Week West Coast',373.11,37657.9522699812,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Weeks West Coast',671.598,37601.3823349779,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Day East Coast',107.159,37275.7359646449,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Days East Coast',192.8862,38536.2606421485,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 3 Days East Coast',321.477,38459.0360928693,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 5 Days East Coast',428.636,38129.307884931,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Week East Coast',535.795,40033.3878335664,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Weeks East Coast',964.431,39313.9725564362,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Day Mexico',71.142,37811.7129253815,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Days Mexico',128.0556,39183.6346355892,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 3 Days Mexico',213.426,38924.2769522567,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 5 Days Mexico',284.568,39298.7113757213,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Week Mexico',355.71,38957.0651958543,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Weeks Mexico',640.278,39462.0684195455,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Day Canada',113.287,39180.8168341431,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Days Canada',203.9166,38879.074454327,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 3 Days Canada',339.861,37685.0799336758,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 5 Days Canada',453.148,38758.4005149295,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Week Canada',566.435,39137.1733311248,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Weeks Canada',1019.583,37266.8967811644,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Day Scandinavia',111.735,37795.7316542821,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Days Scandinavia',201.123,38037.3179699925,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 3 Days Scandinavia',335.205,39238.6665718835,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 5 Days Scandinavia',446.94,38703.4397942087,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 1 Week Scandinavia',558.675,37571.2057501235,0)
INSERT INTO dbo.CurrentProducts VALUES ('History Tour 2 Weeks Scandinavia',1005.615,37321.8653259859,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Day West Coast',122.441,38183.7201059893,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Days West Coast',220.3938,39038.5808624833,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 3 Days West Coast',367.323,39852.4745643548,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 5 Days West Coast',489.764,39023.6564045141,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Week West Coast',612.205,37960.954554801,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Weeks West Coast',1101.969,38935.3250468,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Day East Coast',61.86,38051.8189952563,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Days East Coast',111.348,39710.8799736661,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 3 Days East Coast',185.58,39860.3050847484,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 5 Days East Coast',247.44,38356.3223683349,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Week East Coast',309.3,39343.4713408586,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Weeks East Coast',556.74,38688.8949543991,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Day Mexico',32.601,39177.2507165277,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Days Mexico',58.6818,38734.1321506432,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 3 Days Mexico',97.803,39878.3911684783,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 5 Days Mexico',130.404,37651.90411053,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Week Mexico',163.005,40069.9657832473,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Weeks Mexico',293.409,37337.4502284874,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Day Canada',62.544,38733.6079265914,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Days Canada',112.5792,38730.4444423955,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 3 Days Canada',187.632,38949.1223512803,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 5 Days Canada',250.176,38981.1774902795,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Week Canada',312.72,39788.2929574115,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Weeks Canada',562.896,39397.5812249504,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Day Scandinavia',107.175,37775.6187499454,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Days Scandinavia',192.915,37500.5485168183,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 3 Days Scandinavia',321.525,37879.0522472816,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 5 Days Scandinavia',428.7,40021.1379357811,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 1 Week Scandinavia',535.875,37566.5201696178,0)
INSERT INTO dbo.CurrentProducts VALUES ('Ocean Cruise Tour 2 Weeks Scandinavia',964.575,38534.809239181,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Day West Coast',85.933,38787.2579950323,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Days West Coast',154.6794,38267.0588560672,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 3 Days West Coast',257.799,39086.819014585,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 5 Days West Coast',343.732,37362.3953086562,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Week West Coast',429.665,40073.8722688064,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Weeks West Coast',773.397,37094.4313894593,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Day East Coast',69.992,37312.4384572618,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Days East Coast',125.9856,38589.0535116781,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 3 Days East Coast',209.976,39177.6920423815,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 5 Days East Coast',279.968,39972.5183074982,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Week East Coast',349.96,37666.7992296851,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Weeks East Coast',629.928,38840.6337311778,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Day Mexico',79.597,39366.9233556736,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Days Mexico',143.2746,39210.3484879195,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 3 Days Mexico',238.791,39272.7094335333,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 5 Days Mexico',318.388,38332.8699127606,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Week Mexico',397.985,38203.8170697493,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Weeks Mexico',716.373,38210.2550780113,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Day Canada',47.793,38838.2107985091,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Days Canada',86.0274,38910.5510944471,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 3 Days Canada',143.379,40003.8239810228,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 5 Days Canada',191.172,38952.1410394223,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Week Canada',238.965,39732.0257603557,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Weeks Canada',430.137,37568.7828882842,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Day Scandinavia',109.382,39863.5332310877,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Days Scandinavia',196.8876,37924.307520065,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 3 Days Scandinavia',328.146,38864.1960656966,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 5 Days Scandinavia',437.528,39710.4716969311,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 1 Week Scandinavia',546.91,39289.5037618314,0)
INSERT INTO dbo.CurrentProducts VALUES ('Fruit Tasting Tour 2 Weeks Scandinavia',984.438,39122.6254457712,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Day West Coast',89.501,37744.1486228508,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Days West Coast',161.1018,37135.6300594289,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 3 Days West Coast',268.503,37376.1867728991,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 5 Days West Coast',358.004,38281.7243853953,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Week West Coast',447.505,39752.3688003156,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Weeks West Coast',805.509,39554.6088926774,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Day East Coast',52.681,39671.4784243299,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Days East Coast',94.8258,38961.6241522531,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 3 Days East Coast',158.043,39215.8383591909,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 5 Days East Coast',210.724,39428.2711428262,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Week East Coast',263.405,38000.7189785108,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Weeks East Coast',474.129,38707.4772789601,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Day Mexico',87.436,39966.5531140111,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Days Mexico',157.3848,39186.9379515532,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 3 Days Mexico',262.308,39776.9529120641,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 5 Days Mexico',349.744,37827.5704072264,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Week Mexico',437.18,37864.6186420288,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Weeks Mexico',786.924,38292.8687348044,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Day Canada',73.698,38302.2206435708,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Days Canada',132.6564,39547.6785464789,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 3 Days Canada',221.094,39940.8213650633,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 5 Days Canada',294.792,39640.8763172209,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Week Canada',368.49,39416.2398842794,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Weeks Canada',663.282,37764.5773057776,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Day Scandinavia',32.574,39910.2470534372,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Days Scandinavia',58.6332,37631.9260935416,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 3 Days Scandinavia',97.722,38953.7376064852,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 5 Days Scandinavia',130.296,37970.5814023271,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 1 Week Scandinavia',162.87,39241.1417814266,0)
INSERT INTO dbo.CurrentProducts VALUES ('Mountain Lodge 2 Weeks Scandinavia',293.166,37277.1534790265,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Day West Coast',80.311,39539.6445896785,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Days West Coast',144.5598,38230.5301288512,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 3 Days West Coast',240.933,40053.5975167824,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 5 Days West Coast',321.244,39625.3575887326,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Week West Coast',401.555,37867.6491966216,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Weeks West Coast',722.799,39467.9977682216,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Day East Coast',86.484,38110.5438675191,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Days East Coast',155.6712,37542.3132047829,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 3 Days East Coast',259.452,37705.0039098792,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 5 Days East Coast',345.936,38423.3904094082,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Week East Coast',432.42,39208.9394759492,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Weeks East Coast',778.356,39152.702090343,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Day Mexico',98.592,39784.7390401797,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Days Mexico',177.4656,39548.0496229064,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 3 Days Mexico',295.776,39057.1151337681,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 5 Days Mexico',394.368,37957.4266295324,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Week Mexico',492.96,38383.9513193707,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Weeks Mexico',887.328,37732.5499649975,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Day Canada',93.377,40028.0150331161,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Days Canada',168.0786,39018.4491735898,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 3 Days Canada',280.131,39590.5634195641,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 5 Days Canada',373.508,40038.471194825,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Week Canada',466.885,38805.3137987867,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Weeks Canada',840.393,37670.1412211842,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Day Scandinavia',97.766,39100.016257,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Days Scandinavia',175.9788,40038.1644300365,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 3 Days Scandinavia',293.298,40015.7566315276,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 5 Days Scandinavia',391.064,38961.3211196043,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 1 Week Scandinavia',488.83,39134.3702543418,0)
INSERT INTO dbo.CurrentProducts VALUES ('Spa & Pleasure Getaway 2 Weeks Scandinavia',879.894,39078.6532827256,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Day West Coast',74.451,38556.0511002497,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Days West Coast',134.0118,38532.136960191,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 3 Days West Coast',223.353,39845.9396591064,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 5 Days West Coast',297.804,39083.546326845,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Week West Coast',372.255,37740.9762031719,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Weeks West Coast',670.059,37603.9645562123,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Day East Coast',41.979,38774.155977381,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Days East Coast',75.5622,37801.4925235734,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 3 Days East Coast',125.937,37154.4757301926,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 5 Days East Coast',167.916,39997.0822181988,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Week East Coast',209.895,37280.6776105354,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Weeks East Coast',377.811,39635.8307957767,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Day Mexico',98.331,37485.8588675928,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Days Mexico',176.9958,37828.8038725909,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 3 Days Mexico',294.993,39250.2941996541,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 5 Days Mexico',393.324,37126.7014153854,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Week Mexico',491.655,39963.6662095651,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Weeks Mexico',884.979,39420.8373384674,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Day Canada',45.795,39133.7271776902,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Days Canada',82.431,37832.8028451852,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 3 Days Canada',137.385,38932.4623176296,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 5 Days Canada',183.18,39656.6936201949,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Week Canada',228.975,38525.3127781851,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Weeks Canada',412.155,39977.8503750038,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Day Scandinavia',113.714,39994.2353211326,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Days Scandinavia',204.6852,39106.7984060653,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 3 Days Scandinavia',341.142,37409.4715274264,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 5 Days Scandinavia',454.856,37397.5483929613,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 1 Week Scandinavia',568.57,37586.5944969283,0)
INSERT INTO dbo.CurrentProducts VALUES ('Horseback Tour 2 Weeks Scandinavia',1023.426,38171.3562460292,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Day West Coast',50.041,38665.7944095907,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Days West Coast',90.0738,37630.662588767,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 3 Days West Coast',150.123,38743.8561054508,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 5 Days West Coast',200.164,38569.9944311471,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Week West Coast',250.205,39919.6465494652,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Weeks West Coast',450.369,39306.5902617159,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Day East Coast',86.747,38764.0322420001,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Days East Coast',156.1446,39185.7390501223,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 3 Days East Coast',260.241,38641.7488825278,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 5 Days East Coast',346.988,38772.6047127871,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Week East Coast',433.735,37718.3544552153,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Weeks East Coast',780.723,37474.4597581584,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Day Mexico',105.121,38434.7719406379,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Days Mexico',189.2178,38948.7313595436,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 3 Days Mexico',315.363,37859.6220581876,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 5 Days Mexico',420.484,38936.8130722673,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Week Mexico',525.605,38531.1485848024,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Weeks Mexico',946.089,37582.0832330975,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Day Canada',77.542,39040.1486145081,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Days Canada',139.5756,38158.0764677055,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 3 Days Canada',232.626,37396.8052611365,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 5 Days Canada',310.168,39743.3569105114,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Week Canada',387.71,39292.8441571621,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Weeks Canada',697.878,38489.8715875445,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Day Scandinavia',68.267,38885.1428910932,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Days Scandinavia',122.8806,37830.9486719757,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 3 Days Scandinavia',204.801,37557.1990569005,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 5 Days Scandinavia',273.068,38228.3819797289,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 1 Week Scandinavia',341.335,37360.1145008556,0)
INSERT INTO dbo.CurrentProducts VALUES ('Tiger Watching Tour 2 Weeks Scandinavia',614.403,38531.4466703237,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Day West Coast',45.342,39656.6474332081,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Days West Coast',81.6156,38895.1962985817,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 3 Days West Coast',136.026,39435.6771891336,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 5 Days West Coast',181.368,37280.1957909715,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Week West Coast',226.71,38468.9078442224,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Weeks West Coast',408.078,39224.3525227126,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Day East Coast',78.948,39786.882000643,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Days East Coast',142.1064,39909.0573895541,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 3 Days East Coast',236.844,38229.9911029681,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 5 Days East Coast',315.792,39209.7658292767,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Week East Coast',394.74,38013.1974484003,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Weeks East Coast',710.532,38700.2735869192,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Day Mexico',86.593,40072.1039751201,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Days Mexico',155.8674,39691.8589936503,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 3 Days Mexico',259.779,39889.4253551568,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 5 Days Mexico',346.372,39951.3102128472,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Week Mexico',432.965,38741.569244788,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Weeks Mexico',779.337,38167.235827615,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Day Canada',90.695,38157.9014558443,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Days Canada',163.251,39786.3292250139,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 3 Days Canada',272.085,37538.8818307287,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 5 Days Canada',362.78,37203.043147374,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Week Canada',453.475,38221.310285883,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Weeks Canada',816.255,37554.1441495897,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Day Scandinavia',34.506,39606.6721303414,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Days Scandinavia',62.1108,39547.838924132,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 3 Days Scandinavia',103.518,39847.4869823663,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 5 Days Scandinavia',138.024,37460.0237166914,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 1 Week Scandinavia',172.53,37802.9368717074,0)
INSERT INTO dbo.CurrentProducts VALUES ('Winter Tour 2 Weeks Scandinavia',310.554,37522.7986461728,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Day West Coast',111.366,37583.9712802758,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Days West Coast',200.4588,37137.8244145207,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 3 Days West Coast',334.098,37989.6671438015,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 5 Days West Coast',445.464,37650.8483501377,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Week West Coast',556.83,39781.2664787429,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Weeks West Coast',1002.294,38718.4080674201,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Day East Coast',52.67,39647.8721868812,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Days East Coast',94.806,39860.2779618258,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 3 Days East Coast',158.01,39793.899889636,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 5 Days East Coast',210.68,39695.8506850488,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Week East Coast',263.35,39085.1263368186,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Weeks East Coast',474.03,39228.4792363168,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Day Mexico',101.068,37690.2251970164,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Days Mexico',181.9224,39768.7440648667,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 3 Days Mexico',303.204,40005.2189959714,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 5 Days Mexico',404.272,38477.1381711309,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Week Mexico',505.34,39913.6302696751,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Weeks Mexico',909.612,38197.7632755546,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Day Canada',78.95,40052.0732592917,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Days Canada',142.11,37250.8931081998,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 3 Days Canada',236.85,39479.8542715733,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 5 Days Canada',315.8,37076.5009983985,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Week Canada',394.75,39357.4571477092,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Weeks Canada',710.55,39443.7406462206,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Day Scandinavia',66.897,38626.0192799691,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Days Scandinavia',120.4146,39142.2472994262,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 3 Days Scandinavia',200.691,38025.2371501039,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 5 Days Scandinavia',267.588,38908.1796946685,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 1 Week Scandinavia',334.485,37469.2847738863,0)
INSERT INTO dbo.CurrentProducts VALUES ('Acting Lessons Tour 2 Weeks Scandinavia',602.073,39978.1605817813,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Day West Coast',68.552,39951.665760659,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Days West Coast',123.3936,38955.081275012,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 3 Days West Coast',205.656,37196.4194858087,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 5 Days West Coast',274.208,37944.6635849826,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Week West Coast',342.76,38927.7614483123,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Weeks West Coast',616.968,37356.2213882187,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Day East Coast',108.552,40042.3966459903,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Days East Coast',195.3936,39310.4831025214,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 3 Days East Coast',325.656,38611.5898819862,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 5 Days East Coast',434.208,39121.3354216831,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Week East Coast',542.76,39670.5490313236,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Weeks East Coast',976.968,38789.9067306531,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Day Mexico',31.909,38181.3226233095,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Days Mexico',57.4362,38545.1558051282,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 3 Days Mexico',95.727,37459.1026057267,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 5 Days Mexico',127.636,39444.1110086949,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Week Mexico',159.545,38077.6028896905,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Weeks Mexico',287.181,38558.1510300578,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Day Canada',34.944,38994.1860862793,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Days Canada',62.8992,39306.6894817408,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 3 Days Canada',104.832,37100.7528648246,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 5 Days Canada',139.776,37964.1540797924,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Week Canada',174.72,39164.9770711097,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Weeks Canada',314.496,39193.5740822919,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Day Scandinavia',80.648,38594.2137419175,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Days Scandinavia',145.1664,37451.5886940492,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 3 Days Scandinavia',241.944,37423.163598442,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 5 Days Scandinavia',322.592,38238.6649483707,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 1 Week Scandinavia',403.24,39537.7393903769,0)
INSERT INTO dbo.CurrentProducts VALUES ('Cherry Festival Tour 2 Weeks Scandinavia',725.832,40062.5201378689,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Day West Coast',129.011,37935.2451138552,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Days West Coast',232.2198,37941.1088585795,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 3 Days West Coast',387.033,40024.4968381058,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 5 Days West Coast',516.044,39815.6641091276,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Week West Coast',645.055,39572.4699514138,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Weeks West Coast',1161.099,39813.761017456,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Day East Coast',127.554,39107.6427558377,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Days East Coast',229.5972,39678.5276303785,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 3 Days East Coast',382.662,38018.9422528185,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 5 Days East Coast',510.216,38524.220641511,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Week East Coast',637.77,39956.6611837714,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Weeks East Coast',1147.986,38689.5562833884,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Day Mexico',67.391,37682.2739666782,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Days Mexico',121.3038,37457.3622647415,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 3 Days Mexico',202.173,37110.4713419162,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 5 Days Mexico',269.564,37793.9079811227,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Week Mexico',336.955,37688.2227916864,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Weeks Mexico',606.519,39855.4758975481,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Day Canada',77.909,39431.0891118735,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Days Canada',140.2362,38761.5476662674,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 3 Days Canada',233.727,39545.3753814707,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 5 Days Canada',311.636,37107.4780802896,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Week Canada',389.545,38645.0253195637,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Weeks Canada',701.181,38370.5160960145,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Day Scandinavia',113.354,39465.960948266,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Days Scandinavia',204.0372,38663.6936297148,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 3 Days Scandinavia',340.062,39244.9900189166,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 5 Days Scandinavia',453.416,38890.1553691139,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 1 Week Scandinavia',566.77,37546.7123270793,0)
INSERT INTO dbo.CurrentProducts VALUES ('Lakes Tour 2 Weeks Scandinavia',1020.186,37294.0559140129,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Day West Coast',46.728,37780.0309118199,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Days West Coast',84.1104,37599.2747534866,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 3 Days West Coast',140.184,39708.1457957801,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 5 Days West Coast',186.912,38561.3750274918,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Week West Coast',233.64,39313.5880191351,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Weeks West Coast',420.552,37505.1467849873,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Day East Coast',127.197,38140.0876282796,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Days East Coast',228.9546,38527.0671212311,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 3 Days East Coast',381.591,39983.707613704,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 5 Days East Coast',508.788,37393.106808344,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Week East Coast',635.985,38482.1817491695,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Weeks East Coast',1144.773,38191.7026783081,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Day Mexico',51.058,37762.7538485892,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Days Mexico',91.9044,38312.3091055567,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 3 Days Mexico',153.174,38567.2302594105,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 5 Days Mexico',204.232,38404.2289388254,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Week Mexico',255.29,38956.8368020235,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Weeks Mexico',459.522,37138.2599417381,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Day Canada',92.982,40000.1924316229,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Days Canada',167.3676,39499.8597885427,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 3 Days Canada',278.946,38201.3155227173,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 5 Days Canada',371.928,39615.9858746373,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Week Canada',464.91,37342.9843066688,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Weeks Canada',836.838,38652.9563435308,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Day Scandinavia',93.812,39503.4061507898,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Days Scandinavia',168.8616,38117.229939474,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 3 Days Scandinavia',281.436,39594.7925821028,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 5 Days Scandinavia',375.248,39647.9035247136,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 1 Week Scandinavia',469.06,38719.6919930719,0)
INSERT INTO dbo.CurrentProducts VALUES ('Rain Forest Tour 2 Weeks Scandinavia',844.308,37204.5981655394,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Day West Coast',75.387,39828.1905132623,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Days West Coast',135.6966,39146.8212782558,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 3 Days West Coast',226.161,39712.4844002102,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 5 Days West Coast',301.548,37903.7961234193,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Week West Coast',376.935,38472.0289232607,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Weeks West Coast',678.483,39915.2684756034,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Day East Coast',124.012,39978.5042708372,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Days East Coast',223.2216,38289.5636554002,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 3 Days East Coast',372.036,37563.2447341988,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 5 Days East Coast',496.048,39801.2763501134,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Week East Coast',620.06,39825.4926689736,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Weeks East Coast',1116.108,39107.3948514973,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Day Mexico',41.837,37652.6319534484,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Days Mexico',75.3066,37969.6766439463,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 3 Days Mexico',125.511,39327.7894916309,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 5 Days Mexico',167.348,38579.0016039004,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Week Mexico',209.185,39822.2153620053,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Weeks Mexico',376.533,38048.4189377813,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Day Canada',108.762,39701.7310116844,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Days Canada',195.7716,37868.5410789019,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 3 Days Canada',326.286,39789.7049093695,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 5 Days Canada',435.048,39180.6451698346,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Week Canada',543.81,39057.5320774288,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Weeks Canada',978.858,37203.7650785947,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Day Scandinavia',36.042,37243.8547300148,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Days Scandinavia',64.8756,37563.9051251149,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 3 Days Scandinavia',108.126,39176.3721276658,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 5 Days Scandinavia',144.168,39974.809854147,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 1 Week Scandinavia',180.21,38099.0643392389,0)
INSERT INTO dbo.CurrentProducts VALUES ('River Rapids Tour 2 Weeks Scandinavia',324.378,38750.2426391363,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Day West Coast',35.308,38768.6720670346,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Days West Coast',63.5544,39565.0193832539,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 3 Days West Coast',105.924,37903.0886526045,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 5 Days West Coast',141.232,38487.5286816379,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Week West Coast',176.54,38060.0757217404,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Weeks West Coast',317.772,38551.3313263994,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Day East Coast',85.551,39224.8936928778,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Days East Coast',153.9918,39187.0051265412,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 3 Days East Coast',256.653,40039.8853346666,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 5 Days East Coast',342.204,38159.3929622938,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Week East Coast',427.755,37828.7077123686,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Weeks East Coast',769.959,37120.6707352996,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Day Mexico',72.792,37762.5073278733,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Days Mexico',131.0256,39179.7619718188,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 3 Days Mexico',218.376,39341.4269639062,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 5 Days Mexico',291.168,38435.4403025849,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Week Mexico',363.96,38048.0496204576,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Weeks Mexico',655.128,37465.9460871125,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Day Canada',48.351,39731.8099294616,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Days Canada',87.0318,38487.7284865386,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 3 Days Canada',145.053,37196.0266056157,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 5 Days Canada',193.404,37671.7498961104,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Week Canada',241.755,38725.0022961075,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Weeks Canada',435.159,37250.0007437607,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Day Scandinavia',42.001,38663.6779050741,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Days Scandinavia',75.6018,38164.3175356193,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 3 Days Scandinavia',126.003,38333.5712492646,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 5 Days Scandinavia',168.004,37693.2247157841,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 1 Week Scandinavia',210.005,39207.1447779282,0)
INSERT INTO dbo.CurrentProducts VALUES ('Snow Ski Tour 2 Weeks Scandinavia',378.009,37114.2735210806,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Day West Coast',120.198,37075.0609196017,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Days West Coast',216.3564,39404.0065275085,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 3 Days West Coast',360.594,38963.1270731733,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 5 Days West Coast',480.792,39030.6848344847,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Week West Coast',600.99,37737.6471577446,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Weeks West Coast',1101.969,39793.4792398887,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Day East Coast',64.133,39238.4682552525,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Days East Coast',115.4394,37682.1987089733,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 3 Days East Coast',192.399,39441.8045383956,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 5 Days East Coast',256.532,39283.4777025131,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Week East Coast',320.665,37386.9569586964,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Weeks East Coast',577.197,39567.1485568427,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Day Mexico',77.308,37610.568919616,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Days Mexico',139.1544,39459.4126750044,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 3 Days Mexico',231.924,38164.6927467932,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 5 Days Mexico',309.232,38820.3214944845,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Week Mexico',386.54,38633.2902654754,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Weeks Mexico',695.772,37317.5065290309,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Day Canada',44.265,39554.4611166264,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Days Canada',79.677,37464.2863800955,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 3 Days Canada',132.795,39789.3890414472,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 5 Days Canada',177.06,38687.6722511034,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Week Canada',221.325,38259.2236279945,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Weeks Canada',398.385,37093.2726849676,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Day Scandinavia',40.564,38331.2919847311,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Days Scandinavia',73.0152,39389.4766400892,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 3 Days Scandinavia',121.692,38116.1062198842,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 5 Days Scandinavia',162.256,38644.2753609275,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 1 Week Scandinavia',202.82,38322.894033825,0)
INSERT INTO dbo.CurrentProducts VALUES ('Wine Tasting Tour 2 Weeks Scandinavia',365.076,37404.8146269419,0)


ALTER TABLE dbo.CurrentProducts ADD Category varchar(20) NULL
GO

UPDATE dbo.CurrentProducts SET Category = 'Medium-Stay'
UPDATE dbo.CurrentProducts SET Category = 'No-Stay' WHERE ProductName like '%1 day%'
UPDATE dbo.CurrentProducts SET Category = 'Overnight-Stay' WHERE ProductName like '%2 day%'
UPDATE dbo.CurrentProducts SET Category = 'LongTerm-Stay' WHERE ProductName like '%week%'


create table Employee
(EmpID int primary key not null,
LastName varchar(30) null,
FirstName varchar(20) null,
HireDate datetime null,
LocationID int null)
go


create table Location
(LocationID int not null unique,
Street varchar(30) null,
City varchar(20) null,
[state] char(2) null)
go



insert into Employee values(1,'Adams','Alex','1/1/01','001')
insert into Employee values(2,'Brown','Barry','8/12/02','001')
insert into Employee values(3,'Osako','Lee','9/1/99','002')
insert into Employee values(4,'Kennson','David','3/16/96','001')
insert into Employee values(5,'Bender','Eric','5/17/07','001')
insert into Employee values(6,'Kendall','Lisa','11/15/01','004')
insert into Employee values(7,'Lonning','David','1/1/00','001')
insert into Employee values(8,'Marshbank','John','11/15/01',null)
insert into Employee values(9,'Newton','James','9/30/03','002')
insert into Employee values(10,'O''Haire','Terry','10/04/04','002')
insert into Employee values(11,'Smith','Sally','4/1/89','001')
insert into Employee values(12,'O''Neil','Barbara','5/26/95','004')

insert into Location values(1,'111 First ST','Seattle', 'WA')
insert into Location values(2,'222 Second AVE', 'Boston','MA')
insert into Location values(3,'333 Third PL','Chicago','IL')
insert into Location values(4,'444 Ruby ST','Spokane', 'WA')
go

--Add a new ManagerID field to the Employee table of JProCo
ALTER TABLE Employee
ADD ManagerID int NULL
GO

--Update all Seattle Employees to Report to Sally Smith (Except herself)
UPDATE Employee SET ManagerID = 11
WHERE LocationID =  1 AND EmpID != 11

--Update all Boston Employee to report to Lee Osako (except for himself)
UPDATE Employee SET ManagerID = 3
WHERE LocationID = 2 AND EmpID != 3

--Update all Spokane Employees to report directly to David Kennson
UPDATE Employee SET ManagerID = 4
WHERE locationID = 4

--Set all sales people with no office location to work for David Kennson
UPDATE Employee SET ManagerID = 4
WHERE LocationID IS NULL

--Set Lee Osako to work for Sally Smith
UPDATE Employee SET ManagerID = 11
WHERE EmpID = 3

--Add a new Status field to the Employee table of JProCo
ALTER TABLE Employee
ADD [Status] CHAR(12) NULL
GO

UPDATE Employee SET Status = 'On Leave' WHERE EmpID = 7
UPDATE Employee SET Status = 'Has Tenure' WHERE EmpID in (12,4)

CREATE TABLE [Grant]
(
GrantID char(3) NOT NULL UNIQUE,
GrantName Nvarchar(50) NOT NULL,
EmpID int,
Amount smallmoney
)

INSERT INTO [Grant] VALUES ('001','92 Purr_Scents %% team',7,4750)
INSERT INTO [Grant] VALUES ('002','K-Land fund trust',2,15750)
INSERT INTO [Grant] VALUES ('003','Robert@BigStarBank.com',7,18100)
--INSERT INTO [Grant] VALUES ('004','Norman''s Outreach',null,21000)
INSERT INTO [Grant] VALUES ('005','BIG 6''s Foundation%',4,21000)
INSERT INTO [Grant] VALUES ('006','TALTA_Kishan International',3,18100)
INSERT INTO [Grant] VALUES ('007','Ben@MoreTechnology.com',010,41000)
INSERT INTO [Grant] VALUES ('008','www.@-Last-U-Can-Help.com',7,25000)
INSERT INTO [Grant] VALUES ('009','Thank you @.com',11,21500)
INSERT INTO [Grant] VALUES ('010','Just Mom', 5,9900)
INSERT INTO [Grant] VALUES ('011', 'Big Giver Tom', 7, 95900)
INSERT INTO [Grant] VALUES ('012', 'Mega Mercy', 9, 55000)
GO

create procedure spGetEmployeeLastAndState
@eid char(3)
as
select e.LastName, a.state
from Employee as e inner join Location as a
on e.LocationID = a.LocationID
where e.LocationID = @eid
go

--exec spGetEmployeeLastAndState '002'
-- go






USE JProCo
GO

CREATE TABLE Customer
(CustomerID INT PRIMARY  KEY,
CustomerType NVARCHAR(25),
FirstName NVArCHAR(30),
LastName NVARCHAR(40),
CompanyName NVARCHAR(100)
)
GO

INSERT INTO Customer VALUES (1,'Consumer','Mark','Williams',NULL)
INSERT INTO Customer VALUES (2,'Consumer','Lee','Young',NULL)
INSERT INTO Customer VALUES (3,'Consumer','Patricia','Martin',NULL)
INSERT INTO Customer VALUES (4,'Consumer','Mary','Lopez',NULL)
INSERT INTO Customer VALUES (5,'Consumer',NULL,NULL,'MoreTechnology.com')

------

UPDATE PayRates SET YearlySalary = YearlySalary + 1000
FROM Employee INNER JOIN PayRates
ON Employee.EmpID = PayRates.EmpID
WHERE ManagerID = 11
AND YearlySalary IS NOT NULL 
GO 

USE JProCo
GO

CREATE TABLE SalesInvoice
(InvoiceID int PRIMARY KEY,
OrderDate datetime NOT NULL,
PaidDate datetime NOT NULL,
CustomerID int NOT NULL,
Comment NTEXT)
GO

UPDATE MgmtTraining 
SET ApprovedDate = '1/1/2007' WHERE ClassID = 1

UPDATE MgmtTraining 
SET ApprovedDate = '1/15/2007' WHERE ClassID = 2

UPDATE MgmtTraining 
SET ApprovedDate = '2/12/2008' WHERE ClassID = 3


USE JProCo
GO

IF EXISTS(SELECT * FROM sys.tables WHERE [name] = 'SalesInvoiceDetail')
DROP TABLE SalesInvoiceDetail
GO


CREATE TABLE SalesInvoiceDetail
(InvoiceDetailID INT PRIMARY KEY,
InvoiceID INT NOT NULL,
ProductID INT NOT NULL, Quantity INT NOT NULL,
UnitDiscount smallmoney)
GO

INSERT INTO SalesInvoicedetail VALUES (1,1,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2,1,77,3,0)

INSERT INTO SalesInvoicedetail VALUES (3,1,78,6,0)
GO

INSERT INTO Customer VALUES (6,'Consumer','Ruth','Clark',NULL)
INSERT INTO Customer VALUES (7,'Consumer','Tessa','Wright',NULL)
INSERT INTO Customer VALUES (8,'Consumer','Jennifer','Garcia',NULL)
INSERT INTO Customer VALUES (9,'Consumer','Linda','Adams',NULL)
INSERT INTO Customer VALUES (10,'Consumer',' Robert','Wilson',NULL)
--INSERT INTO Customer VALUES (10,'Consumer','Robert','Wilson',NULL)
INSERT INTO Customer VALUES (11,'Consumer','Kimberly','Taylor',NULL)
INSERT INTO Customer VALUES (12,'Consumer','Helen','Hernandez',NULL)
INSERT INTO Customer VALUES (13,'Consumer','Linda','Hernandez',NULL)
INSERT INTO Customer VALUES (14,'Consumer','Elizabeth','White',NULL)
INSERT INTO Customer VALUES (15,'Consumer','Anthony','Scott',NULL)
INSERT INTO Customer VALUES (16,'Consumer','Paul','Perez',NULL)
INSERT INTO Customer VALUES (17,'Consumer','Sanjay','Mitchell',NULL)
INSERT INTO Customer VALUES (18,'Consumer','Donald','Walker',NULL)
INSERT INTO Customer VALUES (19,'Consumer','Patricia','Rodriguez',NULL)
INSERT INTO Customer VALUES (20,'Consumer','Elizabeth','Wilson',NULL)
INSERT INTO Customer VALUES (21,'Consumer','Carol','Thompson',NULL)
INSERT INTO Customer VALUES (22,'Consumer','George','Hall',NULL)
INSERT INTO Customer VALUES (23,'Consumer','Daniel','Gonzalez',NULL)
INSERT INTO Customer VALUES (24,'Consumer','Paul','Edwards',NULL)
INSERT INTO Customer VALUES (25,'Consumer','Lee','Hall',NULL)
INSERT INTO Customer VALUES (26,'Consumer','Sandra','Williams',NULL)
INSERT INTO Customer VALUES (27,'Consumer','George','Allen',NULL)
INSERT INTO Customer VALUES (28,'Consumer','John','Allen',NULL)
INSERT INTO Customer VALUES (29,'Consumer','Lisa','Scott',NULL)
INSERT INTO Customer VALUES (30,'Consumer','Steven','Baker',NULL)
INSERT INTO Customer VALUES (31,'Consumer','Thomas','Martinez',NULL)
INSERT INTO Customer VALUES (32,'Consumer','Paul','Turner',NULL)
INSERT INTO Customer VALUES (33,'Consumer','Ruth','King',NULL)
INSERT INTO Customer VALUES (34,'Consumer','Richard','Brown',NULL)
INSERT INTO Customer VALUES (35,'Consumer','Kenneth','Campbell',NULL)
INSERT INTO Customer VALUES (36,'Consumer','Jeff','Walker',NULL)
INSERT INTO Customer VALUES (37,'Consumer','John','Nelson',NULL)
INSERT INTO Customer VALUES (38,'Consumer','Linda','Adams',NULL)
INSERT INTO Customer VALUES (39,'Consumer','John','Jackson',NULL)
INSERT INTO Customer VALUES (40,'Consumer','Susan','Wright',NULL)
INSERT INTO Customer VALUES (41,'Consumer','Deborah','Smith',NULL)
INSERT INTO Customer VALUES (42,'Consumer','James','Campbell',NULL)
INSERT INTO Customer VALUES (43,'Consumer','Patricia','Parker',NULL)
INSERT INTO Customer VALUES (44,'Consumer','Sarah','Thompson',NULL)
INSERT INTO Customer VALUES (45,'Consumer','Thomas','Lee',NULL)
INSERT INTO Customer VALUES (46,'Consumer','Jason','Hill',NULL)
INSERT INTO Customer VALUES (47,'Consumer','Sarah','Campbell',NULL)
INSERT INTO Customer VALUES (48,'Consumer','Donna','Martinez',NULL)
INSERT INTO Customer VALUES (49,'Consumer','Jason','Adams',NULL)
INSERT INTO Customer VALUES (50,'Consumer','William','Green',NULL)
INSERT INTO Customer VALUES (51,'Consumer','Sanjay','Scott',NULL)
INSERT INTO Customer VALUES (52,'Consumer','Daniel','Nelson',NULL)
INSERT INTO Customer VALUES (53,'Consumer','Michael','Johnson',NULL)
INSERT INTO Customer VALUES (54,'Consumer','Barbara','Campbell',NULL)
INSERT INTO Customer VALUES (55,'Consumer','Kevin','Smith',NULL)
INSERT INTO Customer VALUES (56,'Consumer','Elizabeth','Rodriguez',NULL)
INSERT INTO Customer VALUES (57,'Consumer','Sandra','Allen',NULL)
INSERT INTO Customer VALUES (58,'Consumer','Jason','Harris',NULL)
INSERT INTO Customer VALUES (59,'Consumer','Barbara','Green',NULL)
INSERT INTO Customer VALUES (60,'Consumer','Joseph','Perez',NULL)
INSERT INTO Customer VALUES (61,'Consumer','Lisa','Hall',NULL)
INSERT INTO Customer VALUES (62,'Consumer',' Robert','Wright',NULL)
--INSERT INTO Customer VALUES (62,'Consumer','Robert','Wright',NULL)
INSERT INTO Customer VALUES (63,'Consumer','Carol','Miller',NULL)
INSERT INTO Customer VALUES (64,'Consumer','Linda','Johnson',NULL)
INSERT INTO Customer VALUES (65,'Consumer','Lisa','Moore',NULL)
INSERT INTO Customer VALUES (66,'Consumer','Michael','Turner',NULL)
INSERT INTO Customer VALUES (67,'Consumer','Brian','Hall',NULL)
INSERT INTO Customer VALUES (68,'Consumer','Richard','Moore',NULL)
INSERT INTO Customer VALUES (69,'Consumer','Donna','Lopez',NULL)
INSERT INTO Customer VALUES (70,'Consumer','Sarah','Smith',NULL)
INSERT INTO Customer VALUES (71,'Consumer','George','Jackson',NULL)
INSERT INTO Customer VALUES (72,'Consumer','Donald','Scott',NULL)
INSERT INTO Customer VALUES (73,'Consumer','Sarah','Nelson',NULL)
INSERT INTO Customer VALUES (74,'Consumer','Donald','Turner',NULL)
INSERT INTO Customer VALUES (75,'Consumer','Nancy','Rodriguez',NULL)
INSERT INTO Customer VALUES (76,'Consumer','Daniel','Green',NULL)
INSERT INTO Customer VALUES (77,'Consumer','Patricia','Moore',NULL)
INSERT INTO Customer VALUES (78,'Consumer','Deborah','Lewis',NULL)
INSERT INTO Customer VALUES (79,'Consumer','Donald','Collins',NULL)
INSERT INTO Customer VALUES (80,'Consumer','Susan','Phillips',NULL)
INSERT INTO Customer VALUES (81,'Consumer','Pedro','Brown',NULL)
INSERT INTO Customer VALUES (82,'Consumer','Kenneth','Young',NULL)
INSERT INTO Customer VALUES (83,'Consumer','Charles','Wilson',NULL)
INSERT INTO Customer VALUES (84,'Consumer','Kimberly','Wright',NULL)
INSERT INTO Customer VALUES (85,'Consumer','Daniel','Williams',NULL)
INSERT INTO Customer VALUES (86,'Consumer','Karen','Turner',NULL)
INSERT INTO Customer VALUES (87,'Consumer','Jeff','Phillips',NULL)
INSERT INTO Customer VALUES (88,'Consumer','Brian','Baker',NULL)
INSERT INTO Customer VALUES (89,'Consumer','Betty','Roberts',NULL)
INSERT INTO Customer VALUES (90,'Consumer','Edward','Martinez',NULL)
INSERT INTO Customer VALUES (91,'Consumer','Kenneth','Thompson',NULL)
INSERT INTO Customer VALUES (92,'Consumer','Lisa','Garcia',NULL)
INSERT INTO Customer VALUES (93,'Consumer','Joseph','Lee',NULL)
INSERT INTO Customer VALUES (94,'Consumer','Elizabeth','Hall',NULL)
INSERT INTO Customer VALUES (95,'Consumer','Charles','White',NULL)
INSERT INTO Customer VALUES (96,'Consumer','Richard','Thompson',NULL)
INSERT INTO Customer VALUES (97,'Consumer','Ruth','Smith',NULL)
INSERT INTO Customer VALUES (98,'Consumer','Charles','Edwards',NULL)
INSERT INTO Customer VALUES (99,'Consumer','Kevin','Lewis',NULL)
INSERT INTO Customer VALUES (100,'Consumer','Jennifer','Wright',NULL)
INSERT INTO Customer VALUES (101,'Consumer','Paul','Davis',NULL)
INSERT INTO Customer VALUES (102,'Consumer','Ronald','Garcia',NULL)
INSERT INTO Customer VALUES (103,'Consumer','Edward','Hill',NULL)
INSERT INTO Customer VALUES (104,'Consumer',' Robert','Anderson',NULL)
--INSERT INTO Customer VALUES (104,'Consumer','Robert','Anderson',NULL)
INSERT INTO Customer VALUES (105,'Consumer','Barbara','Miller',NULL)
INSERT INTO Customer VALUES (106,'Consumer','Charles','Campbell',NULL)
INSERT INTO Customer VALUES (107,'Consumer','Michael','Perez',NULL)
INSERT INTO Customer VALUES (108,'Consumer','Jeff','Roberts',NULL)
INSERT INTO Customer VALUES (109,'Consumer','Carol','Moore',NULL)
INSERT INTO Customer VALUES (110,'Consumer','John','Adams',NULL)
INSERT INTO Customer VALUES (111,'Consumer','Michael','Jackson',NULL)
INSERT INTO Customer VALUES (112,'Consumer','Laura','Adams',NULL)
INSERT INTO Customer VALUES (113,'Consumer','Jason','Garcia',NULL)
INSERT INTO Customer VALUES (114,'Consumer','Ronald','White',NULL)
INSERT INTO Customer VALUES (115,'Consumer','Mark','Davis',NULL)
INSERT INTO Customer VALUES (116,'Consumer','Jennifer','Johnson',NULL)
INSERT INTO Customer VALUES (117,'Business',NULL,NULL,'Puma Consulting')
INSERT INTO Customer VALUES (118,'Consumer','Charles','King',NULL)
INSERT INTO Customer VALUES (119,'Consumer','Nancy','Garcia',NULL)
INSERT INTO Customer VALUES (120,'Consumer','Paul','Hill',NULL)
INSERT INTO Customer VALUES (121,'Consumer','Paul','Roberts',NULL)
INSERT INTO Customer VALUES (122,'Consumer','Michael','Walker',NULL)
INSERT INTO Customer VALUES (123,'Consumer','George','Wilson',NULL)
INSERT INTO Customer VALUES (124,'Consumer','Brian','Mitchell',NULL)
INSERT INTO Customer VALUES (125,'Consumer','Jason','Wright',NULL)
INSERT INTO Customer VALUES (126,'Consumer','Daniel','Scott',NULL)
INSERT INTO Customer VALUES (127,'Consumer','Richard','Adams',NULL)
INSERT INTO Customer VALUES (128,'Consumer','Pedro','Brown',NULL)
INSERT INTO Customer VALUES (129,'Consumer','Ruth','Carter',NULL)
INSERT INTO Customer VALUES (130,'Consumer','Edward','Baker',NULL)
INSERT INTO Customer VALUES (131,'Consumer','George','Edwards',NULL)
INSERT INTO Customer VALUES (132,'Consumer','Sarah','Wright',NULL)
INSERT INTO Customer VALUES (133,'Consumer','Michael','Thomas',NULL)
INSERT INTO Customer VALUES (134,'Consumer','Mark','Wright',NULL)
INSERT INTO Customer VALUES (135,'Consumer','Nancy','Perez',NULL)
INSERT INTO Customer VALUES (136,'Consumer','Maria','Wilson',NULL)
INSERT INTO Customer VALUES (137,'Consumer','Patricia','King',NULL)
INSERT INTO Customer VALUES (138,'Consumer','Karen','Thompson',NULL)
INSERT INTO Customer VALUES (139,'Consumer','Sandra','Anderson',NULL)
INSERT INTO Customer VALUES (140,'Consumer','Carol','Allen',NULL)
INSERT INTO Customer VALUES (141,'Consumer','Elizabeth','Davis',NULL)
INSERT INTO Customer VALUES (142,'Consumer','Lee','Thompson',NULL)
INSERT INTO Customer VALUES (143,'Consumer','George','Hill',NULL)
INSERT INTO Customer VALUES (144,'Consumer','Richard','Davis',NULL)
INSERT INTO Customer VALUES (145,'Consumer','Charles','Lewis',NULL)
INSERT INTO Customer VALUES (146,'Consumer','Susan','Thomas',NULL)
INSERT INTO Customer VALUES (147,'Consumer','Sanjay','Robinson',NULL)
INSERT INTO Customer VALUES (148,'Consumer','Karen','Campbell',NULL)
INSERT INTO Customer VALUES (149,'Consumer','Kimberly','Allen',NULL)
INSERT INTO Customer VALUES (150,'Consumer','William','Jackson',NULL)
INSERT INTO Customer VALUES (151,'Consumer','Carol','Young',NULL)
INSERT INTO Customer VALUES (152,'Consumer','Donna','Adams',NULL)
INSERT INTO Customer VALUES (153,'Consumer','Lisa','Parker',NULL)
INSERT INTO Customer VALUES (154,'Consumer','Mark','Garcia',NULL)
INSERT INTO Customer VALUES (155,'Consumer','Jeff','Lewis',NULL)
INSERT INTO Customer VALUES (156,'Consumer','Ruth','Brown',NULL)
INSERT INTO Customer VALUES (157,'Consumer','Edward','Mitchell',NULL)
INSERT INTO Customer VALUES (158,'Consumer','Tessa','Allen',NULL)
INSERT INTO Customer VALUES (159,'Consumer','Richard','Phillips',NULL)
INSERT INTO Customer VALUES (160,'Consumer','Donna','Allen',NULL)
INSERT INTO Customer VALUES (161,'Consumer','Elizabeth','Phillips',NULL)
INSERT INTO Customer VALUES (162,'Consumer','Carol','Rodriguez',NULL)
INSERT INTO Customer VALUES (163,'Consumer','John','Lopez',NULL)
INSERT INTO Customer VALUES (164,'Consumer','Kevin','Edwards',NULL)
INSERT INTO Customer VALUES (165,'Consumer','Richard','Phillips',NULL)
INSERT INTO Customer VALUES (166,'Consumer','Joseph','Robinson',NULL)
INSERT INTO Customer VALUES (167,'Consumer','Carol','Hall',NULL)
INSERT INTO Customer VALUES (168,'Consumer','Anthony','Brown',NULL)
INSERT INTO Customer VALUES (169,'Consumer','Mark','Williams',NULL)
INSERT INTO Customer VALUES (170,'Consumer','Paul','Turner',NULL)
INSERT INTO Customer VALUES (171,'Consumer','Jennifer','Davis',NULL)
INSERT INTO Customer VALUES (172,'Consumer','Ruth','Lewis',NULL)
INSERT INTO Customer VALUES (173,'Consumer','Ruth','Jackson',NULL)
INSERT INTO Customer VALUES (174,'Consumer','Donna','Johnson',NULL)
INSERT INTO Customer VALUES (175,'Consumer','Ronald','Young',NULL)
INSERT INTO Customer VALUES (176,'Consumer','Elizabeth','Lopez',NULL)
INSERT INTO Customer VALUES (177,'Consumer','Susan','Adams',NULL)
INSERT INTO Customer VALUES (178,'Consumer','George','Adams',NULL)
INSERT INTO Customer VALUES (179,'Consumer','John','Brown',NULL)
INSERT INTO Customer VALUES (180,'Consumer','Jeff','Smith',NULL)
INSERT INTO Customer VALUES (181,'Consumer','Daniel','Young',NULL)
INSERT INTO Customer VALUES (182,'Consumer','Daniel','Evans',NULL)
INSERT INTO Customer VALUES (183,'Consumer','Brian','Williams',NULL)
INSERT INTO Customer VALUES (184,'Consumer','Brian','Lewis',NULL)
INSERT INTO Customer VALUES (185,'Consumer','Sanjay','Garcia',NULL)
INSERT INTO Customer VALUES (186,'Consumer','Edward','Campbell',NULL)
INSERT INTO Customer VALUES (187,'Consumer','Patricia','Green',NULL)
INSERT INTO Customer VALUES (188,'Consumer','Kenneth','Scott',NULL)
INSERT INTO Customer VALUES (189,'Consumer','William','Hall',NULL)
INSERT INTO Customer VALUES (190,'Consumer','Kevin','Davis',NULL)
INSERT INTO Customer VALUES (191,'Consumer','Paul','Davis',NULL)
INSERT INTO Customer VALUES (192,'Consumer','Kevin','Edwards',NULL)
INSERT INTO Customer VALUES (193,'Consumer',' Robert','Hill',NULL)
--INSERT INTO Customer VALUES (193,'Consumer','Robert','Hill',NULL)
INSERT INTO Customer VALUES (194,'Consumer','Jeff','Martin',NULL)
INSERT INTO Customer VALUES (195,'Consumer','Carol','Clark',NULL)
INSERT INTO Customer VALUES (196,'Consumer','Sandra','Nelson',NULL)
INSERT INTO Customer VALUES (197,'Consumer','Michael','Taylor',NULL)
INSERT INTO Customer VALUES (198,'Consumer','Brian','Hernandez',NULL)
INSERT INTO Customer VALUES (199,'Consumer','David','Davis',NULL)
INSERT INTO Customer VALUES (200,'Consumer','Ruth','Allen',NULL)
INSERT INTO Customer VALUES (201,'Consumer','Pedro','Anderson',NULL)
INSERT INTO Customer VALUES (202,'Consumer','John','Mitchell',NULL)
INSERT INTO Customer VALUES (203,'Consumer','Jeff','Hill',NULL)
INSERT INTO Customer VALUES (204,'Consumer','Ronald','Turner',NULL)
INSERT INTO Customer VALUES (205,'Consumer','Thomas','Scott',NULL)
INSERT INTO Customer VALUES (206,'Consumer','Brian','Walker',NULL)
INSERT INTO Customer VALUES (207,'Consumer','Ruth','Garcia',NULL)
INSERT INTO Customer VALUES (208,'Consumer','Linda','Parker',NULL)
INSERT INTO Customer VALUES (209,'Consumer','Carol','Miller',NULL)
INSERT INTO Customer VALUES (210,'Consumer','Rick','Green',NULL)
INSERT INTO Customer VALUES (211,'Consumer','Steven','Garcia',NULL)
INSERT INTO Customer VALUES (212,'Consumer','Nancy','Thompson',NULL)
INSERT INTO Customer VALUES (213,'Consumer','Jeff','Hernandez',NULL)
INSERT INTO Customer VALUES (214,'Consumer','Thomas','Brown',NULL)
INSERT INTO Customer VALUES (215,'Consumer','James','Miller',NULL)
INSERT INTO Customer VALUES (216,'Consumer','Richard','Miller',NULL)
INSERT INTO Customer VALUES (217,'Consumer','Tessa','Nelson',NULL)
INSERT INTO Customer VALUES (218,'Consumer','Richard','Thomas',NULL)
INSERT INTO Customer VALUES (219,'Consumer','Lisa','White',NULL)
INSERT INTO Customer VALUES (220,'Consumer','Laura','Brown',NULL)
INSERT INTO Customer VALUES (221,'Consumer','Deborah','White',NULL)
INSERT INTO Customer VALUES (222,'Consumer','Tessa','Baker',NULL)
INSERT INTO Customer VALUES (223,'Consumer','Linda','Adams',NULL)
INSERT INTO Customer VALUES (224,'Consumer','Patricia','Clark',NULL)
INSERT INTO Customer VALUES (225,'Consumer','George','Jackson',NULL)
INSERT INTO Customer VALUES (226,'Consumer','Thomas','Harris',NULL)
INSERT INTO Customer VALUES (227,'Consumer','Michael','Brown',NULL)
INSERT INTO Customer VALUES (228,'Consumer','Anthony','Martinez',NULL)
INSERT INTO Customer VALUES (229,'Consumer','Sarah','Anderson',NULL)
INSERT INTO Customer VALUES (230,'Consumer','Jason','Edwards',NULL)
INSERT INTO Customer VALUES (231,'Consumer','Daniel','Smith',NULL)
INSERT INTO Customer VALUES (232,'Consumer','Mary','Perez',NULL)
INSERT INTO Customer VALUES (233,'Consumer','Pedro','Johnson',NULL)
INSERT INTO Customer VALUES (234,'Consumer','Daniel','Rodriguez',NULL)
INSERT INTO Customer VALUES (235,'Consumer','Sanjay','Carter',NULL)
INSERT INTO Customer VALUES (236,'Consumer','Maria','Hill',NULL)
INSERT INTO Customer VALUES (237,'Consumer','Lee','Gonzalez',NULL)
INSERT INTO Customer VALUES (238,'Consumer','Anthony','Hill',NULL)
INSERT INTO Customer VALUES (239,'Consumer','Lisa','Hall',NULL)
INSERT INTO Customer VALUES (240,'Consumer','Deborah','Mitchell',NULL)
INSERT INTO Customer VALUES (241,'Consumer','Ronald','Anderson',NULL)
INSERT INTO Customer VALUES (242,'Consumer','James','Nelson',NULL)
INSERT INTO Customer VALUES (243,'Consumer','Maria','Edwards',NULL)
INSERT INTO Customer VALUES (244,'Consumer','Brian','Wilson',NULL)
INSERT INTO Customer VALUES (245,'Consumer','Donald','Taylor',NULL)
INSERT INTO Customer VALUES (246,'Consumer','Jason','Campbell',NULL)
INSERT INTO Customer VALUES (247,'Consumer','Brian','Allen',NULL)
INSERT INTO Customer VALUES (248,'Consumer','James','Hill',NULL)
INSERT INTO Customer VALUES (249,'Consumer','Ruth','Carter',NULL)
INSERT INTO Customer VALUES (250,'Consumer','Elizabeth','Walker',NULL)
INSERT INTO Customer VALUES (251,'Consumer','Deborah','Moore',NULL)
INSERT INTO Customer VALUES (252,'Consumer','Barbara','Green',NULL)
INSERT INTO Customer VALUES (253,'Consumer','Lisa','Phillips',NULL)
INSERT INTO Customer VALUES (254,'Consumer','Thomas','Rodriguez',NULL)
INSERT INTO Customer VALUES (255,'Consumer','Ruth','Garcia',NULL)
INSERT INTO Customer VALUES (256,'Consumer','Steven','Garcia',NULL)
INSERT INTO Customer VALUES (257,'Consumer','Donald','White',NULL)
INSERT INTO Customer VALUES (258,'Consumer','Lisa','Allen',NULL)
INSERT INTO Customer VALUES (259,'Consumer','Sandra','Miller',NULL)
INSERT INTO Customer VALUES (260,'Consumer','Paul','Lewis',NULL)
INSERT INTO Customer VALUES (261,'Consumer','Charles','Harris',NULL)
INSERT INTO Customer VALUES (262,'Consumer','Thomas','Rodriguez',NULL)
INSERT INTO Customer VALUES (263,'Consumer','Steven','Martin',NULL)
INSERT INTO Customer VALUES (264,'Consumer','Barbara','Nelson',NULL)
INSERT INTO Customer VALUES (265,'Consumer','Sandra','Nelson',NULL)
INSERT INTO Customer VALUES (266,'Consumer','William','Wright',NULL)
INSERT INTO Customer VALUES (267,'Consumer','Donald','Johnson',NULL)
INSERT INTO Customer VALUES (268,'Consumer','Elizabeth','Puma',NULL)
INSERT INTO Customer VALUES (269,'Consumer','Jason','Jackson',NULL)
INSERT INTO Customer VALUES (270,'Consumer','Jeff','Hernandez',NULL)
INSERT INTO Customer VALUES (271,'Consumer','Donald','Mitchell',NULL)
INSERT INTO Customer VALUES (272,'Consumer','Kimberly','Lewis',NULL)
INSERT INTO Customer VALUES (273,'Consumer','James','Hernandez',NULL)
INSERT INTO Customer VALUES (274,'Consumer','Daniel','Anderson',NULL)
INSERT INTO Customer VALUES (275,'Consumer','Patricia','Taylor',NULL)
INSERT INTO Customer VALUES (276,'Consumer','Michael','Martin',NULL)
INSERT INTO Customer VALUES (277,'Consumer','Helen','Campbell',NULL)
INSERT INTO Customer VALUES (278,'Consumer','Steven','Wright',NULL)
INSERT INTO Customer VALUES (279,'Consumer','Kevin','Campbell',NULL)
INSERT INTO Customer VALUES (280,'Consumer','David','White',NULL)
INSERT INTO Customer VALUES (281,'Consumer','Thomas','King',NULL)
INSERT INTO Customer VALUES (282,'Consumer','Joseph','Clark',NULL)
INSERT INTO Customer VALUES (283,'Consumer','Jason','Robinson',NULL)
INSERT INTO Customer VALUES (284,'Consumer','Brian','Robinson',NULL)
INSERT INTO Customer VALUES (285,'Consumer','Sanjay','Wright',NULL)
INSERT INTO Customer VALUES (286,'Consumer','John','Evans',NULL)
INSERT INTO Customer VALUES (287,'Consumer','Sarah','Young',NULL)
INSERT INTO Customer VALUES (288,'Consumer','Pedro','Carter',NULL)
INSERT INTO Customer VALUES (289,'Consumer','Lisa','Miller',NULL)
INSERT INTO Customer VALUES (290,'Consumer','Susan','Harris',NULL)
INSERT INTO Customer VALUES (291,'Consumer','Richard','Turner',NULL)
INSERT INTO Customer VALUES (292,'Consumer','Pedro','Walker',NULL)
INSERT INTO Customer VALUES (293,'Consumer','Jennifer','Roberts',NULL)
INSERT INTO Customer VALUES (294,'Consumer','Donald','Adams',NULL)
INSERT INTO Customer VALUES (295,'Consumer','Kenneth','Anderson',NULL)
INSERT INTO Customer VALUES (296,'Consumer','Donna','Campbell',NULL)
INSERT INTO Customer VALUES (297,'Consumer','Sandra','Puma',NULL)
INSERT INTO Customer VALUES (298,'Consumer','Kimberly','Campbell',NULL)
INSERT INTO Customer VALUES (299,'Consumer','Donald','Allen',NULL)
INSERT INTO Customer VALUES (300,'Consumer','Thomas','Wilson',NULL)
INSERT INTO Customer VALUES (301,'Consumer','Jennifer','Davis',NULL)
INSERT INTO Customer VALUES (302,'Consumer','Laura','Wright',NULL)
INSERT INTO Customer VALUES (303,'Consumer','Mark','White',NULL)
INSERT INTO Customer VALUES (304,'Consumer','Nancy','Robinson',NULL)
INSERT INTO Customer VALUES (305,'Consumer','James','Robinson',NULL)
INSERT INTO Customer VALUES (306,'Consumer','Elizabeth','Mitchell',NULL)
INSERT INTO Customer VALUES (307,'Consumer','Nancy','Robinson',NULL)
INSERT INTO Customer VALUES (308,'Consumer','Betty','Lewis',NULL)
INSERT INTO Customer VALUES (309,'Consumer','Betty','Campbell',NULL)
INSERT INTO Customer VALUES (310,'Consumer',' Robert','Thomas',NULL)
--INSERT INTO Customer VALUES (310,'Consumer','Robert','Thomas',NULL)
INSERT INTO Customer VALUES (311,'Consumer','Jennifer','Hernandez',NULL)
INSERT INTO Customer VALUES (312,'Consumer','Donald','Nelson',NULL)
INSERT INTO Customer VALUES (313,'Consumer','Donald','Turner',NULL)
INSERT INTO Customer VALUES (314,'Consumer','John','Thompson',NULL)
INSERT INTO Customer VALUES (315,'Consumer','Sanjay','Rodriguez',NULL)
INSERT INTO Customer VALUES (316,'Consumer','Elizabeth','Rodriguez',NULL)
INSERT INTO Customer VALUES (317,'Consumer','Elizabeth','Wilson',NULL)
INSERT INTO Customer VALUES (318,'Consumer','Barbara','White',NULL)
INSERT INTO Customer VALUES (319,'Consumer',' Robert','Lewis',NULL)
--INSERT INTO Customer VALUES (319,'Consumer','Robert','Lewis',NULL)
INSERT INTO Customer VALUES (320,'Consumer','Patricia','Evans',NULL)
INSERT INTO Customer VALUES (321,'Consumer','Edward','Lopez',NULL)
INSERT INTO Customer VALUES (322,'Consumer','Edward','Wilson',NULL)
INSERT INTO Customer VALUES (323,'Consumer','Anthony','Taylor',NULL)
INSERT INTO Customer VALUES (324,'Consumer','Pedro','Gonzalez',NULL)
INSERT INTO Customer VALUES (325,'Consumer','Patricia','Harris',NULL)
INSERT INTO Customer VALUES (326,'Consumer','Karen','Walker',NULL)
INSERT INTO Customer VALUES (327,'Consumer','George','King',NULL)
INSERT INTO Customer VALUES (328,'Consumer','William','Wright',NULL)
INSERT INTO Customer VALUES (329,'Consumer','Jennifer','Wright',NULL)
INSERT INTO Customer VALUES (330,'Consumer','Tessa','Allen',NULL)
INSERT INTO Customer VALUES (331,'Consumer','Sanjay','Wright',NULL)
INSERT INTO Customer VALUES (332,'Consumer','Betty','Hernandez',NULL)
INSERT INTO Customer VALUES (333,'Consumer','Karen','Phillips',NULL)
INSERT INTO Customer VALUES (334,'Consumer','Elizabeth','Phillips',NULL)
INSERT INTO Customer VALUES (335,'Consumer','Betty','Baker',NULL)
INSERT INTO Customer VALUES (336,'Consumer','Kenneth','Jackson',NULL)
INSERT INTO Customer VALUES (337,'Consumer','Kevin','Taylor',NULL)
INSERT INTO Customer VALUES (338,'Consumer','George','Wright',NULL)
INSERT INTO Customer VALUES (339,'Consumer','Jeff','Wright',NULL)
INSERT INTO Customer VALUES (340,'Consumer','George','Martinez',NULL)
INSERT INTO Customer VALUES (341,'Consumer','Kevin','Hill',NULL)
INSERT INTO Customer VALUES (342,'Consumer','Tessa','Baker',NULL)
INSERT INTO Customer VALUES (343,'Consumer','Mark','Martin',NULL)
INSERT INTO Customer VALUES (344,'Consumer','Linda','Adams',NULL)
INSERT INTO Customer VALUES (345,'Consumer','Steven','Garcia',NULL)
INSERT INTO Customer VALUES (346,'Consumer','Elizabeth','Davis',NULL)
INSERT INTO Customer VALUES (347,'Consumer','Sanjay','Smith',NULL)
INSERT INTO Customer VALUES (348,'Consumer','Linda','Anderson',NULL)
INSERT INTO Customer VALUES (349,'Consumer','Joseph','Thomas',NULL)
INSERT INTO Customer VALUES (350,'Consumer','Ruth','Lopez',NULL)
INSERT INTO Customer VALUES (351,'Consumer','Jason','Moore',NULL)
INSERT INTO Customer VALUES (352,'Consumer','William','Edwards',NULL)
INSERT INTO Customer VALUES (353,'Consumer','Donald','Thomas',NULL)
INSERT INTO Customer VALUES (354,'Consumer','Richard','Hall',NULL)
INSERT INTO Customer VALUES (355,'Consumer','Anthony','Rodriguez',NULL)
INSERT INTO Customer VALUES (356,'Consumer','Barbara','Lopez',NULL)
INSERT INTO Customer VALUES (357,'Consumer','William','Thomas',NULL)
INSERT INTO Customer VALUES (358,'Consumer','Donald','Martinez',NULL)
INSERT INTO Customer VALUES (359,'Consumer','Paul','Parker',NULL)
INSERT INTO Customer VALUES (360,'Consumer','Sanjay','Johnson',NULL)
INSERT INTO Customer VALUES (361,'Consumer','Anthony','Clark',NULL)
INSERT INTO Customer VALUES (362,'Consumer','Ronald','Puma',NULL)
INSERT INTO Customer VALUES (363,'Consumer','Paul','Thomas',NULL)
INSERT INTO Customer VALUES (364,'Consumer','Richard','Jackson',NULL)
INSERT INTO Customer VALUES (365,'Consumer',' Robert','Lewis',NULL)
--INSERT INTO Customer VALUES (365,'Consumer','Robert','Lewis',NULL)
INSERT INTO Customer VALUES (366,'Consumer','Richard','Lopez',NULL)
INSERT INTO Customer VALUES (367,'Consumer','Susan','Wright',NULL)
INSERT INTO Customer VALUES (368,'Consumer','Steven','Phillips',NULL)
INSERT INTO Customer VALUES (369,'Consumer','Pedro','Carter',NULL)
INSERT INTO Customer VALUES (370,'Consumer','Susan','Nelson',NULL)
INSERT INTO Customer VALUES (371,'Consumer','Karen','Hall',NULL)
INSERT INTO Customer VALUES (372,'Consumer','Donna','Edwards',NULL)
INSERT INTO Customer VALUES (373,'Consumer','Patricia','Martin',NULL)
INSERT INTO Customer VALUES (374,'Consumer','William','Turner',NULL)
INSERT INTO Customer VALUES (375,'Consumer','Ronald','Smith',NULL)
INSERT INTO Customer VALUES (376,'Consumer','Deborah','Hill',NULL)
INSERT INTO Customer VALUES (377,'Consumer','Jennifer','Allen',NULL)
INSERT INTO Customer VALUES (378,'Consumer','Karen','Robinson',NULL)
INSERT INTO Customer VALUES (379,'Consumer','Mark','Jackson',NULL)
INSERT INTO Customer VALUES (380,'Consumer','Pedro','Martinez',NULL)
INSERT INTO Customer VALUES (381,'Consumer','Kenneth','Hill',NULL)
INSERT INTO Customer VALUES (382,'Consumer','Patricia','Hill',NULL)
INSERT INTO Customer VALUES (383,'Consumer','Linda','Rodriguez',NULL)
INSERT INTO Customer VALUES (384,'Consumer','Mary','Thomas',NULL)
INSERT INTO Customer VALUES (385,'Consumer','William','Martin',NULL)
INSERT INTO Customer VALUES (386,'Consumer','Lisa','Rodriguez',NULL)
INSERT INTO Customer VALUES (387,'Consumer','Joseph','Carter',NULL)
INSERT INTO Customer VALUES (388,'Consumer','Karen','Hill',NULL)
INSERT INTO Customer VALUES (389,'Consumer','Ruth','Lopez',NULL)
INSERT INTO Customer VALUES (390,'Consumer','Daniel','King',NULL)
INSERT INTO Customer VALUES (391,'Consumer','Mary','Harris',NULL)
INSERT INTO Customer VALUES (392,'Consumer','Charles','Lopez',NULL)
INSERT INTO Customer VALUES (393,'Consumer',' Robert','Turner',NULL)
--INSERT INTO Customer VALUES (393,'Consumer','Robert','Turner',NULL)
INSERT INTO Customer VALUES (394,'Consumer','Karen','Wilson',NULL)
INSERT INTO Customer VALUES (395,'Consumer','Donna','White',NULL)
INSERT INTO Customer VALUES (396,'Consumer','Carol','Smith',NULL)
INSERT INTO Customer VALUES (397,'Consumer','Thomas','Hall',NULL)
INSERT INTO Customer VALUES (398,'Consumer','David','Wilson',NULL)
INSERT INTO Customer VALUES (399,'Consumer','Brian','Thomas',NULL)
INSERT INTO Customer VALUES (400,'Consumer','Donald','Lopez',NULL)
INSERT INTO Customer VALUES (401,'Consumer','Karen','Hall',NULL)
INSERT INTO Customer VALUES (402,'Consumer','Carol','Campbell',NULL)
INSERT INTO Customer VALUES (403,'Consumer','Ruth','Martinez',NULL)
INSERT INTO Customer VALUES (404,'Consumer','Mary','Smith',NULL)
INSERT INTO Customer VALUES (405,'Consumer','Rick','Rodriguez',NULL)
INSERT INTO Customer VALUES (406,'Consumer','Laura','Thompson',NULL)
INSERT INTO Customer VALUES (407,'Consumer','Deborah','Clark',NULL)
INSERT INTO Customer VALUES (408,'Consumer','Donald','Brown',NULL)
INSERT INTO Customer VALUES (409,'Consumer','David','Evans',NULL)
INSERT INTO Customer VALUES (410,'Consumer','Ronald','Lopez',NULL)
INSERT INTO Customer VALUES (411,'Consumer','Kenneth','Perez',NULL)
INSERT INTO Customer VALUES (412,'Consumer','Edward','Hill',NULL)
INSERT INTO Customer VALUES (413,'Consumer','Maria','Harris',NULL)
INSERT INTO Customer VALUES (414,'Consumer','Jeff','Brown',NULL)
INSERT INTO Customer VALUES (415,'Consumer','Mark','King',NULL)
INSERT INTO Customer VALUES (416,'Consumer','Elizabeth','Baker',NULL)
INSERT INTO Customer VALUES (417,'Consumer','Brian','Hill',NULL)
INSERT INTO Customer VALUES (418,'Consumer','Donna','Gonzalez',NULL)
INSERT INTO Customer VALUES (419,'Consumer','Ruth','Jones',NULL)
INSERT INTO Customer VALUES (420,'Consumer','Lee','Jackson',NULL)
INSERT INTO Customer VALUES (421,'Consumer','Donald','Taylor',NULL)
INSERT INTO Customer VALUES (422,'Consumer','Steven','Robinson',NULL)
INSERT INTO Customer VALUES (423,'Consumer','Rick','Collins',NULL)
INSERT INTO Customer VALUES (424,'Consumer','Linda','Gonzalez',NULL)
INSERT INTO Customer VALUES (425,'Consumer','Mark','Robinson',NULL)
INSERT INTO Customer VALUES (426,'Consumer','Sarah','Martin',NULL)
INSERT INTO Customer VALUES (427,'Consumer','Brian','Williams',NULL)
INSERT INTO Customer VALUES (428,'Consumer','Edward','Thompson',NULL)
INSERT INTO Customer VALUES (429,'Consumer','Susan','Taylor',NULL)
INSERT INTO Customer VALUES (430,'Consumer','William','Lee',NULL)
INSERT INTO Customer VALUES (431,'Consumer','Jennifer','Parker',NULL)
INSERT INTO Customer VALUES (432,'Consumer','Nancy','Carter',NULL)
INSERT INTO Customer VALUES (433,'Consumer','Joseph','Baker',NULL)
INSERT INTO Customer VALUES (434,'Consumer','Deborah','Davis',NULL)
INSERT INTO Customer VALUES (435,'Consumer','Anthony','Young',NULL)
INSERT INTO Customer VALUES (436,'Consumer','Nancy','Hall',NULL)
INSERT INTO Customer VALUES (437,'Consumer','Betty','Lewis',NULL)
INSERT INTO Customer VALUES (438,'Consumer','William','Nelson',NULL)
INSERT INTO Customer VALUES (439,'Consumer','Sanjay','Campbell',NULL)
INSERT INTO Customer VALUES (440,'Consumer','Mary','Green',NULL)
INSERT INTO Customer VALUES (441,'Consumer','Tessa','King',NULL)
INSERT INTO Customer VALUES (442,'Consumer','George','Anderson',NULL)
INSERT INTO Customer VALUES (443,'Consumer','Karen','Hill',NULL)
INSERT INTO Customer VALUES (444,'Consumer','Betty','Robinson',NULL)
INSERT INTO Customer VALUES (445,'Consumer','Edward','Perez',NULL)
INSERT INTO Customer VALUES (446,'Consumer','Sarah','Green',NULL)
INSERT INTO Customer VALUES (447,'Consumer','Mary','Garcia',NULL)
INSERT INTO Customer VALUES (448,'Consumer','Jennifer','Anderson',NULL)
INSERT INTO Customer VALUES (449,'Consumer','Mary','Turner',NULL)
INSERT INTO Customer VALUES (450,'Consumer','David','Harris',NULL)
INSERT INTO Customer VALUES (451,'Consumer','Pedro','Jackson',NULL)
INSERT INTO Customer VALUES (452,'Consumer','Steven','Jackson',NULL)
INSERT INTO Customer VALUES (453,'Consumer','Elizabeth','Smith',NULL)
INSERT INTO Customer VALUES (454,'Consumer','Donald','Baker',NULL)
INSERT INTO Customer VALUES (455,'Consumer','Jeff','White',NULL)
INSERT INTO Customer VALUES (456,'Consumer','Kenneth','Williams',NULL)
INSERT INTO Customer VALUES (457,'Consumer','Ronald','Phillips',NULL)
INSERT INTO Customer VALUES (458,'Consumer','Jeff','Scott',NULL)
INSERT INTO Customer VALUES (459,'Consumer','John','Walker',NULL)
INSERT INTO Customer VALUES (460,'Consumer','Daniel','Walker',NULL)
INSERT INTO Customer VALUES (461,'Consumer','Linda','Johnson',NULL)
INSERT INTO Customer VALUES (462,'Consumer','Paul','Smith',NULL)
INSERT INTO Customer VALUES (463,'Consumer','Betty','Hernandez',NULL)
INSERT INTO Customer VALUES (464,'Consumer','Donald','Garcia',NULL)
INSERT INTO Customer VALUES (465,'Consumer','Lee','Perez',NULL)
INSERT INTO Customer VALUES (466,'Consumer','Lisa','Clark',NULL)
INSERT INTO Customer VALUES (467,'Consumer','Brian','Harris',NULL)
INSERT INTO Customer VALUES (468,'Consumer','Donald','King',NULL)
INSERT INTO Customer VALUES (469,'Consumer','Deborah','Carter',NULL)
INSERT INTO Customer VALUES (470,'Consumer','Kenneth','Hill',NULL)
INSERT INTO Customer VALUES (471,'Consumer','Donna','Baker',NULL)
INSERT INTO Customer VALUES (472,'Consumer','Mary','Robinson',NULL)
INSERT INTO Customer VALUES (473,'Consumer','Kenneth','Hall',NULL)
INSERT INTO Customer VALUES (474,'Consumer','Barbara','Allen',NULL)
INSERT INTO Customer VALUES (475,'Consumer','Carol','Roberts',NULL)
INSERT INTO Customer VALUES (476,'Consumer','Tessa','Anderson',NULL)
INSERT INTO Customer VALUES (477,'Consumer','Kimberly','Puma',NULL)
INSERT INTO Customer VALUES (478,'Consumer','Donald','Davis',NULL)
INSERT INTO Customer VALUES (479,'Consumer','Edward','Puma',NULL)
INSERT INTO Customer VALUES (480,'Consumer','Susan','Wright',NULL)
INSERT INTO Customer VALUES (481,'Consumer','Donald','Turner',NULL)
INSERT INTO Customer VALUES (482,'Consumer','Jeff','Wilson',NULL)
INSERT INTO Customer VALUES (483,'Consumer','Thomas','Thomas',NULL)
INSERT INTO Customer VALUES (484,'Consumer','John','Young',NULL)
INSERT INTO Customer VALUES (485,'Consumer','Steven','Phillips',NULL)
INSERT INTO Customer VALUES (486,'Consumer','Steven','Harris',NULL)
INSERT INTO Customer VALUES (487,'Consumer','Donald','Taylor',NULL)
INSERT INTO Customer VALUES (488,'Consumer','Paul','Johnson',NULL)
INSERT INTO Customer VALUES (489,'Consumer','Jeff','Jones',NULL)
INSERT INTO Customer VALUES (490,'Consumer','Donald','Miller',NULL)
INSERT INTO Customer VALUES (491,'Consumer','Pedro','Clark',NULL)
INSERT INTO Customer VALUES (492,'Consumer','Donald','Walker',NULL)
INSERT INTO Customer VALUES (493,'Consumer','Thomas','Wright',NULL)
INSERT INTO Customer VALUES (494,'Consumer','Jennifer','Moore',NULL)
INSERT INTO Customer VALUES (495,'Consumer','Paul','Carter',NULL)
INSERT INTO Customer VALUES (496,'Consumer','Sarah','Adams',NULL)
INSERT INTO Customer VALUES (497,'Consumer','Mary','Rodriguez',NULL)
INSERT INTO Customer VALUES (498,'Consumer','Jason','Campbell',NULL)
INSERT INTO Customer VALUES (499,'Consumer','Donald','Campbell',NULL)
INSERT INTO Customer VALUES (500,'Consumer','Pedro','Lopez',NULL)
INSERT INTO Customer VALUES (501,'Consumer','James','Martinez',NULL)
INSERT INTO Customer VALUES (502,'Consumer','Mary','Rodriguez',NULL)
INSERT INTO Customer VALUES (503,'Consumer','Jeff','Parker',NULL)
INSERT INTO Customer VALUES (504,'Consumer','Patricia','Nelson',NULL)
INSERT INTO Customer VALUES (505,'Consumer','Barbara','Lopez',NULL)
INSERT INTO Customer VALUES (506,'Consumer','Mary','Smith',NULL)
INSERT INTO Customer VALUES (507,'Consumer','Michael','Hill',NULL)
INSERT INTO Customer VALUES (508,'Consumer','Sandra','Gonzalez',NULL)
INSERT INTO Customer VALUES (509,'Consumer','Kevin','Campbell',NULL)
INSERT INTO Customer VALUES (510,'Consumer','Jeff','Davis',NULL)
INSERT INTO Customer VALUES (511,'Consumer','Charles','Wilson',NULL)
INSERT INTO Customer VALUES (512,'Consumer','Kevin','Hernandez',NULL)
INSERT INTO Customer VALUES (513,'Consumer','David','Clark',NULL)
INSERT INTO Customer VALUES (514,'Consumer','Daniel','Scott',NULL)
INSERT INTO Customer VALUES (515,'Consumer','Charles','Wright',NULL)
INSERT INTO Customer VALUES (516,'Consumer','James','Lee',NULL)
INSERT INTO Customer VALUES (517,'Consumer','Carol','Wright',NULL)
INSERT INTO Customer VALUES (518,'Consumer','Susan','Thompson',NULL)
INSERT INTO Customer VALUES (519,'Consumer','Richard','Collins',NULL)
INSERT INTO Customer VALUES (520,'Consumer','Helen','Walker',NULL)
INSERT INTO Customer VALUES (521,'Consumer','Charles','Wilson',NULL)
INSERT INTO Customer VALUES (522,'Consumer','John','Scott',NULL)
INSERT INTO Customer VALUES (523,'Consumer','David','Carter',NULL)
INSERT INTO Customer VALUES (524,'Consumer','Sandra','Walker',NULL)
INSERT INTO Customer VALUES (525,'Consumer','Maria','Hall',NULL)
INSERT INTO Customer VALUES (526,'Consumer','Thomas','Roberts',NULL)
INSERT INTO Customer VALUES (527,'Consumer','Pedro','Williams',NULL)
INSERT INTO Customer VALUES (528,'Consumer','Barbara','Lopez',NULL)
INSERT INTO Customer VALUES (529,'Consumer','Carol','Smith',NULL)
INSERT INTO Customer VALUES (530,'Consumer','Paul','Walker',NULL)
INSERT INTO Customer VALUES (531,'Consumer','John','Smith',NULL)
INSERT INTO Customer VALUES (532,'Consumer','Michael','Nelson',NULL)
INSERT INTO Customer VALUES (533,'Consumer','Deborah','Campbell',NULL)
INSERT INTO Customer VALUES (534,'Consumer','Daniel','Evans',NULL)
INSERT INTO Customer VALUES (535,'Consumer','Pedro','Allen',NULL)
INSERT INTO Customer VALUES (536,'Consumer','Elizabeth','Jackson',NULL)
INSERT INTO Customer VALUES (537,'Consumer','Joseph','Brown',NULL)
INSERT INTO Customer VALUES (538,'Consumer','Charles','Baker',NULL)
INSERT INTO Customer VALUES (539,'Consumer','Karen','Baker',NULL)
INSERT INTO Customer VALUES (540,'Consumer','Kevin','Scott',NULL)
INSERT INTO Customer VALUES (541,'Consumer','Donald','Miller',NULL)
INSERT INTO Customer VALUES (542,'Consumer','Thomas','Martin',NULL)
INSERT INTO Customer VALUES (543,'Consumer','Thomas','Turner',NULL)
INSERT INTO Customer VALUES (544,'Consumer','Karen','Evans',NULL)
INSERT INTO Customer VALUES (545,'Consumer','James','Anderson',NULL)
INSERT INTO Customer VALUES (546,'Consumer','Sarah','Jones',NULL)
INSERT INTO Customer VALUES (547,'Consumer','Thomas','Clark',NULL)
INSERT INTO Customer VALUES (548,'Consumer','Edward','Williams',NULL)
INSERT INTO Customer VALUES (549,'Consumer','Sanjay','Lewis',NULL)
INSERT INTO Customer VALUES (550,'Consumer','George','Gonzalez',NULL)
INSERT INTO Customer VALUES (551,'Consumer','Sanjay','Rodriguez',NULL)
INSERT INTO Customer VALUES (552,'Consumer','Maria','Baker',NULL)
INSERT INTO Customer VALUES (553,'Consumer','Patricia','Young',NULL)
INSERT INTO Customer VALUES (554,'Consumer','Donna','Carter',NULL)
INSERT INTO Customer VALUES (555,'Consumer','William','Parker',NULL)
INSERT INTO Customer VALUES (556,'Consumer','Kenneth','Hall',NULL)
INSERT INTO Customer VALUES (557,'Consumer','James','Hall',NULL)
INSERT INTO Customer VALUES (558,'Consumer','John','Smith',NULL)
INSERT INTO Customer VALUES (559,'Consumer','Lisa','Wright',NULL)
INSERT INTO Customer VALUES (560,'Consumer','Patricia','Green',NULL)
INSERT INTO Customer VALUES (561,'Consumer','Rick','Evans',NULL)
INSERT INTO Customer VALUES (562,'Consumer','Ruth','Davis',NULL)
INSERT INTO Customer VALUES (563,'Consumer','Kenneth','Collins',NULL)
INSERT INTO Customer VALUES (564,'Consumer','Helen','Thompson',NULL)
INSERT INTO Customer VALUES (565,'Consumer','Sanjay','Jackson',NULL)
INSERT INTO Customer VALUES (566,'Consumer','Elizabeth','Wright',NULL)
INSERT INTO Customer VALUES (567,'Consumer','Anthony','Perez',NULL)
INSERT INTO Customer VALUES (568,'Consumer','Michael','Phillips',NULL)
INSERT INTO Customer VALUES (569,'Consumer','Ruth','Scott',NULL)
INSERT INTO Customer VALUES (570,'Consumer','John','Anderson',NULL)
INSERT INTO Customer VALUES (571,'Consumer','Susan','Phillips',NULL)
INSERT INTO Customer VALUES (572,'Consumer','Sarah','Jackson',NULL)
INSERT INTO Customer VALUES (573,'Consumer','Joseph','Jones',NULL)
INSERT INTO Customer VALUES (574,'Consumer','Kimberly','Brown',NULL)
INSERT INTO Customer VALUES (575,'Consumer','Pedro','Martin',NULL)
INSERT INTO Customer VALUES (576,'Consumer','Anthony','Jones',NULL)
INSERT INTO Customer VALUES (577,'Consumer','Linda','Clark',NULL)
INSERT INTO Customer VALUES (578,'Consumer','Mary','Turner',NULL)
INSERT INTO Customer VALUES (579,'Consumer','Donald','Turner',NULL)
INSERT INTO Customer VALUES (580,'Consumer','John','Parker',NULL)
INSERT INTO Customer VALUES (581,'Consumer','Maria','Harris',NULL)
INSERT INTO Customer VALUES (582,'Consumer','Sandra','Lopez',NULL)
INSERT INTO Customer VALUES (583,'Consumer','Anthony','Rodriguez',NULL)
INSERT INTO Customer VALUES (584,'Consumer','Pedro','Nelson',NULL)
INSERT INTO Customer VALUES (585,'Consumer','Donald','Walker',NULL)
INSERT INTO Customer VALUES (586,'Consumer','Lisa','Brown',NULL)
INSERT INTO Customer VALUES (587,'Consumer','William','Moore',NULL)
INSERT INTO Customer VALUES (588,'Consumer','Paul','Lopez',NULL)
INSERT INTO Customer VALUES (589,'Consumer','Pedro','Allen',NULL)
INSERT INTO Customer VALUES (590,'Consumer','Sanjay','Green',NULL)
INSERT INTO Customer VALUES (591,'Consumer','Elizabeth','Brown',NULL)
INSERT INTO Customer VALUES (592,'Consumer','Lisa','Perez',NULL)
INSERT INTO Customer VALUES (593,'Consumer','Sarah','Hill',NULL)
INSERT INTO Customer VALUES (594,'Consumer','William','Wilson',NULL)
INSERT INTO Customer VALUES (595,'Consumer','Ruth','Allen',NULL)
INSERT INTO Customer VALUES (596,'Consumer','Kenneth','Davis',NULL)
INSERT INTO Customer VALUES (597,'Consumer','Thomas','Anderson',NULL)
INSERT INTO Customer VALUES (598,'Consumer','William','Davis',NULL)
INSERT INTO Customer VALUES (599,'Consumer','Betty','Taylor',NULL)
INSERT INTO Customer VALUES (600,'Consumer','Joseph','Martin',NULL)
INSERT INTO Customer VALUES (601,'Consumer','David','Johnson',NULL)
INSERT INTO Customer VALUES (602,'Consumer','Ronald','Jackson',NULL)
INSERT INTO Customer VALUES (603,'Consumer','Paul','Thomas',NULL)
INSERT INTO Customer VALUES (604,'Consumer','Donna','Evans',NULL)
INSERT INTO Customer VALUES (605,'Consumer','Brian','Wright',NULL)
INSERT INTO Customer VALUES (606,'Consumer','Susan','Phillips',NULL)
INSERT INTO Customer VALUES (607,'Consumer','Tessa','Roberts',NULL)
INSERT INTO Customer VALUES (608,'Consumer','Jason','Johnson',NULL)
INSERT INTO Customer VALUES (609,'Consumer','Deborah','Anderson',NULL)
INSERT INTO Customer VALUES (610,'Consumer','Nancy','Scott',NULL)
INSERT INTO Customer VALUES (611,'Consumer','John','Allen',NULL)
INSERT INTO Customer VALUES (612,'Consumer','Ruth','Moore',NULL)
INSERT INTO Customer VALUES (613,'Consumer','Jason','Gonzalez',NULL)
INSERT INTO Customer VALUES (614,'Consumer','Paul','Turner',NULL)
INSERT INTO Customer VALUES (615,'Consumer','Betty','Allen',NULL)
INSERT INTO Customer VALUES (616,'Consumer','Edward','Hill',NULL)
INSERT INTO Customer VALUES (617,'Consumer','Charles','Parker',NULL)
INSERT INTO Customer VALUES (618,'Consumer','John','Smith',NULL)
INSERT INTO Customer VALUES (619,'Consumer','Helen','Lopez',NULL)
INSERT INTO Customer VALUES (620,'Consumer','Steven','Wright',NULL)
INSERT INTO Customer VALUES (621,'Consumer','Jason','Clark',NULL)
INSERT INTO Customer VALUES (622,'Consumer','Nancy','Young',NULL)
INSERT INTO Customer VALUES (623,'Consumer','Susan','Scott',NULL)
INSERT INTO Customer VALUES (624,'Consumer',' Robert','Cambell',NULL)
--INSERT INTO Customer VALUES (624,'Consumer','Robert','Campbell',NULL)
INSERT INTO Customer VALUES (625,'Consumer','Lisa','Parker',NULL)
INSERT INTO Customer VALUES (626,'Consumer','Jennifer','Taylor',NULL)
INSERT INTO Customer VALUES (627,'Consumer','Patricia','Scott',NULL)
INSERT INTO Customer VALUES (628,'Consumer','Susan','Smith',NULL)
INSERT INTO Customer VALUES (629,'Consumer','Linda','Wright',NULL)
INSERT INTO Customer VALUES (630,'Consumer','Richard','Hill',NULL)
INSERT INTO Customer VALUES (631,'Consumer','Daniel','Anderson',NULL)
INSERT INTO Customer VALUES (632,'Consumer','Helen','Mitchell',NULL)
INSERT INTO Customer VALUES (633,'Consumer','Elizabeth','Robinson',NULL)
INSERT INTO Customer VALUES (634,'Consumer','Rick','Allen',NULL)
INSERT INTO Customer VALUES (635,'Consumer','Kevin','Hill',NULL)
INSERT INTO Customer VALUES (636,'Consumer','Ronald','Taylor',NULL)
INSERT INTO Customer VALUES (637,'Consumer','Deborah','Hall',NULL)
INSERT INTO Customer VALUES (638,'Consumer','Anthony','Davis',NULL)
INSERT INTO Customer VALUES (639,'Consumer','Steven','Taylor',NULL)
INSERT INTO Customer VALUES (640,'Consumer','Steven','Baker',NULL)
INSERT INTO Customer VALUES (641,'Consumer','Donald','Campbell',NULL)
INSERT INTO Customer VALUES (642,'Consumer','Donna','Evans',NULL)
INSERT INTO Customer VALUES (643,'Consumer','Steven','Baker',NULL)
INSERT INTO Customer VALUES (644,'Consumer','Sarah','Green',NULL)
INSERT INTO Customer VALUES (645,'Consumer','Betty','Allen',NULL)
INSERT INTO Customer VALUES (646,'Consumer','Michael','Clark',NULL)
INSERT INTO Customer VALUES (647,'Consumer','Barbara','Williams',NULL)
INSERT INTO Customer VALUES (648,'Consumer','Brian','Garcia',NULL)
INSERT INTO Customer VALUES (649,'Consumer','Jeff','Martin',NULL)
INSERT INTO Customer VALUES (650,'Consumer','Richard','King',NULL)
INSERT INTO Customer VALUES (651,'Consumer','Charles','Hall',NULL)
INSERT INTO Customer VALUES (652,'Consumer','Helen','Martin',NULL)
INSERT INTO Customer VALUES (653,'Consumer','Laura','Wilson',NULL)
INSERT INTO Customer VALUES (654,'Consumer','Nancy','Edwards',NULL)
INSERT INTO Customer VALUES (655,'Consumer','Elizabeth','Carter',NULL)
INSERT INTO Customer VALUES (656,'Consumer','David','Young',NULL)
INSERT INTO Customer VALUES (657,'Consumer','Jason','Wright',NULL)
INSERT INTO Customer VALUES (658,'Consumer','Ronald','Jackson',NULL)
INSERT INTO Customer VALUES (659,'Consumer','Lisa','Lewis',NULL)
INSERT INTO Customer VALUES (660,'Consumer','George','Lopez',NULL)
INSERT INTO Customer VALUES (661,'Consumer','James','Nelson',NULL)
INSERT INTO Customer VALUES (662,'Consumer','Paul','Lee',NULL)
INSERT INTO Customer VALUES (663,'Consumer','Brian','Hill',NULL)
INSERT INTO Customer VALUES (664,'Consumer','Donald','Nelson',NULL)
INSERT INTO Customer VALUES (665,'Consumer','Steven','Martinez',NULL)
INSERT INTO Customer VALUES (666,'Consumer','Jeff','Nelson',NULL)
INSERT INTO Customer VALUES (667,'Consumer','Tessa','Anderson',NULL)
INSERT INTO Customer VALUES (668,'Consumer','Charles','Young',NULL)
INSERT INTO Customer VALUES (669,'Consumer','Laura','Edwards',NULL)
INSERT INTO Customer VALUES (670,'Consumer','Lisa','Smith',NULL)
INSERT INTO Customer VALUES (671,'Consumer','Laura','Wilson',NULL)
INSERT INTO Customer VALUES (672,'Consumer','Kenneth','Brown',NULL)
INSERT INTO Customer VALUES (673,'Consumer','Ruth','Evans',NULL)
INSERT INTO Customer VALUES (674,'Consumer','Elizabeth','Edwards',NULL)
INSERT INTO Customer VALUES (675,'Consumer','Thomas','Moore',NULL)
INSERT INTO Customer VALUES (676,'Consumer','Thomas','Adams',NULL)
INSERT INTO Customer VALUES (677,'Consumer','Elizabeth','Johnson',NULL)
INSERT INTO Customer VALUES (678,'Consumer','Lisa','Green',NULL)
INSERT INTO Customer VALUES (679,'Consumer','Pedro','Anderson',NULL)
INSERT INTO Customer VALUES (680,'Consumer','Sanjay','Johnson',NULL)
INSERT INTO Customer VALUES (681,'Consumer','David','Harris',NULL)
INSERT INTO Customer VALUES (682,'Consumer','Donna','Davis',NULL)
INSERT INTO Customer VALUES (683,'Consumer','Deborah','Anderson',NULL)
INSERT INTO Customer VALUES (684,'Consumer','Michael','Scott',NULL)
INSERT INTO Customer VALUES (685,'Consumer','Maria','Garcia',NULL)
INSERT INTO Customer VALUES (686,'Consumer','Thomas','Edwards',NULL)
INSERT INTO Customer VALUES (687,'Consumer','Joseph','Rodriguez',NULL)
INSERT INTO Customer VALUES (688,'Consumer','Patricia','Lewis',NULL)
INSERT INTO Customer VALUES (689,'Consumer','Carol','Lopez',NULL)
INSERT INTO Customer VALUES (690,'Consumer','Maria','Baker',NULL)
INSERT INTO Customer VALUES (691,'Consumer',' Robert','Hill',NULL)
--INSERT INTO Customer VALUES (691,'Consumer','Robert','Hill',NULL)
INSERT INTO Customer VALUES (692,'Consumer','Karen','Johnson',NULL)
INSERT INTO Customer VALUES (693,'Consumer','Linda','Baker',NULL)
INSERT INTO Customer VALUES (694,'Consumer','Jason','Miller',NULL)
INSERT INTO Customer VALUES (695,'Consumer','Susan','Williams',NULL)
INSERT INTO Customer VALUES (696,'Consumer','Daniel','Moore',NULL)
INSERT INTO Customer VALUES (697,'Consumer','Jennifer','Hill',NULL)
INSERT INTO Customer VALUES (698,'Consumer','Donna','Walker',NULL)
INSERT INTO Customer VALUES (699,'Consumer','Brian','Thompson',NULL)
INSERT INTO Customer VALUES (700,'Consumer','Richard','Hernandez',NULL)
INSERT INTO Customer VALUES (701,'Consumer','Sandra','Miller',NULL)
INSERT INTO Customer VALUES (702,'Consumer','Thomas','Hernandez',NULL)
INSERT INTO Customer VALUES (703,'Consumer','Tessa','Allen',NULL)
INSERT INTO Customer VALUES (704,'Consumer','Susan','Wright',NULL)
INSERT INTO Customer VALUES (705,'Consumer','Sandra','Hall',NULL)
INSERT INTO Customer VALUES (706,'Consumer',' Robert','Jackson',NULL)
--INSERT INTO Customer VALUES (706,'Consumer','Robert','Jackson',NULL)
INSERT INTO Customer VALUES (707,'Consumer','Barbara','Mitchell',NULL)
INSERT INTO Customer VALUES (708,'Consumer','Tessa','Puma',NULL)
INSERT INTO Customer VALUES (709,'Consumer','Jason','Mitchell',NULL)
INSERT INTO Customer VALUES (710,'Consumer','Charles','Miller',NULL)
INSERT INTO Customer VALUES (711,'Consumer','Thomas','Taylor',NULL)
INSERT INTO Customer VALUES (712,'Consumer','Anthony','Smith',NULL)
INSERT INTO Customer VALUES (713,'Consumer','Anthony','Robinson',NULL)
INSERT INTO Customer VALUES (714,'Consumer','Thomas','Thompson',NULL)
INSERT INTO Customer VALUES (715,'Consumer','Betty','Rodriguez',NULL)
INSERT INTO Customer VALUES (716,'Consumer','Joseph','Turner',NULL)
INSERT INTO Customer VALUES (717,'Consumer','Kimberly','Martin',NULL)
INSERT INTO Customer VALUES (718,'Consumer','Kevin','Green',NULL)
INSERT INTO Customer VALUES (719,'Consumer','Kenneth','Allen',NULL)
INSERT INTO Customer VALUES (720,'Consumer','Kevin','Baker',NULL)
INSERT INTO Customer VALUES (721,'Consumer','Donna','Walker',NULL)
INSERT INTO Customer VALUES (722,'Consumer','Patricia','Parker',NULL)
INSERT INTO Customer VALUES (723,'Consumer','Helen','Smith',NULL)
INSERT INTO Customer VALUES (724,'Consumer','Richard','Edwards',NULL)
INSERT INTO Customer VALUES (725,'Consumer','Kevin','Green',NULL)
INSERT INTO Customer VALUES (726,'Consumer','Kimberly','Lee',NULL)
INSERT INTO Customer VALUES (727,'Consumer','Donald','Perez',NULL)
INSERT INTO Customer VALUES (728,'Consumer','Daniel','Lee',NULL)
INSERT INTO Customer VALUES (729,'Consumer','Steven','Wilson',NULL)
INSERT INTO Customer VALUES (730,'Consumer','Nancy','Williams',NULL)
INSERT INTO Customer VALUES (731,'Consumer','Brian','Nelson',NULL)
INSERT INTO Customer VALUES (732,'Consumer','Mark','Green',NULL)
INSERT INTO Customer VALUES (733,'Consumer','Laura','Walker',NULL)
INSERT INTO Customer VALUES (734,'Consumer','George','Davis',NULL)
INSERT INTO Customer VALUES (735,'Consumer','John','Jackson',NULL)
INSERT INTO Customer VALUES (736,'Consumer','William','Carter',NULL)
INSERT INTO Customer VALUES (737,'Consumer','Jason','Nelson',NULL)
INSERT INTO Customer VALUES (738,'Consumer','Sandra','Parker',NULL)
INSERT INTO Customer VALUES (739,'Consumer','Edward','Adams',NULL)
INSERT INTO Customer VALUES (740,'Consumer','Maria','Harris',NULL)
INSERT INTO Customer VALUES (741,'Consumer','Charles','Robinson',NULL)
INSERT INTO Customer VALUES (742,'Consumer','Sandra','Garcia',NULL)
INSERT INTO Customer VALUES (743,'Consumer','Kimberly','Lopez',NULL)
INSERT INTO Customer VALUES (744,'Consumer','Brian','Wright',NULL)
INSERT INTO Customer VALUES (745,'Consumer','Richard','Edwards',NULL)
INSERT INTO Customer VALUES (746,'Consumer','Pedro','Adams',NULL)
INSERT INTO Customer VALUES (747,'Consumer','Jason','Adams',NULL)
INSERT INTO Customer VALUES (748,'Consumer','Elizabeth','Collins',NULL)
INSERT INTO Customer VALUES (749,'Consumer','Carol','Hill',NULL)
INSERT INTO Customer VALUES (750,'Consumer','Sanjay','Young',NULL)
INSERT INTO Customer VALUES (751,'Consumer','Brian','Parker',NULL)
INSERT INTO Customer VALUES (752,'Consumer','Sanjay','Turner',NULL)
INSERT INTO Customer VALUES (753,'Consumer','James','Jackson',NULL)
INSERT INTO Customer VALUES (754,'Consumer','Joseph','Allen',NULL)
INSERT INTO Customer VALUES (755,'Consumer',' Robert','Turner',NULL)
--INSERT INTO Customer VALUES (755,'Consumer','Robert','Turner',NULL)
INSERT INTO Customer VALUES (756,'Consumer','Donald','Robinson',NULL)
INSERT INTO Customer VALUES (757,'Consumer','Michael','Moore',NULL)
INSERT INTO Customer VALUES (758,'Consumer','Karen','Thomas',NULL)
INSERT INTO Customer VALUES (759,'Consumer','George','Hall',NULL)
INSERT INTO Customer VALUES (760,'Consumer','Barbara','Clark',NULL)
INSERT INTO Customer VALUES (761,'Consumer','Linda','Mitchell',NULL)
INSERT INTO Customer VALUES (762,'Consumer','Paul','Hernandez',NULL)
INSERT INTO Customer VALUES (763,'Consumer','Tessa','Anderson',NULL)
INSERT INTO Customer VALUES (764,'Consumer','Sanjay','Collins',NULL)
INSERT INTO Customer VALUES (765,'Consumer','Steven','Martinez',NULL)
INSERT INTO Customer VALUES (766,'Consumer','Sandra','Lopez',NULL)
INSERT INTO Customer VALUES (767,'Consumer','Jeff','Baker',NULL)
INSERT INTO Customer VALUES (768,'Consumer','Michael','Anderson',NULL)
INSERT INTO Customer VALUES (769,'Consumer','Anthony','Garcia',NULL)
INSERT INTO Customer VALUES (770,'Consumer','Susan','Lewis',NULL)
INSERT INTO Customer VALUES (771,'Consumer','Susan','Johnson',NULL)
INSERT INTO Customer VALUES (772,'Consumer','Helen','Green',NULL)
INSERT INTO Customer VALUES (773,'Consumer','Laura','Taylor',NULL)
INSERT INTO Customer VALUES (774,'Consumer','Susan','Campbell',NULL)
INSERT INTO Customer VALUES (775,'Consumer','Lisa','Nelson',NULL)
GO

IF EXISTS(SELECT * FROM sys.tables WHERE [name] = 'SalesInvoice')
DROP TABLE SalesInvoice
GO

CREATE TABLE SalesInvoice
(InvoiceID int PRIMARY KEY,OrderDate datetime NOT NULL,PaidDate datetime NOT NULL,CustomerID int NOT NULL,Comment NTEXT)
GO

INSERT INTO SalesInvoice VALUES (1,38718,38726.140793859,472,NULL)
INSERT INTO SalesInvoice VALUES (2,38719.0990911428,38747.177483682,388,NULL)
INSERT INTO SalesInvoice VALUES (3,38719.2312633406,38760.5729465349,279,NULL)
INSERT INTO SalesInvoice VALUES (4,38719.9215122434,38754.9209982502,309,NULL)
INSERT INTO SalesInvoice VALUES (5,38720.4845555224,38756.8343349879,757,NULL)
INSERT INTO SalesInvoice VALUES (6,38721.9953046514,38743.9500694127,493,NULL)
INSERT INTO SalesInvoice VALUES (7,38723.3378843757,38751.3624821028,209,NULL)
INSERT INTO SalesInvoice VALUES (8,38723.5446020246,38763.2800695646,649,NULL)
INSERT INTO SalesInvoice VALUES (9,38723.9069802573,38742.1701616779,597,NULL)
INSERT INTO SalesInvoice VALUES (10,38724.8563354403,38766.6597700722,736,NULL)
INSERT INTO SalesInvoice VALUES (11,38725.9380131387,38733.7070695694,329,NULL)
INSERT INTO SalesInvoice VALUES (12,38726.2965840168,38737.2744150853,52,NULL)
INSERT INTO SalesInvoice VALUES (13,38727.3520370904,38760.3536268323,234,NULL)
INSERT INTO SalesInvoice VALUES (14,38727.836117162,38741.3207648102,772,NULL)
INSERT INTO SalesInvoice VALUES (15,38728.4445165595,38766.9413273431,47,NULL)
INSERT INTO SalesInvoice VALUES (16,38729.8030210647,38744.2573964671,152,NULL)
INSERT INTO SalesInvoice VALUES (17,38731.1189765359,38735.6394550788,394,NULL)
INSERT INTO SalesInvoice VALUES (18,38731.1765002043,38752.7279870284,746,NULL)
INSERT INTO SalesInvoice VALUES (19,38731.7502887695,38739.0099258457,251,NULL)
INSERT INTO SalesInvoice VALUES (20,38732.2753296688,38739.3867178327,529,NULL)
INSERT INTO SalesInvoice VALUES (21,38732.9030929746,38746.4374583964,240,NULL)
INSERT INTO SalesInvoice VALUES (22,38732.9869616949,38761.2578305737,151,NULL)
INSERT INTO SalesInvoice VALUES (23,38733.2051470061,38769.3401730588,191,NULL)
INSERT INTO SalesInvoice VALUES (24,38733.4341754005,38767.1763315374,380,NULL)
INSERT INTO SalesInvoice VALUES (25,38733.7928842985,38754.9447830071,231,NULL)
INSERT INTO SalesInvoice VALUES (26,38734.873225962,38737.4101827192,696,NULL)
INSERT INTO SalesInvoice VALUES (27,38735.8722212943,38743.3282242907,306,NULL)
INSERT INTO SalesInvoice VALUES (28,38737.2276242182,38747.2626011986,37,NULL)
INSERT INTO SalesInvoice VALUES (29,38737.5374658517,38773.9676236816,461,NULL)
INSERT INTO SalesInvoice VALUES (30,38738.1140238226,38748.2884122791,346,NULL)
INSERT INTO SalesInvoice VALUES (31,38738.3643707275,38742.3946148848,98,NULL)
INSERT INTO SalesInvoice VALUES (32,38738.9511152976,38768.2640048507,453,NULL)
INSERT INTO SalesInvoice VALUES (33,38739.8826353079,38766.1122286331,754,NULL)
INSERT INTO SalesInvoice VALUES (34,38741.39628395,38783.3047008761,179,NULL)
INSERT INTO SalesInvoice VALUES (35,38741.7115064215,38787.0832965861,388,NULL)
INSERT INTO SalesInvoice VALUES (36,38742.0050497398,38783.6525533684,48,NULL)
INSERT INTO SalesInvoice VALUES (37,38742.8504968656,38760.1014531724,720,NULL)
INSERT INTO SalesInvoice VALUES (38,38743.7318774566,38791.895553286,74,NULL)
INSERT INTO SalesInvoice VALUES (39,38744.7258570813,38793.7893767066,682,NULL)
INSERT INTO SalesInvoice VALUES (40,38746.0297442152,38784.4907007577,136,NULL)
INSERT INTO SalesInvoice VALUES (41,38746.9561316035,38774.8872928472,514,NULL)
INSERT INTO SalesInvoice VALUES (42,38748.1709448483,38793.3938158297,281,NULL)
INSERT INTO SalesInvoice VALUES (43,38749.1099988511,38767.8238152888,196,NULL)
INSERT INTO SalesInvoice VALUES (44,38750.3530875098,38788.5246993056,683,NULL)
INSERT INTO SalesInvoice VALUES (45,38750.7371562395,38752.9872234833,459,NULL)
INSERT INTO SalesInvoice VALUES (46,38751.7743056589,38777.0075792641,155,NULL)
INSERT INTO SalesInvoice VALUES (47,38752.9845026683,38767.7670589205,323,NULL)
INSERT INTO SalesInvoice VALUES (48,38754.5022275757,38755.591440466,700,NULL)
INSERT INTO SalesInvoice VALUES (49,38755.6029234932,38796.7789032811,69,NULL)
INSERT INTO SalesInvoice VALUES (50,38756.587462653,38758.8036369451,253,NULL)
INSERT INTO SalesInvoice VALUES (51,38757.2792241018,38801.0022541686,564,NULL)
INSERT INTO SalesInvoice VALUES (52,38758.007366426,38761.5793654888,346,NULL)
INSERT INTO SalesInvoice VALUES (53,38758.1670354107,38802.6095281397,282,NULL)
INSERT INTO SalesInvoice VALUES (54,38758.4510909077,38790.5979351624,377,NULL)
INSERT INTO SalesInvoice VALUES (55,38759.7418912251,38794.6072000998,642,NULL)
INSERT INTO SalesInvoice VALUES (56,38760.6125474154,38809.0924658353,575,NULL)
INSERT INTO SalesInvoice VALUES (57,38762.0748171334,38779.3321228876,344,NULL)
INSERT INTO SalesInvoice VALUES (58,38763.1088004561,38767.9816789464,649,NULL)
INSERT INTO SalesInvoice VALUES (59,38764.1094713329,38784.6456617673,717,NULL)
INSERT INTO SalesInvoice VALUES (60,38764.7666976103,38799.2214578249,235,NULL)
INSERT INTO SalesInvoice VALUES (61,38766.0339768503,38793.9393219604,552,NULL)
INSERT INTO SalesInvoice VALUES (62,38766.0441064797,38774.2888031732,346,NULL)
INSERT INTO SalesInvoice VALUES (63,38767.1127049262,38786.1730569637,760,NULL)
INSERT INTO SalesInvoice VALUES (64,38768.6925997182,38807.4203570075,540,NULL)
INSERT INTO SalesInvoice VALUES (65,38770.0663995335,38790.1032181873,22,NULL)
INSERT INTO SalesInvoice VALUES (66,38771.3613219383,38776.4594021817,504,NULL)
INSERT INTO SalesInvoice VALUES (67,38772.2201040777,38787.011640473,695,NULL)
INSERT INTO SalesInvoice VALUES (68,38773.7770280238,38806.1511234016,695,NULL)
INSERT INTO SalesInvoice VALUES (69,38775.3217890288,38799.1146821273,12,NULL)
INSERT INTO SalesInvoice VALUES (70,38776.2600561458,38777.7842118518,215,NULL)
INSERT INTO SalesInvoice VALUES (71,38776.4330363059,38810.4293650436,692,NULL)
INSERT INTO SalesInvoice VALUES (72,38777.016443558,38823.1052152497,747,NULL)
INSERT INTO SalesInvoice VALUES (73,38778.4929111724,38805.082578113,281,NULL)
INSERT INTO SalesInvoice VALUES (74,38779.7402004078,38792.1233658655,438,NULL)
INSERT INTO SalesInvoice VALUES (75,38780.4818109062,38789.5553509163,136,NULL)
INSERT INTO SalesInvoice VALUES (76,38781.1145203662,38825.7654518439,548,NULL)
INSERT INTO SalesInvoice VALUES (77,38781.9660873679,38809.6263890496,368,NULL)
INSERT INTO SalesInvoice VALUES (78,38781.9783132148,38806.1954529126,605,NULL)
INSERT INTO SalesInvoice VALUES (79,38783.3428042146,38796.5448255355,723,NULL)
INSERT INTO SalesInvoice VALUES (80,38783.5388688458,38812.3195973515,176,NULL)
INSERT INTO SalesInvoice VALUES (81,38783.891876063,38808.4130754467,251,NULL)
INSERT INTO SalesInvoice VALUES (82,38784.5018324743,38834.1478083414,284,NULL)
INSERT INTO SalesInvoice VALUES (83,38785.7873301238,38805.5372342508,283,NULL)
INSERT INTO SalesInvoice VALUES (84,38786.5649878649,38817.1198806381,555,NULL)
INSERT INTO SalesInvoice VALUES (85,38787.4452184824,38836.318221908,449,NULL)
INSERT INTO SalesInvoice VALUES (86,38787.5967850526,38797.9533858781,363,NULL)
INSERT INTO SalesInvoice VALUES (87,38788.6301232483,38789.4537023986,343,NULL)
INSERT INTO SalesInvoice VALUES (88,38789.4480484015,38812.2921163166,97,NULL)
INSERT INTO SalesInvoice VALUES (89,38790.0195513724,38796.502853651,423,NULL)
INSERT INTO SalesInvoice VALUES (90,38790.9915324196,38834.9245157414,736,NULL)
INSERT INTO SalesInvoice VALUES (91,38791.6189292057,38827.0208866979,635,NULL)
INSERT INTO SalesInvoice VALUES (92,38791.6752061189,38820.6840665928,416,NULL)
INSERT INTO SalesInvoice VALUES (93,38793.0601596477,38827.302987873,206,NULL)
INSERT INTO SalesInvoice VALUES (94,38794.0915540058,38840.9590770236,250,NULL)
INSERT INTO SalesInvoice VALUES (95,38795.4064463569,38810.8101975233,416,NULL)
INSERT INTO SalesInvoice VALUES (96,38796.3444996488,38827.6825080785,538,NULL)
INSERT INTO SalesInvoice VALUES (97,38797.4698022684,38825.0330987443,504,NULL)
INSERT INTO SalesInvoice VALUES (98,38798.9758592098,38843.5204242071,679,NULL)
INSERT INTO SalesInvoice VALUES (99,38799.9688282093,38848.3293616435,665,NULL)
INSERT INTO SalesInvoice VALUES (100,38801.0953269203,38814.6459109301,557,NULL)
INSERT INTO SalesInvoice VALUES (101,38802.4563359253,38823.6116034562,529,NULL)
INSERT INTO SalesInvoice VALUES (102,38803.5861938809,38851.8609164304,79,NULL)
INSERT INTO SalesInvoice VALUES (103,38804.1771322494,38822.8913117482,440,NULL)
INSERT INTO SalesInvoice VALUES (104,38805.154829564,38826.5390499292,430,NULL)
INSERT INTO SalesInvoice VALUES (105,38805.2184351006,38854.5877059318,42,NULL)
INSERT INTO SalesInvoice VALUES (106,38805.7490867623,38817.9969093652,57,NULL)
INSERT INTO SalesInvoice VALUES (107,38807.196340494,38813.0914217734,665,NULL)
INSERT INTO SalesInvoice VALUES (108,38807.2663009714,38844.6639741173,168,NULL)
INSERT INTO SalesInvoice VALUES (109,38807.3874567196,38833.5779348128,337,NULL)
INSERT INTO SalesInvoice VALUES (110,38807.7330616085,38853.803371782,651,NULL)
INSERT INTO SalesInvoice VALUES (111,38808.9781646387,38853.7712506828,249,NULL)
INSERT INTO SalesInvoice VALUES (112,38809.1664794061,38833.3955197776,150,NULL)
INSERT INTO SalesInvoice VALUES (113,38809.8733360939,38847.5453158895,95,NULL)
INSERT INTO SalesInvoice VALUES (114,38810.7109115217,38830.2430435595,656,NULL)
INSERT INTO SalesInvoice VALUES (115,38811.7310518512,38852.2687037575,466,NULL)
INSERT INTO SalesInvoice VALUES (116,38812.9931984477,38852.3032058587,134,NULL)
INSERT INTO SalesInvoice VALUES (117,38814.0519461015,38857.269095617,230,NULL)
INSERT INTO SalesInvoice VALUES (118,38814.2831336775,38863.2754549001,584,NULL)
INSERT INTO SalesInvoice VALUES (119,38815.5552096673,38847.4106746713,31,NULL)
INSERT INTO SalesInvoice VALUES (120,38816.0102136216,38864.0255025731,348,NULL)
INSERT INTO SalesInvoice VALUES (121,38816.5466248304,38860.0282445648,640,NULL)
INSERT INTO SalesInvoice VALUES (122,38817.5121055047,38823.5120729269,510,NULL)
INSERT INTO SalesInvoice VALUES (123,38818.8579286589,38856.5903819773,633,NULL)
INSERT INTO SalesInvoice VALUES (124,38819.4805315929,38853.8181781507,557,NULL)
INSERT INTO SalesInvoice VALUES (125,38820.8028825126,38843.004477958,30,NULL)
INSERT INTO SalesInvoice VALUES (126,38821.4170132856,38865.3675050379,394,NULL)
INSERT INTO SalesInvoice VALUES (127,38822.9530054938,38825.7329273634,648,NULL)
INSERT INTO SalesInvoice VALUES (128,38823.2642628745,38865.5767142827,197,NULL)
INSERT INTO SalesInvoice VALUES (129,38823.2827064254,38846.7955603474,613,NULL)
INSERT INTO SalesInvoice VALUES (130,38824.0666742341,38869.4947967093,33,NULL)
INSERT INTO SalesInvoice VALUES (131,38824.9349660565,38870.38279091,96,NULL)
INSERT INTO SalesInvoice VALUES (132,38825.3335519072,38867.6845346321,350,NULL)
INSERT INTO SalesInvoice VALUES (133,38825.5086682828,38849.2054679956,702,NULL)
INSERT INTO SalesInvoice VALUES (134,38826.2800824246,38859.4612777774,746,NULL)
INSERT INTO SalesInvoice VALUES (135,38827.3258960855,38872.4782904775,335,NULL)
INSERT INTO SalesInvoice VALUES (136,38827.3640590984,38832.5136242312,459,NULL)
INSERT INTO SalesInvoice VALUES (137,38828.7340045916,38870.9499042295,697,NULL)
INSERT INTO SalesInvoice VALUES (138,38829.8151674581,38866.2689568753,637,NULL)
INSERT INTO SalesInvoice VALUES (139,38831.33755404,38862.0846475959,151,NULL)
INSERT INTO SalesInvoice VALUES (140,38832.6564057389,38869.1408440906,35,NULL)
INSERT INTO SalesInvoice VALUES (141,38834.008755453,38844.4350747408,652,NULL)
INSERT INTO SalesInvoice VALUES (142,38834.5959965619,38853.6684524808,215,NULL)
INSERT INTO SalesInvoice VALUES (143,38834.984639475,38870.7303115708,508,NULL)
INSERT INTO SalesInvoice VALUES (144,38835.0660021237,38859.7781118582,548,NULL)
INSERT INTO SalesInvoice VALUES (145,38835.7298384057,38847.1129797267,503,NULL)
INSERT INTO SalesInvoice VALUES (146,38836.183196733,38863.5006625491,50,NULL)
INSERT INTO SalesInvoice VALUES (147,38836.800835898,38846.7940140774,106,NULL)
INSERT INTO SalesInvoice VALUES (148,38838.2015572901,38872.0212897629,575,NULL)
INSERT INTO SalesInvoice VALUES (149,38839.6229241889,38887.7595579459,760,NULL)
INSERT INTO SalesInvoice VALUES (150,38840.4910739342,38889.5052465576,748,NULL)
INSERT INTO SalesInvoice VALUES (151,38842.0638306078,38846.0229734834,227,NULL)
INSERT INTO SalesInvoice VALUES (152,38843.1908230821,38860.5248459542,626,NULL)
INSERT INTO SalesInvoice VALUES (153,38844.1039013877,38863.6495698738,549,NULL)
INSERT INTO SalesInvoice VALUES (154,38845.5274215553,38850.0824112374,190,NULL)
INSERT INTO SalesInvoice VALUES (155,38845.7324980353,38877.5736483172,100,NULL)
INSERT INTO SalesInvoice VALUES (156,38845.8764781043,38872.8922191662,522,NULL)
INSERT INTO SalesInvoice VALUES (157,38847.3606966436,38855.2048211128,441,NULL)
INSERT INTO SalesInvoice VALUES (158,38848.7463005567,38853.16437755,657,NULL)
INSERT INTO SalesInvoice VALUES (159,38848.7983947491,38878.6280836671,722,NULL)
INSERT INTO SalesInvoice VALUES (160,38849.2977282359,38864.7863765227,749,NULL)
INSERT INTO SalesInvoice VALUES (161,38849.673184963,38873.8748374418,8,NULL)
INSERT INTO SalesInvoice VALUES (162,38851.0230020711,38888.9245880664,726,NULL)
INSERT INTO SalesInvoice VALUES (163,38852.1656401434,38888.9915925949,650,NULL)
INSERT INTO SalesInvoice VALUES (164,38852.2779531091,38862.4976666685,405,NULL)
INSERT INTO SalesInvoice VALUES (165,38852.6549348954,38875.5702424186,202,NULL)
INSERT INTO SalesInvoice VALUES (166,38853.5374524316,38872.9057118015,424,NULL)
INSERT INTO SalesInvoice VALUES (167,38854.6035358201,38874.6960374788,504,NULL)
INSERT INTO SalesInvoice VALUES (168,38855.6263468577,38868.3656875914,259,NULL)
INSERT INTO SalesInvoice VALUES (169,38856.9920214311,38877.980118151,627,NULL)
INSERT INTO SalesInvoice VALUES (170,38857.1009048821,38859.4906160532,140,NULL)
INSERT INTO SalesInvoice VALUES (171,38857.8843843771,38893.5147327247,355,NULL)
INSERT INTO SalesInvoice VALUES (172,38859.1641420852,38900.6189928676,474,NULL)
INSERT INTO SalesInvoice VALUES (173,38860.2085493586,38865.7578303155,252,NULL)
INSERT INTO SalesInvoice VALUES (174,38861.7518927881,38875.9723227115,520,NULL)
INSERT INTO SalesInvoice VALUES (175,38863.2631540809,38882.1949173407,432,NULL)
INSERT INTO SalesInvoice VALUES (176,38863.8933685077,38879.4060923449,141,NULL)
INSERT INTO SalesInvoice VALUES (177,38865.2269537446,38875.678336191,629,NULL)
INSERT INTO SalesInvoice VALUES (178,38866.3480299692,38891.3308940614,33,NULL)
INSERT INTO SalesInvoice VALUES (179,38866.8323482919,38880.348318473,262,NULL)
INSERT INTO SalesInvoice VALUES (180,38867.7908937716,38915.8694205344,92,NULL)
INSERT INTO SalesInvoice VALUES (181,38868.1289702728,38900.4065969574,680,NULL)
INSERT INTO SalesInvoice VALUES (182,38868.9419809737,38905.2467948345,764,NULL)
INSERT INTO SalesInvoice VALUES (183,38869.3016182836,38914.933889246,185,NULL)
INSERT INTO SalesInvoice VALUES (184,38870.8197381834,38918.3509448993,586,NULL)
INSERT INTO SalesInvoice VALUES (185,38871.6525306361,38912.3503522265,291,NULL)
INSERT INTO SalesInvoice VALUES (186,38872.98968819,38904.970710833,575,NULL)
INSERT INTO SalesInvoice VALUES (187,38874.0913833376,38890.8178281897,398,NULL)
INSERT INTO SalesInvoice VALUES (188,38874.9540836065,38877.1784426462,585,NULL)
INSERT INTO SalesInvoice VALUES (189,38876.1018352205,38911.3165912994,702,NULL)
INSERT INTO SalesInvoice VALUES (190,38876.7817039389,38897.0419542401,247,NULL)
INSERT INTO SalesInvoice VALUES (191,38877.6935375405,38896.5097650189,756,NULL)
INSERT INTO SalesInvoice VALUES (192,38879.0851947667,38892.2363456918,454,NULL)
INSERT INTO SalesInvoice VALUES (193,38880.1953531212,38884.4260009711,588,NULL)
INSERT INTO SalesInvoice VALUES (194,38881.1829365724,38907.6924850074,116,NULL)
INSERT INTO SalesInvoice VALUES (195,38881.8098531677,38919.319744046,731,NULL)
INSERT INTO SalesInvoice VALUES (196,38882.088984574,38930.3645868381,234,NULL)
INSERT INTO SalesInvoice VALUES (197,38882.9999674676,38887.3362469464,349,NULL)
INSERT INTO SalesInvoice VALUES (198,38883.3991819584,38884.0789892952,369,NULL)
INSERT INTO SalesInvoice VALUES (199,38884.120460626,38912.6183224996,449,NULL)
INSERT INTO SalesInvoice VALUES (200,38885.4883417901,38909.1542606253,486,NULL)
INSERT INTO SalesInvoice VALUES (201,38886.4764076353,38887.1250095269,617,NULL)
INSERT INTO SalesInvoice VALUES (202,38887.5538053535,38890.1261233975,700,NULL)
INSERT INTO SalesInvoice VALUES (203,38888.3394684037,38911.6866870222,582,NULL)
INSERT INTO SalesInvoice VALUES (204,38888.9527340015,38936.3313504515,694,NULL)
INSERT INTO SalesInvoice VALUES (205,38888.9683797061,38894.3194654683,454,NULL)
INSERT INTO SalesInvoice VALUES (206,38889.853694368,38922.7005193337,355,NULL)
INSERT INTO SalesInvoice VALUES (207,38890.8299570312,38918.520426238,675,NULL)
INSERT INTO SalesInvoice VALUES (208,38891.8319039471,38927.3432702663,585,NULL)
INSERT INTO SalesInvoice VALUES (209,38893.3783660605,38922.4426997355,393,NULL)
INSERT INTO SalesInvoice VALUES (210,38894.1067555186,38928.6088633972,615,NULL)
INSERT INTO SalesInvoice VALUES (211,38894.4303938245,38936.5163679094,661,NULL)
INSERT INTO SalesInvoice VALUES (212,38895.0883121552,38907.0777357913,582,NULL)
INSERT INTO SalesInvoice VALUES (213,38895.5016497773,38926.4179169414,564,NULL)
INSERT INTO SalesInvoice VALUES (214,38897.0525989269,38931.7570047275,388,NULL)
INSERT INTO SalesInvoice VALUES (215,38898.194237062,38915.6020806129,52,NULL)
INSERT INTO SalesInvoice VALUES (216,38898.9602039369,38946.4503461022,94,NULL)
INSERT INTO SalesInvoice VALUES (217,38899.6399077378,38937.6779796738,623,NULL)
INSERT INTO SalesInvoice VALUES (218,38899.8114589051,38916.1485186006,512,NULL)
INSERT INTO SalesInvoice VALUES (219,38900.9700921843,38909.9593020426,91,NULL)
INSERT INTO SalesInvoice VALUES (220,38901.2313676839,38932.4759984343,621,NULL)
INSERT INTO SalesInvoice VALUES (221,38901.907887569,38948.5161852056,617,NULL)
INSERT INTO SalesInvoice VALUES (222,38902.9069609405,38947.3830414101,196,NULL)
INSERT INTO SalesInvoice VALUES (223,38903.1940319716,38904.6828548173,676,NULL)
INSERT INTO SalesInvoice VALUES (224,38903.6984185893,38924.8796219648,44,NULL)
INSERT INTO SalesInvoice VALUES (225,38904.5074369054,38946.3599058355,175,NULL)
INSERT INTO SalesInvoice VALUES (226,38905.0500784313,38950.0921752126,326,NULL)
INSERT INTO SalesInvoice VALUES (227,38906.6124980787,38944.6826444893,685,NULL)
INSERT INTO SalesInvoice VALUES (228,38907.9848268082,38914.1906549955,526,NULL)
INSERT INTO SalesInvoice VALUES (229,38908.047176674,38943.4616725779,596,NULL)
INSERT INTO SalesInvoice VALUES (230,38908.3992350438,38957.6474073869,105,NULL)
INSERT INTO SalesInvoice VALUES (231,38909.5099863014,38912.6612698928,428,NULL)
INSERT INTO SalesInvoice VALUES (232,38910.3769759721,38947.8033795708,549,NULL)
INSERT INTO SalesInvoice VALUES (233,38911.4181171355,38945.1278975122,464,NULL)
INSERT INTO SalesInvoice VALUES (234,38912.894474653,38953.7012928802,685,NULL)
INSERT INTO SalesInvoice VALUES (235,38913.284841221,38952.336600624,60,NULL)
INSERT INTO SalesInvoice VALUES (236,38914.1089644203,38924.9747336357,67,NULL)
INSERT INTO SalesInvoice VALUES (237,38914.527937348,38955.6232900102,733,NULL)
INSERT INTO SalesInvoice VALUES (238,38915.9582549562,38916.3222291877,702,NULL)
INSERT INTO SalesInvoice VALUES (239,38915.9711788715,38917.12562865,538,NULL)
INSERT INTO SalesInvoice VALUES (240,38916.5124171105,38935.3284769997,607,NULL)
INSERT INTO SalesInvoice VALUES (241,38917.8546715241,38927.3349397285,771,NULL)
INSERT INTO SalesInvoice VALUES (242,38917.9790274074,38933.5108376757,276,NULL)
INSERT INTO SalesInvoice VALUES (243,38918.3083171962,38946.8535510504,102,NULL)
INSERT INTO SalesInvoice VALUES (244,38919.3189261802,38962.8555458767,161,NULL)
INSERT INTO SalesInvoice VALUES (245,38920.5130371829,38952.2105127547,539,NULL)
INSERT INTO SalesInvoice VALUES (246,38921.1349277687,38948.3109850496,391,NULL)
INSERT INTO SalesInvoice VALUES (247,38921.7144373587,38957.6093005431,656,NULL)
INSERT INTO SalesInvoice VALUES (248,38923.1605106611,38944.298150079,739,NULL)
INSERT INTO SalesInvoice VALUES (249,38923.9719800583,38925.5378336134,376,NULL)
INSERT INTO SalesInvoice VALUES (250,38925.1801694276,38943.4118633594,26,NULL)
INSERT INTO SalesInvoice VALUES (251,38926.2773127573,38952.5411135717,635,NULL)
INSERT INTO SalesInvoice VALUES (252,38926.9672232058,38941.4251383222,713,NULL)
INSERT INTO SalesInvoice VALUES (253,38928.1106570758,38946.6216385736,771,NULL)
INSERT INTO SalesInvoice VALUES (254,38928.4763190984,38939.1596688232,207,NULL)
INSERT INTO SalesInvoice VALUES (255,38928.9884275972,38946.7764748095,62,NULL)
INSERT INTO SalesInvoice VALUES (256,38929.1799890555,38938.4145184751,371,NULL)
INSERT INTO SalesInvoice VALUES (257,38929.2301122861,38930.4651815079,289,NULL)
INSERT INTO SalesInvoice VALUES (258,38929.8141911377,38934.3020157585,260,NULL)
INSERT INTO SalesInvoice VALUES (259,38931.3192668176,38981.0448440909,387,NULL)
INSERT INTO SalesInvoice VALUES (260,38932.3979436512,38943.0099179466,184,NULL)
INSERT INTO SalesInvoice VALUES (261,38933.6329357497,38949.7927186737,516,NULL)
INSERT INTO SalesInvoice VALUES (262,38934.4114157589,38955.9161557788,529,NULL)
INSERT INTO SalesInvoice VALUES (263,38935.5362967368,38973.2518544114,747,NULL)
INSERT INTO SalesInvoice VALUES (264,38936.9018925915,38971.6666288157,361,NULL)
INSERT INTO SalesInvoice VALUES (265,38937.078282349,38967.5209270603,419,NULL)
INSERT INTO SalesInvoice VALUES (266,38937.600879455,38944.0455667695,238,NULL)
INSERT INTO SalesInvoice VALUES (267,38938.5486090875,38961.8650974069,237,NULL)
INSERT INTO SalesInvoice VALUES (268,38940.1123979432,38985.7932681216,160,NULL)
INSERT INTO SalesInvoice VALUES (269,38940.6949489331,38955.7371891584,692,NULL)
INSERT INTO SalesInvoice VALUES (270,38941.9360175049,38957.2197990595,242,NULL)
INSERT INTO SalesInvoice VALUES (271,38942.0215176129,38956.2769193091,63,NULL)
INSERT INTO SalesInvoice VALUES (272,38943.4994722728,38990.4028516784,662,NULL)
INSERT INTO SalesInvoice VALUES (273,38943.8004589407,38970.5327777343,444,NULL)
INSERT INTO SalesInvoice VALUES (274,38944.4881534001,38984.8651840509,375,NULL)
INSERT INTO SalesInvoice VALUES (275,38945.2911845235,38968.2636705657,534,NULL)
INSERT INTO SalesInvoice VALUES (276,38945.8087827582,38945.8153974831,371,NULL)
INSERT INTO SalesInvoice VALUES (277,38947.2871034333,38963.634992902,157,NULL)
INSERT INTO SalesInvoice VALUES (278,38947.3819688838,38953.9520186251,360,NULL)
INSERT INTO SalesInvoice VALUES (279,38948.4027246345,38957.1177101489,371,NULL)
INSERT INTO SalesInvoice VALUES (280,38949.8227829632,38978.0007858584,166,NULL)
INSERT INTO SalesInvoice VALUES (281,38950.2728693385,38999.0106922548,411,NULL)
INSERT INTO SalesInvoice VALUES (282,38951.8206677529,38967.0912302839,542,NULL)
INSERT INTO SalesInvoice VALUES (283,38951.9034830365,38956.1410924928,618,NULL)
INSERT INTO SalesInvoice VALUES (284,38952.2870025553,38979.4266499475,385,NULL)
INSERT INTO SalesInvoice VALUES (285,38952.5938275495,38975.1441519386,137,NULL)
INSERT INTO SalesInvoice VALUES (286,38953.3339662552,38978.6254758041,307,NULL)
INSERT INTO SalesInvoice VALUES (287,38954.8199069889,38970.165527768,656,NULL)
INSERT INTO SalesInvoice VALUES (288,38956.2498786701,38992.3468858765,241,NULL)
INSERT INTO SalesInvoice VALUES (289,38956.7514019753,38990.0006157942,53,NULL)
INSERT INTO SalesInvoice VALUES (290,38957.5445999165,38983.6274264416,397,NULL)
INSERT INTO SalesInvoice VALUES (291,38958.1516741433,39005.939981688,252,NULL)
INSERT INTO SalesInvoice VALUES (292,38958.9233817589,38959.9979952773,290,NULL)
INSERT INTO SalesInvoice VALUES (293,38959.3296017735,38990.7372556337,569,NULL)
INSERT INTO SalesInvoice VALUES (294,38960.3658375364,38996.8795608918,481,NULL)
INSERT INTO SalesInvoice VALUES (295,38961.1094057489,38985.9590599954,650,NULL)
INSERT INTO SalesInvoice VALUES (296,38962.1035222265,38972.5743629247,450,NULL)
INSERT INTO SalesInvoice VALUES (297,38962.390924525,38992.2485465958,558,NULL)
INSERT INTO SalesInvoice VALUES (298,38963.5224004087,39009.8117185164,393,NULL)
INSERT INTO SalesInvoice VALUES (299,38964.6373495467,39003.53016419,544,NULL)
INSERT INTO SalesInvoice VALUES (300,38965.2148658154,39014.2120576219,279,NULL)
INSERT INTO SalesInvoice VALUES (301,38966.082332703,39012.7972247636,523,NULL)
INSERT INTO SalesInvoice VALUES (302,38967.5531371819,38973.4796130975,385,NULL)
INSERT INTO SalesInvoice VALUES (303,38968.3918248465,38971.8438033335,120,NULL)
INSERT INTO SalesInvoice VALUES (304,38969.8168393054,39005.1503753123,554,NULL)
INSERT INTO SalesInvoice VALUES (305,38969.9826667905,39001.774156288,105,NULL)
INSERT INTO SalesInvoice VALUES (306,38970.4376633247,38985.2681803289,283,NULL)
INSERT INTO SalesInvoice VALUES (307,38971.770593359,38986.658529788,68,NULL)
INSERT INTO SalesInvoice VALUES (308,38971.8095135281,39018.4566190631,561,NULL)
INSERT INTO SalesInvoice VALUES (309,38973.261950449,38986.6637714849,509,NULL)
INSERT INTO SalesInvoice VALUES (310,38974.7601228662,39010.1980384453,368,NULL)
INSERT INTO SalesInvoice VALUES (311,38976.0872667574,39023.5168566124,384,NULL)
INSERT INTO SalesInvoice VALUES (312,38977.540801715,39012.2404438541,432,NULL)
INSERT INTO SalesInvoice VALUES (313,38978.0851176286,39007.7587853352,511,NULL)
INSERT INTO SalesInvoice VALUES (314,38978.977719154,39007.855778913,46,NULL)
INSERT INTO SalesInvoice VALUES (315,38979.0194878783,39010.0199013535,248,NULL)
INSERT INTO SalesInvoice VALUES (316,38979.3614630302,39002.0146764571,12,NULL)
INSERT INTO SalesInvoice VALUES (317,38980.0529175386,39018.3560429211,738,NULL)
INSERT INTO SalesInvoice VALUES (318,38980.552111787,39027.7744387256,12,NULL)
INSERT INTO SalesInvoice VALUES (319,38981.7271986719,38985.7124062051,773,NULL)
INSERT INTO SalesInvoice VALUES (320,38982.158027266,39008.4741580905,82,NULL)
INSERT INTO SalesInvoice VALUES (321,38982.8144075357,39025.9783828316,348,NULL)
INSERT INTO SalesInvoice VALUES (322,38983.0672495776,39013.3988609784,732,NULL)
INSERT INTO SalesInvoice VALUES (323,38984.2168084459,39013.6476880234,676,NULL)
INSERT INTO SalesInvoice VALUES (324,38985.0045907929,38996.8214859397,458,NULL)
INSERT INTO SalesInvoice VALUES (325,38986.102812699,39002.7104278363,445,NULL)
INSERT INTO SalesInvoice VALUES (326,38986.3998512648,38993.8242364494,456,NULL)
INSERT INTO SalesInvoice VALUES (327,38987.157125693,39005.6279406509,398,NULL)
INSERT INTO SalesInvoice VALUES (328,38988.1142875094,39017.5365671422,184,NULL)
INSERT INTO SalesInvoice VALUES (329,38989.192973726,38990.1428322752,597,NULL)
INSERT INTO SalesInvoice VALUES (330,38989.7156464207,39029.6078514808,387,NULL)
INSERT INTO SalesInvoice VALUES (331,38990.5363813159,39029.4733385039,372,NULL)
INSERT INTO SalesInvoice VALUES (332,38991.1606643758,39012.33309699,539,NULL)
INSERT INTO SalesInvoice VALUES (333,38991.5329334308,39040.1623366737,556,NULL)
INSERT INTO SalesInvoice VALUES (334,38992.712190282,39039.184341895,237,NULL)
INSERT INTO SalesInvoice VALUES (335,38992.782717515,39005.4173510933,139,NULL)
INSERT INTO SalesInvoice VALUES (336,38993.9428107336,39022.407673603,274,NULL)
INSERT INTO SalesInvoice VALUES (337,38995.2782721121,39009.1016313551,304,NULL)
INSERT INTO SalesInvoice VALUES (338,38995.9471598174,39026.4793250228,554,NULL)
INSERT INTO SalesInvoice VALUES (339,38997.2857872511,39016.4751025915,74,NULL)
INSERT INTO SalesInvoice VALUES (340,38998.3061932581,39004.6709802044,472,NULL)
INSERT INTO SalesInvoice VALUES (341,38999.3842981405,39043.0337857231,601,NULL)
INSERT INTO SalesInvoice VALUES (342,39000.0434807281,39036.6401701287,50,NULL)
INSERT INTO SalesInvoice VALUES (343,39000.0634828241,39035.742616199,584,NULL)
INSERT INTO SalesInvoice VALUES (344,39001.4402041461,39038.1076384362,367,NULL)
INSERT INTO SalesInvoice VALUES (345,39002.1276695994,39018.5454462358,155,NULL)
INSERT INTO SalesInvoice VALUES (346,39003.1105169998,39033.5308691545,254,NULL)
INSERT INTO SalesInvoice VALUES (347,39004.3873111286,39049.0932073771,307,NULL)
INSERT INTO SalesInvoice VALUES (348,39004.7589712217,39015.4112427823,31,NULL)
INSERT INTO SalesInvoice VALUES (349,39005.5057708872,39006.1549047651,216,NULL)
INSERT INTO SalesInvoice VALUES (350,39006.9836095906,39044.3166509483,15,NULL)
INSERT INTO SalesInvoice VALUES (351,39008.5055870782,39023.1821610954,673,NULL)
INSERT INTO SalesInvoice VALUES (352,39009.6610612374,39027.7093284112,182,NULL)
INSERT INTO SalesInvoice VALUES (353,39010.4598308719,39023.5982047463,68,NULL)
INSERT INTO SalesInvoice VALUES (354,39011.874205236,39045.1300054609,612,NULL)
INSERT INTO SalesInvoice VALUES (355,39013.4049571062,39038.8470441133,706,NULL)
INSERT INTO SalesInvoice VALUES (356,39014.6026630238,39039.5990668808,387,NULL)
INSERT INTO SalesInvoice VALUES (357,39015.7475715486,39053.130818897,143,NULL)
INSERT INTO SalesInvoice VALUES (358,39016.454077456,39058.0953419165,593,NULL)
INSERT INTO SalesInvoice VALUES (359,39017.5481669903,39020.6698202909,482,NULL)
INSERT INTO SalesInvoice VALUES (360,39018.9022441862,39057.3977372442,713,NULL)
INSERT INTO SalesInvoice VALUES (361,39019.20499984,39027.0779193616,576,NULL)
INSERT INTO SalesInvoice VALUES (362,39020.3767640738,39036.9514568513,494,NULL)
INSERT INTO SalesInvoice VALUES (363,39021.2764258601,39021.2899866883,755,NULL)
INSERT INTO SalesInvoice VALUES (364,39022.3590759305,39062.6838345491,408,NULL)
INSERT INTO SalesInvoice VALUES (365,39022.580828804,39039.4985462367,26,NULL)
INSERT INTO SalesInvoice VALUES (366,39023.7277966471,39036.9996207411,192,NULL)
INSERT INTO SalesInvoice VALUES (367,39024.0873204724,39054.4397923247,289,NULL)
INSERT INTO SalesInvoice VALUES (368,39025.3862062063,39047.5077966261,385,NULL)
INSERT INTO SalesInvoice VALUES (369,39026.7601105771,39040.6780798685,553,NULL)
INSERT INTO SalesInvoice VALUES (370,39027.4860692572,39053.2603911536,234,NULL)
INSERT INTO SalesInvoice VALUES (371,39028.9892687693,39074.9767481685,308,NULL)
INSERT INTO SalesInvoice VALUES (372,39029.0245899181,39077.4492443848,768,NULL)
INSERT INTO SalesInvoice VALUES (373,39030.3072996331,39066.6136295935,544,NULL)
INSERT INTO SalesInvoice VALUES (374,39030.307683287,39074.9715843925,142,NULL)
INSERT INTO SalesInvoice VALUES (375,39031.0759951795,39043.7674335729,392,NULL)
INSERT INTO SalesInvoice VALUES (376,39032.2718351427,39072.0627870855,309,NULL)
INSERT INTO SalesInvoice VALUES (377,39033.2649602057,39067.564774866,686,NULL)
INSERT INTO SalesInvoice VALUES (378,39034.6750366131,39057.1808920839,666,NULL)
INSERT INTO SalesInvoice VALUES (379,39034.9687368909,39064.0995537445,313,NULL)
INSERT INTO SalesInvoice VALUES (380,39035.2133298565,39071.2695128646,559,NULL)
INSERT INTO SalesInvoice VALUES (381,39036.2388358838,39048.6410132957,739,NULL)
INSERT INTO SalesInvoice VALUES (382,39037.4220515697,39082.2940227587,332,NULL)
INSERT INTO SalesInvoice VALUES (383,39037.9469173516,39074.2204362223,291,NULL)
INSERT INTO SalesInvoice VALUES (384,39038.6114193641,39071.792830885,210,NULL)
INSERT INTO SalesInvoice VALUES (385,39038.8706974851,39039.899445943,324,NULL)
INSERT INTO SalesInvoice VALUES (386,39039.7740164417,39073.1619962804,548,NULL)
INSERT INTO SalesInvoice VALUES (387,39040.5069626568,39054.4525651035,234,NULL)
INSERT INTO SalesInvoice VALUES (388,39041.7875114793,39058.1860733993,170,NULL)
INSERT INTO SalesInvoice VALUES (389,39042.7729745931,39044.1772760211,328,NULL)
INSERT INTO SalesInvoice VALUES (390,39043.8010751875,39050.5636174494,49,NULL)
INSERT INTO SalesInvoice VALUES (391,39044.7081674532,39072.7206972673,383,NULL)
INSERT INTO SalesInvoice VALUES (392,39044.8552599485,39078.6428549787,670,NULL)
INSERT INTO SalesInvoice VALUES (393,39045.9625817205,39055.0797631078,706,NULL)
INSERT INTO SalesInvoice VALUES (394,39046.7412516796,39059.1886605328,646,NULL)
INSERT INTO SalesInvoice VALUES (395,39047.586046039,39063.0523768845,240,NULL)
INSERT INTO SalesInvoice VALUES (396,39049.0076499772,39049.9849559848,513,NULL)
INSERT INTO SalesInvoice VALUES (397,39049.3946463379,39069.5063677764,317,NULL)
INSERT INTO SalesInvoice VALUES (398,39049.4150923705,39053.9745934227,515,NULL)
INSERT INTO SalesInvoice VALUES (399,39050.9845708051,39080.9203349164,113,NULL)
INSERT INTO SalesInvoice VALUES (400,39052.4993356037,39079.8569721495,356,NULL)
INSERT INTO SalesInvoice VALUES (401,39052.8138074006,39052.8983028233,712,NULL)
INSERT INTO SalesInvoice VALUES (402,39053.1591306901,39086.5058762783,43,NULL)
INSERT INTO SalesInvoice VALUES (403,39054.691737271,39065.4869065445,460,NULL)
INSERT INTO SalesInvoice VALUES (404,39054.8145447985,39068.6981044377,80,NULL)
INSERT INTO SalesInvoice VALUES (405,39055.4200540705,39100.5059875078,715,NULL)
INSERT INTO SalesInvoice VALUES (406,39056.6862518794,39096.0666412954,409,NULL)
INSERT INTO SalesInvoice VALUES (407,39057.7007231389,39089.9547996645,223,NULL)
INSERT INTO SalesInvoice VALUES (408,39058.5374574652,39097.9437806477,670,NULL)
INSERT INTO SalesInvoice VALUES (409,39059.9152659846,39079.7589313639,214,NULL)
INSERT INTO SalesInvoice VALUES (410,39060.9298229486,39088.4658325927,517,NULL)
INSERT INTO SalesInvoice VALUES (411,39061.1860256289,39074.2520929794,748,NULL)
INSERT INTO SalesInvoice VALUES (412,39062.3909988706,39104.1649505375,703,NULL)
INSERT INTO SalesInvoice VALUES (413,39063.7128354757,39066.7036395423,608,NULL)
INSERT INTO SalesInvoice VALUES (414,39064.7303799768,39083.9455060735,659,NULL)
INSERT INTO SalesInvoice VALUES (415,39065.583390414,39076.28995697,355,NULL)
INSERT INTO SalesInvoice VALUES (416,39066.3004939758,39106.3399991098,473,NULL)
INSERT INTO SalesInvoice VALUES (417,39066.7752014667,39069.3396786258,689,NULL)
INSERT INTO SalesInvoice VALUES (418,39067.5612948939,39068.757471071,732,NULL)
INSERT INTO SalesInvoice VALUES (419,39068.2953351568,39102.5087795126,665,NULL)
INSERT INTO SalesInvoice VALUES (420,39069.8202911963,39094.9071490961,89,NULL)
INSERT INTO SalesInvoice VALUES (421,39071.3529546447,39113.0939933625,139,NULL)
INSERT INTO SalesInvoice VALUES (422,39072.7449852343,39091.5435680947,242,NULL)
INSERT INTO SalesInvoice VALUES (423,39072.8282660932,39119.4339660784,155,NULL)
INSERT INTO SalesInvoice VALUES (424,39073.1099174541,39107.651506339,645,NULL)
INSERT INTO SalesInvoice VALUES (425,39073.9271844095,39119.4623028858,9,NULL)
INSERT INTO SalesInvoice VALUES (426,39074.1534431452,39107.0323525815,327,NULL)
INSERT INTO SalesInvoice VALUES (427,39074.9965055164,39093.9623973377,354,NULL)
INSERT INTO SalesInvoice VALUES (428,39075.5294406692,39102.7096595008,415,NULL)
INSERT INTO SalesInvoice VALUES (429,39076.7651127084,39090.9747327728,149,NULL)
INSERT INTO SalesInvoice VALUES (430,39076.9828680296,39080.8822693302,141,NULL)
INSERT INTO SalesInvoice VALUES (431,39077.3858829038,39113.568879503,252,NULL)
INSERT INTO SalesInvoice VALUES (432,39078.5920212691,39100.5979333901,477,NULL)
INSERT INTO SalesInvoice VALUES (433,39079.029613973,39081.0182950921,712,NULL)
INSERT INTO SalesInvoice VALUES (434,39079.2362890124,39092.328965994,153,NULL)
INSERT INTO SalesInvoice VALUES (435,39079.9226478778,39092.8547200663,628,NULL)
INSERT INTO SalesInvoice VALUES (436,39080.1421051113,39093.8592924529,405,NULL)
INSERT INTO SalesInvoice VALUES (437,39080.2340467462,39109.8034102473,425,NULL)
INSERT INTO SalesInvoice VALUES (438,39080.6488215587,39089.6265856348,78,NULL)
INSERT INTO SalesInvoice VALUES (439,39081.0540077001,39112.9787946142,46,NULL)
INSERT INTO SalesInvoice VALUES (440,39081.630098337,39116.2449641359,64,NULL)
INSERT INTO SalesInvoice VALUES (441,39082.3185510486,39127.4664786031,576,NULL)
INSERT INTO SalesInvoice VALUES (442,39083.5141493274,39091.2428322234,542,NULL)
INSERT INTO SalesInvoice VALUES (443,39083.8794921317,39088.6316779276,3,NULL)
INSERT INTO SalesInvoice VALUES (444,39085.3919539337,39126.0149355941,330,NULL)
INSERT INTO SalesInvoice VALUES (445,39085.7520107826,39128.2195615747,588,NULL)
INSERT INTO SalesInvoice VALUES (446,39085.8923743136,39103.9918555106,375,NULL)
INSERT INTO SalesInvoice VALUES (447,39086.6805975421,39106.2142160182,583,NULL)
INSERT INTO SalesInvoice VALUES (448,39088.1776218993,39116.8456016302,547,NULL)
INSERT INTO SalesInvoice VALUES (449,39089.6447032508,39119.8867856021,750,NULL)
INSERT INTO SalesInvoice VALUES (450,39089.7666478384,39112.21258116,720,NULL)
INSERT INTO SalesInvoice VALUES (451,39090.2940968349,39116.1048638892,594,NULL)
INSERT INTO SalesInvoice VALUES (452,39091.4937546959,39102.2264542891,281,NULL)
INSERT INTO SalesInvoice VALUES (453,39092.6229908701,39128.2149169233,516,NULL)
INSERT INTO SalesInvoice VALUES (454,39093.7669225666,39095.8210939603,686,NULL)
INSERT INTO SalesInvoice VALUES (455,39094.0586526605,39103.3476846668,96,NULL)
INSERT INTO SalesInvoice VALUES (456,39094.5480508704,39133.1909542391,602,NULL)
INSERT INTO SalesInvoice VALUES (457,39094.5516425863,39139.520033192,775,NULL)
INSERT INTO SalesInvoice VALUES (458,39096.0141241784,39136.8115998846,486,NULL)
INSERT INTO SalesInvoice VALUES (459,39096.7122725985,39135.4173426342,380,NULL)
INSERT INTO SalesInvoice VALUES (460,39097.2922158817,39112.07636993,306,NULL)
INSERT INTO SalesInvoice VALUES (461,39098.1556533481,39103.6603325258,474,NULL)
INSERT INTO SalesInvoice VALUES (462,39098.7742058858,39143.309708826,484,NULL)
INSERT INTO SalesInvoice VALUES (463,39099.540551811,39124.1311941461,162,NULL)
INSERT INTO SalesInvoice VALUES (464,39100.130906966,39143.8406130596,85,NULL)
INSERT INTO SalesInvoice VALUES (465,39100.6404131878,39125.0983504504,21,NULL)
INSERT INTO SalesInvoice VALUES (466,39100.7409967569,39107.8282870201,767,NULL)
INSERT INTO SalesInvoice VALUES (467,39100.8615116592,39140.0632979588,91,NULL)
INSERT INTO SalesInvoice VALUES (468,39101.350501835,39145.1090642919,643,NULL)
INSERT INTO SalesInvoice VALUES (469,39101.9588898207,39122.4392662246,551,NULL)
INSERT INTO SalesInvoice VALUES (470,39103.3627939378,39126.2061869353,701,NULL)
INSERT INTO SalesInvoice VALUES (471,39104.1212251271,39149.520974306,734,NULL)
INSERT INTO SalesInvoice VALUES (472,39104.6435418462,39119.650021286,684,NULL)
INSERT INTO SalesInvoice VALUES (473,39105.6772733883,39126.0698548602,94,NULL)
INSERT INTO SalesInvoice VALUES (474,39106.6946569454,39109.2881792737,34,NULL)
INSERT INTO SalesInvoice VALUES (475,39107.2722880438,39113.6061819948,59,NULL)
INSERT INTO SalesInvoice VALUES (476,39108.4039612062,39137.2554873474,29,NULL)
INSERT INTO SalesInvoice VALUES (477,39109.7891142664,39144.9454820944,495,NULL)
INSERT INTO SalesInvoice VALUES (478,39111.3082057317,39116.6412235083,233,NULL)
INSERT INTO SalesInvoice VALUES (479,39111.397546336,39148.8717959999,658,NULL)
INSERT INTO SalesInvoice VALUES (480,39111.6202039323,39113.3669235301,702,NULL)
INSERT INTO SalesInvoice VALUES (481,39111.8245791366,39135.0117765642,453,NULL)
INSERT INTO SalesInvoice VALUES (482,39111.9552373013,39125.7641363043,433,NULL)
INSERT INTO SalesInvoice VALUES (483,39113.4158164343,39149.9179137589,251,NULL)
INSERT INTO SalesInvoice VALUES (484,39114.2808356047,39116.6774602169,596,NULL)
INSERT INTO SalesInvoice VALUES (485,39115.2496071643,39123.8216807912,364,NULL)
INSERT INTO SalesInvoice VALUES (486,39116.2856559101,39128.0798698945,13,NULL)
INSERT INTO SalesInvoice VALUES (487,39116.9158028004,39127.2796917647,646,NULL)
INSERT INTO SalesInvoice VALUES (488,39117.3782514467,39133.2409559813,52,NULL)
INSERT INTO SalesInvoice VALUES (489,39117.9983142839,39153.0315243418,484,NULL)
INSERT INTO SalesInvoice VALUES (490,39119.292627775,39142.1132989098,12,NULL)
INSERT INTO SalesInvoice VALUES (491,39119.7820646461,39168.4335767677,263,NULL)
INSERT INTO SalesInvoice VALUES (492,39121.2311874686,39151.3965148547,353,NULL)
INSERT INTO SalesInvoice VALUES (493,39121.5693306276,39133.240288377,445,NULL)
INSERT INTO SalesInvoice VALUES (494,39121.7539435286,39131.466354506,753,NULL)
INSERT INTO SalesInvoice VALUES (495,39123.2439542974,39154.1040242237,11,NULL)
INSERT INTO SalesInvoice VALUES (496,39123.6236066869,39144.0770736584,361,NULL)
INSERT INTO SalesInvoice VALUES (497,39124.8385921702,39140.6611285414,394,NULL)
INSERT INTO SalesInvoice VALUES (498,39125.3848643569,39174.7697630252,79,NULL)
INSERT INTO SalesInvoice VALUES (499,39125.7764715655,39155.1539368392,62,NULL)
INSERT INTO SalesInvoice VALUES (500,39126.0620451334,39128.0773872082,103,NULL)
INSERT INTO SalesInvoice VALUES (501,39127.4016793736,39128.074121369,386,NULL)
INSERT INTO SalesInvoice VALUES (502,39128.9283212697,39148.8531336577,81,NULL)
INSERT INTO SalesInvoice VALUES (503,39129.0822753136,39177.3521677241,275,NULL)
INSERT INTO SalesInvoice VALUES (504,39130.4067354669,39164.1165638371,688,NULL)
INSERT INTO SalesInvoice VALUES (505,39131.8888014437,39136.7847119933,240,NULL)
INSERT INTO SalesInvoice VALUES (506,39132.3009568227,39158.4611822219,487,NULL)
INSERT INTO SalesInvoice VALUES (507,39133.6498393618,39179.1380235308,417,NULL)
INSERT INTO SalesInvoice VALUES (508,39135.188227747,39165.4398795184,7,NULL)
INSERT INTO SalesInvoice VALUES (509,39135.4571028284,39159.7814523378,405,NULL)
INSERT INTO SalesInvoice VALUES (510,39136.0142109291,39167.6541137358,34,NULL)
INSERT INTO SalesInvoice VALUES (511,39137.266638776,39139.3624730349,135,NULL)
INSERT INTO SalesInvoice VALUES (512,39138.282325986,39172.3621083935,212,NULL)
INSERT INTO SalesInvoice VALUES (513,39138.9367562289,39178.0617200502,240,NULL)
INSERT INTO SalesInvoice VALUES (514,39140.0858359517,39179.0760984088,704,NULL)
INSERT INTO SalesInvoice VALUES (515,39141.3644656486,39186.169523742,263,NULL)
INSERT INTO SalesInvoice VALUES (516,39141.4068161437,39189.3727125634,501,NULL)
INSERT INTO SalesInvoice VALUES (517,39141.5152469493,39163.6000175308,20,NULL)
INSERT INTO SalesInvoice VALUES (518,39141.6258707462,39145.5791275134,148,NULL)
INSERT INTO SalesInvoice VALUES (519,39142.03069566,39183.0398346172,642,NULL)
INSERT INTO SalesInvoice VALUES (520,39142.4213293651,39163.143744201,499,NULL)
INSERT INTO SalesInvoice VALUES (521,39142.4954531679,39151.7860267876,583,NULL)
INSERT INTO SalesInvoice VALUES (522,39142.6586795781,39168.2542058418,576,NULL)
INSERT INTO SalesInvoice VALUES (523,39142.7528206558,39184.8851429825,472,NULL)
INSERT INTO SalesInvoice VALUES (524,39143.7269823886,39169.8542996148,123,NULL)
INSERT INTO SalesInvoice VALUES (525,39143.9605425199,39178.009506353,677,NULL)
INSERT INTO SalesInvoice VALUES (526,39145.2487306284,39181.5263745253,250,NULL)
INSERT INTO SalesInvoice VALUES (527,39146.2950814656,39161.6516498233,639,NULL)
INSERT INTO SalesInvoice VALUES (528,39146.8630391522,39162.505672604,334,NULL)
INSERT INTO SalesInvoice VALUES (529,39147.9939273202,39150.2529262653,685,NULL)
INSERT INTO SalesInvoice VALUES (530,39148.8706058137,39192.9722162479,142,NULL)
INSERT INTO SalesInvoice VALUES (531,39148.9491270995,39175.9510365113,104,NULL)
INSERT INTO SalesInvoice VALUES (532,39149.6317327435,39177.3801008864,123,NULL)
INSERT INTO SalesInvoice VALUES (533,39150.6950566343,39178.2027524063,308,NULL)
INSERT INTO SalesInvoice VALUES (534,39152.104358147,39183.1796713422,360,NULL)
INSERT INTO SalesInvoice VALUES (535,39152.4498564016,39196.4920668979,155,NULL)
INSERT INTO SalesInvoice VALUES (536,39153.4369954446,39187.1452983616,424,NULL)
INSERT INTO SalesInvoice VALUES (537,39153.5232770725,39201.9708523934,245,NULL)
INSERT INTO SalesInvoice VALUES (538,39153.8089140994,39176.6147063703,505,NULL)
INSERT INTO SalesInvoice VALUES (539,39154.4938425061,39161.8422270945,406,NULL)
INSERT INTO SalesInvoice VALUES (540,39155.9468463412,39204.4708995185,509,NULL)
INSERT INTO SalesInvoice VALUES (541,39157.2986409578,39172.8147347212,492,NULL)
INSERT INTO SalesInvoice VALUES (542,39157.4695541899,39204.4663261081,708,NULL)
INSERT INTO SalesInvoice VALUES (543,39158.3433894215,39204.6262781232,268,NULL)
INSERT INTO SalesInvoice VALUES (544,39159.7598237751,39187.2428184663,534,NULL)
INSERT INTO SalesInvoice VALUES (545,39160.3171777851,39182.3825165821,503,NULL)
INSERT INTO SalesInvoice VALUES (546,39160.5087305031,39196.5838801678,474,NULL)
INSERT INTO SalesInvoice VALUES (547,39160.8908651827,39197.2855547745,526,NULL)
INSERT INTO SalesInvoice VALUES (548,39162.4729725798,39197.26717333,264,NULL)
INSERT INTO SalesInvoice VALUES (549,39163.9511040105,39178.9864235405,145,NULL)
INSERT INTO SalesInvoice VALUES (550,39165.0975583096,39166.0058418872,282,NULL)
INSERT INTO SalesInvoice VALUES (551,39165.9108049039,39212.683705323,753,NULL)
INSERT INTO SalesInvoice VALUES (552,39166.2380615299,39189.7595019121,310,NULL)
INSERT INTO SalesInvoice VALUES (553,39167.7654119495,39179.8192892564,364,NULL)
INSERT INTO SalesInvoice VALUES (554,39168.6975038235,39217.6560483427,344,NULL)
INSERT INTO SalesInvoice VALUES (555,39170.0113256817,39179.6772060233,202,NULL)
INSERT INTO SalesInvoice VALUES (556,39170.9198757507,39206.1987324567,642,NULL)
INSERT INTO SalesInvoice VALUES (557,39171.0152385088,39191.1050064763,73,NULL)
INSERT INTO SalesInvoice VALUES (558,39171.3624394375,39200.7671010955,521,NULL)
INSERT INTO SalesInvoice VALUES (559,39171.4873556708,39198.853740874,167,NULL)
INSERT INTO SalesInvoice VALUES (560,39172.376972851,39177.0033932315,75,NULL)
INSERT INTO SalesInvoice VALUES (561,39172.9907950209,39207.0856211145,412,NULL)
INSERT INTO SalesInvoice VALUES (562,39173.5398055663,39219.4639806812,762,NULL)
INSERT INTO SalesInvoice VALUES (563,39174.9178706109,39213.1678531528,211,NULL)
INSERT INTO SalesInvoice VALUES (564,39176.0324390134,39202.564676468,493,NULL)
INSERT INTO SalesInvoice VALUES (565,39176.1222640003,39184.0847463268,208,NULL)
INSERT INTO SalesInvoice VALUES (566,39176.837837481,39184.1718244712,140,NULL)
INSERT INTO SalesInvoice VALUES (567,39178.3780747099,39218.6469898924,333,NULL)
INSERT INTO SalesInvoice VALUES (568,39179.050165423,39218.0090302495,550,NULL)
INSERT INTO SalesInvoice VALUES (569,39180.4836958017,39227.5736787239,591,NULL)
INSERT INTO SalesInvoice VALUES (570,39181.8529133116,39195.4131569001,149,NULL)
INSERT INTO SalesInvoice VALUES (571,39183.3072881136,39189.2151848923,450,NULL)
INSERT INTO SalesInvoice VALUES (572,39184.0360833564,39206.8318620499,148,NULL)
INSERT INTO SalesInvoice VALUES (573,39185.2927469233,39213.0390988573,183,NULL)
INSERT INTO SalesInvoice VALUES (574,39185.6211277902,39196.9113699991,185,NULL)
INSERT INTO SalesInvoice VALUES (575,39186.5761653778,39223.1136960806,468,NULL)
INSERT INTO SalesInvoice VALUES (576,39186.9452906777,39188.1911241639,574,NULL)
INSERT INTO SalesInvoice VALUES (577,39187.7142663869,39212.7496975871,205,NULL)
INSERT INTO SalesInvoice VALUES (578,39188.9459757212,39201.8641419334,478,NULL)
INSERT INTO SalesInvoice VALUES (579,39189.2105102036,39236.6195885029,80,NULL)
INSERT INTO SalesInvoice VALUES (580,39190.0289337494,39204.3870059224,496,NULL)
INSERT INTO SalesInvoice VALUES (581,39190.2996031564,39212.9009543247,765,NULL)
INSERT INTO SalesInvoice VALUES (582,39191.0652857383,39233.9060604348,463,NULL)
INSERT INTO SalesInvoice VALUES (583,39191.6335495301,39199.3088967319,132,NULL)
INSERT INTO SalesInvoice VALUES (584,39192.4369301831,39229.0729743229,559,NULL)
INSERT INTO SalesInvoice VALUES (585,39193.6919331977,39220.5949508619,747,NULL)
INSERT INTO SalesInvoice VALUES (586,39195.1114951323,39220.9820518281,574,NULL)
INSERT INTO SalesInvoice VALUES (587,39196.2094685178,39232.8547983043,585,NULL)
INSERT INTO SalesInvoice VALUES (588,39196.5833387601,39225.0786254177,754,NULL)
INSERT INTO SalesInvoice VALUES (589,39196.6537259907,39224.4485148344,550,NULL)
INSERT INTO SalesInvoice VALUES (590,39197.0042244799,39234.1784260752,663,NULL)
INSERT INTO SalesInvoice VALUES (591,39198.2740519138,39219.3922675133,405,NULL)
INSERT INTO SalesInvoice VALUES (592,39199.4222823366,39226.481751775,384,NULL)
INSERT INTO SalesInvoice VALUES (593,39200.6578270113,39216.4911055711,608,NULL)
INSERT INTO SalesInvoice VALUES (594,39201.9613087077,39226.5106880361,67,NULL)
INSERT INTO SalesInvoice VALUES (595,39202.643452162,39246.5612713268,624,NULL)
INSERT INTO SalesInvoice VALUES (596,39204.0661412807,39209.069924409,212,NULL)
INSERT INTO SalesInvoice VALUES (597,39204.9205048364,39250.0388455854,209,NULL)
INSERT INTO SalesInvoice VALUES (598,39205.6046960677,39223.8764486926,279,NULL)
INSERT INTO SalesInvoice VALUES (599,39207.020147575,39229.3261398477,58,NULL)
INSERT INTO SalesInvoice VALUES (600,39207.8345438075,39240.6500443336,136,NULL)
INSERT INTO SalesInvoice VALUES (601,39208.6589719465,39221.5124763632,701,NULL)
INSERT INTO SalesInvoice VALUES (602,39210.0521918964,39219.3642345136,221,NULL)
INSERT INTO SalesInvoice VALUES (603,39211.1339593353,39252.9562282278,22,NULL)
INSERT INTO SalesInvoice VALUES (604,39212.2597362263,39235.9532984787,730,NULL)
INSERT INTO SalesInvoice VALUES (605,39212.9849269816,39236.9535013701,469,NULL)
INSERT INTO SalesInvoice VALUES (606,39213.6399450551,39215.2990299626,164,NULL)
INSERT INTO SalesInvoice VALUES (607,39214.4750024081,39246.4654723929,563,NULL)
INSERT INTO SalesInvoice VALUES (608,39215.3974988313,39243.9834891825,17,NULL)
INSERT INTO SalesInvoice VALUES (609,39216.5553158033,39262.9987241557,83,NULL)
INSERT INTO SalesInvoice VALUES (610,39217.9432557617,39262.690423381,463,NULL)
INSERT INTO SalesInvoice VALUES (611,39217.9731983199,39257.5218977855,385,NULL)
INSERT INTO SalesInvoice VALUES (612,39218.4568246908,39234.7436496946,456,NULL)
INSERT INTO SalesInvoice VALUES (613,39220.0221013358,39233.5011264569,408,NULL)
INSERT INTO SalesInvoice VALUES (614,39220.4582001608,39225.0130798101,41,NULL)
INSERT INTO SalesInvoice VALUES (615,39221.7114061312,39258.3737598156,760,NULL)
INSERT INTO SalesInvoice VALUES (616,39222.5262053491,39244.7783729179,717,NULL)
INSERT INTO SalesInvoice VALUES (617,39223.9763013889,39246.2773978328,54,NULL)
INSERT INTO SalesInvoice VALUES (618,39224.7271608349,39274.6069203837,750,NULL)
INSERT INTO SalesInvoice VALUES (619,39226.0411915295,39253.0134477083,684,NULL)
INSERT INTO SalesInvoice VALUES (620,39227.6213757758,39274.8159017891,30,NULL)
INSERT INTO SalesInvoice VALUES (621,39227.8713925135,39261.3576453065,105,NULL)
INSERT INTO SalesInvoice VALUES (622,39229.0974395978,39268.5484370221,594,NULL)
INSERT INTO SalesInvoice VALUES (623,39230.3034251244,39274.0819688043,463,NULL)
INSERT INTO SalesInvoice VALUES (624,39230.6244643117,39254.076251716,319,NULL)
INSERT INTO SalesInvoice VALUES (625,39230.9983624121,39235.3343042262,185,NULL)
INSERT INTO SalesInvoice VALUES (626,39232.1434989635,39237.0187618394,217,NULL)
INSERT INTO SalesInvoice VALUES (627,39233.4427319755,39246.4912519843,66,NULL)
INSERT INTO SalesInvoice VALUES (628,39233.6510703789,39245.3641340059,21,NULL)
INSERT INTO SalesInvoice VALUES (629,39234.105831463,39261.1620391605,447,NULL)
INSERT INTO SalesInvoice VALUES (630,39234.8932569378,39263.3720210891,621,NULL)
INSERT INTO SalesInvoice VALUES (631,39235.1357306022,39268.9552384823,68,NULL)
INSERT INTO SalesInvoice VALUES (632,39236.674064538,39239.8450153808,739,NULL)
INSERT INTO SalesInvoice VALUES (633,39237.8178788938,39243.490853437,493,NULL)
INSERT INTO SalesInvoice VALUES (634,39239.1699508816,39258.1635977644,496,NULL)
INSERT INTO SalesInvoice VALUES (635,39240.3204767098,39278.1147749451,422,NULL)
INSERT INTO SalesInvoice VALUES (636,39241.4485788206,39288.289258553,113,NULL)
INSERT INTO SalesInvoice VALUES (637,39242.7482905127,39249.1038568525,44,NULL)
INSERT INTO SalesInvoice VALUES (638,39243.3430623996,39243.6119189639,21,NULL)
INSERT INTO SalesInvoice VALUES (639,39243.6443707938,39282.1583526454,388,NULL)
INSERT INTO SalesInvoice VALUES (640,39244.923424489,39245.4918130646,774,NULL)
INSERT INTO SalesInvoice VALUES (641,39245.4683762719,39292.4101168527,298,NULL)
INSERT INTO SalesInvoice VALUES (642,39245.7168246449,39280.5939492774,576,NULL)
INSERT INTO SalesInvoice VALUES (643,39246.551201555,39256.4272952859,13,NULL)
INSERT INTO SalesInvoice VALUES (644,39247.6367881828,39273.5927929236,156,NULL)
INSERT INTO SalesInvoice VALUES (645,39248.4979759796,39259.9428771627,201,NULL)
INSERT INTO SalesInvoice VALUES (646,39249.9927568755,39266.6695212452,580,NULL)
INSERT INTO SalesInvoice VALUES (647,39251.2959699024,39268.5182238959,770,NULL)
INSERT INTO SalesInvoice VALUES (648,39251.7602344767,39277.6053236161,502,NULL)
INSERT INTO SalesInvoice VALUES (649,39252.6094325247,39296.9566132419,524,NULL)
INSERT INTO SalesInvoice VALUES (650,39254.0137145395,39297.7162544108,651,NULL)
INSERT INTO SalesInvoice VALUES (651,39254.0593345443,39254.9325318524,592,NULL)
INSERT INTO SalesInvoice VALUES (652,39254.27565133,39285.1442821389,71,NULL)
INSERT INTO SalesInvoice VALUES (653,39255.2358098141,39256.7556435447,268,NULL)
INSERT INTO SalesInvoice VALUES (654,39256.328153695,39297.0582568183,37,NULL)
INSERT INTO SalesInvoice VALUES (655,39257.1611172433,39289.3645865411,748,NULL)
INSERT INTO SalesInvoice VALUES (656,39258.1939417988,39263.4670689422,585,NULL)
INSERT INTO SalesInvoice VALUES (657,39258.9420578254,39281.6181774369,311,NULL)
INSERT INTO SalesInvoice VALUES (658,39259.0699221558,39308.8005866579,337,NULL)
INSERT INTO SalesInvoice VALUES (659,39260.4714472879,39300.9669288328,485,NULL)
INSERT INTO SalesInvoice VALUES (660,39260.6713838591,39292.6710028324,299,NULL)
INSERT INTO SalesInvoice VALUES (661,39261.8152189329,39267.8537627803,312,NULL)
INSERT INTO SalesInvoice VALUES (662,39262.5906837602,39288.4583102604,289,NULL)
INSERT INTO SalesInvoice VALUES (663,39263.9615614068,39284.8922353039,446,NULL)
INSERT INTO SalesInvoice VALUES (664,39264.3505263547,39303.1824527056,607,NULL)
INSERT INTO SalesInvoice VALUES (665,39264.6969570574,39271.0329868513,443,NULL)
INSERT INTO SalesInvoice VALUES (666,39265.2845204613,39296.3456725901,244,NULL)
INSERT INTO SalesInvoice VALUES (667,39265.6159457961,39284.6300085552,252,NULL)
INSERT INTO SalesInvoice VALUES (668,39267.014045132,39283.2634799483,261,NULL)
INSERT INTO SalesInvoice VALUES (669,39268.4121111372,39294.3441815475,480,NULL)
INSERT INTO SalesInvoice VALUES (670,39269.3812579009,39301.7126547344,245,NULL)
INSERT INTO SalesInvoice VALUES (671,39270.048998091,39315.8844652547,168,NULL)
INSERT INTO SalesInvoice VALUES (672,39270.7946696586,39294.1831122613,476,NULL)
INSERT INTO SalesInvoice VALUES (673,39272.2023623238,39308.2722828266,441,NULL)
INSERT INTO SalesInvoice VALUES (674,39273.5784520813,39286.6646377978,294,NULL)
INSERT INTO SalesInvoice VALUES (675,39273.7004823597,39310.3606975733,531,NULL)
INSERT INTO SalesInvoice VALUES (676,39273.7757866465,39322.8996131168,226,NULL)
INSERT INTO SalesInvoice VALUES (677,39274.665435869,39323.3250162699,538,NULL)
INSERT INTO SalesInvoice VALUES (678,39275.6337538069,39289.1685262238,107,NULL)
INSERT INTO SalesInvoice VALUES (679,39276.5902944724,39304.5629415099,88,NULL)
INSERT INTO SalesInvoice VALUES (680,39277.915037382,39297.4376255197,148,NULL)
INSERT INTO SalesInvoice VALUES (681,39278.2967835651,39284.4663279557,68,NULL)
INSERT INTO SalesInvoice VALUES (682,39278.9827386976,39281.5562215444,543,NULL)
INSERT INTO SalesInvoice VALUES (683,39280.055176629,39291.0055457991,86,NULL)
INSERT INTO SalesInvoice VALUES (684,39280.2919380548,39300.5824973151,497,NULL)
INSERT INTO SalesInvoice VALUES (685,39281.7559409841,39326.9113963005,331,NULL)
INSERT INTO SalesInvoice VALUES (686,39282.0755306725,39288.5596235427,217,NULL)
INSERT INTO SalesInvoice VALUES (687,39283.3777017503,39323.6171006252,251,NULL)
INSERT INTO SalesInvoice VALUES (688,39284.8354063402,39312.3937764428,773,NULL)
INSERT INTO SalesInvoice VALUES (689,39285.7808436252,39316.1052315842,155,NULL)
INSERT INTO SalesInvoice VALUES (690,39286.5837904046,39308.7251680898,571,NULL)
INSERT INTO SalesInvoice VALUES (691,39286.6157067093,39294.9675547171,506,NULL)
INSERT INTO SalesInvoice VALUES (692,39286.7921731136,39297.2106960132,358,NULL)
INSERT INTO SalesInvoice VALUES (693,39286.9228346427,39299.4823686581,204,NULL)
INSERT INTO SalesInvoice VALUES (694,39287.1408473197,39308.5286627906,236,NULL)
INSERT INTO SalesInvoice VALUES (695,39287.3043298151,39312.4392590959,143,NULL)
INSERT INTO SalesInvoice VALUES (696,39287.3661000531,39303.4089346031,647,NULL)
INSERT INTO SalesInvoice VALUES (697,39288.6293135485,39300.7687282665,461,NULL)
INSERT INTO SalesInvoice VALUES (698,39290.0847014055,39326.5023486817,138,NULL)
INSERT INTO SalesInvoice VALUES (699,39290.3722956989,39296.4501013844,600,NULL)
INSERT INTO SalesInvoice VALUES (700,39290.4658833396,39318.7586868743,125,NULL)
INSERT INTO SalesInvoice VALUES (701,39291.562457661,39337.0600132996,57,NULL)
INSERT INTO SalesInvoice VALUES (702,39292.5672632573,39336.9134333502,684,NULL)
INSERT INTO SalesInvoice VALUES (703,39293.6601076877,39329.5834404466,94,NULL)
INSERT INTO SalesInvoice VALUES (704,39294.9827343116,39333.0564056465,174,NULL)
INSERT INTO SalesInvoice VALUES (705,39295.9015496678,39335.9424570012,25,NULL)
INSERT INTO SalesInvoice VALUES (706,39296.6879299338,39345.1627988039,761,NULL)
INSERT INTO SalesInvoice VALUES (707,39296.8728858069,39322.2150883254,126,NULL)
INSERT INTO SalesInvoice VALUES (708,39297.1580642539,39303.4366897978,408,NULL)
INSERT INTO SalesInvoice VALUES (709,39297.3904739217,39318.7915309932,663,NULL)
INSERT INTO SalesInvoice VALUES (710,39298.5596729801,39336.934416052,648,NULL)
INSERT INTO SalesInvoice VALUES (711,39299.4172492971,39324.0688933638,150,NULL)
INSERT INTO SalesInvoice VALUES (712,39300.9340436696,39335.0000443849,536,NULL)
INSERT INTO SalesInvoice VALUES (713,39302.2601652376,39345.7485367898,184,NULL)
INSERT INTO SalesInvoice VALUES (714,39303.7702838575,39344.0858665641,425,NULL)
INSERT INTO SalesInvoice VALUES (715,39304.9218365675,39353.1029084846,540,NULL)
INSERT INTO SalesInvoice VALUES (716,39305.3822109065,39340.4237469261,727,NULL)
INSERT INTO SalesInvoice VALUES (717,39306.7424950989,39337.2017206499,37,NULL)
INSERT INTO SalesInvoice VALUES (718,39307.0431593591,39339.6151564931,685,NULL)
INSERT INTO SalesInvoice VALUES (719,39307.9184296913,39345.5514304882,505,NULL)
INSERT INTO SalesInvoice VALUES (720,39309.2669766023,39331.4806162931,361,NULL)
INSERT INTO SalesInvoice VALUES (721,39310.6960293622,39327.3069754357,125,NULL)
INSERT INTO SalesInvoice VALUES (722,39311.7240611273,39345.3118516601,11,NULL)
INSERT INTO SalesInvoice VALUES (723,39313.2332423747,39344.6510856269,535,NULL)
INSERT INTO SalesInvoice VALUES (724,39313.4949445098,39357.3714546993,601,NULL)
INSERT INTO SalesInvoice VALUES (725,39314.237168259,39338.3126500348,412,NULL)
INSERT INTO SalesInvoice VALUES (726,39314.5189346138,39353.0222891244,426,NULL)
INSERT INTO SalesInvoice VALUES (727,39314.9518831573,39330.961157881,569,NULL)
INSERT INTO SalesInvoice VALUES (728,39316.3783582338,39329.2000341478,344,NULL)
INSERT INTO SalesInvoice VALUES (729,39316.3820158286,39343.8499275983,188,NULL)
INSERT INTO SalesInvoice VALUES (730,39317.31852464,39358.2535074746,315,NULL)
INSERT INTO SalesInvoice VALUES (731,39318.5102625309,39332.01917417,339,NULL)
INSERT INTO SalesInvoice VALUES (732,39319.0309784519,39343.6282664195,566,NULL)
INSERT INTO SalesInvoice VALUES (733,39320.2548664988,39353.3922920293,480,NULL)
INSERT INTO SalesInvoice VALUES (734,39321.5234305571,39346.4027232398,372,NULL)
INSERT INTO SalesInvoice VALUES (735,39322.2433620723,39369.2413259587,12,NULL)
INSERT INTO SalesInvoice VALUES (736,39323.0678111255,39350.0211451487,184,NULL)
INSERT INTO SalesInvoice VALUES (737,39323.3184992519,39372.3266208901,72,NULL)
INSERT INTO SalesInvoice VALUES (738,39323.8732636587,39330.2433113512,638,NULL)
INSERT INTO SalesInvoice VALUES (739,39324.6380723252,39341.8890949334,738,NULL)
INSERT INTO SalesInvoice VALUES (740,39325.4447873842,39374.1463897425,428,NULL)
INSERT INTO SalesInvoice VALUES (741,39326.1057195636,39359.3456210591,406,NULL)
INSERT INTO SalesInvoice VALUES (742,39327.2211608801,39364.0991582344,104,NULL)
INSERT INTO SalesInvoice VALUES (743,39327.5769041902,39339.5270500938,402,NULL)
INSERT INTO SalesInvoice VALUES (744,39328.9259251612,39369.4254879566,335,NULL)
INSERT INTO SalesInvoice VALUES (745,39330.3342076177,39352.3000611383,252,NULL)
INSERT INTO SalesInvoice VALUES (746,39331.1701894661,39333.7180767101,736,NULL)
INSERT INTO SalesInvoice VALUES (747,39332.1213986203,39379.0864377964,191,NULL)
INSERT INTO SalesInvoice VALUES (748,39333.2536205224,39379.82090566,713,NULL)
INSERT INTO SalesInvoice VALUES (749,39334.4460400752,39344.241790469,665,NULL)
INSERT INTO SalesInvoice VALUES (750,39335.937803934,39374.2053553192,636,NULL)
INSERT INTO SalesInvoice VALUES (751,39335.99633517,39344.6342800059,101,NULL)
INSERT INTO SalesInvoice VALUES (752,39337.4585982601,39375.3348442985,480,NULL)
INSERT INTO SalesInvoice VALUES (753,39338.0411554657,39380.2128856938,461,NULL)
INSERT INTO SalesInvoice VALUES (754,39338.1208099814,39360.8728445876,749,NULL)
INSERT INTO SalesInvoice VALUES (755,39338.3798299745,39349.8786244683,321,NULL)
INSERT INTO SalesInvoice VALUES (756,39338.5981831618,39382.6509698284,198,NULL)
INSERT INTO SalesInvoice VALUES (757,39339.7229062316,39383.5156053712,376,NULL)
INSERT INTO SalesInvoice VALUES (758,39340.1219445528,39342.4904134439,560,NULL)
INSERT INTO SalesInvoice VALUES (759,39340.4687592433,39367.1029702351,40,NULL)
INSERT INTO SalesInvoice VALUES (760,39341.0440898162,39384.0395912115,414,NULL)
INSERT INTO SalesInvoice VALUES (761,39341.642010133,39345.2456810696,773,NULL)
INSERT INTO SalesInvoice VALUES (762,39342.0585221835,39349.1548281183,650,NULL)
INSERT INTO SalesInvoice VALUES (763,39343.4766481643,39363.8493014186,708,NULL)
INSERT INTO SalesInvoice VALUES (764,39343.778756534,39384.645277567,588,NULL)
INSERT INTO SalesInvoice VALUES (765,39345.0796226136,39370.1534385901,190,NULL)
INSERT INTO SalesInvoice VALUES (766,39345.7536526776,39383.7327373564,659,NULL)
INSERT INTO SalesInvoice VALUES (767,39346.0895734253,39350.4945840396,41,NULL)
INSERT INTO SalesInvoice VALUES (768,39346.2831449348,39362.09363266,342,NULL)
INSERT INTO SalesInvoice VALUES (769,39347.5896740366,39361.9292819951,100,NULL)
INSERT INTO SalesInvoice VALUES (770,39348.5010905272,39363.027977384,264,NULL)
INSERT INTO SalesInvoice VALUES (771,39349.2479873855,39377.0550375921,377,NULL)
INSERT INTO SalesInvoice VALUES (772,39350.6873586073,39383.5333028069,191,NULL)
INSERT INTO SalesInvoice VALUES (773,39351.2877295592,39363.4154389196,402,NULL)
INSERT INTO SalesInvoice VALUES (774,39352.4222720099,39387.5104131707,770,NULL)
INSERT INTO SalesInvoice VALUES (775,39353.2652547721,39400.9215253963,58,NULL)
INSERT INTO SalesInvoice VALUES (776,39353.6672007147,39361.6261081228,300,NULL)
INSERT INTO SalesInvoice VALUES (777,39354.7382924203,39400.2015020944,680,NULL)
INSERT INTO SalesInvoice VALUES (778,39355.5784871589,39403.3460009672,12,NULL)
INSERT INTO SalesInvoice VALUES (779,39355.7763774976,39364.0932829054,188,NULL)
INSERT INTO SalesInvoice VALUES (780,39357.1780597917,39370.0497349834,295,NULL)
INSERT INTO SalesInvoice VALUES (781,39357.4836411197,39385.5835073806,32,NULL)
INSERT INTO SalesInvoice VALUES (782,39358.3868855091,39382.6883125875,497,NULL)
INSERT INTO SalesInvoice VALUES (783,39359.7862533407,39398.9077150293,463,NULL)
INSERT INTO SalesInvoice VALUES (784,39361.021988525,39385.2381896623,154,NULL)
INSERT INTO SalesInvoice VALUES (785,39362.4276005351,39399.0071799493,29,NULL)
INSERT INTO SalesInvoice VALUES (786,39363.8730497728,39403.3966997437,534,NULL)
INSERT INTO SalesInvoice VALUES (787,39365.0701841215,39410.513872896,345,NULL)
INSERT INTO SalesInvoice VALUES (788,39365.1123425879,39406.8871143565,411,NULL)
INSERT INTO SalesInvoice VALUES (789,39366.5564286545,39389.8082800643,583,NULL)
INSERT INTO SalesInvoice VALUES (790,39367.953289012,39392.7605357946,677,NULL)
INSERT INTO SalesInvoice VALUES (791,39368.6531216069,39400.3780653728,627,NULL)
INSERT INTO SalesInvoice VALUES (792,39369.6557235519,39404.99584653,471,NULL)
INSERT INTO SalesInvoice VALUES (793,39370.701350965,39379.94632867,536,NULL)
INSERT INTO SalesInvoice VALUES (794,39371.7323813492,39386.8232588774,556,NULL)
INSERT INTO SalesInvoice VALUES (795,39372.2680154249,39406.0660990329,682,NULL)
INSERT INTO SalesInvoice VALUES (796,39373.0601395359,39413.7917600975,538,NULL)
INSERT INTO SalesInvoice VALUES (797,39373.6005117069,39403.5778794948,722,NULL)
INSERT INTO SalesInvoice VALUES (798,39373.6902796093,39402.2721662296,471,NULL)
INSERT INTO SalesInvoice VALUES (799,39373.8259204034,39413.618976786,122,NULL)
INSERT INTO SalesInvoice VALUES (800,39374.7481572316,39412.3217373258,577,NULL)
INSERT INTO SalesInvoice VALUES (801,39376.0646562005,39376.1127168054,272,NULL)
INSERT INTO SalesInvoice VALUES (802,39376.573433313,39419.3850299523,104,NULL)
INSERT INTO SalesInvoice VALUES (803,39377.5133705577,39400.5899170501,306,NULL)
INSERT INTO SalesInvoice VALUES (804,39377.6480673381,39387.3411635567,436,NULL)
INSERT INTO SalesInvoice VALUES (805,39378.5645367816,39424.266651506,458,NULL)
INSERT INTO SalesInvoice VALUES (806,39379.6510038581,39400.3063182333,751,NULL)
INSERT INTO SalesInvoice VALUES (807,39380.5696056049,39422.3891355479,65,NULL)
INSERT INTO SalesInvoice VALUES (808,39380.6404462534,39399.8897538622,162,NULL)
INSERT INTO SalesInvoice VALUES (809,39382.1702548636,39392.3214688574,674,NULL)
INSERT INTO SalesInvoice VALUES (810,39383.1058918711,39404.605002747,337,NULL)
INSERT INTO SalesInvoice VALUES (811,39383.8701212646,39423.0398848128,4,NULL)
INSERT INTO SalesInvoice VALUES (812,39384.2441839133,39392.5819559663,753,NULL)
INSERT INTO SalesInvoice VALUES (813,39384.935170812,39395.733158019,434,NULL)
INSERT INTO SalesInvoice VALUES (814,39385.3242328414,39388.4217956325,20,NULL)
INSERT INTO SalesInvoice VALUES (815,39386.3609382681,39413.2243869912,623,NULL)
INSERT INTO SalesInvoice VALUES (816,39387.1296533268,39406.7506198154,271,NULL)
INSERT INTO SalesInvoice VALUES (817,39388.5166289932,39435.4935331185,526,NULL)
INSERT INTO SalesInvoice VALUES (818,39389.2998113321,39434.9393694792,454,NULL)
INSERT INTO SalesInvoice VALUES (819,39389.7028550063,39410.055862592,772,NULL)
INSERT INTO SalesInvoice VALUES (820,39389.9400892515,39428.1507323141,448,NULL)
INSERT INTO SalesInvoice VALUES (821,39390.6813466273,39409.1298781539,658,NULL)
INSERT INTO SalesInvoice VALUES (822,39391.8072231837,39401.8297420126,39,NULL)
INSERT INTO SalesInvoice VALUES (823,39392.0882215871,39428.6661078429,74,NULL)
INSERT INTO SalesInvoice VALUES (824,39393.4748963616,39420.451684534,1,NULL)
INSERT INTO SalesInvoice VALUES (825,39393.8152120374,39440.7932784019,584,NULL)
INSERT INTO SalesInvoice VALUES (826,39394.1593753381,39403.9446600013,771,NULL)
INSERT INTO SalesInvoice VALUES (827,39394.2905030368,39434.8316128867,379,NULL)
INSERT INTO SalesInvoice VALUES (828,39395.6851534022,39428.2533788203,3,NULL)
INSERT INTO SalesInvoice VALUES (829,39396.0040982272,39428.0644455396,498,NULL)
INSERT INTO SalesInvoice VALUES (830,39397.2924273535,39433.9029705226,696,NULL)
INSERT INTO SalesInvoice VALUES (831,39397.3046852843,39445.4914190834,107,NULL)
INSERT INTO SalesInvoice VALUES (832,39398.0358223833,39417.052375862,597,NULL)
INSERT INTO SalesInvoice VALUES (833,39399.3130725763,39404.1142319185,641,NULL)
INSERT INTO SalesInvoice VALUES (834,39399.8917159965,39400.7201159623,547,NULL)
INSERT INTO SalesInvoice VALUES (835,39401.0227796904,39419.8456081681,218,NULL)
INSERT INTO SalesInvoice VALUES (836,39401.2128493111,39444.9561277533,424,NULL)
INSERT INTO SalesInvoice VALUES (837,39402.4875983638,39418.8746620165,697,NULL)
INSERT INTO SalesInvoice VALUES (838,39403.2449478057,39404.6833864228,123,NULL)
INSERT INTO SalesInvoice VALUES (839,39403.745302324,39430.4249504741,203,NULL)
INSERT INTO SalesInvoice VALUES (840,39405.103476526,39433.7092398156,122,NULL)
INSERT INTO SalesInvoice VALUES (841,39405.6215298824,39449.899592895,667,NULL)
INSERT INTO SalesInvoice VALUES (842,39407.1019856379,39450.4679709336,632,NULL)
INSERT INTO SalesInvoice VALUES (843,39407.1619172729,39418.6085035313,96,NULL)
INSERT INTO SalesInvoice VALUES (844,39407.3610243175,39413.4572386909,243,NULL)
INSERT INTO SalesInvoice VALUES (845,39408.8598049947,39412.5346927019,585,NULL)
INSERT INTO SalesInvoice VALUES (846,39410.4051870871,39430.4166173784,755,NULL)
INSERT INTO SalesInvoice VALUES (847,39411.0319761501,39427.2996254512,601,NULL)
INSERT INTO SalesInvoice VALUES (848,39411.7656784186,39428.5111412131,45,NULL)
INSERT INTO SalesInvoice VALUES (849,39412.0324622457,39443.5105390562,504,NULL)
INSERT INTO SalesInvoice VALUES (850,39412.1673763317,39453.2375656412,549,NULL)
INSERT INTO SalesInvoice VALUES (851,39413.3839186201,39432.21002792,686,NULL)
INSERT INTO SalesInvoice VALUES (852,39413.3998378582,39463.3629938004,624,NULL)
INSERT INTO SalesInvoice VALUES (853,39414.4763111653,39461.6823500192,291,NULL)
INSERT INTO SalesInvoice VALUES (854,39415.5962397387,39445.2686624442,232,NULL)
INSERT INTO SalesInvoice VALUES (855,39416.9174335281,39425.1503687997,132,NULL)
INSERT INTO SalesInvoice VALUES (856,39417.8926302639,39455.9454291735,538,NULL)
INSERT INTO SalesInvoice VALUES (857,39417.9294659332,39436.4422080675,263,NULL)
INSERT INTO SalesInvoice VALUES (858,39419.0019019261,39465.6141621,106,NULL)
INSERT INTO SalesInvoice VALUES (859,39419.6927249989,39443.1837595375,395,NULL)
INSERT INTO SalesInvoice VALUES (860,39419.8617716422,39439.4607248472,31,NULL)
INSERT INTO SalesInvoice VALUES (861,39421.1535075684,39467.5717586274,307,NULL)
INSERT INTO SalesInvoice VALUES (862,39422.2407143586,39436.7414788721,365,NULL)
INSERT INTO SalesInvoice VALUES (863,39423.3536671898,39464.877997663,405,NULL)
INSERT INTO SalesInvoice VALUES (864,39424.6302234652,39431.1719672729,153,NULL)
INSERT INTO SalesInvoice VALUES (865,39425.044970602,39467.6662331354,243,NULL)
INSERT INTO SalesInvoice VALUES (866,39426.5889388338,39453.9808127867,405,NULL)
INSERT INTO SalesInvoice VALUES (867,39427.7123042112,39467.1186596946,645,NULL)
INSERT INTO SalesInvoice VALUES (868,39429.1140374531,39444.7540779002,228,NULL)
INSERT INTO SalesInvoice VALUES (869,39429.3909495923,39457.1284389784,473,NULL)
INSERT INTO SalesInvoice VALUES (870,39429.8707343613,39459.6052024663,334,NULL)
INSERT INTO SalesInvoice VALUES (871,39430.5767139091,39455.6514890733,560,NULL)
INSERT INTO SalesInvoice VALUES (872,39431.1973854883,39465.8700148758,697,NULL)
INSERT INTO SalesInvoice VALUES (873,39431.255688553,39462.7576667392,181,NULL)
INSERT INTO SalesInvoice VALUES (874,39432.2398132369,39443.3470770724,332,NULL)
INSERT INTO SalesInvoice VALUES (875,39432.9516113704,39471.2231457603,597,NULL)
INSERT INTO SalesInvoice VALUES (876,39434.1323973634,39437.5509473923,293,NULL)
INSERT INTO SalesInvoice VALUES (877,39434.3808140467,39476.1337394673,160,NULL)
INSERT INTO SalesInvoice VALUES (878,39434.4074585261,39442.7614757694,82,NULL)
INSERT INTO SalesInvoice VALUES (879,39435.6226957728,39484.7401964133,186,NULL)
INSERT INTO SalesInvoice VALUES (880,39436.0827438582,39476.8810576096,177,NULL)
INSERT INTO SalesInvoice VALUES (881,39436.4377982621,39444.1053685624,510,NULL)
INSERT INTO SalesInvoice VALUES (882,39437.3922065167,39449.4947736225,332,NULL)
INSERT INTO SalesInvoice VALUES (883,39438.2159955325,39467.0159151959,206,NULL)
INSERT INTO SalesInvoice VALUES (884,39438.6211333324,39473.9903320905,260,NULL)
INSERT INTO SalesInvoice VALUES (885,39439.1541794816,39482.6561688735,583,NULL)
INSERT INTO SalesInvoice VALUES (886,39440.4706663171,39466.7972778981,322,NULL)
INSERT INTO SalesInvoice VALUES (887,39441.0739720229,39490.021097795,763,NULL)
INSERT INTO SalesInvoice VALUES (888,39441.5718900556,39457.0917995184,674,NULL)
INSERT INTO SalesInvoice VALUES (889,39442.8789942605,39467.3405767069,185,NULL)
INSERT INTO SalesInvoice VALUES (890,39443.3618513601,39450.1520286335,187,NULL)
INSERT INTO SalesInvoice VALUES (891,39444.1001388807,39487.251315815,155,NULL)
INSERT INTO SalesInvoice VALUES (892,39445.2388769268,39480.6694283663,433,NULL)
INSERT INTO SalesInvoice VALUES (893,39445.6002504001,39456.7301109511,676,NULL)
INSERT INTO SalesInvoice VALUES (894,39446.3412755156,39479.9190264395,674,NULL)
INSERT INTO SalesInvoice VALUES (895,39447.0626768053,39485.6076420331,484,NULL)
INSERT INTO SalesInvoice VALUES (896,39448.4451700306,39466.3244830141,566,NULL)
INSERT INTO SalesInvoice VALUES (897,39448.6107335831,39480.7182764352,57,NULL)
INSERT INTO SalesInvoice VALUES (898,39449.6850833847,39484.7089428452,426,NULL)
INSERT INTO SalesInvoice VALUES (899,39450.9712040625,39486.8614208025,141,NULL)
INSERT INTO SalesInvoice VALUES (900,39452.4846746069,39478.5818358486,26,NULL)
INSERT INTO SalesInvoice VALUES (901,39453.1974921824,39489.9938338929,134,NULL)
INSERT INTO SalesInvoice VALUES (902,39453.5629965582,39483.8642883841,55,NULL)
INSERT INTO SalesInvoice VALUES (903,39454.9203743439,39471.1414760747,674,NULL)
INSERT INTO SalesInvoice VALUES (904,39456.0933019767,39504.3497448366,20,NULL)
INSERT INTO SalesInvoice VALUES (905,39456.1539426721,39498.2026460898,315,NULL)
INSERT INTO SalesInvoice VALUES (906,39456.4107460005,39501.2056189271,174,NULL)
INSERT INTO SalesInvoice VALUES (907,39456.9151627543,39460.752214697,682,NULL)
INSERT INTO SalesInvoice VALUES (908,39458.255245685,39463.9376684437,200,NULL)
INSERT INTO SalesInvoice VALUES (909,39458.5904216188,39459.5994360396,730,NULL)
INSERT INTO SalesInvoice VALUES (910,39458.7871594384,39476.5918008776,32,NULL)
INSERT INTO SalesInvoice VALUES (911,39459.232757618,39482.6065783287,224,NULL)
INSERT INTO SalesInvoice VALUES (912,39459.5582518716,39487.6068993261,392,NULL)
INSERT INTO SalesInvoice VALUES (913,39460.0817072354,39462.3226234941,549,NULL)
INSERT INTO SalesInvoice VALUES (914,39461.2301948494,39476.4263255006,535,NULL)
INSERT INTO SalesInvoice VALUES (915,39461.4449179335,39487.1157090543,775,NULL)
INSERT INTO SalesInvoice VALUES (916,39462.1313702414,39505.2531871405,433,NULL)
INSERT INTO SalesInvoice VALUES (917,39463.5551752345,39479.7039308161,763,NULL)
INSERT INTO SalesInvoice VALUES (918,39464.2884519581,39476.4214179524,387,NULL)
INSERT INTO SalesInvoice VALUES (919,39465.6754546149,39488.0382103536,773,NULL)
INSERT INTO SalesInvoice VALUES (920,39465.9136715568,39485.1233389587,336,NULL)
INSERT INTO SalesInvoice VALUES (921,39466.3760268659,39467.6548272412,390,NULL)
INSERT INTO SalesInvoice VALUES (922,39466.3908305717,39499.8779026308,211,NULL)
INSERT INTO SalesInvoice VALUES (923,39467.6051602192,39496.0797295096,540,NULL)
INSERT INTO SalesInvoice VALUES (924,39468.9876455656,39483.5339858666,537,NULL)
INSERT INTO SalesInvoice VALUES (925,39469.5767677178,39512.9454399929,459,NULL)
INSERT INTO SalesInvoice VALUES (926,39471.1372691976,39497.2479310872,743,NULL)
INSERT INTO SalesInvoice VALUES (927,39472.0031853562,39492.9495273812,394,NULL)
INSERT INTO SalesInvoice VALUES (928,39472.4002029458,39479.4174340394,111,NULL)
INSERT INTO SalesInvoice VALUES (929,39473.2869741829,39515.4230679147,724,NULL)
INSERT INTO SalesInvoice VALUES (930,39473.9866820215,39500.7876591204,665,NULL)
INSERT INTO SalesInvoice VALUES (931,39474.793602711,39475.3896045311,388,NULL)
INSERT INTO SalesInvoice VALUES (932,39475.862941382,39488.5242136835,176,NULL)
INSERT INTO SalesInvoice VALUES (933,39477.3646741039,39504.5986128342,511,NULL)
INSERT INTO SalesInvoice VALUES (934,39477.625915608,39501.3048338636,509,NULL)
INSERT INTO SalesInvoice VALUES (935,39478.4662938204,39523.450592486,621,NULL)
INSERT INTO SalesInvoice VALUES (936,39478.9446541901,39520.7250389273,474,NULL)
INSERT INTO SalesInvoice VALUES (937,39480.525647082,39507.7908043989,458,NULL)
INSERT INTO SalesInvoice VALUES (938,39480.9269443733,39527.1949303487,746,NULL)
INSERT INTO SalesInvoice VALUES (939,39481.0016554287,39498.1943305731,503,NULL)
INSERT INTO SalesInvoice VALUES (940,39481.2332839087,39515.9532178176,153,NULL)
INSERT INTO SalesInvoice VALUES (941,39481.3151318468,39518.1383998242,429,NULL)
INSERT INTO SalesInvoice VALUES (942,39482.780228198,39495.0335981786,455,NULL)
INSERT INTO SalesInvoice VALUES (943,39483.1146278066,39524.0053448643,2,NULL)
INSERT INTO SalesInvoice VALUES (944,39484.6430758094,39519.4425045329,397,NULL)
INSERT INTO SalesInvoice VALUES (945,39485.4207975797,39520.1287056465,10,NULL)
INSERT INTO SalesInvoice VALUES (946,39486.3216016028,39535.0259239095,519,NULL)
INSERT INTO SalesInvoice VALUES (947,39487.5461381265,39525.0742029549,645,NULL)
INSERT INTO SalesInvoice VALUES (948,39487.6816983014,39497.1846246132,108,NULL)
INSERT INTO SalesInvoice VALUES (949,39487.7021978841,39535.6291717665,3,NULL)
INSERT INTO SalesInvoice VALUES (950,39487.7376862801,39523.8395449743,370,NULL)
INSERT INTO SalesInvoice VALUES (951,39488.2354554896,39501.6169553226,169,NULL)
INSERT INTO SalesInvoice VALUES (952,39488.583094493,39492.6990387946,133,NULL)
INSERT INTO SalesInvoice VALUES (953,39489.7502986338,39527.5438031299,84,NULL)
INSERT INTO SalesInvoice VALUES (954,39491.2610120821,39507.1191400371,259,NULL)
INSERT INTO SalesInvoice VALUES (955,39491.2937856853,39516.4112345979,434,NULL)
INSERT INTO SalesInvoice VALUES (956,39492.6940660304,39506.0135993016,124,NULL)
INSERT INTO SalesInvoice VALUES (957,39493.0611582103,39513.4207435214,80,NULL)
INSERT INTO SalesInvoice VALUES (958,39494.2130995501,39520.8446763892,448,NULL)
INSERT INTO SalesInvoice VALUES (959,39495.7122345942,39544.9207278268,272,NULL)
INSERT INTO SalesInvoice VALUES (960,39496.2491550178,39515.9582089741,260,NULL)
INSERT INTO SalesInvoice VALUES (961,39496.8996858044,39499.1759820521,57,NULL)
INSERT INTO SalesInvoice VALUES (962,39497.9709254163,39503.8093080481,728,NULL)
INSERT INTO SalesInvoice VALUES (963,39498.0004438246,39502.1521960537,503,NULL)
INSERT INTO SalesInvoice VALUES (964,39499.3901142823,39547.4835376143,318,NULL)
INSERT INTO SalesInvoice VALUES (965,39500.1134698788,39511.2463300655,769,NULL)
INSERT INTO SalesInvoice VALUES (966,39501.3295457639,39501.4488623195,598,NULL)
INSERT INTO SalesInvoice VALUES (967,39501.7379298229,39526.4640900286,251,NULL)
INSERT INTO SalesInvoice VALUES (968,39502.77792877,39535.7377899228,505,NULL)
INSERT INTO SalesInvoice VALUES (969,39503.1041227275,39541.6942768658,380,NULL)
INSERT INTO SalesInvoice VALUES (970,39504.5143986015,39509.0428614717,190,NULL)
INSERT INTO SalesInvoice VALUES (971,39505.585168123,39543.0714199042,360,NULL)
INSERT INTO SalesInvoice VALUES (972,39506.3416504003,39552.7352994692,56,NULL)
INSERT INTO SalesInvoice VALUES (973,39506.794292649,39549.500108157,304,NULL)
INSERT INTO SalesInvoice VALUES (974,39507.6324003429,39508.4756501007,700,NULL)
INSERT INTO SalesInvoice VALUES (975,39508.3481010927,39527.547146723,25,NULL)
INSERT INTO SalesInvoice VALUES (976,39509.8515453578,39537.9588717046,391,NULL)
INSERT INTO SalesInvoice VALUES (977,39510.5570411964,39532.5539012557,357,NULL)
INSERT INTO SalesInvoice VALUES (978,39510.722284177,39543.7871378991,66,NULL)
INSERT INTO SalesInvoice VALUES (979,39511.7489551822,39523.184608632,203,NULL)
INSERT INTO SalesInvoice VALUES (980,39512.8849534787,39550.3077555673,535,NULL)
INSERT INTO SalesInvoice VALUES (981,39513.5143807282,39521.816523632,441,NULL)
INSERT INTO SalesInvoice VALUES (982,39514.5331768813,39540.5907862743,288,NULL)
INSERT INTO SalesInvoice VALUES (983,39515.9947164577,39532.1130801924,756,NULL)
INSERT INTO SalesInvoice VALUES (984,39516.8256171892,39553.2499964215,448,NULL)
INSERT INTO SalesInvoice VALUES (985,39518.3776523849,39552.2611616916,165,NULL)
INSERT INTO SalesInvoice VALUES (986,39518.5386716091,39531.7291418068,274,NULL)
INSERT INTO SalesInvoice VALUES (987,39519.1389892328,39562.6114243915,319,NULL)
INSERT INTO SalesInvoice VALUES (988,39520.6315161473,39526.2720218277,15,NULL)
INSERT INTO SalesInvoice VALUES (989,39521.4546096846,39569.8545556105,13,NULL)
INSERT INTO SalesInvoice VALUES (990,39521.8611755964,39561.524721335,684,NULL)
INSERT INTO SalesInvoice VALUES (991,39522.5416858767,39523.7915118315,489,NULL)
INSERT INTO SalesInvoice VALUES (992,39523.0745626363,39550.2530537023,375,NULL)
INSERT INTO SalesInvoice VALUES (993,39524.2108663792,39565.3371494174,262,NULL)
INSERT INTO SalesInvoice VALUES (994,39524.5737992964,39573.6376485104,491,NULL)
INSERT INTO SalesInvoice VALUES (995,39524.8918606342,39526.2647200418,488,NULL)
INSERT INTO SalesInvoice VALUES (996,39525.6930752546,39566.342994694,536,NULL)
INSERT INTO SalesInvoice VALUES (997,39526.8602223145,39561.2238091525,281,NULL)
INSERT INTO SalesInvoice VALUES (998,39527.2808290451,39537.2587439815,254,NULL)
INSERT INTO SalesInvoice VALUES (999,39528.0976531908,39571.0891086947,605,NULL)
INSERT INTO SalesInvoice VALUES (1000,39529.4255287864,39567.3754988301,469,NULL)
INSERT INTO SalesInvoice VALUES (1001,39530.1494617603,39542.3047740587,298,NULL)
INSERT INTO SalesInvoice VALUES (1002,39531.4283613157,39548.5648838465,484,NULL)
INSERT INTO SalesInvoice VALUES (1003,39532.8709606445,39544.8259889501,88,NULL)
INSERT INTO SalesInvoice VALUES (1004,39533.2927763583,39558.9156006554,584,NULL)
INSERT INTO SalesInvoice VALUES (1005,39534.2207626998,39554.0613044273,745,NULL)
INSERT INTO SalesInvoice VALUES (1006,39535.4973650856,39561.0200236496,328,NULL)
INSERT INTO SalesInvoice VALUES (1007,39536.0843357225,39549.2749477231,471,NULL)
INSERT INTO SalesInvoice VALUES (1008,39536.4064069902,39565.2337219128,193,NULL)
INSERT INTO SalesInvoice VALUES (1009,39537.987346041,39571.2881445084,189,NULL)
INSERT INTO SalesInvoice VALUES (1010,39539.2287683197,39568.3405999696,95,NULL)
INSERT INTO SalesInvoice VALUES (1011,39539.5721283083,39578.5666269921,77,NULL)
INSERT INTO SalesInvoice VALUES (1012,39540.499114381,39557.289633942,572,NULL)
INSERT INTO SalesInvoice VALUES (1013,39541.7315098527,39570.9582855883,764,NULL)
INSERT INTO SalesInvoice VALUES (1014,39542.8907990893,39587.8111226331,132,NULL)
INSERT INTO SalesInvoice VALUES (1015,39544.0638862438,39549.8203942918,464,NULL)
INSERT INTO SalesInvoice VALUES (1016,39545.24051618,39577.7093932831,726,NULL)
INSERT INTO SalesInvoice VALUES (1017,39545.8502486335,39557.8932881154,444,NULL)
INSERT INTO SalesInvoice VALUES (1018,39547.3758904319,39579.5617913717,678,NULL)
INSERT INTO SalesInvoice VALUES (1019,39548.4965783837,39562.9769285853,603,NULL)
INSERT INTO SalesInvoice VALUES (1020,39549.028773736,39594.7989667196,104,NULL)
INSERT INTO SalesInvoice VALUES (1021,39549.0729940938,39586.770771247,9,NULL)
INSERT INTO SalesInvoice VALUES (1022,39549.3535116337,39597.0249800963,386,NULL)
INSERT INTO SalesInvoice VALUES (1023,39550.2187765154,39565.6716399774,130,NULL)
INSERT INTO SalesInvoice VALUES (1024,39551.0364933246,39576.3696094209,519,NULL)
INSERT INTO SalesInvoice VALUES (1025,39551.9556407276,39586.4481940845,11,NULL)
INSERT INTO SalesInvoice VALUES (1026,39552.2447582013,39591.282397611,548,NULL)
INSERT INTO SalesInvoice VALUES (1027,39553.676382898,39569.0314622038,1,NULL)
INSERT INTO SalesInvoice VALUES (1028,39554.9128881881,39559.3216427002,302,NULL)
INSERT INTO SalesInvoice VALUES (1029,39556.4569217375,39574.2000481954,620,NULL)
INSERT INTO SalesInvoice VALUES (1030,39557.1925465253,39563.6373444723,233,NULL)
INSERT INTO SalesInvoice VALUES (1031,39557.6298619012,39596.4654228429,79,NULL)
INSERT INTO SalesInvoice VALUES (1032,39558.9321725705,39576.9932803001,593,NULL)
INSERT INTO SalesInvoice VALUES (1033,39559.2513719447,39574.8086861377,409,NULL)
INSERT INTO SalesInvoice VALUES (1034,39559.3224684481,39605.1005536703,594,NULL)
INSERT INTO SalesInvoice VALUES (1035,39559.8271418192,39572.2590170368,396,NULL)
INSERT INTO SalesInvoice VALUES (1036,39560.7127228185,39583.6243756428,259,NULL)
INSERT INTO SalesInvoice VALUES (1037,39561.537385351,39580.5072070171,676,NULL)
INSERT INTO SalesInvoice VALUES (1038,39562.5517357261,39585.2276537589,623,NULL)
INSERT INTO SalesInvoice VALUES (1039,39562.8231908172,39595.3823168425,256,NULL)
INSERT INTO SalesInvoice VALUES (1040,39563.0157548672,39595.8660254794,210,NULL)
INSERT INTO SalesInvoice VALUES (1041,39563.441881687,39602.6156326491,334,NULL)
INSERT INTO SalesInvoice VALUES (1042,39563.5294528093,39590.6401836425,750,NULL)
INSERT INTO SalesInvoice VALUES (1043,39563.7656167266,39601.5847458296,36,NULL)
INSERT INTO SalesInvoice VALUES (1044,39564.2125937596,39569.5837317931,484,NULL)
INSERT INTO SalesInvoice VALUES (1045,39565.127523573,39594.3578073587,761,NULL)
INSERT INTO SalesInvoice VALUES (1046,39565.5373260979,39593.5376027041,436,NULL)
INSERT INTO SalesInvoice VALUES (1047,39567.0135738837,39587.9297047327,252,NULL)
INSERT INTO SalesInvoice VALUES (1048,39567.3042452253,39570.3244278117,684,NULL)
INSERT INTO SalesInvoice VALUES (1049,39567.4535624657,39608.0278000887,32,NULL)
INSERT INTO SalesInvoice VALUES (1050,39568.0124812917,39616.4715357834,371,NULL)
INSERT INTO SalesInvoice VALUES (1051,39569.2783924445,39617.4241177176,219,NULL)
INSERT INTO SalesInvoice VALUES (1052,39569.6471306784,39608.4446473172,550,NULL)
INSERT INTO SalesInvoice VALUES (1053,39570.9970173269,39601.108116066,0,NULL)
INSERT INTO SalesInvoice VALUES (1054,39571.7604448737,39620.2858619717,542,NULL)
INSERT INTO SalesInvoice VALUES (1055,39571.7895930496,39591.563321387,703,NULL)
INSERT INTO SalesInvoice VALUES (1056,39572.1880924774,39583.421036649,178,NULL)
INSERT INTO SalesInvoice VALUES (1057,39572.4034506665,39579.7936520042,408,NULL)
INSERT INTO SalesInvoice VALUES (1058,39573.5026313336,39578.753158085,358,NULL)
INSERT INTO SalesInvoice VALUES (1059,39574.846833987,39594.8315069746,62,NULL)
INSERT INTO SalesInvoice VALUES (1060,39575.1775096491,39580.1917804205,734,NULL)
INSERT INTO SalesInvoice VALUES (1061,39576.7292220344,39617.503395407,770,NULL)
INSERT INTO SalesInvoice VALUES (1062,39577.2917349273,39578.4473383247,698,NULL)
INSERT INTO SalesInvoice VALUES (1063,39578.1993355413,39593.381472766,575,NULL)
INSERT INTO SalesInvoice VALUES (1064,39579.0206950076,39616.0415752008,24,NULL)
INSERT INTO SalesInvoice VALUES (1065,39580.5724654077,39610.4141888681,124,NULL)
INSERT INTO SalesInvoice VALUES (1066,39581.0148828049,39591.4610924733,422,NULL)
INSERT INTO SalesInvoice VALUES (1067,39581.4447421914,39609.5243516977,559,NULL)
INSERT INTO SalesInvoice VALUES (1068,39582.7792888855,39608.958576071,680,NULL)
INSERT INTO SalesInvoice VALUES (1069,39583.2283513761,39624.4924291591,597,NULL)
INSERT INTO SalesInvoice VALUES (1070,39584.1825318353,39590.1151479036,55,NULL)
INSERT INTO SalesInvoice VALUES (1071,39585.756640793,39613.4619975059,29,NULL)
INSERT INTO SalesInvoice VALUES (1072,39586.8919596159,39621.4018984059,96,NULL)
INSERT INTO SalesInvoice VALUES (1073,39588.3243742336,39612.147685141,499,NULL)
INSERT INTO SalesInvoice VALUES (1074,39589.5734002444,39608.4474288009,673,NULL)
INSERT INTO SalesInvoice VALUES (1075,39590.61458419,39614.9831474478,752,NULL)
INSERT INTO SalesInvoice VALUES (1076,39591.3863314896,39592.7966529877,72,NULL)
INSERT INTO SalesInvoice VALUES (1077,39592.9270251212,39596.4725180297,256,NULL)
INSERT INTO SalesInvoice VALUES (1078,39593.9928474964,39641.7191675968,698,NULL)
INSERT INTO SalesInvoice VALUES (1079,39594.5405603512,39600.3962945811,701,NULL)
INSERT INTO SalesInvoice VALUES (1080,39594.9208201636,39599.4610397394,91,NULL)
INSERT INTO SalesInvoice VALUES (1081,39595.821222258,39602.7485262656,404,NULL)
INSERT INTO SalesInvoice VALUES (1082,39596.7409250183,39608.8634219517,604,NULL)
INSERT INTO SalesInvoice VALUES (1083,39598.0722448751,39616.70402611,708,NULL)
INSERT INTO SalesInvoice VALUES (1084,39598.5738195418,39635.2555740199,238,NULL)
INSERT INTO SalesInvoice VALUES (1085,39598.7384275179,39644.2675787828,678,NULL)
INSERT INTO SalesInvoice VALUES (1086,39600.2335504439,39631.7216831833,498,NULL)
INSERT INTO SalesInvoice VALUES (1087,39600.6899194009,39641.2851304448,357,NULL)
INSERT INTO SalesInvoice VALUES (1088,39601.5013957487,39651.4479843393,38,NULL)
INSERT INTO SalesInvoice VALUES (1089,39602.3854049556,39613.0944759195,274,NULL)
INSERT INTO SalesInvoice VALUES (1090,39603.6561021696,39605.7356401542,630,NULL)
INSERT INTO SalesInvoice VALUES (1091,39604.3764402897,39616.5905142044,339,NULL)
INSERT INTO SalesInvoice VALUES (1092,39605.9307744102,39631.3504798753,148,NULL)
INSERT INTO SalesInvoice VALUES (1093,39606.097074391,39621.6263065951,245,NULL)
INSERT INTO SalesInvoice VALUES (1094,39606.672193043,39618.8544156706,89,NULL)
INSERT INTO SalesInvoice VALUES (1095,39607.4075935059,39629.9648572244,135,NULL)
INSERT INTO SalesInvoice VALUES (1096,39608.3672841841,39609.501300896,29,NULL)
INSERT INTO SalesInvoice VALUES (1097,39609.9416997877,39613.5270108751,52,NULL)
INSERT INTO SalesInvoice VALUES (1098,39610.0521503963,39648.4832087655,308,NULL)
INSERT INTO SalesInvoice VALUES (1099,39610.9283971117,39660.1463125263,63,NULL)
INSERT INTO SalesInvoice VALUES (1100,39611.235730097,39650.4798173852,325,NULL)
INSERT INTO SalesInvoice VALUES (1101,39611.354876428,39640.2966396052,723,NULL)
INSERT INTO SalesInvoice VALUES (1102,39611.7369309454,39640.1316489638,28,NULL)
INSERT INTO SalesInvoice VALUES (1103,39612.6313748528,39621.6125538443,700,NULL)
INSERT INTO SalesInvoice VALUES (1104,39613.1222543975,39641.1007647809,160,NULL)
INSERT INTO SalesInvoice VALUES (1105,39613.1825842238,39653.0495572348,561,NULL)
INSERT INTO SalesInvoice VALUES (1106,39613.7747774702,39663.4627982795,457,NULL)
INSERT INTO SalesInvoice VALUES (1107,39614.4531488793,39660.8458243798,691,NULL)
INSERT INTO SalesInvoice VALUES (1108,39615.3369514375,39664.8619944385,420,NULL)
INSERT INTO SalesInvoice VALUES (1109,39616.4309173921,39622.4820962509,49,NULL)
INSERT INTO SalesInvoice VALUES (1110,39616.6632904035,39649.126896119,416,NULL)
INSERT INTO SalesInvoice VALUES (1111,39617.0712693721,39643.2140767076,118,NULL)
INSERT INTO SalesInvoice VALUES (1112,39617.591761281,39653.3808388704,78,NULL)
INSERT INTO SalesInvoice VALUES (1113,39619.0312778022,39662.935370744,515,NULL)
INSERT INTO SalesInvoice VALUES (1114,39620.5171293386,39620.5244429882,289,NULL)
INSERT INTO SalesInvoice VALUES (1115,39621.966878787,39639.9437520222,287,NULL)
INSERT INTO SalesInvoice VALUES (1116,39622.7666106491,39623.4356491974,570,NULL)
INSERT INTO SalesInvoice VALUES (1117,39623.8125406452,39660.429466124,682,NULL)
INSERT INTO SalesInvoice VALUES (1118,39625.3590148369,39631.019620376,727,NULL)
INSERT INTO SalesInvoice VALUES (1119,39626.7959536854,39673.7229300738,208,NULL)
INSERT INTO SalesInvoice VALUES (1120,39627.4352315822,39659.8666590668,659,NULL)
INSERT INTO SalesInvoice VALUES (1121,39627.9917966998,39672.2397449735,28,NULL)
INSERT INTO SalesInvoice VALUES (1122,39628.1610363983,39676.7616253483,459,NULL)
INSERT INTO SalesInvoice VALUES (1123,39629.4287913726,39675.5277645077,124,NULL)
INSERT INTO SalesInvoice VALUES (1124,39630.2248366665,39674.7092638176,621,NULL)
INSERT INTO SalesInvoice VALUES (1125,39630.3415583559,39658.5449482884,330,NULL)
INSERT INTO SalesInvoice VALUES (1126,39631.0476034623,39636.2626511953,379,NULL)
INSERT INTO SalesInvoice VALUES (1127,39631.3257994916,39669.2428283337,391,NULL)
INSERT INTO SalesInvoice VALUES (1128,39631.6144971808,39653.22515065,596,NULL)
INSERT INTO SalesInvoice VALUES (1129,39631.8556999573,39643.7430556287,389,NULL)
INSERT INTO SalesInvoice VALUES (1130,39633.3103875799,39682.2283975191,645,NULL)
INSERT INTO SalesInvoice VALUES (1131,39633.3664200449,39650.3054691866,687,NULL)
INSERT INTO SalesInvoice VALUES (1132,39633.8949880937,39657.69666576,453,NULL)
INSERT INTO SalesInvoice VALUES (1133,39634.4600551172,39642.4242961044,659,NULL)
INSERT INTO SalesInvoice VALUES (1134,39635.2418850364,39646.3549959029,669,NULL)
INSERT INTO SalesInvoice VALUES (1135,39635.6755237726,39654.9225054383,238,NULL)
INSERT INTO SalesInvoice VALUES (1136,39636.2499680633,39653.8252779851,287,NULL)
INSERT INTO SalesInvoice VALUES (1137,39637.7025769849,39647.5611493294,677,NULL)
INSERT INTO SalesInvoice VALUES (1138,39638.8772195726,39643.7941086241,701,NULL)
INSERT INTO SalesInvoice VALUES (1139,39639.7880046102,39646.4549605361,160,NULL)
INSERT INTO SalesInvoice VALUES (1140,39640.0408468698,39655.7675846591,134,NULL)
INSERT INTO SalesInvoice VALUES (1141,39640.4412156505,39643.0733302587,502,NULL)
INSERT INTO SalesInvoice VALUES (1142,39641.5066214725,39666.4322242623,738,NULL)
INSERT INTO SalesInvoice VALUES (1143,39641.5531000845,39669.9842921931,252,NULL)
INSERT INTO SalesInvoice VALUES (1144,39642.4218305218,39687.9682648586,306,NULL)
INSERT INTO SalesInvoice VALUES (1145,39643.243630882,39678.547183293,260,NULL)
INSERT INTO SalesInvoice VALUES (1146,39643.5338226807,39683.0001344525,288,NULL)
INSERT INTO SalesInvoice VALUES (1147,39643.9402328641,39648.2631397976,216,NULL)
INSERT INTO SalesInvoice VALUES (1148,39644.8531817206,39680.2142146301,723,NULL)
INSERT INTO SalesInvoice VALUES (1149,39646.0343341561,39657.4783422734,653,NULL)
INSERT INTO SalesInvoice VALUES (1150,39647.1115817467,39693.2067699399,145,NULL)
INSERT INTO SalesInvoice VALUES (1151,39647.6372243482,39684.6990791056,504,NULL)
INSERT INTO SalesInvoice VALUES (1152,39648.8379238437,39695.188549418,763,NULL)
INSERT INTO SalesInvoice VALUES (1153,39649.7058817299,39666.0626888491,119,NULL)
INSERT INTO SalesInvoice VALUES (1154,39651.0188280823,39700.039065946,690,NULL)
INSERT INTO SalesInvoice VALUES (1155,39652.4795927448,39653.4332745684,15,NULL)
INSERT INTO SalesInvoice VALUES (1156,39652.657043644,39671.3126345643,341,NULL)
INSERT INTO SalesInvoice VALUES (1157,39652.9183132,39674.8602534926,120,NULL)
INSERT INTO SalesInvoice VALUES (1158,39653.3819116088,39701.535906691,730,NULL)
INSERT INTO SalesInvoice VALUES (1159,39653.9075553895,39680.0438834457,222,NULL)
INSERT INTO SalesInvoice VALUES (1160,39655.2740113871,39668.8486260465,174,NULL)
INSERT INTO SalesInvoice VALUES (1161,39655.4556973133,39688.5709145474,771,NULL)
INSERT INTO SalesInvoice VALUES (1162,39656.5823444422,39669.9894719146,361,NULL)
INSERT INTO SalesInvoice VALUES (1163,39657.8567096049,39687.608173949,706,NULL)
INSERT INTO SalesInvoice VALUES (1164,39658.2312874312,39690.2890159442,414,NULL)
INSERT INTO SalesInvoice VALUES (1165,39658.5296197449,39661.2495007567,109,NULL)
INSERT INTO SalesInvoice VALUES (1166,39659.8665693124,39666.8978563399,773,NULL)
INSERT INTO SalesInvoice VALUES (1167,39660.3590993649,39676.5726897275,238,NULL)
INSERT INTO SalesInvoice VALUES (1168,39660.6465034067,39667.214954992,469,NULL)
INSERT INTO SalesInvoice VALUES (1169,39662.0712316629,39686.9814746915,470,NULL)
INSERT INTO SalesInvoice VALUES (1170,39663.4411473853,39673.4447191116,347,NULL)
INSERT INTO SalesInvoice VALUES (1171,39663.7076954951,39701.9862165131,295,NULL)
INSERT INTO SalesInvoice VALUES (1172,39665.0551641919,39693.9289984854,373,NULL)
INSERT INTO SalesInvoice VALUES (1173,39665.1329609393,39676.027694227,36,NULL)
INSERT INTO SalesInvoice VALUES (1174,39665.7839945479,39701.5525382103,770,NULL)
INSERT INTO SalesInvoice VALUES (1175,39666.3527170144,39666.533173559,753,NULL)
INSERT INTO SalesInvoice VALUES (1176,39666.882958269,39671.9648181946,402,NULL)
INSERT INTO SalesInvoice VALUES (1177,39668.3701106061,39709.484786382,495,NULL)
INSERT INTO SalesInvoice VALUES (1178,39668.9953349651,39680.2699847378,402,NULL)
INSERT INTO SalesInvoice VALUES (1179,39669.7227286273,39681.700933029,87,NULL)
INSERT INTO SalesInvoice VALUES (1180,39669.823164378,39716.4818828823,721,NULL)
INSERT INTO SalesInvoice VALUES (1181,39670.5344133371,39672.2155344986,717,NULL)
INSERT INTO SalesInvoice VALUES (1182,39670.7915875,39709.3410926182,350,NULL)
INSERT INTO SalesInvoice VALUES (1183,39671.9859823514,39674.2749690962,138,NULL)
INSERT INTO SalesInvoice VALUES (1184,39673.1675833716,39674.5820499506,465,NULL)
INSERT INTO SalesInvoice VALUES (1185,39674.3040609742,39709.5986617807,302,NULL)
INSERT INTO SalesInvoice VALUES (1186,39675.7329645327,39686.4079643079,732,NULL)
INSERT INTO SalesInvoice VALUES (1187,39677.2478544823,39697.1175668015,321,NULL)
INSERT INTO SalesInvoice VALUES (1188,39678.6456491638,39699.4695249623,604,NULL)
INSERT INTO SalesInvoice VALUES (1189,39678.8040515364,39721.2131780319,763,NULL)
INSERT INTO SalesInvoice VALUES (1190,39679.6801335424,39704.4351193679,97,NULL)
INSERT INTO SalesInvoice VALUES (1191,39679.7274444897,39708.2468603963,157,NULL)
INSERT INTO SalesInvoice VALUES (1192,39680.2136546246,39695.3337055301,694,NULL)
INSERT INTO SalesInvoice VALUES (1193,39680.8220821154,39728.1444656665,396,NULL)
INSERT INTO SalesInvoice VALUES (1194,39681.1923149066,39722.1282816316,723,NULL)
INSERT INTO SalesInvoice VALUES (1195,39681.6110071533,39725.41926682,263,NULL)
INSERT INTO SalesInvoice VALUES (1196,39682.7303655899,39694.7612278752,252,NULL)
INSERT INTO SalesInvoice VALUES (1197,39684.252296695,39709.7778198888,210,NULL)
INSERT INTO SalesInvoice VALUES (1198,39684.4449039742,39720.6992005263,766,NULL)
INSERT INTO SalesInvoice VALUES (1199,39685.9415637328,39714.6497131782,567,NULL)
INSERT INTO SalesInvoice VALUES (1200,39687.3545283563,39698.1333364506,712,NULL)
INSERT INTO SalesInvoice VALUES (1201,39688.7339106332,39702.3489124755,608,NULL)
INSERT INTO SalesInvoice VALUES (1202,39689.8962297495,39695.4583045125,342,NULL)
INSERT INTO SalesInvoice VALUES (1203,39690.8539145704,39722.4011042906,344,NULL)
INSERT INTO SalesInvoice VALUES (1204,39691.0765048445,39740.7896658836,372,NULL)
INSERT INTO SalesInvoice VALUES (1205,39691.9279631201,39740.6457782225,91,NULL)
INSERT INTO SalesInvoice VALUES (1206,39692.4981902441,39697.0345690583,348,NULL)
INSERT INTO SalesInvoice VALUES (1207,39693.2150362583,39718.6290318664,213,NULL)
INSERT INTO SalesInvoice VALUES (1208,39693.3907753219,39728.1994657128,388,NULL)
INSERT INTO SalesInvoice VALUES (1209,39693.7314787068,39702.9368142425,433,NULL)
INSERT INTO SalesInvoice VALUES (1210,39694.993882587,39744.1642265786,494,NULL)
INSERT INTO SalesInvoice VALUES (1211,39695.2154831088,39695.6456466211,52,NULL)
INSERT INTO SalesInvoice VALUES (1212,39696.7558444029,39743.7108210801,415,NULL)
INSERT INTO SalesInvoice VALUES (1213,39698.0943628989,39717.7176854211,151,NULL)
INSERT INTO SalesInvoice VALUES (1214,39698.3556604308,39701.4887987858,690,NULL)
INSERT INTO SalesInvoice VALUES (1215,39699.4096135434,39720.0362660074,68,NULL)
INSERT INTO SalesInvoice VALUES (1216,39699.9927637306,39749.2243027974,545,NULL)
INSERT INTO SalesInvoice VALUES (1217,39700.3107416277,39739.6777272036,304,NULL)
INSERT INTO SalesInvoice VALUES (1218,39700.5329390442,39700.8837888842,327,NULL)
INSERT INTO SalesInvoice VALUES (1219,39700.6787301842,39734.0418221676,194,NULL)
INSERT INTO SalesInvoice VALUES (1220,39701.8046020675,39738.539347227,697,NULL)
INSERT INTO SalesInvoice VALUES (1221,39701.9695508648,39739.3625777052,71,NULL)
INSERT INTO SalesInvoice VALUES (1222,39703.0176414324,39715.2658540611,178,NULL)
INSERT INTO SalesInvoice VALUES (1223,39703.9530056121,39721.1995374885,407,NULL)
INSERT INTO SalesInvoice VALUES (1224,39704.6568341993,39752.7221751511,131,NULL)
INSERT INTO SalesInvoice VALUES (1225,39705.6581032024,39727.0875981058,227,NULL)
INSERT INTO SalesInvoice VALUES (1226,39707.0093870633,39744.2628737536,508,NULL)
INSERT INTO SalesInvoice VALUES (1227,39708.3688449004,39732.3189784475,486,NULL)
INSERT INTO SalesInvoice VALUES (1228,39709.8033257492,39710.8010277423,664,NULL)
INSERT INTO SalesInvoice VALUES (1229,39710.7543480869,39732.269472826,716,NULL)
INSERT INTO SalesInvoice VALUES (1230,39712.2362092048,39761.6842500699,78,NULL)
INSERT INTO SalesInvoice VALUES (1231,39712.3201816557,39751.1543347367,29,NULL)
INSERT INTO SalesInvoice VALUES (1232,39713.3029268664,39736.8307301615,322,NULL)
INSERT INTO SalesInvoice VALUES (1233,39713.532776781,39725.4872887915,111,NULL)
INSERT INTO SalesInvoice VALUES (1234,39714.9629155765,39727.9951126307,170,NULL)
INSERT INTO SalesInvoice VALUES (1235,39716.172782715,39721.2842374078,113,NULL)
INSERT INTO SalesInvoice VALUES (1236,39716.2802824137,39742.4895717552,349,NULL)
INSERT INTO SalesInvoice VALUES (1237,39717.4967823254,39767.3432262268,487,NULL)
INSERT INTO SalesInvoice VALUES (1238,39718.9817737968,39729.1756873739,101,NULL)
INSERT INTO SalesInvoice VALUES (1239,39720.183329566,39761.7361219806,305,NULL)
INSERT INTO SalesInvoice VALUES (1240,39720.9108606223,39728.9191298089,63,NULL)
INSERT INTO SalesInvoice VALUES (1241,39721.1682367073,39747.8537218198,157,NULL)
INSERT INTO SalesInvoice VALUES (1242,39722.2973237882,39770.9331703597,72,NULL)
INSERT INTO SalesInvoice VALUES (1243,39723.5755743804,39745.4796693784,190,NULL)
INSERT INTO SalesInvoice VALUES (1244,39724.3252021981,39768.7710131786,365,NULL)
INSERT INTO SalesInvoice VALUES (1245,39724.772848315,39749.924539475,714,NULL)
INSERT INTO SalesInvoice VALUES (1246,39724.796162139,39746.9613351971,127,NULL)
INSERT INTO SalesInvoice VALUES (1247,39724.8775619629,39739.9235272512,337,NULL)
INSERT INTO SalesInvoice VALUES (1248,39725.9064977065,39768.6866508335,132,NULL)
INSERT INTO SalesInvoice VALUES (1249,39726.2007422015,39741.6117248604,351,NULL)
INSERT INTO SalesInvoice VALUES (1250,39726.599160398,39731.7973951821,92,NULL)
INSERT INTO SalesInvoice VALUES (1251,39726.9051343983,39768.5807919657,600,NULL)
INSERT INTO SalesInvoice VALUES (1252,39727.9817521493,39735.7552913188,695,NULL)
INSERT INTO SalesInvoice VALUES (1253,39729.0107929221,39755.2603628388,605,NULL)
INSERT INTO SalesInvoice VALUES (1254,39729.1272380234,39754.5636867707,386,NULL)
INSERT INTO SalesInvoice VALUES (1255,39729.9844051163,39732.1737734351,465,NULL)
INSERT INTO SalesInvoice VALUES (1256,39730.3952158606,39764.9151613138,667,NULL)
INSERT INTO SalesInvoice VALUES (1257,39731.7000157533,39758.5943281463,188,NULL)
INSERT INTO SalesInvoice VALUES (1258,39732.1090391312,39755.490736842,472,NULL)
INSERT INTO SalesInvoice VALUES (1259,39733.2337822358,39749.5416729623,723,NULL)
INSERT INTO SalesInvoice VALUES (1260,39734.4074218109,39753.5182929307,409,NULL)
INSERT INTO SalesInvoice VALUES (1261,39734.9915940786,39738.7570366818,112,NULL)
INSERT INTO SalesInvoice VALUES (1262,39736.366613687,39737.1085194366,705,NULL)
INSERT INTO SalesInvoice VALUES (1263,39737.2230565997,39744.3239719929,223,NULL)
INSERT INTO SalesInvoice VALUES (1264,39737.5779488542,39742.297893137,624,NULL)
INSERT INTO SalesInvoice VALUES (1265,39737.9957800268,39785.3641611249,60,NULL)
INSERT INTO SalesInvoice VALUES (1266,39738.0009293829,39768.667352962,558,NULL)
INSERT INTO SalesInvoice VALUES (1267,39738.7768944299,39761.5141514143,153,NULL)
INSERT INTO SalesInvoice VALUES (1268,39739.5524638005,39743.1896048272,103,NULL)
INSERT INTO SalesInvoice VALUES (1269,39740.8554669822,39786.5837663025,443,NULL)
INSERT INTO SalesInvoice VALUES (1270,39742.109745944,39744.3281321332,403,NULL)
INSERT INTO SalesInvoice VALUES (1271,39742.2321500062,39754.4188082211,351,NULL)
INSERT INTO SalesInvoice VALUES (1272,39743.2151158413,39787.7074752093,158,NULL)
INSERT INTO SalesInvoice VALUES (1273,39743.5610065459,39762.7764377627,647,NULL)
INSERT INTO SalesInvoice VALUES (1274,39744.9638808583,39746.0089483074,232,NULL)
INSERT INTO SalesInvoice VALUES (1275,39745.9321305158,39746.0497084674,383,NULL)
INSERT INTO SalesInvoice VALUES (1276,39746.489001519,39791.9620984985,549,NULL)
INSERT INTO SalesInvoice VALUES (1277,39748.0627507748,39762.33235201,365,NULL)
INSERT INTO SalesInvoice VALUES (1278,39748.2402887496,39764.9750237222,650,NULL)
INSERT INTO SalesInvoice VALUES (1279,39749.2041608373,39796.5396611915,664,NULL)
INSERT INTO SalesInvoice VALUES (1280,39749.9034802816,39797.8726171054,395,NULL)
INSERT INTO SalesInvoice VALUES (1281,39750.6348846968,39794.2545962249,236,NULL)
INSERT INTO SalesInvoice VALUES (1282,39751.3796940133,39794.1158698738,433,NULL)
INSERT INTO SalesInvoice VALUES (1283,39751.8869022404,39801.414017405,575,NULL)
INSERT INTO SalesInvoice VALUES (1284,39753.3320158021,39787.1631341805,615,NULL)
INSERT INTO SalesInvoice VALUES (1285,39754.6681699724,39803.1802593859,490,NULL)
INSERT INTO SalesInvoice VALUES (1286,39755.5656329107,39802.1527690147,426,NULL)
INSERT INTO SalesInvoice VALUES (1287,39756.1921547481,39790.53689913,185,NULL)
INSERT INTO SalesInvoice VALUES (1288,39756.6275583644,39791.7293118437,152,NULL)
INSERT INTO SalesInvoice VALUES (1289,39757.0967166961,39764.1765426947,639,NULL)
INSERT INTO SalesInvoice VALUES (1290,39758.2274434922,39791.170930432,540,NULL)
INSERT INTO SalesInvoice VALUES (1291,39759.450059153,39801.4529469333,190,NULL)
INSERT INTO SalesInvoice VALUES (1292,39760.7110015544,39806.3064010576,138,NULL)
INSERT INTO SalesInvoice VALUES (1293,39760.7865738058,39775.8823588153,16,NULL)
INSERT INTO SalesInvoice VALUES (1294,39762.1345827393,39809.5590484549,711,NULL)
INSERT INTO SalesInvoice VALUES (1295,39762.4256246706,39772.1125662884,415,NULL)
INSERT INTO SalesInvoice VALUES (1296,39763.2718515255,39775.7836112542,564,NULL)
INSERT INTO SalesInvoice VALUES (1297,39763.6546407754,39789.3966748111,218,NULL)
INSERT INTO SalesInvoice VALUES (1298,39764.709756044,39768.4662380029,329,NULL)
INSERT INTO SalesInvoice VALUES (1299,39765.8471415318,39785.3048636528,145,NULL)
INSERT INTO SalesInvoice VALUES (1300,39766.0724471954,39800.2047229802,69,NULL)
INSERT INTO SalesInvoice VALUES (1301,39767.1382433203,39770.4916665794,454,NULL)
INSERT INTO SalesInvoice VALUES (1302,39768.6936503563,39814.4660625044,629,NULL)
INSERT INTO SalesInvoice VALUES (1303,39769.864660649,39805.0177230995,603,NULL)
INSERT INTO SalesInvoice VALUES (1304,39770.3569841054,39780.1998564761,663,NULL)
INSERT INTO SalesInvoice VALUES (1305,39770.5976417041,39815.2894311398,298,NULL)
INSERT INTO SalesInvoice VALUES (1306,39771.4486869291,39811.5403049241,698,NULL)
INSERT INTO SalesInvoice VALUES (1307,39772.7042209701,39775.6371407668,528,NULL)
INSERT INTO SalesInvoice VALUES (1308,39772.759717177,39782.5831034239,352,NULL)
INSERT INTO SalesInvoice VALUES (1309,39773.3926897575,39797.5630330422,264,NULL)
INSERT INTO SalesInvoice VALUES (1310,39773.9869996886,39804.258728655,408,NULL)
INSERT INTO SalesInvoice VALUES (1311,39774.3937859509,39811.4652721223,363,NULL)
INSERT INTO SalesInvoice VALUES (1312,39775.1587616846,39803.216748774,155,NULL)
INSERT INTO SalesInvoice VALUES (1313,39775.6790888039,39806.6773676404,416,NULL)
INSERT INTO SalesInvoice VALUES (1314,39776.7336359259,39777.4473728995,189,NULL)
INSERT INTO SalesInvoice VALUES (1315,39777.1755085544,39809.8031041049,642,NULL)
INSERT INTO SalesInvoice VALUES (1316,39777.2920275974,39798.4432138226,569,NULL)
INSERT INTO SalesInvoice VALUES (1317,39777.5540362843,39793.7006716627,15,NULL)
INSERT INTO SalesInvoice VALUES (1318,39777.8505763439,39817.9706423345,92,NULL)
INSERT INTO SalesInvoice VALUES (1319,39778.1874130511,39799.4564113503,501,NULL)
INSERT INTO SalesInvoice VALUES (1320,39778.3033634019,39783.1453472842,708,NULL)
INSERT INTO SalesInvoice VALUES (1321,39778.6747662083,39781.7170028793,652,NULL)
INSERT INTO SalesInvoice VALUES (1322,39778.7914674977,39789.9996035164,106,NULL)
INSERT INTO SalesInvoice VALUES (1323,39779.1023719206,39811.5831653528,410,NULL)
INSERT INTO SalesInvoice VALUES (1324,39780.4468700476,39810.5400364883,591,NULL)
INSERT INTO SalesInvoice VALUES (1325,39781.2697173405,39816.7805976644,177,NULL)
INSERT INTO SalesInvoice VALUES (1326,39782.7176620267,39819.0173626018,343,NULL)
INSERT INTO SalesInvoice VALUES (1327,39783.9711042865,39816.8194345296,471,NULL)
INSERT INTO SalesInvoice VALUES (1328,39785.0125109757,39802.6397492777,425,NULL)
INSERT INTO SalesInvoice VALUES (1329,39786.5123226432,39803.8073682219,222,NULL)
INSERT INTO SalesInvoice VALUES (1330,39787.0687495529,39830.7192182878,631,NULL)
INSERT INTO SalesInvoice VALUES (1331,39787.4071745681,39797.5562975517,702,NULL)
INSERT INTO SalesInvoice VALUES (1332,39788.4379083446,39825.1859584189,104,NULL)
INSERT INTO SalesInvoice VALUES (1333,39788.6474358923,39810.3710229322,273,NULL)
INSERT INTO SalesInvoice VALUES (1334,39789.7674317529,39835.0022747306,732,NULL)
INSERT INTO SalesInvoice VALUES (1335,39790.0539885579,39804.8717740856,182,NULL)
INSERT INTO SalesInvoice VALUES (1336,39790.3382645932,39799.9394369176,203,NULL)
INSERT INTO SalesInvoice VALUES (1337,39790.3570464451,39821.1635585821,60,NULL)
INSERT INTO SalesInvoice VALUES (1338,39791.9288562236,39828.4417501109,66,NULL)
INSERT INTO SalesInvoice VALUES (1339,39793.0684094546,39800.2343653812,217,NULL)
INSERT INTO SalesInvoice VALUES (1340,39793.127505988,39796.9964880849,347,NULL)
INSERT INTO SalesInvoice VALUES (1341,39794.5297948634,39821.7695767808,221,NULL)
INSERT INTO SalesInvoice VALUES (1342,39795.6648328259,39819.0467320802,177,NULL)
INSERT INTO SalesInvoice VALUES (1343,39796.2488877055,39829.0362501523,764,NULL)
INSERT INTO SalesInvoice VALUES (1344,39796.5726611548,39808.681961263,765,NULL)
INSERT INTO SalesInvoice VALUES (1345,39797.2481135369,39801.9717614602,506,NULL)
INSERT INTO SalesInvoice VALUES (1346,39797.8545737714,39823.6826001757,185,NULL)
INSERT INTO SalesInvoice VALUES (1347,39798.7340844436,39808.2640300258,308,NULL)
INSERT INTO SalesInvoice VALUES (1348,39799.3117716359,39811.5716185323,605,NULL)
INSERT INTO SalesInvoice VALUES (1349,39799.9120320341,39839.6275092472,356,NULL)
INSERT INTO SalesInvoice VALUES (1350,39801.2478887291,39833.5918399955,452,NULL)
INSERT INTO SalesInvoice VALUES (1351,39802.1644070868,39842.1504539972,432,NULL)
INSERT INTO SalesInvoice VALUES (1352,39802.4810426879,39822.2457446776,774,NULL)
INSERT INTO SalesInvoice VALUES (1353,39802.6071913484,39815.7975773189,738,NULL)
INSERT INTO SalesInvoice VALUES (1354,39803.5920240077,39848.3882036594,596,NULL)
INSERT INTO SalesInvoice VALUES (1355,39804.9480373961,39843.0512105576,240,NULL)
INSERT INTO SalesInvoice VALUES (1356,39806.2067192486,39831.361822971,454,NULL)
INSERT INTO SalesInvoice VALUES (1357,39807.2936505636,39820.6874534895,233,NULL)
INSERT INTO SalesInvoice VALUES (1358,39808.3465353689,39815.356431412,476,NULL)
INSERT INTO SalesInvoice VALUES (1359,39808.8524468249,39833.7720966764,741,NULL)
INSERT INTO SalesInvoice VALUES (1360,39809.9946983827,39856.9043455297,375,NULL)
INSERT INTO SalesInvoice VALUES (1361,39810.6173966728,39815.2658416023,299,NULL)
INSERT INTO SalesInvoice VALUES (1362,39810.6710548884,39816.4826492326,402,NULL)
INSERT INTO SalesInvoice VALUES (1363,39812.073845265,39840.4662807037,482,NULL)
INSERT INTO SalesInvoice VALUES (1364,39812.0776327634,39832.6410698686,525,NULL)
INSERT INTO SalesInvoice VALUES (1365,39812.1701529621,39812.9402619218,566,NULL)
INSERT INTO SalesInvoice VALUES (1366,39813.050104909,39860.0058478202,393,NULL)
INSERT INTO SalesInvoice VALUES (1367,39814.5542859481,39821.3066923141,571,NULL)
INSERT INTO SalesInvoice VALUES (1368,39815.3983017613,39823.581484707,107,NULL)
INSERT INTO SalesInvoice VALUES (1369,39815.4968498818,39827.9932572317,268,NULL)
INSERT INTO SalesInvoice VALUES (1370,39815.5163890681,39829.4820902689,342,NULL)
INSERT INTO SalesInvoice VALUES (1371,39816.2653111583,39828.2888131292,191,NULL)
INSERT INTO SalesInvoice VALUES (1372,39816.56896388,39832.4306056058,166,NULL)
INSERT INTO SalesInvoice VALUES (1373,39818.047462666,39843.9031094858,386,NULL)
INSERT INTO SalesInvoice VALUES (1374,39819.4873506753,39866.4279681604,610,NULL)
INSERT INTO SalesInvoice VALUES (1375,39820.452813688,39820.7783125777,374,NULL)
INSERT INTO SalesInvoice VALUES (1376,39820.5025608343,39857.9881798601,604,NULL)
INSERT INTO SalesInvoice VALUES (1377,39821.4925919612,39834.2853011971,279,NULL)
INSERT INTO SalesInvoice VALUES (1378,39822.9649052587,39869.5738132033,199,NULL)
INSERT INTO SalesInvoice VALUES (1379,39823.0794207093,39831.4546606757,11,NULL)
INSERT INTO SalesInvoice VALUES (1380,39824.392386967,39839.0918804367,270,NULL)
INSERT INTO SalesInvoice VALUES (1381,39824.7137565112,39858.9623843539,154,NULL)
INSERT INTO SalesInvoice VALUES (1382,39825.1721225359,39855.044286866,348,NULL)
INSERT INTO SalesInvoice VALUES (1383,39826.6909019648,39850.5445243651,304,NULL)
INSERT INTO SalesInvoice VALUES (1384,39827.7615267282,39857.9890691434,432,NULL)
INSERT INTO SalesInvoice VALUES (1385,39829.1818446929,39832.8258260288,289,NULL)
INSERT INTO SalesInvoice VALUES (1386,39830.1817279063,39851.0513915047,42,NULL)
INSERT INTO SalesInvoice VALUES (1387,39830.3902073511,39850.4482654326,476,NULL)
INSERT INTO SalesInvoice VALUES (1388,39831.5503209021,39855.321189484,658,NULL)
INSERT INTO SalesInvoice VALUES (1389,39832.4457791088,39872.5310030129,162,NULL)
INSERT INTO SalesInvoice VALUES (1390,39833.4913207384,39854.8298707056,50,NULL)
INSERT INTO SalesInvoice VALUES (1391,39834.1550938896,39848.0030433784,624,NULL)
INSERT INTO SalesInvoice VALUES (1392,39834.5932436413,39866.8119298178,259,NULL)
INSERT INTO SalesInvoice VALUES (1393,39834.8737335323,39871.5276849172,256,NULL)
INSERT INTO SalesInvoice VALUES (1394,39836.1594676062,39858.8325428883,595,NULL)
INSERT INTO SalesInvoice VALUES (1395,39836.9759474838,39840.0984829123,286,NULL)
INSERT INTO SalesInvoice VALUES (1396,39837.9428873422,39879.3599214828,466,NULL)
INSERT INTO SalesInvoice VALUES (1397,39838.7858808734,39881.2492523274,425,NULL)
INSERT INTO SalesInvoice VALUES (1398,39839.948049263,39848.105919749,735,NULL)
INSERT INTO SalesInvoice VALUES (1399,39840.8938235967,39842.4576060457,768,NULL)
INSERT INTO SalesInvoice VALUES (1400,39841.1165707152,39862.0685891687,48,NULL)
INSERT INTO SalesInvoice VALUES (1401,39842.3062962732,39847.1832753687,1,NULL)
INSERT INTO SalesInvoice VALUES (1402,39842.9732476802,39847.0272525683,517,NULL)
INSERT INTO SalesInvoice VALUES (1403,39844.2292038051,39884.9952918017,180,NULL)
INSERT INTO SalesInvoice VALUES (1404,39845.4403104706,39882.814987042,334,NULL)
INSERT INTO SalesInvoice VALUES (1405,39846.4426926605,39889.6643866205,673,NULL)
INSERT INTO SalesInvoice VALUES (1406,39846.8380871251,39890.727189943,104,NULL)
INSERT INTO SalesInvoice VALUES (1407,39847.0645485791,39875.9659521912,431,NULL)
INSERT INTO SalesInvoice VALUES (1408,39847.1425947894,39877.4420546667,595,NULL)
INSERT INTO SalesInvoice VALUES (1409,39847.3727331776,39883.9123417125,308,NULL)
INSERT INTO SalesInvoice VALUES (1410,39847.6706175397,39886.4425559449,315,NULL)
INSERT INTO SalesInvoice VALUES (1411,39848.1863960161,39873.4781468115,248,NULL)
INSERT INTO SalesInvoice VALUES (1412,39849.5001193494,39880.5163740327,86,NULL)
INSERT INTO SalesInvoice VALUES (1413,39850.4490456421,39851.6343651134,771,NULL)
INSERT INTO SalesInvoice VALUES (1414,39851.2581607539,39895.7336394114,152,NULL)
INSERT INTO SalesInvoice VALUES (1415,39851.5580473108,39887.7341589844,53,NULL)
INSERT INTO SalesInvoice VALUES (1416,39851.9243814246,39891.5273293153,741,NULL)
INSERT INTO SalesInvoice VALUES (1417,39853.3553670518,39890.3411598755,361,NULL)
INSERT INTO SalesInvoice VALUES (1418,39854.0487103958,39894.2078769436,768,NULL)
INSERT INTO SalesInvoice VALUES (1419,39854.1548609838,39902.2839974476,106,NULL)
INSERT INTO SalesInvoice VALUES (1420,39854.5904250643,39880.4985294101,408,NULL)
INSERT INTO SalesInvoice VALUES (1421,39855.8624321592,39901.4848203979,288,NULL)
INSERT INTO SalesInvoice VALUES (1422,39856.5371107622,39894.5169277349,246,NULL)
INSERT INTO SalesInvoice VALUES (1423,39857.4274858929,39885.483510372,396,NULL)
INSERT INTO SalesInvoice VALUES (1424,39858.3000947506,39864.8012538733,282,NULL)
INSERT INTO SalesInvoice VALUES (1425,39859.1498189858,39872.4025196134,161,NULL)
INSERT INTO SalesInvoice VALUES (1426,39860.0591580422,39888.8818343277,551,NULL)
INSERT INTO SalesInvoice VALUES (1427,39860.5013549206,39894.1336744594,150,NULL)
INSERT INTO SalesInvoice VALUES (1428,39861.4942747132,39884.0125624275,463,NULL)
INSERT INTO SalesInvoice VALUES (1429,39862.1595857599,39898.4705196397,124,NULL)
INSERT INTO SalesInvoice VALUES (1430,39863.0507468055,39904.5980582217,403,NULL)
INSERT INTO SalesInvoice VALUES (1431,39864.1210112135,39903.1160594598,760,NULL)
INSERT INTO SalesInvoice VALUES (1432,39865.5680621522,39893.2375503766,564,NULL)
INSERT INTO SalesInvoice VALUES (1433,39865.8662564324,39885.9843887202,522,NULL)
INSERT INTO SalesInvoice VALUES (1434,39867.0608331513,39887.6556209504,33,NULL)
INSERT INTO SalesInvoice VALUES (1435,39868.4178283863,39887.2963867824,625,NULL)
INSERT INTO SalesInvoice VALUES (1436,39868.9111917069,39901.2672424446,9,NULL)
INSERT INTO SalesInvoice VALUES (1437,39869.7118085448,39903.2860693118,544,NULL)
INSERT INTO SalesInvoice VALUES (1438,39870.2210622457,39872.85573314,400,NULL)
INSERT INTO SalesInvoice VALUES (1439,39871.2456027718,39871.2637254908,194,NULL)
INSERT INTO SalesInvoice VALUES (1440,39872.1270155647,39883.8123252194,114,NULL)
INSERT INTO SalesInvoice VALUES (1441,39873.5103623988,39876.6805492952,600,NULL)
INSERT INTO SalesInvoice VALUES (1442,39873.716534041,39912.5235970382,313,NULL)
INSERT INTO SalesInvoice VALUES (1443,39874.9806776478,39903.9790022356,172,NULL)
INSERT INTO SalesInvoice VALUES (1444,39875.2351240062,39877.290104459,211,NULL)
INSERT INTO SalesInvoice VALUES (1445,39876.4383264447,39879.6373381432,382,NULL)
INSERT INTO SalesInvoice VALUES (1446,39877.5373998254,39926.7522007149,419,NULL)
INSERT INTO SalesInvoice VALUES (1447,39878.1690913684,39901.3792907123,17,NULL)
INSERT INTO SalesInvoice VALUES (1448,39879.3794333612,39913.9065559071,106,NULL)
INSERT INTO SalesInvoice VALUES (1449,39879.8915964654,39881.6833932461,709,NULL)
INSERT INTO SalesInvoice VALUES (1450,39880.8963380488,39908.830160374,235,NULL)
INSERT INTO SalesInvoice VALUES (1451,39881.1922715939,39930.3664545668,33,NULL)
INSERT INTO SalesInvoice VALUES (1452,39882.1049362353,39931.1349824165,681,NULL)
INSERT INTO SalesInvoice VALUES (1453,39882.4579686419,39891.0620471453,509,NULL)
INSERT INTO SalesInvoice VALUES (1454,39883.3579137977,39920.5903474459,633,NULL)
INSERT INTO SalesInvoice VALUES (1455,39883.3650540791,39914.3508142294,86,NULL)
INSERT INTO SalesInvoice VALUES (1456,39883.5070473015,39926.8734380171,600,NULL)
INSERT INTO SalesInvoice VALUES (1457,39884.8987662241,39889.0811061239,433,NULL)
INSERT INTO SalesInvoice VALUES (1458,39885.2804465307,39924.3042628294,42,NULL)
INSERT INTO SalesInvoice VALUES (1459,39886.6658751094,39928.0275499816,490,NULL)
INSERT INTO SalesInvoice VALUES (1460,39887.8370455227,39923.3879543401,84,NULL)
INSERT INTO SalesInvoice VALUES (1461,39887.9329376361,39919.1507500414,14,NULL)
INSERT INTO SalesInvoice VALUES (1462,39889.490738504,39915.8614271385,458,NULL)
INSERT INTO SalesInvoice VALUES (1463,39890.434354982,39894.6279097407,11,NULL)
INSERT INTO SalesInvoice VALUES (1464,39891.1766640418,39917.3004441295,367,NULL)
INSERT INTO SalesInvoice VALUES (1465,39892.2972824134,39918.9915120209,614,NULL)
INSERT INTO SalesInvoice VALUES (1466,39893.6744245939,39917.9761660575,408,NULL)
INSERT INTO SalesInvoice VALUES (1467,39894.7135672325,39911.7974482193,632,NULL)
INSERT INTO SalesInvoice VALUES (1468,39896.1020070484,39932.6734288378,610,NULL)
INSERT INTO SalesInvoice VALUES (1469,39897.2801787604,39911.9216648903,702,NULL)
INSERT INTO SalesInvoice VALUES (1470,39897.492239087,39921.9934673279,179,NULL)
INSERT INTO SalesInvoice VALUES (1471,39899.0137751532,39915.2098839603,209,NULL)
INSERT INTO SalesInvoice VALUES (1472,39899.7594331961,39937.0460245443,468,NULL)
INSERT INTO SalesInvoice VALUES (1473,39900.4748373213,39940.4188405938,747,NULL)
INSERT INTO SalesInvoice VALUES (1474,39901.7696695534,39923.2129719786,281,NULL)
INSERT INTO SalesInvoice VALUES (1475,39903.3427757387,39926.7727214701,186,NULL)
INSERT INTO SalesInvoice VALUES (1476,39904.2403882006,39939.532959644,696,NULL)
INSERT INTO SalesInvoice VALUES (1477,39905.5038258651,39911.9731302027,176,NULL)
INSERT INTO SalesInvoice VALUES (1478,39906.2696338095,39918.9748337826,190,NULL)
INSERT INTO SalesInvoice VALUES (1479,39906.4538967849,39950.8151410263,79,NULL)
INSERT INTO SalesInvoice VALUES (1480,39906.8824494863,39940.5863272961,744,NULL)
INSERT INTO SalesInvoice VALUES (1481,39907.5895454468,39931.6918424492,298,NULL)
INSERT INTO SalesInvoice VALUES (1482,39907.9274949476,39951.0871578605,570,NULL)
INSERT INTO SalesInvoice VALUES (1483,39908.8303562405,39922.3884802705,111,NULL)
INSERT INTO SalesInvoice VALUES (1484,39908.895857302,39949.5889594474,411,NULL)
INSERT INTO SalesInvoice VALUES (1485,39909.0898119285,39950.3015010674,249,NULL)
INSERT INTO SalesInvoice VALUES (1486,39909.2570708918,39913.8518451194,584,NULL)
INSERT INTO SalesInvoice VALUES (1487,39910.1920945051,39914.6031846568,14,NULL)
INSERT INTO SalesInvoice VALUES (1488,39911.5640503077,39937.3617971976,145,NULL)
INSERT INTO SalesInvoice VALUES (1489,39912.4310927597,39950.5411271868,621,NULL)
INSERT INTO SalesInvoice VALUES (1490,39913.4391980796,39934.2298841427,450,NULL)
INSERT INTO SalesInvoice VALUES (1491,39914.5468906756,39953.9059177208,331,NULL)
INSERT INTO SalesInvoice VALUES (1492,39914.9723571527,39927.2999333203,178,NULL)
INSERT INTO SalesInvoice VALUES (1493,39915.0077300748,39918.8721668622,424,NULL)
INSERT INTO SalesInvoice VALUES (1494,39915.9310611445,39962.5760530935,31,NULL)
INSERT INTO SalesInvoice VALUES (1495,39916.5099833552,39921.0230365953,573,NULL)
INSERT INTO SalesInvoice VALUES (1496,39917.123827711,39961.5640860226,464,NULL)
INSERT INTO SalesInvoice VALUES (1497,39918.5776583433,39959.3254252431,393,NULL)
INSERT INTO SalesInvoice VALUES (1498,39919.9748709723,39951.7629530283,704,NULL)
INSERT INTO SalesInvoice VALUES (1499,39921.038147854,39959.8291098353,363,NULL)
INSERT INTO SalesInvoice VALUES (1500,39921.1721321156,39957.4005187688,357,NULL)
INSERT INTO SalesInvoice VALUES (1501,39922.5690576742,39925.2377686564,669,NULL)
INSERT INTO SalesInvoice VALUES (1502,39922.6708479586,39967.5343349139,188,NULL)
INSERT INTO SalesInvoice VALUES (1503,39922.7941710868,39938.6839252485,683,NULL)
INSERT INTO SalesInvoice VALUES (1504,39923.8470146855,39933.1470338192,735,NULL)
INSERT INTO SalesInvoice VALUES (1505,39923.9525441482,39956.1141867751,347,NULL)
INSERT INTO SalesInvoice VALUES (1506,39924.2334276713,39972.3992567884,30,NULL)
INSERT INTO SalesInvoice VALUES (1507,39924.3057295188,39930.4818527335,127,NULL)
INSERT INTO SalesInvoice VALUES (1508,39924.8429457689,39969.0202342117,25,NULL)
INSERT INTO SalesInvoice VALUES (1509,39925.7933820712,39962.3944180113,4,NULL)
INSERT INTO SalesInvoice VALUES (1510,39927.3567788687,39933.558712765,204,NULL)
INSERT INTO SalesInvoice VALUES (1511,39927.5691814712,39960.3840867045,74,NULL)
INSERT INTO SalesInvoice VALUES (1512,39928.7863762618,39969.4140236878,651,NULL)
INSERT INTO SalesInvoice VALUES (1513,39930.3041628216,39931.9145739512,642,NULL)
INSERT INTO SalesInvoice VALUES (1514,39930.740277958,39946.4082858753,682,NULL)
INSERT INTO SalesInvoice VALUES (1515,39931.3286388573,39936.1921063247,763,NULL)
INSERT INTO SalesInvoice VALUES (1516,39931.3765325048,39980.982878118,672,NULL)
INSERT INTO SalesInvoice VALUES (1517,39931.6963005021,39967.7239250772,712,NULL)
INSERT INTO SalesInvoice VALUES (1518,39932.4607972485,39936.1119870808,539,NULL)
INSERT INTO SalesInvoice VALUES (1519,39932.7129234803,39946.6993339877,412,NULL)
INSERT INTO SalesInvoice VALUES (1520,39933.9373144476,39961.0347703026,593,NULL)
INSERT INTO SalesInvoice VALUES (1521,39935.1773917503,39954.0301951309,342,NULL)
INSERT INTO SalesInvoice VALUES (1522,39935.9700408821,39941.4572091011,354,NULL)
INSERT INTO SalesInvoice VALUES (1523,39936.6001074735,39944.7227288468,99,NULL)
INSERT INTO SalesInvoice VALUES (1524,39938.065488765,39948.282632279,612,NULL)
INSERT INTO SalesInvoice VALUES (1525,39938.6498121637,39977.2855260924,32,NULL)
INSERT INTO SalesInvoice VALUES (1526,39940.20341672,39955.115989176,134,NULL)
INSERT INTO SalesInvoice VALUES (1527,39941.5425527755,39953.6679427404,72,NULL)
INSERT INTO SalesInvoice VALUES (1528,39942.4702569899,39968.7046607217,452,NULL)
INSERT INTO SalesInvoice VALUES (1529,39943.697432177,39977.7231407653,501,NULL)
INSERT INTO SalesInvoice VALUES (1530,39944.9889702002,39989.5388080529,656,NULL)
INSERT INTO SalesInvoice VALUES (1531,39945.05449345,39984.2308518572,566,NULL)
INSERT INTO SalesInvoice VALUES (1532,39945.1711948851,39982.3438982821,89,NULL)
INSERT INTO SalesInvoice VALUES (1533,39945.7462005923,39984.0935184854,588,NULL)
INSERT INTO SalesInvoice VALUES (1534,39945.9536806889,39967.149257843,651,NULL)
INSERT INTO SalesInvoice VALUES (1535,39946.8810425765,39948.2725202725,756,NULL)
INSERT INTO SalesInvoice VALUES (1536,39947.9977613436,39995.6146004827,553,NULL)
INSERT INTO SalesInvoice VALUES (1537,39949.2602988876,39953.8964078287,51,NULL)
INSERT INTO SalesInvoice VALUES (1538,39950.7205907367,39953.2684633524,563,NULL)
INSERT INTO SalesInvoice VALUES (1539,39951.6023116552,39981.0447592665,725,NULL)
INSERT INTO SalesInvoice VALUES (1540,39952.1456192397,39980.4222343064,56,NULL)
INSERT INTO SalesInvoice VALUES (1541,39953.3620981928,39996.9130506445,441,NULL)
INSERT INTO SalesInvoice VALUES (1542,39954.7285016781,39988.422917362,349,NULL)
INSERT INTO SalesInvoice VALUES (1543,39955.3064175731,39959.049606495,87,NULL)
INSERT INTO SalesInvoice VALUES (1544,39955.5296985039,40003.1146513283,681,NULL)
INSERT INTO SalesInvoice VALUES (1545,39956.2221212902,39995.327939484,549,NULL)
INSERT INTO SalesInvoice VALUES (1546,39957.7908842559,39967.7552330628,219,NULL)
INSERT INTO SalesInvoice VALUES (1547,39957.865136893,39994.0538926311,403,NULL)
INSERT INTO SalesInvoice VALUES (1548,39958.1511192066,39971.7005248539,663,NULL)
INSERT INTO SalesInvoice VALUES (1549,39958.4405565964,39969.1933290824,548,NULL)
INSERT INTO SalesInvoice VALUES (1550,39959.2655408666,39971.5318833633,632,NULL)
INSERT INTO SalesInvoice VALUES (1551,39960.3685960278,40000.0213804095,505,NULL)
INSERT INTO SalesInvoice VALUES (1552,39960.3689934139,40007.0263937128,388,NULL)
INSERT INTO SalesInvoice VALUES (1553,39960.8030130256,39975.7796778549,139,NULL)
INSERT INTO SalesInvoice VALUES (1554,39962.1473653298,40011.3838503627,765,NULL)
INSERT INTO SalesInvoice VALUES (1555,39962.2114114238,40002.5833258062,744,NULL)
INSERT INTO SalesInvoice VALUES (1556,39962.5403558311,39981.2557378477,443,NULL)
INSERT INTO SalesInvoice VALUES (1557,39963.2393507435,40009.0805405508,388,NULL)
INSERT INTO SalesInvoice VALUES (1558,39964.391485589,39990.9879095292,601,NULL)
INSERT INTO SalesInvoice VALUES (1559,39964.5702476672,39973.4548279144,399,NULL)
INSERT INTO SalesInvoice VALUES (1560,39965.7582580056,40014.067359384,90,NULL)
INSERT INTO SalesInvoice VALUES (1561,39966.3594842625,39969.565006896,704,NULL)
INSERT INTO SalesInvoice VALUES (1562,39967.5002858436,39988.21331382,165,NULL)
INSERT INTO SalesInvoice VALUES (1563,39968.7937028503,40006.7876323439,45,NULL)
INSERT INTO SalesInvoice VALUES (1564,39969.0483008182,40011.1563240825,278,NULL)
INSERT INTO SalesInvoice VALUES (1565,39969.988822228,39970.9281525904,382,NULL)
INSERT INTO SalesInvoice VALUES (1566,39970.8844805832,40004.4948700723,30,NULL)
INSERT INTO SalesInvoice VALUES (1567,39972.2586857694,39981.760804493,711,NULL)
INSERT INTO SalesInvoice VALUES (1568,39972.5650923251,40006.9422965342,213,NULL)
INSERT INTO SalesInvoice VALUES (1569,39972.8447914886,40015.4559933943,665,NULL)
INSERT INTO SalesInvoice VALUES (1570,39974.1155200047,39992.3170306742,413,NULL)
INSERT INTO SalesInvoice VALUES (1571,39974.7948924034,39989.0967407204,149,NULL)
INSERT INTO SalesInvoice VALUES (1572,39976.0560199082,39989.7864004453,418,NULL)
INSERT INTO SalesInvoice VALUES (1573,39976.0639824824,40000.6192044989,525,NULL)
INSERT INTO SalesInvoice VALUES (1574,39976.8854266318,39980.9520700512,546,NULL)
INSERT INTO SalesInvoice VALUES (1575,39976.9737482872,40011.9864427173,103,NULL)
INSERT INTO SalesInvoice VALUES (1576,39977.3756777956,39990.164913095,427,NULL)
INSERT INTO SalesInvoice VALUES (1577,39978.0918225899,39980.7148061261,658,NULL)
INSERT INTO SalesInvoice VALUES (1578,39978.1860990133,40000.924027294,401,NULL)
INSERT INTO SalesInvoice VALUES (1579,39979.3615120943,39989.7388794352,681,NULL)
INSERT INTO SalesInvoice VALUES (1580,39980.8663798268,39992.9303743713,614,NULL)
INSERT INTO SalesInvoice VALUES (1581,39981.9424201824,40002.130345947,770,NULL)
INSERT INTO SalesInvoice VALUES (1582,39982.0204048555,40005.2108331044,8,NULL)
INSERT INTO SalesInvoice VALUES (1583,39983.0480546342,39999.2579524935,392,NULL)
INSERT INTO SalesInvoice VALUES (1584,39983.1251821043,39993.1974157879,238,NULL)
INSERT INTO SalesInvoice VALUES (1585,39984.6132185662,40024.6573403914,726,NULL)
INSERT INTO SalesInvoice VALUES (1586,39985.795320902,40020.9833720935,214,NULL)
INSERT INTO SalesInvoice VALUES (1587,39987.3215347326,40028.0168876186,259,NULL)
INSERT INTO SalesInvoice VALUES (1588,39987.4130961354,40005.1247112363,534,NULL)
INSERT INTO SalesInvoice VALUES (1589,39988.555622832,40037.6359999803,629,NULL)
INSERT INTO SalesInvoice VALUES (1590,39989.3890126028,40006.9933476208,728,NULL)
INSERT INTO SalesInvoice VALUES (1591,39990.6682887385,40005.5821868605,347,NULL)
INSERT INTO SalesInvoice VALUES (1592,39991.211108409,39995.6651452183,317,NULL)
INSERT INTO SalesInvoice VALUES (1593,39991.8623109329,40000.6964117565,442,NULL)
INSERT INTO SalesInvoice VALUES (1594,39993.1060132985,40036.1193872569,458,NULL)
INSERT INTO SalesInvoice VALUES (1595,39994.068937999,40027.0624518722,558,NULL)
INSERT INTO SalesInvoice VALUES (1596,39995.3027084908,40008.0082459969,255,NULL)
INSERT INTO SalesInvoice VALUES (1597,39996.8444526595,40025.4172791935,154,NULL)
INSERT INTO SalesInvoice VALUES (1598,39998.0362362145,40039.1361243141,654,NULL)
INSERT INTO SalesInvoice VALUES (1599,39999.1941345993,40020.2652229798,547,NULL)
INSERT INTO SalesInvoice VALUES (1600,39999.5521142658,40034.2183756021,195,NULL)
INSERT INTO SalesInvoice VALUES (1601,40000.0811846026,40011.2592979446,257,NULL)
INSERT INTO SalesInvoice VALUES (1602,40001.0450209476,40019.8695387742,81,NULL)
INSERT INTO SalesInvoice VALUES (1603,40001.3110652594,40013.4232246112,338,NULL)
INSERT INTO SalesInvoice VALUES (1604,40002.0561817605,40028.0133579184,710,NULL)
INSERT INTO SalesInvoice VALUES (1605,40002.8016041512,40016.810840984,487,NULL)
INSERT INTO SalesInvoice VALUES (1606,40002.8613066714,40037.8533151369,441,NULL)
INSERT INTO SalesInvoice VALUES (1607,40004.2383013201,40005.1155110068,121,NULL)
INSERT INTO SalesInvoice VALUES (1608,40004.9394139322,40010.1084073921,352,NULL)
INSERT INTO SalesInvoice VALUES (1609,40006.3100534991,40020.9432119906,15,NULL)
INSERT INTO SalesInvoice VALUES (1610,40007.7295847792,40009.7746535086,368,NULL)
INSERT INTO SalesInvoice VALUES (1611,40009.2043380358,40040.8947787778,392,NULL)
INSERT INTO SalesInvoice VALUES (1612,40009.554693548,40015.4431069499,601,NULL)
INSERT INTO SalesInvoice VALUES (1613,40009.7519740271,40029.0699665867,298,NULL)
INSERT INTO SalesInvoice VALUES (1614,40010.7292067517,40058.2539324674,87,NULL)
INSERT INTO SalesInvoice VALUES (1615,40010.7614478444,40023.1449324625,289,NULL)
INSERT INTO SalesInvoice VALUES (1616,40011.2206401673,40055.679675274,683,NULL)
INSERT INTO SalesInvoice VALUES (1617,40011.8575408526,40045.4794692402,370,NULL)
INSERT INTO SalesInvoice VALUES (1618,40012.4174828587,40056.0796610831,686,NULL)
INSERT INTO SalesInvoice VALUES (1619,40013.9730020482,40055.7191871815,634,NULL)
INSERT INTO SalesInvoice VALUES (1620,40015.3626374233,40036.8970731836,313,NULL)
INSERT INTO SalesInvoice VALUES (1621,40016.8742192413,40039.6593233769,510,NULL)
INSERT INTO SalesInvoice VALUES (1622,40017.0006320372,40042.8534518163,69,NULL)
INSERT INTO SalesInvoice VALUES (1623,40018.2257584809,40028.3546042985,657,NULL)
INSERT INTO SalesInvoice VALUES (1624,40019.2132645661,40048.3971141382,235,NULL)
INSERT INTO SalesInvoice VALUES (1625,40020.4664589364,40034.2471650245,519,NULL)
INSERT INTO SalesInvoice VALUES (1626,40021.5116462068,40052.6212890379,494,NULL)
INSERT INTO SalesInvoice VALUES (1627,40022.2157569408,40043.1243728044,607,NULL)
INSERT INTO SalesInvoice VALUES (1628,40023.4361776392,40046.5088730045,284,NULL)
INSERT INTO SalesInvoice VALUES (1629,40024.0489965612,40057.8000238586,149,NULL)
INSERT INTO SalesInvoice VALUES (1630,40025.1124228044,40039.8071170927,76,NULL)
INSERT INTO SalesInvoice VALUES (1631,40025.7108865363,40064.5128807221,544,NULL)
INSERT INTO SalesInvoice VALUES (1632,40026.4538353691,40070.4684518868,584,NULL)
INSERT INTO SalesInvoice VALUES (1633,40026.9211019843,40032.0569389855,429,NULL)
INSERT INTO SalesInvoice VALUES (1634,40027.7217355707,40064.7663111388,342,NULL)
INSERT INTO SalesInvoice VALUES (1635,40028.2991154996,40071.7125697722,139,NULL)
INSERT INTO SalesInvoice VALUES (1636,40028.5220834397,40048.9726779231,373,NULL)
INSERT INTO SalesInvoice VALUES (1637,40029.6480568773,40031.9936418737,181,NULL)
INSERT INTO SalesInvoice VALUES (1638,40030.6735616061,40043.3294897467,754,NULL)
INSERT INTO SalesInvoice VALUES (1639,40031.8533404301,40056.7388007921,614,NULL)
INSERT INTO SalesInvoice VALUES (1640,40033.0705306403,40058.3631455204,492,NULL)
INSERT INTO SalesInvoice VALUES (1641,40033.3680402134,40044.035874132,156,NULL)
INSERT INTO SalesInvoice VALUES (1642,40033.4566001668,40058.7942792328,364,NULL)
INSERT INTO SalesInvoice VALUES (1643,40034.1266444239,40083.7039429428,428,NULL)
INSERT INTO SalesInvoice VALUES (1644,40034.3898678259,40054.46665564,400,NULL)
INSERT INTO SalesInvoice VALUES (1645,40035.6920014747,40042.4116545815,729,NULL)
INSERT INTO SalesInvoice VALUES (1646,40036.8071098661,40063.2580163825,636,NULL)
INSERT INTO SalesInvoice VALUES (1647,40037.6517790692,40068.8848180777,710,NULL)
INSERT INTO SalesInvoice VALUES (1648,40038.1669525231,40074.2618183868,322,NULL)
INSERT INTO SalesInvoice VALUES (1649,40039.6915870484,40072.0717549341,118,NULL)
INSERT INTO SalesInvoice VALUES (1650,40039.9838176174,40072.0085015189,771,NULL)
INSERT INTO SalesInvoice VALUES (1651,40040.920768111,40054.8125231244,688,NULL)
INSERT INTO SalesInvoice VALUES (1652,40041.2366218366,40061.1601068674,460,NULL)
INSERT INTO SalesInvoice VALUES (1653,40042.4577026281,40064.7707343578,680,NULL)
INSERT INTO SalesInvoice VALUES (1654,40043.7122244367,40065.1308841699,729,NULL)
INSERT INTO SalesInvoice VALUES (1655,40044.2026613643,40068.807229203,421,NULL)
INSERT INTO SalesInvoice VALUES (1656,40045.1612628649,40065.7267651601,155,NULL)
INSERT INTO SalesInvoice VALUES (1657,40046.1047431278,40064.5306129109,410,NULL)
INSERT INTO SalesInvoice VALUES (1658,40047.0280550456,40049.0501106364,475,NULL)
INSERT INTO SalesInvoice VALUES (1659,40047.218434713,40080.4232067985,741,NULL)
INSERT INTO SalesInvoice VALUES (1660,40048.5657302577,40058.7787974611,187,NULL)
INSERT INTO SalesInvoice VALUES (1661,40048.6161001655,40090.0956409076,532,NULL)
INSERT INTO SalesInvoice VALUES (1662,40049.8485053289,40051.8757819587,524,NULL)
INSERT INTO SalesInvoice VALUES (1663,40050.0358872421,40062.3902442055,382,NULL)
INSERT INTO SalesInvoice VALUES (1664,40050.2917148168,40065.5702700922,198,NULL)
INSERT INTO SalesInvoice VALUES (1665,40051.6652341096,40054.2319926492,331,NULL)
INSERT INTO SalesInvoice VALUES (1666,40053.1306159116,40094.9157245133,116,NULL)
INSERT INTO SalesInvoice VALUES (1667,40053.4207595949,40059.3466070752,715,NULL)
INSERT INTO SalesInvoice VALUES (1668,40054.0154800617,40060.7171569959,163,NULL)
INSERT INTO SalesInvoice VALUES (1669,40055.1016677501,40058.9127415043,579,NULL)
INSERT INTO SalesInvoice VALUES (1670,40056.1530200561,40093.9802038706,245,NULL)
INSERT INTO SalesInvoice VALUES (1671,40056.3514161533,40098.5897850618,558,NULL)
INSERT INTO SalesInvoice VALUES (1672,40056.7499925427,40061.1946694682,180,NULL)
INSERT INTO SalesInvoice VALUES (1673,40058.0666612871,40072.9415480447,625,NULL)
INSERT INTO SalesInvoice VALUES (1674,40059.6456191176,40086.9339858423,701,NULL)
INSERT INTO SalesInvoice VALUES (1675,40060.967630134,40097.6673777903,120,NULL)
INSERT INTO SalesInvoice VALUES (1676,40062.5407653987,40074.7728012614,455,NULL)
INSERT INTO SalesInvoice VALUES (1677,40062.9528562575,40076.3436146112,301,NULL)
INSERT INTO SalesInvoice VALUES (1678,40063.6128798001,40105.1271627493,709,NULL)
INSERT INTO SalesInvoice VALUES (1679,40064.8244771826,40072.2047574974,690,NULL)
INSERT INTO SalesInvoice VALUES (1680,40064.9128825763,40089.9719529642,206,NULL)
INSERT INTO SalesInvoice VALUES (1681,40065.1404312817,40104.9341273165,173,NULL)
INSERT INTO SalesInvoice VALUES (1682,40066.4428069017,40095.641775855,45,NULL)
INSERT INTO SalesInvoice VALUES (1683,40066.7304991912,40080.5079129687,259,NULL)
INSERT INTO SalesInvoice VALUES (1684,40068.2452620547,40102.9702775891,476,NULL)
INSERT INTO SalesInvoice VALUES (1685,40069.0009194629,40080.1318679957,415,NULL)
INSERT INTO SalesInvoice VALUES (1686,40070.2990684916,40076.2711601737,125,NULL)
INSERT INTO SalesInvoice VALUES (1687,40071.6177369454,40086.8792657946,424,NULL)
INSERT INTO SalesInvoice VALUES (1688,40071.7788356125,40110.0611964425,665,NULL)
INSERT INTO SalesInvoice VALUES (1689,40072.0822087378,40084.8790675564,314,NULL)
INSERT INTO SalesInvoice VALUES (1690,40072.3454182358,40119.6840084481,250,NULL)
INSERT INTO SalesInvoice VALUES (1691,40073.4937770263,40098.6024555925,499,NULL)
INSERT INTO SalesInvoice VALUES (1692,40074.8622863096,40117.5239469937,192,NULL)
INSERT INTO SalesInvoice VALUES (1693,40075.8965539869,40125.6739640462,755,NULL)
INSERT INTO SalesInvoice VALUES (1694,40077.3626882699,40114.0067476423,72,NULL)
INSERT INTO SalesInvoice VALUES (1695,40078.3263814732,40103.9291357322,158,NULL)
INSERT INTO SalesInvoice VALUES (1696,40078.9844285687,40098.3454466379,271,NULL)
INSERT INTO SalesInvoice VALUES (1697,40080.0343791165,40112.8322844731,336,NULL)
INSERT INTO SalesInvoice VALUES (1698,40081.2406334459,40097.0010096785,553,NULL)
INSERT INTO SalesInvoice VALUES (1699,40081.4318765231,40100.2018102818,554,NULL)
INSERT INTO SalesInvoice VALUES (1700,40082.4029447606,40083.3692713038,641,NULL)
INSERT INTO SalesInvoice VALUES (1701,40082.9282178134,40129.0741067588,619,NULL)
INSERT INTO SalesInvoice VALUES (1702,40083.3784826448,40132.650099895,338,NULL)
INSERT INTO SalesInvoice VALUES (1703,40084.9246464019,40109.4157322465,159,NULL)
INSERT INTO SalesInvoice VALUES (1704,40085.1578608934,40116.4192644038,468,NULL)
INSERT INTO SalesInvoice VALUES (1705,40085.9444911693,40120.7886393536,529,NULL)
INSERT INTO SalesInvoice VALUES (1706,40086.4481890111,40124.0474165359,546,NULL)
INSERT INTO SalesInvoice VALUES (1707,40086.8641840419,40123.4791236367,156,NULL)
INSERT INTO SalesInvoice VALUES (1708,40088.40161739,40102.5534701044,248,NULL)
INSERT INTO SalesInvoice VALUES (1709,40088.8703954367,40126.2958407364,575,NULL)
INSERT INTO SalesInvoice VALUES (1710,40090.2365533747,40090.9171431711,208,NULL)
INSERT INTO SalesInvoice VALUES (1711,40090.6776615632,40127.329157884,247,NULL)
INSERT INTO SalesInvoice VALUES (1712,40091.0904538761,40136.2943824617,235,NULL)
INSERT INTO SalesInvoice VALUES (1713,40091.3132554845,40103.9049255437,497,NULL)
INSERT INTO SalesInvoice VALUES (1714,40092.022174509,40128.7425289449,27,NULL)
INSERT INTO SalesInvoice VALUES (1715,40092.3207451238,40113.2541769712,582,NULL)
INSERT INTO SalesInvoice VALUES (1716,40093.6997111539,40113.1137972136,126,NULL)
INSERT INTO SalesInvoice VALUES (1717,40094.2151307776,40140.2953976409,500,NULL)
INSERT INTO SalesInvoice VALUES (1718,40095.4451303069,40110.8480490977,259,NULL)
INSERT INTO SalesInvoice VALUES (1719,40096.6217276911,40130.3239401497,248,NULL)
INSERT INTO SalesInvoice VALUES (1720,40097.2799901126,40130.7468514742,526,NULL)
INSERT INTO SalesInvoice VALUES (1721,40098.2254655263,40119.7197699672,235,NULL)
INSERT INTO SalesInvoice VALUES (1722,40098.7719482281,40140.7476758166,448,NULL)
INSERT INTO SalesInvoice VALUES (1723,40099.1300440004,40113.4148703462,51,NULL)
INSERT INTO SalesInvoice VALUES (1724,40100.6375255771,40150.4535803945,249,NULL)
INSERT INTO SalesInvoice VALUES (1725,40102.1980203129,40113.4071933556,289,NULL)
INSERT INTO SalesInvoice VALUES (1726,40103.5751799766,40138.3672664943,147,NULL)
INSERT INTO SalesInvoice VALUES (1727,40104.6116593325,40145.4845306784,34,NULL)
INSERT INTO SalesInvoice VALUES (1728,40105.9728799869,40147.84590327,269,NULL)
INSERT INTO SalesInvoice VALUES (1729,40107.0844209993,40127.2060692523,143,NULL)
INSERT INTO SalesInvoice VALUES (1730,40107.1609203069,40153.165075536,761,NULL)
INSERT INTO SalesInvoice VALUES (1731,40108.7176686589,40149.8858736462,301,NULL)
INSERT INTO SalesInvoice VALUES (1732,40108.8193549074,40124.5583899047,517,NULL)
INSERT INTO SalesInvoice VALUES (1733,40110.3378963935,40121.8890074044,774,NULL)
INSERT INTO SalesInvoice VALUES (1734,40111.217898748,40112.5696199081,378,NULL)
INSERT INTO SalesInvoice VALUES (1735,40112.2754012314,40119.3856299606,31,NULL)
INSERT INTO SalesInvoice VALUES (1736,40113.2318957702,40143.6265449379,252,NULL)
INSERT INTO SalesInvoice VALUES (1737,40114.364339982,40149.5703518416,615,NULL)
INSERT INTO SalesInvoice VALUES (1738,40114.7621185976,40158.9001767872,751,NULL)
INSERT INTO SalesInvoice VALUES (1739,40116.1386764873,40165.2080388578,544,NULL)
INSERT INTO SalesInvoice VALUES (1740,40116.1745117387,40141.0407968291,356,NULL)
INSERT INTO SalesInvoice VALUES (1741,40117.6626408441,40129.8102253554,342,NULL)
INSERT INTO SalesInvoice VALUES (1742,40117.7080495248,40127.074825076,679,NULL)
INSERT INTO SalesInvoice VALUES (1743,40118.3946055246,40158.4582797112,669,NULL)
INSERT INTO SalesInvoice VALUES (1744,40119.0766773221,40161.1102398756,643,NULL)
INSERT INTO SalesInvoice VALUES (1745,40120.6274915077,40161.0909939666,248,NULL)
INSERT INTO SalesInvoice VALUES (1746,40121.5667486147,40154.3826211752,234,NULL)
INSERT INTO SalesInvoice VALUES (1747,40122.3067404186,40170.2474384258,9,NULL)
INSERT INTO SalesInvoice VALUES (1748,40123.548938864,40134.0507486733,512,NULL)
INSERT INTO SalesInvoice VALUES (1749,40123.8616283354,40138.1263191382,709,NULL)
INSERT INTO SalesInvoice VALUES (1750,40123.8759942314,40170.3709532472,98,NULL)
INSERT INTO SalesInvoice VALUES (1751,40124.0972721266,40138.1273438631,48,NULL)
INSERT INTO SalesInvoice VALUES (1752,40125.3778844596,40158.8202657799,641,NULL)
INSERT INTO SalesInvoice VALUES (1753,40126.7420308402,40138.7268348172,713,NULL)
INSERT INTO SalesInvoice VALUES (1754,40128.1704310873,40150.7272237466,742,NULL)
INSERT INTO SalesInvoice VALUES (1755,40128.5447956137,40172.9484406394,133,NULL)
INSERT INTO SalesInvoice VALUES (1756,40128.8543539047,40134.576554357,574,NULL)
INSERT INTO SalesInvoice VALUES (1757,40129.7685330377,40157.5147119492,664,NULL)
INSERT INTO SalesInvoice VALUES (1758,40130.6257105326,40149.391805756,131,NULL)
INSERT INTO SalesInvoice VALUES (1759,40132.1134335881,40139.8370852452,24,NULL)
INSERT INTO SalesInvoice VALUES (1760,40132.1739920081,40136.2286389773,296,NULL)
INSERT INTO SalesInvoice VALUES (1761,40133.1351792454,40168.2308447023,125,NULL)
INSERT INTO SalesInvoice VALUES (1762,40134.1089922991,40139.2107413066,286,NULL)
INSERT INTO SalesInvoice VALUES (1763,40134.2592983944,40139.7825634224,335,NULL)
INSERT INTO SalesInvoice VALUES (1764,40134.8245863788,40144.9947942349,344,NULL)
INSERT INTO SalesInvoice VALUES (1765,40135.3791870846,40172.0528864016,444,NULL)
INSERT INTO SalesInvoice VALUES (1766,40136.9402989966,40142.988187218,422,NULL)
INSERT INTO SalesInvoice VALUES (1767,40138.221624331,40151.1740397249,369,NULL)
INSERT INTO SalesInvoice VALUES (1768,40138.6214067812,40169.2494887554,571,NULL)
INSERT INTO SalesInvoice VALUES (1769,40139.5739783524,40150.5988914834,55,NULL)
INSERT INTO SalesInvoice VALUES (1770,40139.6649651651,40167.2561560361,506,NULL)
INSERT INTO SalesInvoice VALUES (1771,40140.3891618235,40176.0299978244,348,NULL)
INSERT INTO SalesInvoice VALUES (1772,40141.5319738222,40168.5760112235,682,NULL)
INSERT INTO SalesInvoice VALUES (1773,40142.0703189924,40165.5986158372,652,NULL)
INSERT INTO SalesInvoice VALUES (1774,40143.596342095,40147.6209593169,335,NULL)
INSERT INTO SalesInvoice VALUES (1775,40144.4814337713,40193.1807305473,239,NULL)
INSERT INTO SalesInvoice VALUES (1776,40144.9061099086,40186.4457547797,105,NULL)
INSERT INTO SalesInvoice VALUES (1777,40145.7267626949,40189.7952099321,297,NULL)
INSERT INTO SalesInvoice VALUES (1778,40146.7952504913,40174.9769543424,561,NULL)
INSERT INTO SalesInvoice VALUES (1779,40147.5713607576,40184.7245735359,712,NULL)
INSERT INTO SalesInvoice VALUES (1780,40148.4913712177,40192.1041554253,319,NULL)
INSERT INTO SalesInvoice VALUES (1781,40149.4675502306,40195.2892184083,125,NULL)
INSERT INTO SalesInvoice VALUES (1782,40150.3594295678,40188.9346182331,499,NULL)
INSERT INTO SalesInvoice VALUES (1783,40151.9410073215,40160.3341470235,596,NULL)
INSERT INTO SalesInvoice VALUES (1784,40153.0254002327,40184.4282882909,494,NULL)
INSERT INTO SalesInvoice VALUES (1785,40154.3810330817,40167.3639645968,351,NULL)
INSERT INTO SalesInvoice VALUES (1786,40154.8807548866,40161.523338614,599,NULL)
INSERT INTO SalesInvoice VALUES (1787,40155.2531416576,40168.0353308928,223,NULL)
INSERT INTO SalesInvoice VALUES (1788,40155.8697519397,40157.832774119,198,NULL)
INSERT INTO SalesInvoice VALUES (1789,40156.8094462113,40191.5366712853,286,NULL)
INSERT INTO SalesInvoice VALUES (1790,40156.8477651481,40188.7997059114,266,NULL)
INSERT INTO SalesInvoice VALUES (1791,40157.530595225,40178.2993244322,403,NULL)
INSERT INTO SalesInvoice VALUES (1792,40157.8679250679,40162.0528422488,217,NULL)
INSERT INTO SalesInvoice VALUES (1793,40157.893395344,40177.2846019375,745,NULL)
INSERT INTO SalesInvoice VALUES (1794,40159.2356517853,40176.6136761905,346,NULL)
INSERT INTO SalesInvoice VALUES (1795,40160.2918557614,40205.287104856,184,NULL)
INSERT INTO SalesInvoice VALUES (1796,40161.2707347611,40161.7344202305,113,NULL)
INSERT INTO SalesInvoice VALUES (1797,40162.4676528779,40197.7966145018,697,NULL)
INSERT INTO SalesInvoice VALUES (1798,40163.1523868814,40179.552036327,151,NULL)
INSERT INTO SalesInvoice VALUES (1799,40164.3530883946,40172.5766268658,123,NULL)
INSERT INTO SalesInvoice VALUES (1800,40165.904635585,40186.7335210639,40,NULL)
INSERT INTO SalesInvoice VALUES (1801,40167.4495043638,40199.7477501638,396,NULL)
INSERT INTO SalesInvoice VALUES (1802,40168.6038505535,40204.9649155977,747,NULL)
INSERT INTO SalesInvoice VALUES (1803,40169.4537066532,40179.4286651159,452,NULL)
INSERT INTO SalesInvoice VALUES (1804,40170.9764211689,40200.3840433925,490,NULL)
INSERT INTO SalesInvoice VALUES (1805,40171.0973837191,40185.83972248,498,NULL)
INSERT INTO SalesInvoice VALUES (1806,40171.7724804325,40193.2656066084,564,NULL)
INSERT INTO SalesInvoice VALUES (1807,40173.3335405515,40196.3452001284,125,NULL)
INSERT INTO SalesInvoice VALUES (1808,40174.5661089608,40175.3635086429,24,NULL)
INSERT INTO SalesInvoice VALUES (1809,40175.8524183805,40180.8819733276,242,NULL)
INSERT INTO SalesInvoice VALUES (1810,40176.8712661208,40190.3644143382,581,NULL)
INSERT INTO SalesInvoice VALUES (1811,40177.9179918103,40224.5781764542,608,NULL)
INSERT INTO SalesInvoice VALUES (1812,40178.2789268904,40194.8154184878,181,NULL)
INSERT INTO SalesInvoice VALUES (1813,40179.0152543263,40182.8231024416,748,NULL)
INSERT INTO SalesInvoice VALUES (1814,40179.3874777245,40218.7351981894,94,NULL)
INSERT INTO SalesInvoice VALUES (1815,40180.7006775495,40183.7762534474,527,NULL)
INSERT INTO SalesInvoice VALUES (1816,40181.7276481936,40186.2533731021,553,NULL)
INSERT INTO SalesInvoice VALUES (1817,40182.6022874934,40209.4481960194,543,NULL)
INSERT INTO SalesInvoice VALUES (1818,40183.3441885246,40184.0589998776,531,NULL)
INSERT INTO SalesInvoice VALUES (1819,40184.5345066328,40189.803126933,228,NULL)
INSERT INTO SalesInvoice VALUES (1820,40184.7839054102,40214.2498117791,626,NULL)
INSERT INTO SalesInvoice VALUES (1821,40185.5567071194,40207.4539666771,431,NULL)
INSERT INTO SalesInvoice VALUES (1822,40185.7343232169,40212.8015901376,405,NULL)
INSERT INTO SalesInvoice VALUES (1823,40186.3376734394,40231.2886902612,150,NULL)
INSERT INTO SalesInvoice VALUES (1824,40187.823684922,40214.6411101732,602,NULL)
INSERT INTO SalesInvoice VALUES (1825,40189.3210960121,40232.8355347643,456,NULL)
INSERT INTO SalesInvoice VALUES (1826,40190.8875559457,40229.463183035,760,NULL)
INSERT INTO SalesInvoice VALUES (1827,40191.5262353113,40197.5820310149,54,NULL)
INSERT INTO SalesInvoice VALUES (1828,40192.692809432,40208.3686349315,200,NULL)
INSERT INTO SalesInvoice VALUES (1829,40192.9047715689,40241.9635607802,746,NULL)
INSERT INTO SalesInvoice VALUES (1830,40193.9690919548,40215.0371033577,340,NULL)
INSERT INTO SalesInvoice VALUES (1831,40194.0723809589,40194.3362849221,745,NULL)
INSERT INTO SalesInvoice VALUES (1832,40195.2346662969,40198.7432735861,582,NULL)
INSERT INTO SalesInvoice VALUES (1833,40195.6277672261,40225.3103599946,242,NULL)
INSERT INTO SalesInvoice VALUES (1834,40195.9473033895,40206.9249555477,369,NULL)
INSERT INTO SalesInvoice VALUES (1835,40197.3610999225,40215.0022656614,562,NULL)
INSERT INTO SalesInvoice VALUES (1836,40198.5412005264,40199.9713533978,199,NULL)
INSERT INTO SalesInvoice VALUES (1837,40198.8057301132,40206.0744581666,86,NULL)
INSERT INTO SalesInvoice VALUES (1838,40199.66691356,40224.790858832,274,NULL)
INSERT INTO SalesInvoice VALUES (1839,40199.8341392347,40223.7516592766,424,NULL)
INSERT INTO SalesInvoice VALUES (1840,40200.6166792191,40208.8282834622,651,NULL)
INSERT INTO SalesInvoice VALUES (1841,40200.8381821545,40214.4623612958,702,NULL)
INSERT INTO SalesInvoice VALUES (1842,40201.2112748429,40201.6224780468,190,NULL)
INSERT INTO SalesInvoice VALUES (1843,40201.8003008755,40222.4516705428,363,NULL)
INSERT INTO SalesInvoice VALUES (1844,40202.1927369437,40237.2224217077,341,NULL)
INSERT INTO SalesInvoice VALUES (1845,40203.7088709138,40210.9655100204,507,NULL)
INSERT INTO SalesInvoice VALUES (1846,40204.9625863807,40234.2894383775,597,NULL)
INSERT INTO SalesInvoice VALUES (1847,40205.4238569716,40252.3830338142,172,NULL)
INSERT INTO SalesInvoice VALUES (1848,40206.2188558436,40236.6036430701,306,NULL)
INSERT INTO SalesInvoice VALUES (1849,40207.5570066519,40221.7278178653,19,NULL)
INSERT INTO SalesInvoice VALUES (1850,40208.6202876256,40256.146171798,382,NULL)
INSERT INTO SalesInvoice VALUES (1851,40209.5733633136,40220.7076718836,478,NULL)
INSERT INTO SalesInvoice VALUES (1852,40211.0545910536,40257.4707099946,88,NULL)
INSERT INTO SalesInvoice VALUES (1853,40211.1200363464,40252.4802400739,130,NULL)
INSERT INTO SalesInvoice VALUES (1854,40211.5859621437,40244.9234627711,90,NULL)
INSERT INTO SalesInvoice VALUES (1855,40212.6089082197,40254.2123237789,334,NULL)
INSERT INTO SalesInvoice VALUES (1856,40213.2156664057,40262.2477864295,307,NULL)
INSERT INTO SalesInvoice VALUES (1857,40214.5455445896,40264.3254466833,34,NULL)
INSERT INTO SalesInvoice VALUES (1858,40214.9257900899,40260.0419460132,568,NULL)
INSERT INTO SalesInvoice VALUES (1859,40215.7580982365,40254.3004214383,106,NULL)
INSERT INTO SalesInvoice VALUES (1860,40217.3048574801,40236.3025743391,141,NULL)
INSERT INTO SalesInvoice VALUES (1861,40217.3622909074,40255.1431026303,154,NULL)
INSERT INTO SalesInvoice VALUES (1862,40217.9902578901,40243.4214253643,719,NULL)
INSERT INTO SalesInvoice VALUES (1863,40219.4394878183,40246.2804198969,137,NULL)
INSERT INTO SalesInvoice VALUES (1864,40220.702885631,40253.1149564324,451,NULL)
INSERT INTO SalesInvoice VALUES (1865,40221.1849501224,40259.5688682425,348,NULL)
INSERT INTO SalesInvoice VALUES (1866,40222.3938482344,40228.9569456558,673,NULL)
INSERT INTO SalesInvoice VALUES (1867,40223.3720219763,40265.1253126367,722,NULL)
INSERT INTO SalesInvoice VALUES (1868,40224.5843518254,40233.2797285927,83,NULL)
INSERT INTO SalesInvoice VALUES (1869,40224.6534732175,40229.0846260218,588,NULL)
INSERT INTO SalesInvoice VALUES (1870,40225.0337672147,40251.8398576666,461,NULL)
INSERT INTO SalesInvoice VALUES (1871,40226.0646385713,40268.3627562227,627,NULL)
INSERT INTO SalesInvoice VALUES (1872,40227.2648766512,40247.3886340165,49,NULL)
INSERT INTO SalesInvoice VALUES (1873,40227.4730459065,40229.136586299,534,NULL)
INSERT INTO SalesInvoice VALUES (1874,40228.4914435675,40234.1803107545,707,NULL)
INSERT INTO SalesInvoice VALUES (1875,40228.9735179484,40235.780128738,155,NULL)
INSERT INTO SalesInvoice VALUES (1876,40230.4093520302,40264.2849181013,584,NULL)
INSERT INTO SalesInvoice VALUES (1877,40231.2662265975,40264.2139861346,530,NULL)



GO

USE JProCo
GO

IF EXISTS(SELECT * FROM sys.tables WHERE [name] = 'SalesInvoiceDetail')
DROP TABLE SalesInvoiceDetail
GO


CREATE TABLE SalesInvoiceDetail
(InvoiceDetailID INT PRIMARY KEY,
InvoiceID INT NOT NULL,
ProductID INT NOT NULL, Quantity INT NOT NULL,
UnitDiscount smallmoney)

INSERT INTO SalesInvoicedetail VALUES (1,1,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2,1,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (3,1,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (4,1,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (5,1,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (6,2,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (7,3,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (8,4,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (9,5,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (10,5,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (11,5,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (12,5,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (13,5,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (14,5,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (15,6,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (16,7,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (17,8,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (18,8,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (19,8,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (20,8,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (21,8,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (22,8,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (23,8,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (24,8,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (25,8,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (26,9,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (27,9,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (28,9,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (29,9,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (30,9,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (31,9,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (32,9,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (33,9,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (34,9,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (35,9,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (36,9,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (37,9,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (38,9,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (39,9,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (40,9,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (41,9,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (42,9,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (43,9,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (44,9,22,1,0)
INSERT INTO SalesInvoicedetail VALUES (45,9,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (46,9,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (47,9,26,6,0)
INSERT INTO SalesInvoicedetail VALUES (48,9,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (49,9,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (50,9,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (51,9,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (52,9,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (53,9,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (54,9,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (55,9,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (56,9,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (57,9,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (58,9,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (59,9,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (60,9,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (61,9,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (62,9,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (63,9,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (64,9,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (65,9,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (66,9,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (67,9,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (68,9,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (69,9,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (70,9,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (71,9,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (72,9,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (73,9,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (74,9,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (75,9,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (76,9,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (77,9,10,4,0)
INSERT INTO SalesInvoicedetail VALUES (78,9,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (79,9,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (80,9,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (81,10,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (82,10,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (83,10,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (84,10,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (85,10,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (86,10,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (87,10,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (88,10,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (89,10,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (90,10,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (91,10,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (92,10,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (93,10,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (94,10,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (95,10,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (96,10,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (97,10,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (98,10,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (99,10,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (100,10,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (101,10,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (102,10,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (103,10,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (104,10,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (105,10,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (106,10,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (107,10,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (108,10,33,5,0)
INSERT INTO SalesInvoicedetail VALUES (109,10,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (110,11,47,1,0)
INSERT INTO SalesInvoicedetail VALUES (111,12,10,1,0.22)
INSERT INTO SalesInvoicedetail VALUES (112,12,9,5,0.11)
INSERT INTO SalesInvoicedetail VALUES (113,12,73,6,0.06)
INSERT INTO SalesInvoicedetail VALUES (114,12,76,5,0.08)
INSERT INTO SalesInvoicedetail VALUES (115,13,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (116,13,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (117,13,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (118,13,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (119,13,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (120,13,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (121,13,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (122,13,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (123,13,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (124,13,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (125,13,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (126,14,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (127,14,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (128,14,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (129,15,54,2,0.26)
INSERT INTO SalesInvoicedetail VALUES (130,15,15,1,0.27)
INSERT INTO SalesInvoicedetail VALUES (131,15,29,4,0.4)
INSERT INTO SalesInvoicedetail VALUES (132,15,61,3,0.12)
INSERT INTO SalesInvoicedetail VALUES (133,15,62,5,0.21)
INSERT INTO SalesInvoicedetail VALUES (134,15,38,4,0.06)
INSERT INTO SalesInvoicedetail VALUES (135,15,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (136,15,12,2,0.26)
INSERT INTO SalesInvoicedetail VALUES (137,15,8,4,0.11)
INSERT INTO SalesInvoicedetail VALUES (138,15,11,3,0.32)
INSERT INTO SalesInvoicedetail VALUES (139,15,7,3,0.23)
INSERT INTO SalesInvoicedetail VALUES (140,16,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (141,17,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (142,17,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (143,17,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (144,17,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (145,17,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (146,17,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (147,17,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (148,17,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (149,17,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (150,18,76,2,0.23)
INSERT INTO SalesInvoicedetail VALUES (151,18,78,2,0.37)
INSERT INTO SalesInvoicedetail VALUES (152,18,10,3,0.22)
INSERT INTO SalesInvoicedetail VALUES (153,18,75,3,0.28)
INSERT INTO SalesInvoicedetail VALUES (154,18,9,2,0.18)
INSERT INTO SalesInvoicedetail VALUES (155,19,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (156,19,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (157,19,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (158,19,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (159,19,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (160,19,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (161,19,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (162,19,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (163,19,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (164,19,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (165,19,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (166,19,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (167,20,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (168,20,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (169,20,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (170,20,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (171,20,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (172,20,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (173,20,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (174,20,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (175,20,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (176,20,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (177,20,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (178,20,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (179,20,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (180,20,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (181,20,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (182,20,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (183,20,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (184,20,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (185,20,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (186,21,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (187,21,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (188,21,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (189,22,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (190,22,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (191,22,38,6,0)
INSERT INTO SalesInvoicedetail VALUES (192,22,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (193,22,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (194,22,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (195,22,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (196,22,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (197,22,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (198,22,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (199,22,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (200,22,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (201,22,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (202,22,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (203,22,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (204,23,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (205,23,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (206,23,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (207,23,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (208,23,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (209,23,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (210,23,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (211,23,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (212,23,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (213,23,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (214,23,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (215,23,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (216,23,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (217,23,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (218,23,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (219,23,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (220,23,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (221,23,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (222,23,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (223,23,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (224,23,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (225,24,58,1,0.01)
INSERT INTO SalesInvoicedetail VALUES (226,24,62,4,0.23)
INSERT INTO SalesInvoicedetail VALUES (227,24,60,2,0.16)
INSERT INTO SalesInvoicedetail VALUES (228,24,70,5,0.39)
INSERT INTO SalesInvoicedetail VALUES (229,24,15,6,0.06)
INSERT INTO SalesInvoicedetail VALUES (230,25,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (231,25,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (232,25,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (233,25,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (234,25,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (235,25,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (236,25,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (237,25,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (238,25,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (239,25,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (240,25,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (241,25,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (242,25,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (243,26,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (244,26,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (245,26,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (246,26,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (247,26,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (248,26,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (249,27,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (250,27,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (251,27,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (252,27,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (253,28,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (254,28,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (255,28,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (256,29,68,3,0.09)
INSERT INTO SalesInvoicedetail VALUES (257,29,65,5,0.39)
INSERT INTO SalesInvoicedetail VALUES (258,30,25,4,0.3)
INSERT INTO SalesInvoicedetail VALUES (259,30,60,3,0.33)
INSERT INTO SalesInvoicedetail VALUES (260,30,62,6,0.39)
INSERT INTO SalesInvoicedetail VALUES (261,30,38,4,0.11)
INSERT INTO SalesInvoicedetail VALUES (262,30,63,6,0.05)
INSERT INTO SalesInvoicedetail VALUES (263,30,29,5,0.02)
INSERT INTO SalesInvoicedetail VALUES (264,30,54,4,0.24)
INSERT INTO SalesInvoicedetail VALUES (265,30,58,2,0.13)
INSERT INTO SalesInvoicedetail VALUES (266,30,65,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (267,30,70,5,0.03)
INSERT INTO SalesInvoicedetail VALUES (268,30,53,1,0.09)
INSERT INTO SalesInvoicedetail VALUES (269,31,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (270,31,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (271,31,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (272,31,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (273,31,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (274,31,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (275,31,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (276,31,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (277,31,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (278,31,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (279,31,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (280,31,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (281,31,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (282,31,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (283,31,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (284,31,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (285,31,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (286,31,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (287,31,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (288,31,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (289,31,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (290,32,15,3,0.27)
INSERT INTO SalesInvoicedetail VALUES (291,32,70,1,0.33)
INSERT INTO SalesInvoicedetail VALUES (292,32,12,5,0.18)
INSERT INTO SalesInvoicedetail VALUES (293,32,60,5,0.06)
INSERT INTO SalesInvoicedetail VALUES (294,33,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (295,34,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (296,34,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (297,34,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (298,34,30,5,0)
INSERT INTO SalesInvoicedetail VALUES (299,34,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (300,34,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (301,34,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (302,34,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (303,34,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (304,34,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (305,34,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (306,34,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (307,34,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (308,34,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (309,34,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (310,34,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (311,34,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (312,34,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (313,34,64,6,0)
INSERT INTO SalesInvoicedetail VALUES (314,34,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (315,34,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (316,34,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (317,34,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (318,34,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (319,34,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (320,34,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (321,34,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (322,34,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (323,35,16,4,0.11)
INSERT INTO SalesInvoicedetail VALUES (324,35,73,3,0.05)
INSERT INTO SalesInvoicedetail VALUES (325,35,9,4,0.31)
INSERT INTO SalesInvoicedetail VALUES (326,35,7,5,0.34)
INSERT INTO SalesInvoicedetail VALUES (327,35,71,1,0.21)
INSERT INTO SalesInvoicedetail VALUES (328,35,8,3,0.3)
INSERT INTO SalesInvoicedetail VALUES (329,35,74,5,0.36)
INSERT INTO SalesInvoicedetail VALUES (330,35,77,2,0.39)
INSERT INTO SalesInvoicedetail VALUES (331,35,72,3,0.34)
INSERT INTO SalesInvoicedetail VALUES (332,35,78,2,0.38)
INSERT INTO SalesInvoicedetail VALUES (333,36,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (334,36,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (335,36,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (336,36,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (337,36,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (338,36,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (339,36,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (340,36,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (341,36,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (342,36,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (343,36,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (344,37,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (345,37,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (346,37,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (347,37,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (348,37,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (349,37,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (350,37,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (351,37,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (352,38,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (353,39,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (354,40,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (355,41,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (356,42,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (357,43,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (358,44,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (359,45,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (360,46,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (361,47,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (362,48,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (363,49,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (364,50,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (365,51,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (366,52,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (367,53,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (368,54,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (369,55,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (370,56,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (371,57,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (372,58,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (373,59,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (374,60,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (375,61,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (376,62,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (377,63,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (378,64,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (379,65,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (380,66,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (381,67,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (382,68,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (383,69,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (384,70,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (385,71,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (386,72,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (387,73,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (388,74,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (389,75,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (390,76,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (391,77,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (392,78,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (393,79,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (394,80,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (395,81,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (396,82,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (397,83,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (398,84,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (399,85,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (400,86,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (401,87,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (402,88,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (403,89,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (404,90,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (405,91,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (406,92,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (407,93,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (408,94,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (409,95,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (410,96,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (411,97,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (412,98,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (413,99,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (414,100,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (415,101,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (416,102,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (417,103,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (418,104,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (419,105,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (420,106,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (421,107,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (422,108,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (423,109,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (424,110,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (425,111,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (426,112,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (427,113,64,6,0)
INSERT INTO SalesInvoicedetail VALUES (428,114,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (429,115,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (430,116,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (431,117,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (432,118,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (433,119,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (434,120,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (435,121,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (436,122,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (437,123,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (438,124,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (439,125,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (440,126,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (441,127,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (442,128,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (443,129,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (444,130,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (445,131,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (446,132,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (447,133,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (448,134,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (449,135,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (450,136,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (451,137,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (452,138,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (453,139,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (454,140,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (455,141,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (456,142,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (457,143,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (458,144,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (459,145,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (460,146,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (461,147,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (462,148,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (463,149,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (464,150,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (465,151,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (466,152,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (467,153,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (468,154,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (469,155,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (470,156,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (471,157,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (472,158,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (473,159,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (474,160,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (475,161,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (476,162,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (477,163,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (478,164,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (479,165,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (480,166,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (481,167,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (482,168,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (483,169,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (484,170,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (485,171,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (486,172,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (487,173,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (488,174,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (489,175,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (490,176,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (491,177,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (492,178,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (493,179,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (494,180,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (495,181,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (496,182,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (497,183,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (498,184,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (499,185,74,2,0.08)
INSERT INTO SalesInvoicedetail VALUES (500,185,78,3,0.06)
INSERT INTO SalesInvoicedetail VALUES (501,185,42,3,0.2)
INSERT INTO SalesInvoicedetail VALUES (502,185,77,1,0.28)
INSERT INTO SalesInvoicedetail VALUES (503,185,48,6,0.24)
INSERT INTO SalesInvoicedetail VALUES (504,185,41,5,0.13)
INSERT INTO SalesInvoicedetail VALUES (505,185,45,3,0.18)
INSERT INTO SalesInvoicedetail VALUES (506,185,71,3,0.29)
INSERT INTO SalesInvoicedetail VALUES (507,185,9,3,0.1)
INSERT INTO SalesInvoicedetail VALUES (508,185,76,6,0.01)
INSERT INTO SalesInvoicedetail VALUES (509,186,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (510,186,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (511,186,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (512,186,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (513,187,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (514,187,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (515,187,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (516,187,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (517,187,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (518,187,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (519,187,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (520,187,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (521,187,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (522,187,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (523,188,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (524,188,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (525,188,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (526,188,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (527,189,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (528,189,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (529,189,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (530,190,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (531,190,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (532,190,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (533,190,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (534,190,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (535,191,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (536,191,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (537,191,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (538,191,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (539,191,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (540,191,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (541,191,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (542,191,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (543,191,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (544,191,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (545,191,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (546,192,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (547,192,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (548,192,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (549,192,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (550,192,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (551,192,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (552,192,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (553,192,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (554,192,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (555,192,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (556,192,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (557,193,61,3,0.25)
INSERT INTO SalesInvoicedetail VALUES (558,193,60,4,0.29)
INSERT INTO SalesInvoicedetail VALUES (559,193,11,2,0.18)
INSERT INTO SalesInvoicedetail VALUES (560,193,70,3,0.06)
INSERT INTO SalesInvoicedetail VALUES (561,193,7,2,0.23)
INSERT INTO SalesInvoicedetail VALUES (562,193,25,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (563,193,54,6,0.11)
INSERT INTO SalesInvoicedetail VALUES (564,193,38,4,0.07)
INSERT INTO SalesInvoicedetail VALUES (565,193,53,2,0.31)
INSERT INTO SalesInvoicedetail VALUES (566,193,65,3,0.04)
INSERT INTO SalesInvoicedetail VALUES (567,193,12,2,0.34)
INSERT INTO SalesInvoicedetail VALUES (568,193,8,2,0.37)
INSERT INTO SalesInvoicedetail VALUES (569,194,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (570,195,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (571,195,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (572,195,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (573,195,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (574,195,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (575,195,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (576,196,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (577,197,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (578,197,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (579,197,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (580,197,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (581,197,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (582,197,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (583,197,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (584,197,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (585,197,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (586,197,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (587,197,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (588,197,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (589,197,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (590,198,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (591,198,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (592,199,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (593,199,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (594,199,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (595,199,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (596,199,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (597,199,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (598,199,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (599,199,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (600,199,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (601,199,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (602,199,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (603,199,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (604,199,54,1,0)
INSERT INTO SalesInvoicedetail VALUES (605,199,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (606,200,62,2,0.11)
INSERT INTO SalesInvoicedetail VALUES (607,200,61,6,0.24)
INSERT INTO SalesInvoicedetail VALUES (608,200,70,2,0.29)
INSERT INTO SalesInvoicedetail VALUES (609,200,65,5,0.06)
INSERT INTO SalesInvoicedetail VALUES (610,200,38,2,0.12)
INSERT INTO SalesInvoicedetail VALUES (611,200,63,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (612,200,54,5,0.11)
INSERT INTO SalesInvoicedetail VALUES (613,200,22,4,0.13)
INSERT INTO SalesInvoicedetail VALUES (614,200,53,6,0.24)
INSERT INTO SalesInvoicedetail VALUES (615,200,26,2,0.32)
INSERT INTO SalesInvoicedetail VALUES (616,200,66,2,0.04)
INSERT INTO SalesInvoicedetail VALUES (617,200,29,5,0.26)
INSERT INTO SalesInvoicedetail VALUES (618,200,56,3,0.38)
INSERT INTO SalesInvoicedetail VALUES (619,201,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (620,201,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (621,201,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (622,201,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (623,202,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (624,202,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (625,202,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (626,202,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (627,202,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (628,202,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (629,202,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (630,202,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (631,202,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (632,202,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (633,202,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (634,202,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (635,203,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (636,203,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (637,203,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (638,203,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (639,203,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (640,203,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (641,203,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (642,203,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (643,203,33,3,0)
INSERT INTO SalesInvoicedetail VALUES (644,203,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (645,203,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (646,203,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (647,203,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (648,203,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (649,203,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (650,203,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (651,203,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (652,203,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (653,203,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (654,203,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (655,203,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (656,203,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (657,203,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (658,203,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (659,203,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (660,203,22,6,0)
INSERT INTO SalesInvoicedetail VALUES (661,203,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (662,204,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (663,204,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (664,204,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (665,204,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (666,204,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (667,204,48,6,0)
INSERT INTO SalesInvoicedetail VALUES (668,204,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (669,204,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (670,204,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (671,205,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (672,205,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (673,205,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (674,205,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (675,206,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (676,206,47,1,0)
INSERT INTO SalesInvoicedetail VALUES (677,206,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (678,206,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (679,206,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (680,206,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (681,206,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (682,206,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (683,206,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (684,207,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (685,207,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (686,207,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (687,207,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (688,207,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (689,207,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (690,207,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (691,207,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (692,207,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (693,207,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (694,207,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (695,207,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (696,207,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (697,207,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (698,208,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (699,208,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (700,208,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (701,209,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (702,209,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (703,209,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (704,209,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (705,209,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (706,209,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (707,209,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (708,209,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (709,209,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (710,209,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (711,209,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (712,209,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (713,209,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (714,209,48,3,0)
INSERT INTO SalesInvoicedetail VALUES (715,209,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (716,209,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (717,209,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (718,209,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (719,210,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (720,211,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (721,211,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (722,211,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (723,211,45,5,0)
INSERT INTO SalesInvoicedetail VALUES (724,211,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (725,211,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (726,211,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (727,211,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (728,211,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (729,211,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (730,212,60,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (731,212,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (732,212,15,5,0.23)
INSERT INTO SalesInvoicedetail VALUES (733,212,70,3,0.36)
INSERT INTO SalesInvoicedetail VALUES (734,212,58,5,0.36)
INSERT INTO SalesInvoicedetail VALUES (735,213,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (736,213,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (737,213,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (738,213,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (739,213,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (740,213,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (741,213,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (742,213,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (743,213,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (744,213,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (745,213,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (746,213,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (747,213,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (748,213,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (749,214,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (750,214,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (751,214,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (752,214,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (753,214,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (754,214,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (755,214,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (756,214,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (757,214,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (758,214,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (759,214,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (760,214,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (761,214,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (762,214,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (763,214,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (764,214,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (765,215,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (766,215,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (767,215,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (768,215,26,2,0)
INSERT INTO SalesInvoicedetail VALUES (769,215,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (770,215,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (771,215,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (772,215,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (773,215,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (774,215,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (775,215,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (776,215,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (777,215,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (778,215,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (779,215,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (780,215,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (781,215,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (782,215,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (783,215,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (784,215,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (785,215,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (786,215,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (787,215,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (788,215,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (789,215,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (790,215,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (791,215,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (792,215,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (793,216,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (794,217,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (795,217,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (796,217,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (797,217,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (798,217,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (799,217,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (800,217,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (801,217,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (802,217,48,3,0)
INSERT INTO SalesInvoicedetail VALUES (803,217,73,3,0.01)
INSERT INTO SalesInvoicedetail VALUES (804,217,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (805,217,75,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (806,217,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (807,217,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (808,217,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (809,217,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (810,217,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (811,217,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (812,217,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (813,217,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (814,217,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (815,218,62,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (816,218,58,3,0.27)
INSERT INTO SalesInvoicedetail VALUES (817,218,63,2,0.09)
INSERT INTO SalesInvoicedetail VALUES (818,218,54,3,0.04)
INSERT INTO SalesInvoicedetail VALUES (819,218,25,4,0.05)
INSERT INTO SalesInvoicedetail VALUES (820,218,61,5,0.12)
INSERT INTO SalesInvoicedetail VALUES (821,218,70,4,0.06)
INSERT INTO SalesInvoicedetail VALUES (822,218,29,4,0.38)
INSERT INTO SalesInvoicedetail VALUES (823,219,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (824,219,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (825,219,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (826,219,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (827,219,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (828,219,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (829,219,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (830,219,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (831,219,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (832,219,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (833,220,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (834,220,71,5,0.38)
INSERT INTO SalesInvoicedetail VALUES (835,221,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (836,221,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (837,221,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (838,221,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (839,221,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (840,221,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (841,221,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (842,221,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (843,221,30,5,0)
INSERT INTO SalesInvoicedetail VALUES (844,221,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (845,221,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (846,221,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (847,221,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (848,221,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (849,221,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (850,221,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (851,221,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (852,221,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (853,221,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (854,221,38,6,0)
INSERT INTO SalesInvoicedetail VALUES (855,221,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (856,221,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (857,221,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (858,221,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (859,221,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (860,221,12,2,0.04)
INSERT INTO SalesInvoicedetail VALUES (861,222,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (862,222,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (863,222,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (864,222,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (865,222,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (866,222,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (867,222,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (868,222,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (869,222,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (870,222,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (871,222,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (872,222,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (873,222,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (874,223,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (875,223,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (876,223,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (877,223,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (878,223,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (879,223,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (880,223,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (881,223,9,6,0.07)
INSERT INTO SalesInvoicedetail VALUES (882,224,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (883,225,26,3,0.11)
INSERT INTO SalesInvoicedetail VALUES (884,225,32,3,0.24)
INSERT INTO SalesInvoicedetail VALUES (885,225,63,4,0.37)
INSERT INTO SalesInvoicedetail VALUES (886,225,68,4,0.18)
INSERT INTO SalesInvoicedetail VALUES (887,225,70,3,0.25)
INSERT INTO SalesInvoicedetail VALUES (888,225,12,1,0.39)
INSERT INTO SalesInvoicedetail VALUES (889,225,60,4,0.3)
INSERT INTO SalesInvoicedetail VALUES (890,225,22,6,0.13)
INSERT INTO SalesInvoicedetail VALUES (891,225,25,4,0.06)
INSERT INTO SalesInvoicedetail VALUES (892,225,38,4,0.32)
INSERT INTO SalesInvoicedetail VALUES (893,225,49,6,0.09)
INSERT INTO SalesInvoicedetail VALUES (894,225,62,3,0.26)
INSERT INTO SalesInvoicedetail VALUES (895,225,58,3,0.28)
INSERT INTO SalesInvoicedetail VALUES (896,225,54,3,0.06)
INSERT INTO SalesInvoicedetail VALUES (897,225,61,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (898,225,53,1,0.02)
INSERT INTO SalesInvoicedetail VALUES (899,225,65,4,0.32)
INSERT INTO SalesInvoicedetail VALUES (900,226,47,6,0)
INSERT INTO SalesInvoicedetail VALUES (901,226,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (902,226,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (903,226,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (904,226,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (905,226,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (906,226,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (907,226,41,1,0)
INSERT INTO SalesInvoicedetail VALUES (908,226,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (909,226,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (910,226,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (911,226,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (912,226,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (913,226,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (914,226,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (915,226,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (916,226,72,6,0.01)
INSERT INTO SalesInvoicedetail VALUES (917,226,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (918,226,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (919,226,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (920,226,42,1,0)
INSERT INTO SalesInvoicedetail VALUES (921,226,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (922,227,10,5,0)
INSERT INTO SalesInvoicedetail VALUES (923,227,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (924,228,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (925,228,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (926,228,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (927,228,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (928,228,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (929,228,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (930,228,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (931,228,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (932,228,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (933,228,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (934,228,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (935,228,33,3,0)
INSERT INTO SalesInvoicedetail VALUES (936,228,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (937,228,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (938,228,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (939,228,22,6,0)
INSERT INTO SalesInvoicedetail VALUES (940,228,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (941,228,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (942,228,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (943,228,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (944,228,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (945,229,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (946,230,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (947,230,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (948,230,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (949,230,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (950,230,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (951,230,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (952,230,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (953,230,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (954,230,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (955,230,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (956,230,30,5,0)
INSERT INTO SalesInvoicedetail VALUES (957,230,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (958,230,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (959,230,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (960,231,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (961,231,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (962,232,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (963,232,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (964,232,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (965,232,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (966,232,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (967,232,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (968,232,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (969,232,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (970,232,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (971,232,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (972,232,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (973,232,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (974,232,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (975,233,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (976,233,10,2,0)
INSERT INTO SalesInvoicedetail VALUES (977,233,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (978,233,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (979,233,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (980,233,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (981,233,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (982,233,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (983,233,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (984,234,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (985,234,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (986,234,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (987,234,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (988,234,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (989,234,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (990,234,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (991,234,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (992,234,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (993,234,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (994,234,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (995,234,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (996,234,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (997,235,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (998,236,10,4,0)
INSERT INTO SalesInvoicedetail VALUES (999,236,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (1000,236,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1001,236,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (1002,236,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (1003,236,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (1004,236,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (1005,237,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (1006,237,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (1007,237,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (1008,237,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (1009,237,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (1010,237,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (1011,237,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (1012,237,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1013,237,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (1014,237,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (1015,237,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (1016,237,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (1017,237,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (1018,237,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (1019,237,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (1020,238,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (1021,238,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1022,238,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (1023,238,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (1024,238,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (1025,239,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (1026,239,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1027,239,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (1028,239,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (1029,239,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1030,239,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1031,239,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (1032,239,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (1033,239,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (1034,239,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (1035,239,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1036,239,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1037,239,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1038,239,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (1039,240,70,5,0.03)
INSERT INTO SalesInvoicedetail VALUES (1040,240,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (1041,240,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (1042,240,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (1043,240,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (1044,240,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (1045,240,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1046,240,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (1047,240,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (1048,240,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (1049,240,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1050,240,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (1051,240,15,3,0.07)
INSERT INTO SalesInvoicedetail VALUES (1052,240,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (1053,240,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (1054,240,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (1055,240,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (1056,240,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (1057,240,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (1058,240,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (1059,240,38,6,0)
INSERT INTO SalesInvoicedetail VALUES (1060,240,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (1061,240,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (1062,240,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (1063,240,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (1064,240,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1065,240,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (1066,240,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (1067,241,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (1068,241,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (1069,241,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (1070,241,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (1071,241,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (1072,241,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (1073,241,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (1074,241,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (1075,241,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (1076,241,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (1077,241,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (1078,241,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (1079,241,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (1080,242,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1081,242,10,3,0)
INSERT INTO SalesInvoicedetail VALUES (1082,242,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1083,242,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (1084,242,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (1085,242,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (1086,242,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (1087,242,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (1088,242,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (1089,243,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (1090,243,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (1091,243,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (1092,243,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (1093,243,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (1094,243,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1095,243,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (1096,243,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (1097,243,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (1098,243,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (1099,244,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (1100,244,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (1101,244,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (1102,244,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (1103,244,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (1104,244,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (1105,244,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1106,244,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (1107,244,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (1108,244,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (1109,244,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1110,244,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (1111,244,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (1112,244,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (1113,244,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (1114,244,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (1115,244,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (1116,244,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (1117,244,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1118,244,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (1119,245,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1120,246,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (1121,246,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (1122,246,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (1123,246,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (1124,246,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (1125,246,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (1126,246,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (1127,246,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (1128,246,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (1129,246,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (1130,246,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (1131,246,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (1132,247,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1133,247,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (1134,247,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (1135,247,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (1136,247,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (1137,247,38,6,0)
INSERT INTO SalesInvoicedetail VALUES (1138,247,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (1139,247,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (1140,247,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (1141,247,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (1142,247,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (1143,248,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (1144,248,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (1145,248,9,5,0.12)
INSERT INTO SalesInvoicedetail VALUES (1146,248,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (1147,248,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (1148,248,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (1149,248,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (1150,248,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (1151,248,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1152,248,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (1153,248,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (1154,248,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (1155,248,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1156,248,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (1157,249,15,5,0.08)
INSERT INTO SalesInvoicedetail VALUES (1158,249,64,2,0.28)
INSERT INTO SalesInvoicedetail VALUES (1159,249,30,5,0.22)
INSERT INTO SalesInvoicedetail VALUES (1160,249,22,3,0.21)
INSERT INTO SalesInvoicedetail VALUES (1161,249,65,2,0.02)
INSERT INTO SalesInvoicedetail VALUES (1162,249,14,4,0.27)
INSERT INTO SalesInvoicedetail VALUES (1163,249,53,1,0.39)
INSERT INTO SalesInvoicedetail VALUES (1164,249,62,4,0.38)
INSERT INTO SalesInvoicedetail VALUES (1165,249,7,1,0.32)
INSERT INTO SalesInvoicedetail VALUES (1166,249,61,4,0.37)
INSERT INTO SalesInvoicedetail VALUES (1167,249,8,2,0.4)
INSERT INTO SalesInvoicedetail VALUES (1168,249,60,5,0.36)
INSERT INTO SalesInvoicedetail VALUES (1169,249,29,3,0.23)
INSERT INTO SalesInvoicedetail VALUES (1170,249,11,6,0.13)
INSERT INTO SalesInvoicedetail VALUES (1171,249,63,5,0.1)
INSERT INTO SalesInvoicedetail VALUES (1172,249,38,2,0.27)
INSERT INTO SalesInvoicedetail VALUES (1173,249,26,3,0.2)
INSERT INTO SalesInvoicedetail VALUES (1174,249,70,4,0.17)
INSERT INTO SalesInvoicedetail VALUES (1175,249,56,4,0.18)
INSERT INTO SalesInvoicedetail VALUES (1176,249,55,5,0.07)
INSERT INTO SalesInvoicedetail VALUES (1177,249,16,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (1178,249,12,5,0.01)
INSERT INTO SalesInvoicedetail VALUES (1179,250,33,4,0.37)
INSERT INTO SalesInvoicedetail VALUES (1180,250,49,5,0.35)
INSERT INTO SalesInvoicedetail VALUES (1181,250,15,3,0.22)
INSERT INTO SalesInvoicedetail VALUES (1182,251,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (1183,251,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1184,251,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (1185,251,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (1186,251,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (1187,251,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (1188,251,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (1189,251,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (1190,251,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (1191,252,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (1192,252,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (1193,252,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (1194,252,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (1195,252,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1196,252,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (1197,252,33,2,0)
INSERT INTO SalesInvoicedetail VALUES (1198,252,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (1199,252,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1200,252,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (1201,252,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (1202,252,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (1203,252,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (1204,252,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (1205,252,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (1206,252,54,1,0)
INSERT INTO SalesInvoicedetail VALUES (1207,253,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (1208,253,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (1209,253,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (1210,253,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (1211,253,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (1212,253,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (1213,253,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (1214,253,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1215,253,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (1216,253,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (1217,253,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1218,253,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (1219,253,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (1220,253,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (1221,253,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (1222,254,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (1223,254,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (1224,254,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (1225,254,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (1226,254,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (1227,254,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (1228,254,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (1229,254,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (1230,254,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (1231,254,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (1232,254,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (1233,254,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (1234,254,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (1235,254,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1236,254,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (1237,254,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (1238,255,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (1239,255,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (1240,255,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (1241,255,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (1242,255,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (1243,255,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1244,255,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (1245,255,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (1246,255,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1247,255,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (1248,255,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (1249,255,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (1250,256,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (1251,256,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (1252,256,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (1253,256,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (1254,256,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1255,257,78,3,0.12)
INSERT INTO SalesInvoicedetail VALUES (1256,258,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1257,258,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (1258,258,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (1259,258,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (1260,258,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (1261,258,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1262,258,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (1263,258,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (1264,258,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (1265,258,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (1266,258,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (1267,258,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (1268,258,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (1269,258,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (1270,259,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (1271,259,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (1272,259,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (1273,259,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (1274,259,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (1275,259,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (1276,259,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (1277,259,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (1278,259,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (1279,259,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (1280,259,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (1281,259,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (1282,259,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (1283,259,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (1284,260,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (1285,261,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (1286,262,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (1287,263,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (1288,264,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1289,265,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1290,266,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1291,267,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (1292,268,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (1293,269,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (1294,270,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (1295,271,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (1296,272,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (1297,273,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (1298,274,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (1299,275,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (1300,276,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (1301,277,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (1302,278,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (1303,279,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (1304,280,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1305,281,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (1306,282,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (1307,283,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (1308,284,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1309,285,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (1310,286,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1311,287,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1312,288,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (1313,289,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1314,290,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (1315,291,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1316,292,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (1317,293,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (1318,294,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1319,295,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (1320,296,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (1321,297,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (1322,298,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1323,299,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (1324,300,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1325,301,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1326,302,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1327,303,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (1328,304,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1329,305,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (1330,306,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (1331,307,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (1332,308,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1333,309,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (1334,310,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (1335,311,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1336,312,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (1337,313,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (1338,314,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (1339,315,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (1340,316,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1341,317,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (1342,318,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1343,319,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (1344,320,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1345,321,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (1346,322,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (1347,323,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (1348,324,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (1349,325,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (1350,326,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (1351,327,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (1352,328,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1353,329,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (1354,330,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (1355,331,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (1356,332,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (1357,333,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1358,334,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (1359,335,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (1360,336,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (1361,337,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1362,338,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1363,339,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1364,340,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (1365,341,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (1366,342,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (1367,343,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (1368,344,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (1369,345,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1370,346,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1371,347,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (1372,348,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1373,349,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (1374,350,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1375,351,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (1376,352,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (1377,353,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1378,354,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1379,355,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1380,356,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (1381,357,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (1382,358,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (1383,359,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (1384,360,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (1385,361,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1386,362,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (1387,363,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (1388,364,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (1389,365,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (1390,366,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (1391,367,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (1392,368,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (1393,369,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (1394,370,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (1395,371,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (1396,372,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (1397,373,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (1398,374,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1399,375,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (1400,376,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (1401,377,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (1402,378,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (1403,379,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (1404,380,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1405,381,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1406,382,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (1407,383,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (1408,384,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (1409,385,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (1410,386,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (1411,387,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1412,388,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (1413,389,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1414,390,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (1415,391,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (1416,392,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1417,393,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1418,394,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (1419,395,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (1420,396,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (1421,397,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (1422,398,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (1423,399,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (1424,400,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (1425,401,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (1426,402,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (1427,403,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (1428,404,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1429,405,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (1430,406,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1431,407,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1432,408,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (1433,409,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1434,410,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (1435,411,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (1436,412,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (1437,413,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (1438,414,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (1439,415,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (1440,416,62,2,0.12)
INSERT INTO SalesInvoicedetail VALUES (1441,416,12,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (1442,416,70,5,0.25)
INSERT INTO SalesInvoicedetail VALUES (1443,417,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (1444,417,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (1445,417,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (1446,417,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (1447,417,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (1448,417,10,3,0)
INSERT INTO SalesInvoicedetail VALUES (1449,417,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (1450,417,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1451,417,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (1452,418,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1453,418,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (1454,419,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (1455,419,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (1456,419,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (1457,419,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (1458,419,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (1459,419,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (1460,419,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (1461,419,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (1462,420,42,2,0)
INSERT INTO SalesInvoicedetail VALUES (1463,420,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (1464,420,47,6,0)
INSERT INTO SalesInvoicedetail VALUES (1465,420,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (1466,420,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1467,420,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (1468,420,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (1469,420,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1470,421,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (1471,421,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (1472,421,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (1473,421,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (1474,421,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1475,421,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (1476,421,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (1477,421,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (1478,421,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (1479,421,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (1480,421,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (1481,421,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (1482,421,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (1483,421,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1484,421,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (1485,421,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (1486,421,22,6,0)
INSERT INTO SalesInvoicedetail VALUES (1487,421,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (1488,421,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (1489,421,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (1490,421,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (1491,421,26,2,0)
INSERT INTO SalesInvoicedetail VALUES (1492,421,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (1493,421,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (1494,421,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (1495,421,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (1496,421,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (1497,422,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1498,423,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (1499,423,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (1500,423,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (1501,423,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (1502,423,43,6,0)
INSERT INTO SalesInvoicedetail VALUES (1503,423,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (1504,423,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1505,423,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (1506,423,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (1507,423,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (1508,423,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1509,423,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1510,423,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (1511,423,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (1512,423,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (1513,423,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1514,424,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (1515,425,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (1516,425,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (1517,425,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (1518,425,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1519,426,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (1520,426,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1521,427,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (1522,427,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (1523,427,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (1524,427,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (1525,427,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1526,427,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (1527,427,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (1528,427,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (1529,427,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (1530,427,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (1531,427,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (1532,427,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (1533,427,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (1534,427,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (1535,427,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (1536,427,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (1537,427,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (1538,427,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1539,427,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (1540,427,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (1541,427,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (1542,428,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1543,428,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (1544,428,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (1545,428,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (1546,428,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (1547,428,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (1548,428,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (1549,428,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1550,428,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (1551,428,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (1552,428,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (1553,428,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (1554,428,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (1555,428,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (1556,428,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (1557,428,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (1558,428,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (1559,428,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (1560,428,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (1561,428,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (1562,428,42,6,0)
INSERT INTO SalesInvoicedetail VALUES (1563,429,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1564,429,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (1565,430,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (1566,431,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1567,431,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (1568,431,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (1569,432,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (1570,432,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (1571,432,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (1572,432,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (1573,432,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (1574,432,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (1575,432,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (1576,432,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (1577,432,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1578,432,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (1579,432,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1580,432,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (1581,432,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (1582,433,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (1583,433,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (1584,433,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (1585,433,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (1586,433,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (1587,433,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (1588,433,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1589,434,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (1590,434,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (1591,434,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (1592,434,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (1593,434,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (1594,434,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (1595,434,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (1596,434,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (1597,435,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (1598,435,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (1599,435,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (1600,435,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (1601,435,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (1602,435,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (1603,435,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (1604,435,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (1605,435,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (1606,435,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (1607,435,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1608,435,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (1609,435,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (1610,435,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (1611,435,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (1612,435,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (1613,435,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (1614,435,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (1615,435,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (1616,436,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1617,437,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (1618,437,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (1619,437,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (1620,437,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (1621,437,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (1622,437,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (1623,437,41,1,0)
INSERT INTO SalesInvoicedetail VALUES (1624,437,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (1625,437,42,2,0)
INSERT INTO SalesInvoicedetail VALUES (1626,438,77,6,0.23)
INSERT INTO SalesInvoicedetail VALUES (1627,438,71,2,0.03)
INSERT INTO SalesInvoicedetail VALUES (1628,439,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (1629,439,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (1630,439,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (1631,439,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1632,439,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (1633,439,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1634,439,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (1635,439,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (1636,439,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (1637,439,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (1638,439,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (1639,439,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (1640,440,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (1641,440,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (1642,440,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1643,440,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1644,440,9,2,0.02)
INSERT INTO SalesInvoicedetail VALUES (1645,440,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (1646,441,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (1647,441,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (1648,441,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (1649,441,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (1650,441,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (1651,441,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (1652,442,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (1653,442,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (1654,442,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (1655,442,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (1656,442,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1657,442,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (1658,442,43,6,0)
INSERT INTO SalesInvoicedetail VALUES (1659,442,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (1660,442,77,2,0.05)
INSERT INTO SalesInvoicedetail VALUES (1661,442,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (1662,442,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (1663,442,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (1664,442,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (1665,442,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (1666,442,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (1667,442,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (1668,442,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (1669,442,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1670,442,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1671,442,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (1672,442,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (1673,443,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (1674,443,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (1675,443,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (1676,443,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (1677,444,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (1678,444,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (1679,444,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (1680,444,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (1681,444,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (1682,445,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (1683,445,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (1684,445,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (1685,445,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (1686,445,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1687,446,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (1688,446,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (1689,447,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (1690,447,10,4,0)
INSERT INTO SalesInvoicedetail VALUES (1691,447,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1692,447,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (1693,448,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (1694,449,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1695,449,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (1696,449,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (1697,449,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (1698,449,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (1699,449,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (1700,449,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (1701,449,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (1702,449,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (1703,449,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (1704,449,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (1705,449,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (1706,449,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (1707,449,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (1708,449,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (1709,449,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (1710,449,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (1711,449,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (1712,449,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1713,449,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1714,449,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (1715,450,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (1716,450,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (1717,451,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (1718,451,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (1719,451,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (1720,451,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (1721,451,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (1722,451,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (1723,451,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1724,451,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (1725,451,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (1726,451,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (1727,451,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (1728,451,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (1729,451,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1730,451,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (1731,451,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (1732,452,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (1733,452,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (1734,452,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (1735,452,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (1736,452,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (1737,452,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (1738,452,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (1739,452,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (1740,452,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (1741,452,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (1742,452,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (1743,452,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (1744,452,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (1745,452,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (1746,452,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (1747,452,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (1748,452,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (1749,452,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (1750,452,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (1751,452,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (1752,452,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (1753,452,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (1754,453,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (1755,453,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (1756,453,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (1757,453,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (1758,453,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (1759,453,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (1760,453,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (1761,453,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (1762,453,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (1763,453,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (1764,453,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (1765,453,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (1766,453,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (1767,453,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (1768,453,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (1769,453,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (1770,453,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (1771,453,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (1772,453,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (1773,454,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1774,454,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (1775,454,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (1776,454,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (1777,454,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1778,455,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1779,455,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1780,455,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (1781,455,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1782,455,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (1783,455,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (1784,455,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (1785,455,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (1786,455,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (1787,455,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (1788,455,43,1,0)
INSERT INTO SalesInvoicedetail VALUES (1789,455,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (1790,455,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (1791,455,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (1792,455,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (1793,456,33,2,0.33)
INSERT INTO SalesInvoicedetail VALUES (1794,456,60,5,0.02)
INSERT INTO SalesInvoicedetail VALUES (1795,456,25,6,0.09)
INSERT INTO SalesInvoicedetail VALUES (1796,456,32,6,0.16)
INSERT INTO SalesInvoicedetail VALUES (1797,456,62,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (1798,456,56,5,0.09)
INSERT INTO SalesInvoicedetail VALUES (1799,456,38,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (1800,456,70,2,0.02)
INSERT INTO SalesInvoicedetail VALUES (1801,456,55,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (1802,456,29,2,0.31)
INSERT INTO SalesInvoicedetail VALUES (1803,456,64,3,0.08)
INSERT INTO SalesInvoicedetail VALUES (1804,456,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (1805,456,63,4,0.25)
INSERT INTO SalesInvoicedetail VALUES (1806,456,68,4,0.3)
INSERT INTO SalesInvoicedetail VALUES (1807,456,53,4,0.29)
INSERT INTO SalesInvoicedetail VALUES (1808,456,30,4,0.36)
INSERT INTO SalesInvoicedetail VALUES (1809,456,65,4,0.36)
INSERT INTO SalesInvoicedetail VALUES (1810,456,66,4,0.25)
INSERT INTO SalesInvoicedetail VALUES (1811,456,61,5,0.03)
INSERT INTO SalesInvoicedetail VALUES (1812,456,58,2,0.13)
INSERT INTO SalesInvoicedetail VALUES (1813,456,54,2,0.31)
INSERT INTO SalesInvoicedetail VALUES (1814,456,49,2,0.36)
INSERT INTO SalesInvoicedetail VALUES (1815,457,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (1816,457,47,1,0)
INSERT INTO SalesInvoicedetail VALUES (1817,457,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (1818,457,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1819,457,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (1820,457,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1821,457,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1822,457,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (1823,457,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1824,457,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (1825,457,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (1826,457,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (1827,457,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (1828,457,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (1829,457,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (1830,457,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1831,457,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (1832,457,45,5,0)
INSERT INTO SalesInvoicedetail VALUES (1833,457,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (1834,458,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (1835,458,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1836,458,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (1837,458,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (1838,458,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (1839,458,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (1840,459,70,4,0.37)
INSERT INTO SalesInvoicedetail VALUES (1841,459,54,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (1842,459,68,3,0.01)
INSERT INTO SalesInvoicedetail VALUES (1843,459,56,5,0.18)
INSERT INTO SalesInvoicedetail VALUES (1844,459,53,6,0.39)
INSERT INTO SalesInvoicedetail VALUES (1845,459,55,5,0.29)
INSERT INTO SalesInvoicedetail VALUES (1846,459,64,3,0.16)
INSERT INTO SalesInvoicedetail VALUES (1847,459,60,2,0.36)
INSERT INTO SalesInvoicedetail VALUES (1848,459,38,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (1849,459,61,2,0.36)
INSERT INTO SalesInvoicedetail VALUES (1850,459,32,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (1851,459,62,6,0.39)
INSERT INTO SalesInvoicedetail VALUES (1852,459,65,2,0.16)
INSERT INTO SalesInvoicedetail VALUES (1853,459,66,3,0.23)
INSERT INTO SalesInvoicedetail VALUES (1854,459,25,1,0.31)
INSERT INTO SalesInvoicedetail VALUES (1855,459,63,4,0.07)
INSERT INTO SalesInvoicedetail VALUES (1856,460,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (1857,460,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (1858,460,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (1859,461,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1860,461,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (1861,461,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (1862,461,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (1863,461,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (1864,461,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1865,461,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (1866,461,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1867,461,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (1868,461,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1869,461,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (1870,462,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (1871,462,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (1872,462,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (1873,462,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (1874,462,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (1875,462,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (1876,462,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (1877,462,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (1878,462,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (1879,462,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (1880,462,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (1881,462,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (1882,462,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (1883,462,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (1884,462,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (1885,463,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (1886,463,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (1887,463,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1888,463,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (1889,463,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (1890,463,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1891,463,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (1892,463,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (1893,463,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (1894,463,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (1895,463,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1896,463,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (1897,463,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (1898,463,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (1899,464,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (1900,464,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (1901,465,55,3,0.11)
INSERT INTO SalesInvoicedetail VALUES (1902,466,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (1903,466,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (1904,466,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (1905,466,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (1906,466,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (1907,466,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (1908,466,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (1909,466,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (1910,466,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (1911,466,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (1912,466,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (1913,466,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (1914,466,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (1915,466,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (1916,466,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (1917,466,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (1918,466,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (1919,466,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (1920,466,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (1921,466,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (1922,466,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (1923,467,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (1924,467,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (1925,467,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (1926,468,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (1927,468,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (1928,468,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (1929,468,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (1930,468,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (1931,468,10,3,0)
INSERT INTO SalesInvoicedetail VALUES (1932,468,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (1933,469,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (1934,469,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (1935,469,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (1936,469,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (1937,469,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (1938,469,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1939,469,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (1940,469,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (1941,469,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1942,469,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (1943,469,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (1944,469,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (1945,469,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (1946,469,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (1947,469,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (1948,469,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (1949,469,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (1950,469,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (1951,469,45,5,0)
INSERT INTO SalesInvoicedetail VALUES (1952,469,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (1953,469,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (1954,469,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (1955,470,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (1956,470,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (1957,470,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (1958,470,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (1959,470,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (1960,470,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (1961,470,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (1962,470,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (1963,470,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (1964,470,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (1965,470,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (1966,471,65,3,0.08)
INSERT INTO SalesInvoicedetail VALUES (1967,471,11,5,0.15)
INSERT INTO SalesInvoicedetail VALUES (1968,471,62,5,0.39)
INSERT INTO SalesInvoicedetail VALUES (1969,471,55,6,0.23)
INSERT INTO SalesInvoicedetail VALUES (1970,471,22,2,0.24)
INSERT INTO SalesInvoicedetail VALUES (1971,471,61,3,0.13)
INSERT INTO SalesInvoicedetail VALUES (1972,471,15,5,0.09)
INSERT INTO SalesInvoicedetail VALUES (1973,471,30,4,0.18)
INSERT INTO SalesInvoicedetail VALUES (1974,471,64,5,0.35)
INSERT INTO SalesInvoicedetail VALUES (1975,471,29,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (1976,471,63,4,0.19)
INSERT INTO SalesInvoicedetail VALUES (1977,471,66,3,0.06)
INSERT INTO SalesInvoicedetail VALUES (1978,471,68,4,0.29)
INSERT INTO SalesInvoicedetail VALUES (1979,471,14,4,0.4)
INSERT INTO SalesInvoicedetail VALUES (1980,471,38,5,0.13)
INSERT INTO SalesInvoicedetail VALUES (1981,471,7,1,0.03)
INSERT INTO SalesInvoicedetail VALUES (1982,471,32,4,0.16)
INSERT INTO SalesInvoicedetail VALUES (1983,471,49,3,0.22)
INSERT INTO SalesInvoicedetail VALUES (1984,471,54,5,0.21)
INSERT INTO SalesInvoicedetail VALUES (1985,471,60,5,0.09)
INSERT INTO SalesInvoicedetail VALUES (1986,471,16,5,0.25)
INSERT INTO SalesInvoicedetail VALUES (1987,471,53,1,0.05)
INSERT INTO SalesInvoicedetail VALUES (1988,471,70,2,0.22)
INSERT INTO SalesInvoicedetail VALUES (1989,471,56,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (1990,471,58,4,0.09)
INSERT INTO SalesInvoicedetail VALUES (1991,471,26,6,0.08)
INSERT INTO SalesInvoicedetail VALUES (1992,471,33,3,0.19)
INSERT INTO SalesInvoicedetail VALUES (1993,471,25,2,0.01)
INSERT INTO SalesInvoicedetail VALUES (1994,471,8,3,0.15)
INSERT INTO SalesInvoicedetail VALUES (1995,471,12,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (1996,472,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (1997,472,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (1998,472,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (1999,472,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (2000,472,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (2001,472,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (2002,472,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (2003,472,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (2004,472,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (2005,473,9,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (2006,473,7,4,0.18)
INSERT INTO SalesInvoicedetail VALUES (2007,473,76,4,0.02)
INSERT INTO SalesInvoicedetail VALUES (2008,473,8,5,0.14)
INSERT INTO SalesInvoicedetail VALUES (2009,473,73,3,0.26)
INSERT INTO SalesInvoicedetail VALUES (2010,473,16,3,0.21)
INSERT INTO SalesInvoicedetail VALUES (2011,473,71,2,0.06)
INSERT INTO SalesInvoicedetail VALUES (2012,473,78,3,0.16)
INSERT INTO SalesInvoicedetail VALUES (2013,473,72,2,0.4)
INSERT INTO SalesInvoicedetail VALUES (2014,473,77,5,0.02)
INSERT INTO SalesInvoicedetail VALUES (2015,474,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (2016,475,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (2017,475,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (2018,475,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (2019,475,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (2020,475,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (2021,475,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (2022,475,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (2023,475,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (2024,475,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (2025,475,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2026,475,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (2027,475,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (2028,475,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (2029,475,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (2030,475,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (2031,475,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (2032,475,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (2033,476,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2034,477,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2035,478,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2036,479,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (2037,480,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2038,481,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (2039,482,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2040,483,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2041,484,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2042,485,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2043,486,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2044,487,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (2045,488,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2046,489,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (2047,490,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2048,491,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (2049,492,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2050,493,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (2051,494,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (2052,495,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (2053,496,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2054,497,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (2055,498,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (2056,499,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2057,500,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2058,501,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2059,502,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2060,503,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2061,504,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (2062,505,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2063,506,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2064,507,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (2065,508,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (2066,509,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2067,510,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2068,511,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (2069,512,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2070,513,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2071,514,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (2072,515,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2073,516,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (2074,517,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2075,518,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (2076,519,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (2077,520,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2078,521,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (2079,522,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (2080,523,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2081,524,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2082,525,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (2083,526,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2084,527,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2085,528,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (2086,529,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2087,530,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (2088,531,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (2089,532,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (2090,533,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (2091,534,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2092,535,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2093,536,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2094,537,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (2095,538,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (2096,539,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2097,540,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2098,541,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2099,542,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2100,543,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2101,544,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2102,545,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2103,546,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (2104,547,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (2105,548,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (2106,549,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (2107,550,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (2108,551,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2109,552,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2110,553,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2111,554,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2112,555,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2113,556,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (2114,557,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2115,558,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2116,559,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2117,560,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2118,561,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (2119,562,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (2120,563,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2121,564,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2122,565,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (2123,566,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (2124,567,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (2125,568,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (2126,569,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (2127,570,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (2128,571,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (2129,572,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2130,573,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (2131,574,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2132,575,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (2133,576,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2134,577,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2135,578,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2136,579,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2137,580,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2138,581,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2139,582,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2140,583,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2141,584,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2142,585,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2143,586,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (2144,587,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (2145,588,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2146,589,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (2147,590,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2148,591,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2149,592,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (2150,593,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2151,594,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2152,595,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2153,596,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2154,597,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (2155,598,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2156,599,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (2157,600,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2158,601,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (2159,602,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2160,603,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (2161,604,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (2162,605,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2163,606,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2164,607,59,5,0)
INSERT INTO SalesInvoicedetail VALUES (2165,608,67,6,0)
INSERT INTO SalesInvoicedetail VALUES (2166,609,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (2167,610,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2168,611,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (2169,612,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2170,613,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (2171,614,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (2172,615,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2173,616,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2174,617,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2175,618,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2176,619,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (2177,620,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (2178,621,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2179,622,14,2,0.03)
INSERT INTO SalesInvoicedetail VALUES (2180,623,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (2181,624,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (2182,624,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (2183,624,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (2184,624,39,4,0)
INSERT INTO SalesInvoicedetail VALUES (2185,624,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (2186,624,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (2187,624,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (2188,624,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (2189,624,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (2190,624,44,5,0)
INSERT INTO SalesInvoicedetail VALUES (2191,624,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (2192,624,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (2193,624,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (2194,624,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (2195,624,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (2196,625,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (2197,625,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (2198,625,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (2199,625,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (2200,625,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2201,625,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (2202,625,70,1,0.07)
INSERT INTO SalesInvoicedetail VALUES (2203,625,36,4,0)
INSERT INTO SalesInvoicedetail VALUES (2204,625,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (2205,625,26,6,0)
INSERT INTO SalesInvoicedetail VALUES (2206,625,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (2207,625,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (2208,625,67,6,0)
INSERT INTO SalesInvoicedetail VALUES (2209,625,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (2210,625,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2211,625,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (2212,625,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (2213,625,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (2214,625,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (2215,625,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (2216,625,17,3,0)
INSERT INTO SalesInvoicedetail VALUES (2217,625,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (2218,625,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (2219,625,27,4,0)
INSERT INTO SalesInvoicedetail VALUES (2220,625,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (2221,625,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (2222,625,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (2223,626,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (2224,626,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (2225,626,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (2226,626,9,2,0.15)
INSERT INTO SalesInvoicedetail VALUES (2227,626,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (2228,626,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (2229,626,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (2230,626,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (2231,626,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (2232,626,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (2233,626,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2234,626,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (2235,626,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (2236,626,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (2237,626,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (2238,626,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (2239,627,9,5,0.01)
INSERT INTO SalesInvoicedetail VALUES (2240,627,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (2241,627,10,2,0)
INSERT INTO SalesInvoicedetail VALUES (2242,627,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (2243,627,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (2244,627,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (2245,627,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (2246,627,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (2247,627,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (2248,627,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2249,627,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (2250,627,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (2251,627,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (2252,628,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (2253,628,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2254,628,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (2255,628,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (2256,628,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (2257,628,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (2258,629,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (2259,629,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (2260,629,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (2261,629,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (2262,629,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (2263,630,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (2264,630,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (2265,630,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (2266,630,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (2267,630,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (2268,630,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (2269,630,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (2270,630,17,2,0)
INSERT INTO SalesInvoicedetail VALUES (2271,630,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (2272,630,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (2273,630,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (2274,630,33,3,0)
INSERT INTO SalesInvoicedetail VALUES (2275,630,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (2276,630,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (2277,630,38,6,0)
INSERT INTO SalesInvoicedetail VALUES (2278,630,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (2279,630,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (2280,630,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (2281,630,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (2282,630,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (2283,630,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (2284,630,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (2285,630,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (2286,630,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (2287,630,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (2288,630,18,1,0)
INSERT INTO SalesInvoicedetail VALUES (2289,630,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (2290,630,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (2291,630,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (2292,630,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (2293,630,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2294,630,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (2295,630,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (2296,630,36,5,0)
INSERT INTO SalesInvoicedetail VALUES (2297,631,75,2,0.01)
INSERT INTO SalesInvoicedetail VALUES (2298,631,71,3,0.27)
INSERT INTO SalesInvoicedetail VALUES (2299,631,9,1,0.3)
INSERT INTO SalesInvoicedetail VALUES (2300,632,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (2301,632,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (2302,632,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (2303,632,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (2304,633,39,1,0)
INSERT INTO SalesInvoicedetail VALUES (2305,633,44,2,0)
INSERT INTO SalesInvoicedetail VALUES (2306,634,12,4,0.21)
INSERT INTO SalesInvoicedetail VALUES (2307,634,70,3,0.05)
INSERT INTO SalesInvoicedetail VALUES (2308,634,65,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (2309,634,58,5,0.31)
INSERT INTO SalesInvoicedetail VALUES (2310,635,69,4,0.17)
INSERT INTO SalesInvoicedetail VALUES (2311,635,59,6,0.28)
INSERT INTO SalesInvoicedetail VALUES (2312,635,25,1,0.08)
INSERT INTO SalesInvoicedetail VALUES (2313,635,66,5,0.14)
INSERT INTO SalesInvoicedetail VALUES (2314,635,53,5,0.15)
INSERT INTO SalesInvoicedetail VALUES (2315,635,12,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (2316,635,61,4,0.13)
INSERT INTO SalesInvoicedetail VALUES (2317,635,63,6,0.32)
INSERT INTO SalesInvoicedetail VALUES (2318,635,29,5,0.17)
INSERT INTO SalesInvoicedetail VALUES (2319,635,8,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (2320,635,7,4,0.02)
INSERT INTO SalesInvoicedetail VALUES (2321,635,14,4,0.08)
INSERT INTO SalesInvoicedetail VALUES (2322,635,51,4,0.34)
INSERT INTO SalesInvoicedetail VALUES (2323,635,62,2,0.35)
INSERT INTO SalesInvoicedetail VALUES (2324,635,64,1,0.3)
INSERT INTO SalesInvoicedetail VALUES (2325,635,60,2,0.03)
INSERT INTO SalesInvoicedetail VALUES (2326,635,67,3,0.14)
INSERT INTO SalesInvoicedetail VALUES (2327,635,54,5,0.23)
INSERT INTO SalesInvoicedetail VALUES (2328,635,68,3,0.31)
INSERT INTO SalesInvoicedetail VALUES (2329,635,16,2,0.15)
INSERT INTO SalesInvoicedetail VALUES (2330,635,15,4,0.13)
INSERT INTO SalesInvoicedetail VALUES (2331,635,38,1,0.02)
INSERT INTO SalesInvoicedetail VALUES (2332,635,65,2,0.29)
INSERT INTO SalesInvoicedetail VALUES (2333,635,55,6,0.36)
INSERT INTO SalesInvoicedetail VALUES (2334,635,52,2,0.39)
INSERT INTO SalesInvoicedetail VALUES (2335,636,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (2336,636,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (2337,636,9,5,0.07)
INSERT INTO SalesInvoicedetail VALUES (2338,636,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (2339,636,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (2340,636,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (2341,636,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (2342,636,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2343,636,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (2344,636,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (2345,636,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (2346,637,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (2347,637,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (2348,637,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (2349,637,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (2350,637,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (2351,637,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (2352,637,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (2353,637,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (2354,637,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (2355,638,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (2356,638,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (2357,638,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (2358,638,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (2359,638,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (2360,638,69,5,0)
INSERT INTO SalesInvoicedetail VALUES (2361,638,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (2362,638,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2363,638,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (2364,638,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (2365,638,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2366,638,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (2367,638,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (2368,638,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (2369,638,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (2370,638,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (2371,638,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (2372,638,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (2373,638,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (2374,638,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (2375,638,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (2376,638,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (2377,638,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (2378,638,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (2379,638,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (2380,638,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (2381,639,78,6,0.21)
INSERT INTO SalesInvoicedetail VALUES (2382,639,74,1,0.08)
INSERT INTO SalesInvoicedetail VALUES (2383,639,73,1,0.03)
INSERT INTO SalesInvoicedetail VALUES (2384,639,76,2,0.04)
INSERT INTO SalesInvoicedetail VALUES (2385,639,12,3,0.19)
INSERT INTO SalesInvoicedetail VALUES (2386,639,10,2,0.34)
INSERT INTO SalesInvoicedetail VALUES (2387,639,15,2,0.25)
INSERT INTO SalesInvoicedetail VALUES (2388,639,72,5,0.34)
INSERT INTO SalesInvoicedetail VALUES (2389,640,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (2390,640,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (2391,640,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (2392,640,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (2393,640,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (2394,640,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (2395,640,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (2396,640,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (2397,640,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (2398,640,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (2399,640,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (2400,640,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (2401,640,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (2402,640,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2403,640,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (2404,640,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (2405,640,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (2406,640,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (2407,640,69,6,0)
INSERT INTO SalesInvoicedetail VALUES (2408,640,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (2409,640,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (2410,640,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (2411,640,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (2412,640,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (2413,640,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (2414,640,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (2415,640,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (2416,641,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (2417,641,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (2418,641,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (2419,641,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (2420,641,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (2421,641,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (2422,641,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (2423,641,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (2424,641,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (2425,641,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (2426,641,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (2427,641,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (2428,641,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2429,641,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (2430,641,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (2431,641,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2432,641,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (2433,641,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (2434,641,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (2435,641,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (2436,641,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (2437,641,59,1,0)
INSERT INTO SalesInvoicedetail VALUES (2438,641,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (2439,641,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (2440,641,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (2441,641,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2442,641,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (2443,642,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (2444,642,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (2445,642,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (2446,642,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (2447,642,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (2448,642,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (2449,642,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (2450,642,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (2451,642,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (2452,642,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (2453,643,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (2454,643,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (2455,643,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (2456,643,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (2457,643,57,4,0)
INSERT INTO SalesInvoicedetail VALUES (2458,643,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (2459,643,59,5,0)
INSERT INTO SalesInvoicedetail VALUES (2460,643,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (2461,643,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2462,643,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (2463,643,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (2464,643,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2465,643,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2466,643,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (2467,643,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (2468,643,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (2469,643,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (2470,643,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (2471,643,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (2472,643,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (2473,643,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2474,643,26,1,0)
INSERT INTO SalesInvoicedetail VALUES (2475,643,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (2476,643,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (2477,643,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (2478,643,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (2479,643,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (2480,644,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (2481,645,10,5,0.14)
INSERT INTO SalesInvoicedetail VALUES (2482,646,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (2483,646,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (2484,646,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (2485,646,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (2486,646,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (2487,646,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (2488,646,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (2489,646,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (2490,646,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (2491,647,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (2492,647,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (2493,647,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (2494,647,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (2495,647,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (2496,647,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (2497,647,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (2498,647,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (2499,647,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (2500,647,9,3,0.08)
INSERT INTO SalesInvoicedetail VALUES (2501,647,10,5,0)
INSERT INTO SalesInvoicedetail VALUES (2502,647,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (2503,647,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (2504,647,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (2505,647,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (2506,648,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2507,648,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (2508,648,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (2509,648,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (2510,648,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (2511,648,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (2512,648,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (2513,648,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (2514,648,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (2515,648,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (2516,648,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (2517,648,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (2518,648,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (2519,648,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (2520,648,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (2521,648,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (2522,648,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (2523,648,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (2524,648,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (2525,648,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (2526,649,70,4,0.3)
INSERT INTO SalesInvoicedetail VALUES (2527,649,54,3,0.15)
INSERT INTO SalesInvoicedetail VALUES (2528,649,61,4,0.2)
INSERT INTO SalesInvoicedetail VALUES (2529,649,60,5,0.09)
INSERT INTO SalesInvoicedetail VALUES (2530,649,62,1,0.32)
INSERT INTO SalesInvoicedetail VALUES (2531,649,63,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (2532,649,65,3,0.14)
INSERT INTO SalesInvoicedetail VALUES (2533,649,12,6,0.33)
INSERT INTO SalesInvoicedetail VALUES (2534,649,15,2,0.29)
INSERT INTO SalesInvoicedetail VALUES (2535,650,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2536,650,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (2537,650,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (2538,650,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (2539,650,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (2540,650,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (2541,650,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (2542,650,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (2543,650,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (2544,651,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (2545,651,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2546,651,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (2547,651,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2548,651,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (2549,651,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (2550,651,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (2551,651,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (2552,651,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (2553,651,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (2554,651,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (2555,651,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (2556,651,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (2557,651,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (2558,651,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (2559,651,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (2560,651,57,1,0)
INSERT INTO SalesInvoicedetail VALUES (2561,651,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2562,652,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (2563,653,54,4,0.26)
INSERT INTO SalesInvoicedetail VALUES (2564,653,53,3,0.28)
INSERT INTO SalesInvoicedetail VALUES (2565,653,64,4,0.38)
INSERT INTO SalesInvoicedetail VALUES (2566,653,67,4,0.04)
INSERT INTO SalesInvoicedetail VALUES (2567,653,69,5,0.39)
INSERT INTO SalesInvoicedetail VALUES (2568,653,18,6,0.23)
INSERT INTO SalesInvoicedetail VALUES (2569,653,36,2,0.39)
INSERT INTO SalesInvoicedetail VALUES (2570,654,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (2571,654,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (2572,654,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (2573,654,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (2574,655,66,4,0.04)
INSERT INTO SalesInvoicedetail VALUES (2575,655,50,3,0.04)
INSERT INTO SalesInvoicedetail VALUES (2576,655,58,4,0.4)
INSERT INTO SalesInvoicedetail VALUES (2577,655,56,3,0.24)
INSERT INTO SalesInvoicedetail VALUES (2578,655,55,4,0.22)
INSERT INTO SalesInvoicedetail VALUES (2579,655,54,5,0.16)
INSERT INTO SalesInvoicedetail VALUES (2580,655,52,6,0.37)
INSERT INTO SalesInvoicedetail VALUES (2581,655,65,4,0.03)
INSERT INTO SalesInvoicedetail VALUES (2582,655,69,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (2583,655,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (2584,655,49,2,0.12)
INSERT INTO SalesInvoicedetail VALUES (2585,655,29,2,0.15)
INSERT INTO SalesInvoicedetail VALUES (2586,655,57,4,0.26)
INSERT INTO SalesInvoicedetail VALUES (2587,655,30,3,0.08)
INSERT INTO SalesInvoicedetail VALUES (2588,655,38,4,0.21)
INSERT INTO SalesInvoicedetail VALUES (2589,655,26,5,0.39)
INSERT INTO SalesInvoicedetail VALUES (2590,655,32,5,0.04)
INSERT INTO SalesInvoicedetail VALUES (2591,655,64,5,0.11)
INSERT INTO SalesInvoicedetail VALUES (2592,655,61,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (2593,655,70,1,0.34)
INSERT INTO SalesInvoicedetail VALUES (2594,655,68,1,0.13)
INSERT INTO SalesInvoicedetail VALUES (2595,655,62,1,0.37)
INSERT INTO SalesInvoicedetail VALUES (2596,656,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (2597,656,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (2598,656,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (2599,656,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (2600,656,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (2601,656,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (2602,656,17,2,0)
INSERT INTO SalesInvoicedetail VALUES (2603,656,33,3,0)
INSERT INTO SalesInvoicedetail VALUES (2604,656,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (2605,656,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2606,656,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (2607,656,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (2608,656,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (2609,656,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (2610,656,18,4,0)
INSERT INTO SalesInvoicedetail VALUES (2611,656,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2612,656,36,4,0)
INSERT INTO SalesInvoicedetail VALUES (2613,656,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (2614,656,69,1,0)
INSERT INTO SalesInvoicedetail VALUES (2615,656,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (2616,656,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (2617,656,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (2618,656,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (2619,657,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (2620,657,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (2621,657,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (2622,657,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (2623,657,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (2624,658,12,5,0.28)
INSERT INTO SalesInvoicedetail VALUES (2625,658,70,2,0.26)
INSERT INTO SalesInvoicedetail VALUES (2626,658,63,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (2627,658,61,6,0.18)
INSERT INTO SalesInvoicedetail VALUES (2628,658,62,3,0.37)
INSERT INTO SalesInvoicedetail VALUES (2629,658,65,4,0.26)
INSERT INTO SalesInvoicedetail VALUES (2630,659,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (2631,659,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (2632,659,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (2633,659,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (2634,659,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2635,659,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (2636,659,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (2637,659,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (2638,659,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (2639,659,33,3,0)
INSERT INTO SalesInvoicedetail VALUES (2640,659,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (2641,659,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (2642,659,26,1,0)
INSERT INTO SalesInvoicedetail VALUES (2643,659,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (2644,659,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (2645,659,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (2646,659,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (2647,659,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (2648,659,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (2649,659,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (2650,659,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (2651,659,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (2652,659,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (2653,659,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (2654,659,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2655,659,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (2656,659,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (2657,659,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (2658,660,9,5,0.31)
INSERT INTO SalesInvoicedetail VALUES (2659,660,14,2,0.08)
INSERT INTO SalesInvoicedetail VALUES (2660,660,48,1,0.12)
INSERT INTO SalesInvoicedetail VALUES (2661,660,75,2,0.05)
INSERT INTO SalesInvoicedetail VALUES (2662,660,76,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (2663,660,73,4,0.22)
INSERT INTO SalesInvoicedetail VALUES (2664,661,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (2665,661,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (2666,661,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (2667,661,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (2668,661,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (2669,661,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2670,661,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (2671,661,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (2672,661,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (2673,661,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (2674,661,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (2675,661,48,6,0)
INSERT INTO SalesInvoicedetail VALUES (2676,661,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (2677,661,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (2678,662,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2679,663,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (2680,664,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (2681,665,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (2682,666,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2683,667,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (2684,668,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2685,669,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (2686,670,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2687,671,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2688,672,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2689,673,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2690,674,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2691,675,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (2692,676,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2693,677,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (2694,678,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (2695,679,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (2696,680,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (2697,681,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2698,682,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2699,683,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (2700,684,59,4,0)
INSERT INTO SalesInvoicedetail VALUES (2701,685,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (2702,686,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2703,687,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2704,688,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (2705,689,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2706,690,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (2707,691,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (2708,692,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2709,693,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (2710,694,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2711,695,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (2712,696,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (2713,697,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (2714,698,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (2715,699,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2716,700,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (2717,701,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2718,702,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2719,703,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2720,704,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2721,705,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2722,706,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (2723,707,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2724,708,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2725,709,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (2726,710,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2727,711,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2728,712,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2729,713,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (2730,714,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2731,715,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (2732,716,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2733,717,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (2734,718,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (2735,719,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2736,720,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (2737,721,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (2738,722,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (2739,723,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2740,724,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (2741,725,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (2742,726,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2743,727,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2744,728,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2745,729,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (2746,730,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (2747,731,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (2748,732,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2749,733,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2750,734,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (2751,735,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (2752,736,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2753,737,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2754,738,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (2755,739,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (2756,740,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2757,741,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2758,742,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2759,743,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2760,744,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (2761,745,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (2762,746,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2763,747,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (2764,748,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2765,749,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (2766,750,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (2767,751,59,5,0)
INSERT INTO SalesInvoicedetail VALUES (2768,752,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2769,753,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (2770,754,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (2771,755,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2772,756,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2773,757,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2774,758,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (2775,759,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2776,760,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (2777,761,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2778,762,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2779,763,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2780,764,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (2781,765,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2782,766,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (2783,767,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2784,768,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (2785,769,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2786,770,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (2787,771,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2788,772,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2789,773,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2790,774,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2791,775,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2792,776,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2793,777,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2794,778,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (2795,779,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (2796,780,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2797,781,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2798,782,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2799,783,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2800,784,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (2801,785,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (2802,786,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (2803,787,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2804,788,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2805,789,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2806,790,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (2807,791,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (2808,792,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2809,793,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2810,794,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (2811,795,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (2812,796,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2813,797,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (2814,798,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (2815,799,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (2816,800,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2817,801,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2818,802,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (2819,803,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2820,804,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2821,805,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (2822,806,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2823,807,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (2824,808,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (2825,809,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (2826,810,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (2827,811,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (2828,812,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (2829,813,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (2830,814,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (2831,815,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2832,816,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (2833,817,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (2834,818,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (2835,819,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (2836,820,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2837,821,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (2838,822,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (2839,823,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (2840,823,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (2841,823,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (2842,823,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (2843,823,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (2844,823,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (2845,823,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (2846,824,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (2847,825,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (2848,825,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (2849,825,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (2850,825,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (2851,826,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (2852,826,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (2853,826,10,3,0)
INSERT INTO SalesInvoicedetail VALUES (2854,826,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (2855,826,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (2856,827,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (2857,828,69,2,0)
INSERT INTO SalesInvoicedetail VALUES (2858,828,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (2859,829,75,3,0.22)
INSERT INTO SalesInvoicedetail VALUES (2860,829,74,4,0.09)
INSERT INTO SalesInvoicedetail VALUES (2861,829,72,4,0.27)
INSERT INTO SalesInvoicedetail VALUES (2862,829,45,3,0.24)
INSERT INTO SalesInvoicedetail VALUES (2863,829,41,2,0.23)
INSERT INTO SalesInvoicedetail VALUES (2864,829,73,4,0.12)
INSERT INTO SalesInvoicedetail VALUES (2865,829,9,5,0.15)
INSERT INTO SalesInvoicedetail VALUES (2866,829,76,5,0.39)
INSERT INTO SalesInvoicedetail VALUES (2867,830,69,2,0)
INSERT INTO SalesInvoicedetail VALUES (2868,830,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (2869,830,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (2870,830,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (2871,830,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (2872,830,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (2873,830,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (2874,830,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (2875,830,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (2876,830,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (2877,830,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (2878,830,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (2879,830,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (2880,830,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (2881,830,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (2882,830,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (2883,830,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (2884,830,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (2885,830,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (2886,830,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (2887,830,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (2888,830,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (2889,830,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (2890,830,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (2891,830,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (2892,830,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2893,830,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (2894,831,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (2895,831,9,5,0.06)
INSERT INTO SalesInvoicedetail VALUES (2896,831,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (2897,831,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (2898,831,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (2899,832,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (2900,832,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (2901,832,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (2902,832,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (2903,832,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (2904,832,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (2905,832,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (2906,833,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (2907,833,60,4,0.24)
INSERT INTO SalesInvoicedetail VALUES (2908,833,58,3,0.13)
INSERT INTO SalesInvoicedetail VALUES (2909,833,62,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (2910,834,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (2911,834,48,3,0)
INSERT INTO SalesInvoicedetail VALUES (2912,834,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (2913,834,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (2914,834,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (2915,834,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (2916,834,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (2917,834,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (2918,834,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (2919,834,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (2920,834,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (2921,834,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (2922,834,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (2923,834,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (2924,834,41,6,0)
INSERT INTO SalesInvoicedetail VALUES (2925,834,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (2926,834,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (2927,834,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (2928,834,10,6,0)
INSERT INTO SalesInvoicedetail VALUES (2929,835,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (2930,835,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (2931,835,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (2932,835,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (2933,835,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (2934,835,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (2935,835,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (2936,835,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (2937,835,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (2938,836,59,5,0.34)
INSERT INTO SalesInvoicedetail VALUES (2939,836,56,6,0.08)
INSERT INTO SalesInvoicedetail VALUES (2940,836,26,4,0.25)
INSERT INTO SalesInvoicedetail VALUES (2941,836,54,6,0.28)
INSERT INTO SalesInvoicedetail VALUES (2942,836,51,4,0.15)
INSERT INTO SalesInvoicedetail VALUES (2943,836,29,3,0.19)
INSERT INTO SalesInvoicedetail VALUES (2944,836,8,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (2945,836,15,3,0.06)
INSERT INTO SalesInvoicedetail VALUES (2946,836,7,2,0.36)
INSERT INTO SalesInvoicedetail VALUES (2947,836,52,4,0.15)
INSERT INTO SalesInvoicedetail VALUES (2948,836,60,3,0.04)
INSERT INTO SalesInvoicedetail VALUES (2949,836,69,5,0.08)
INSERT INTO SalesInvoicedetail VALUES (2950,836,55,2,0.12)
INSERT INTO SalesInvoicedetail VALUES (2951,836,50,3,0.04)
INSERT INTO SalesInvoicedetail VALUES (2952,836,11,3,0.39)
INSERT INTO SalesInvoicedetail VALUES (2953,836,62,2,0.36)
INSERT INTO SalesInvoicedetail VALUES (2954,836,12,5,0.26)
INSERT INTO SalesInvoicedetail VALUES (2955,836,58,4,0.24)
INSERT INTO SalesInvoicedetail VALUES (2956,836,57,2,0.32)
INSERT INTO SalesInvoicedetail VALUES (2957,836,66,6,0.14)
INSERT INTO SalesInvoicedetail VALUES (2958,836,63,3,0.36)
INSERT INTO SalesInvoicedetail VALUES (2959,836,53,2,0.2)
INSERT INTO SalesInvoicedetail VALUES (2960,836,32,4,0.16)
INSERT INTO SalesInvoicedetail VALUES (2961,836,68,4,0.31)
INSERT INTO SalesInvoicedetail VALUES (2962,836,70,4,0.21)
INSERT INTO SalesInvoicedetail VALUES (2963,836,14,3,0.25)
INSERT INTO SalesInvoicedetail VALUES (2964,837,10,5,0)
INSERT INTO SalesInvoicedetail VALUES (2965,837,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (2966,837,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (2967,838,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (2968,838,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (2969,838,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (2970,838,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (2971,838,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (2972,838,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (2973,838,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (2974,838,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (2975,838,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (2976,838,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (2977,838,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (2978,838,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (2979,838,57,4,0)
INSERT INTO SalesInvoicedetail VALUES (2980,838,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (2981,838,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (2982,838,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (2983,838,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (2984,838,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (2985,838,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (2986,839,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (2987,839,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (2988,840,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (2989,840,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (2990,840,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (2991,840,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (2992,840,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (2993,840,33,5,0)
INSERT INTO SalesInvoicedetail VALUES (2994,840,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (2995,840,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (2996,840,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (2997,840,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (2998,840,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (2999,840,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3000,840,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (3001,840,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3002,840,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (3003,841,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (3004,841,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (3005,841,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (3006,841,10,5,0)
INSERT INTO SalesInvoicedetail VALUES (3007,842,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (3008,842,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (3009,842,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (3010,842,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (3011,842,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3012,842,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (3013,843,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (3014,843,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (3015,843,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (3016,843,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (3017,843,57,4,0)
INSERT INTO SalesInvoicedetail VALUES (3018,843,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (3019,843,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (3020,843,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (3021,843,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (3022,843,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (3023,843,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (3024,843,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (3025,843,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (3026,843,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (3027,843,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (3028,843,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (3029,843,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (3030,843,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (3031,843,67,6,0)
INSERT INTO SalesInvoicedetail VALUES (3032,843,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3033,844,56,2,0.19)
INSERT INTO SalesInvoicedetail VALUES (3034,844,22,6,0.21)
INSERT INTO SalesInvoicedetail VALUES (3035,844,54,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (3036,844,38,5,0.26)
INSERT INTO SalesInvoicedetail VALUES (3037,844,26,5,0.35)
INSERT INTO SalesInvoicedetail VALUES (3038,844,70,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (3039,844,30,3,0.24)
INSERT INTO SalesInvoicedetail VALUES (3040,844,66,4,0.08)
INSERT INTO SalesInvoicedetail VALUES (3041,844,32,4,0.05)
INSERT INTO SalesInvoicedetail VALUES (3042,844,68,2,0.24)
INSERT INTO SalesInvoicedetail VALUES (3043,844,62,2,0.14)
INSERT INTO SalesInvoicedetail VALUES (3044,844,60,5,0.33)
INSERT INTO SalesInvoicedetail VALUES (3045,844,49,5,0.12)
INSERT INTO SalesInvoicedetail VALUES (3046,844,53,4,0.28)
INSERT INTO SalesInvoicedetail VALUES (3047,845,60,2,0.05)
INSERT INTO SalesInvoicedetail VALUES (3048,845,58,5,0.03)
INSERT INTO SalesInvoicedetail VALUES (3049,845,12,2,0.08)
INSERT INTO SalesInvoicedetail VALUES (3050,845,70,4,0.29)
INSERT INTO SalesInvoicedetail VALUES (3051,846,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (3052,846,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (3053,846,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (3054,846,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3055,846,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (3056,846,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (3057,846,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (3058,846,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (3059,846,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (3060,846,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (3061,846,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (3062,846,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (3063,846,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (3064,846,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (3065,846,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (3066,846,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (3067,846,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3068,846,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (3069,846,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (3070,846,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (3071,846,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (3072,846,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3073,846,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3074,846,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (3075,846,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (3076,846,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (3077,846,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (3078,847,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (3079,847,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (3080,847,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (3081,847,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (3082,847,45,5,0)
INSERT INTO SalesInvoicedetail VALUES (3083,847,42,2,0)
INSERT INTO SalesInvoicedetail VALUES (3084,847,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (3085,847,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (3086,848,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (3087,848,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3088,848,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (3089,848,33,6,0)
INSERT INTO SalesInvoicedetail VALUES (3090,848,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (3091,848,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (3092,848,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (3093,848,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3094,848,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (3095,848,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3096,848,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (3097,848,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (3098,848,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (3099,848,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (3100,848,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (3101,848,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (3102,848,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (3103,848,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (3104,848,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (3105,848,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (3106,848,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (3107,848,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (3108,848,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3109,848,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (3110,848,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (3111,848,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (3112,848,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (3113,848,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (3114,848,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (3115,848,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (3116,849,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (3117,849,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (3118,849,42,2,0)
INSERT INTO SalesInvoicedetail VALUES (3119,849,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (3120,849,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (3121,849,43,1,0)
INSERT INTO SalesInvoicedetail VALUES (3122,849,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (3123,849,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (3124,849,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (3125,849,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (3126,849,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (3127,849,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (3128,849,44,3,0)
INSERT INTO SalesInvoicedetail VALUES (3129,850,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (3130,850,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (3131,850,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (3132,850,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (3133,851,59,4,0)
INSERT INTO SalesInvoicedetail VALUES (3134,851,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (3135,851,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (3136,851,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (3137,851,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (3138,851,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (3139,851,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (3140,851,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (3141,851,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (3142,851,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (3143,851,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (3144,851,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (3145,851,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (3146,851,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3147,851,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (3148,851,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (3149,851,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (3150,851,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (3151,851,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (3152,851,57,1,0)
INSERT INTO SalesInvoicedetail VALUES (3153,851,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (3154,851,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (3155,851,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (3156,851,69,5,0)
INSERT INTO SalesInvoicedetail VALUES (3157,851,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (3158,851,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (3159,851,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (3160,851,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (3161,851,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (3162,851,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (3163,851,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (3164,851,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (3165,852,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3166,853,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (3167,853,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (3168,853,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3169,853,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3170,853,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (3171,854,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (3172,854,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (3173,855,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (3174,855,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (3175,855,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (3176,855,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (3177,855,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (3178,855,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (3179,855,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (3180,855,48,6,0)
INSERT INTO SalesInvoicedetail VALUES (3181,855,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (3182,855,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (3183,855,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (3184,855,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (3185,855,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (3186,855,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (3187,855,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (3188,855,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (3189,856,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (3190,856,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (3191,856,42,1,0)
INSERT INTO SalesInvoicedetail VALUES (3192,856,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (3193,856,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3194,856,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (3195,856,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (3196,856,39,4,0)
INSERT INTO SalesInvoicedetail VALUES (3197,856,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (3198,856,44,2,0)
INSERT INTO SalesInvoicedetail VALUES (3199,856,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (3200,857,65,3,0.01)
INSERT INTO SalesInvoicedetail VALUES (3201,857,12,1,0.15)
INSERT INTO SalesInvoicedetail VALUES (3202,857,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (3203,857,61,6,0.4)
INSERT INTO SalesInvoicedetail VALUES (3204,857,15,2,0.25)
INSERT INTO SalesInvoicedetail VALUES (3205,857,62,5,0.15)
INSERT INTO SalesInvoicedetail VALUES (3206,857,70,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (3207,858,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (3208,859,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (3209,859,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (3210,859,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (3211,859,22,1,0)
INSERT INTO SalesInvoicedetail VALUES (3212,859,64,6,0)
INSERT INTO SalesInvoicedetail VALUES (3213,859,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (3214,859,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (3215,859,67,6,0)
INSERT INTO SalesInvoicedetail VALUES (3216,859,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (3217,859,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (3218,859,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (3219,859,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3220,859,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (3221,859,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (3222,859,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (3223,859,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (3224,859,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (3225,859,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (3226,859,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (3227,859,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (3228,859,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (3229,859,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (3230,859,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (3231,859,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (3232,859,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (3233,859,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (3234,859,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (3235,860,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (3236,860,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (3237,860,75,6,0.03)
INSERT INTO SalesInvoicedetail VALUES (3238,860,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (3239,860,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (3240,860,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (3241,860,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (3242,860,76,6,0.05)
INSERT INTO SalesInvoicedetail VALUES (3243,860,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (3244,860,9,5,0.01)
INSERT INTO SalesInvoicedetail VALUES (3245,860,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (3246,860,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (3247,860,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (3248,860,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3249,860,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (3250,860,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (3251,860,41,6,0)
INSERT INTO SalesInvoicedetail VALUES (3252,860,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (3253,860,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (3254,860,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (3255,861,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (3256,862,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (3257,862,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (3258,862,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (3259,862,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (3260,862,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (3261,862,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (3262,862,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (3263,862,17,1,0)
INSERT INTO SalesInvoicedetail VALUES (3264,862,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (3265,862,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (3266,862,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (3267,862,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (3268,862,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (3269,862,26,2,0)
INSERT INTO SalesInvoicedetail VALUES (3270,862,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (3271,862,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3272,862,33,6,0)
INSERT INTO SalesInvoicedetail VALUES (3273,862,36,1,0)
INSERT INTO SalesInvoicedetail VALUES (3274,862,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (3275,862,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (3276,862,38,6,0)
INSERT INTO SalesInvoicedetail VALUES (3277,862,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (3278,862,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (3279,862,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3280,862,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (3281,862,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (3282,862,59,4,0)
INSERT INTO SalesInvoicedetail VALUES (3283,862,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (3284,862,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (3285,862,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (3286,862,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (3287,862,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (3288,862,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (3289,862,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (3290,863,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (3291,863,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (3292,863,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (3293,863,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (3294,863,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (3295,863,57,4,0)
INSERT INTO SalesInvoicedetail VALUES (3296,863,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (3297,863,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (3298,863,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (3299,863,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (3300,863,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (3301,863,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (3302,863,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (3303,863,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (3304,863,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (3305,863,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (3306,863,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (3307,863,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (3308,863,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (3309,863,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (3310,863,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (3311,863,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3312,863,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (3313,863,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (3314,863,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (3315,863,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (3316,864,67,4,0.35)
INSERT INTO SalesInvoicedetail VALUES (3317,864,25,1,0.3)
INSERT INTO SalesInvoicedetail VALUES (3318,864,29,4,0.38)
INSERT INTO SalesInvoicedetail VALUES (3319,864,26,6,0.34)
INSERT INTO SalesInvoicedetail VALUES (3320,864,60,2,0.28)
INSERT INTO SalesInvoicedetail VALUES (3321,864,69,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (3322,864,50,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (3323,864,52,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (3324,864,61,6,0.05)
INSERT INTO SalesInvoicedetail VALUES (3325,864,49,1,0.03)
INSERT INTO SalesInvoicedetail VALUES (3326,864,62,6,0.28)
INSERT INTO SalesInvoicedetail VALUES (3327,864,30,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (3328,864,66,3,0.11)
INSERT INTO SalesInvoicedetail VALUES (3329,864,56,5,0.3)
INSERT INTO SalesInvoicedetail VALUES (3330,864,70,4,0.28)
INSERT INTO SalesInvoicedetail VALUES (3331,864,38,3,0.15)
INSERT INTO SalesInvoicedetail VALUES (3332,864,54,6,0.3)
INSERT INTO SalesInvoicedetail VALUES (3333,864,57,1,0)
INSERT INTO SalesInvoicedetail VALUES (3334,864,22,2,0.22)
INSERT INTO SalesInvoicedetail VALUES (3335,864,58,1,0.39)
INSERT INTO SalesInvoicedetail VALUES (3336,864,65,3,0.04)
INSERT INTO SalesInvoicedetail VALUES (3337,864,68,4,0.33)
INSERT INTO SalesInvoicedetail VALUES (3338,865,9,3,0.03)
INSERT INTO SalesInvoicedetail VALUES (3339,865,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (3340,865,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3341,865,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (3342,865,48,6,0)
INSERT INTO SalesInvoicedetail VALUES (3343,865,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (3344,865,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (3345,865,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (3346,865,10,2,0)
INSERT INTO SalesInvoicedetail VALUES (3347,865,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (3348,865,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (3349,865,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (3350,865,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (3351,865,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (3352,865,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (3353,865,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (3354,865,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (3355,866,9,4,0.34)
INSERT INTO SalesInvoicedetail VALUES (3356,866,78,5,0.05)
INSERT INTO SalesInvoicedetail VALUES (3357,866,72,4,0.06)
INSERT INTO SalesInvoicedetail VALUES (3358,867,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (3359,867,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (3360,867,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (3361,867,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (3362,867,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3363,867,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3364,867,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (3365,867,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (3366,867,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (3367,867,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (3368,867,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (3369,867,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (3370,867,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (3371,867,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (3372,867,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (3373,867,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (3374,867,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (3375,867,15,5,0.06)
INSERT INTO SalesInvoicedetail VALUES (3376,867,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (3377,867,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (3378,867,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (3379,867,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (3380,867,33,2,0)
INSERT INTO SalesInvoicedetail VALUES (3381,867,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (3382,867,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (3383,867,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (3384,867,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3385,868,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (3386,868,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (3387,868,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (3388,868,26,2,0)
INSERT INTO SalesInvoicedetail VALUES (3389,868,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (3390,868,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (3391,868,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (3392,868,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (3393,868,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (3394,868,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (3395,868,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (3396,868,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (3397,868,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (3398,869,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (3399,869,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (3400,869,10,4,0)
INSERT INTO SalesInvoicedetail VALUES (3401,869,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (3402,869,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (3403,870,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (3404,870,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (3405,870,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (3406,870,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (3407,870,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (3408,870,43,1,0)
INSERT INTO SalesInvoicedetail VALUES (3409,870,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (3410,870,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (3411,870,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (3412,870,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (3413,870,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (3414,870,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (3415,871,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (3416,872,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (3417,872,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (3418,872,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (3419,872,12,5,0.03)
INSERT INTO SalesInvoicedetail VALUES (3420,872,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (3421,872,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (3422,872,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (3423,872,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (3424,872,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (3425,872,47,6,0)
INSERT INTO SalesInvoicedetail VALUES (3426,872,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (3427,872,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (3428,872,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (3429,872,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (3430,872,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (3431,872,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (3432,872,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (3433,872,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (3434,872,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (3435,872,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (3436,872,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (3437,872,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (3438,873,27,5,0.29)
INSERT INTO SalesInvoicedetail VALUES (3439,873,70,6,0.12)
INSERT INTO SalesInvoicedetail VALUES (3440,873,17,1,0.35)
INSERT INTO SalesInvoicedetail VALUES (3441,873,29,5,0.18)
INSERT INTO SalesInvoicedetail VALUES (3442,873,25,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (3443,873,36,5,0.08)
INSERT INTO SalesInvoicedetail VALUES (3444,873,64,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (3445,873,26,5,0.05)
INSERT INTO SalesInvoicedetail VALUES (3446,873,18,4,0.08)
INSERT INTO SalesInvoicedetail VALUES (3447,873,38,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (3448,873,54,3,0.3)
INSERT INTO SalesInvoicedetail VALUES (3449,873,62,3,0.05)
INSERT INTO SalesInvoicedetail VALUES (3450,873,58,4,0.3)
INSERT INTO SalesInvoicedetail VALUES (3451,873,53,3,0.26)
INSERT INTO SalesInvoicedetail VALUES (3452,873,69,2,0.03)
INSERT INTO SalesInvoicedetail VALUES (3453,873,56,4,0.12)
INSERT INTO SalesInvoicedetail VALUES (3454,873,65,2,0.22)
INSERT INTO SalesInvoicedetail VALUES (3455,873,55,1,0.36)
INSERT INTO SalesInvoicedetail VALUES (3456,873,60,5,0.26)
INSERT INTO SalesInvoicedetail VALUES (3457,873,68,4,0.4)
INSERT INTO SalesInvoicedetail VALUES (3458,874,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (3459,875,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (3460,875,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (3461,875,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (3462,875,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (3463,875,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (3464,875,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (3465,875,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (3466,875,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (3467,875,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (3468,875,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (3469,875,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (3470,875,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (3471,875,26,6,0)
INSERT INTO SalesInvoicedetail VALUES (3472,875,33,2,0)
INSERT INTO SalesInvoicedetail VALUES (3473,875,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (3474,875,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (3475,875,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (3476,875,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3477,875,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (3478,875,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (3479,876,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (3480,876,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (3481,876,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (3482,876,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (3483,876,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (3484,876,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (3485,876,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (3486,876,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (3487,876,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (3488,876,77,4,0.03)
INSERT INTO SalesInvoicedetail VALUES (3489,876,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (3490,876,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (3491,876,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (3492,877,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (3493,877,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (3494,877,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (3495,877,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3496,877,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (3497,877,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (3498,877,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (3499,877,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (3500,877,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (3501,877,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (3502,877,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (3503,877,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (3504,877,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (3505,877,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3506,878,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (3507,879,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (3508,880,59,1,0)
INSERT INTO SalesInvoicedetail VALUES (3509,880,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3510,880,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (3511,880,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3512,880,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (3513,880,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (3514,880,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (3515,880,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (3516,880,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (3517,880,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (3518,880,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (3519,880,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (3520,880,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (3521,880,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (3522,880,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (3523,880,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (3524,880,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (3525,880,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (3526,880,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (3527,880,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (3528,880,26,1,0)
INSERT INTO SalesInvoicedetail VALUES (3529,880,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (3530,880,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (3531,880,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (3532,880,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (3533,880,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (3534,880,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (3535,880,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (3536,880,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (3537,880,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (3538,880,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (3539,880,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (3540,880,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (3541,880,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (3542,880,57,6,0)
INSERT INTO SalesInvoicedetail VALUES (3543,881,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (3544,881,10,3,0)
INSERT INTO SalesInvoicedetail VALUES (3545,882,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (3546,882,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (3547,882,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (3548,882,42,6,0)
INSERT INTO SalesInvoicedetail VALUES (3549,882,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (3550,882,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (3551,882,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (3552,882,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (3553,882,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3554,882,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (3555,882,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (3556,882,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (3557,882,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (3558,882,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (3559,882,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (3560,882,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (3561,883,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (3562,883,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (3563,883,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (3564,883,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (3565,883,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3566,883,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (3567,883,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (3568,883,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (3569,883,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (3570,883,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (3571,884,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3572,884,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3573,884,10,4,0)
INSERT INTO SalesInvoicedetail VALUES (3574,884,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (3575,884,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (3576,884,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (3577,884,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (3578,885,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (3579,885,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (3580,886,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3581,886,10,5,0)
INSERT INTO SalesInvoicedetail VALUES (3582,886,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (3583,886,43,6,0)
INSERT INTO SalesInvoicedetail VALUES (3584,886,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (3585,886,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3586,886,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (3587,886,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (3588,886,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (3589,886,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (3590,886,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (3591,886,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3592,886,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (3593,886,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (3594,887,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (3595,887,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3596,887,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (3597,887,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (3598,887,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (3599,887,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (3600,887,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (3601,887,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3602,888,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (3603,889,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (3604,889,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (3605,889,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (3606,889,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (3607,889,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (3608,889,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (3609,889,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (3610,889,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (3611,889,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (3612,889,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (3613,889,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (3614,889,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (3615,889,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (3616,889,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (3617,889,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3618,889,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3619,889,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (3620,889,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (3621,889,26,2,0)
INSERT INTO SalesInvoicedetail VALUES (3622,889,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (3623,889,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (3624,889,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (3625,889,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (3626,889,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (3627,889,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (3628,889,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (3629,889,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (3630,889,54,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (3631,889,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (3632,890,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (3633,891,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3634,891,10,1,0)
INSERT INTO SalesInvoicedetail VALUES (3635,891,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (3636,891,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (3637,891,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (3638,891,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (3639,891,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (3640,891,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (3641,891,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (3642,891,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (3643,891,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (3644,891,9,4,0.02)
INSERT INTO SalesInvoicedetail VALUES (3645,892,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (3646,892,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (3647,892,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (3648,892,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (3649,892,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (3650,892,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (3651,892,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (3652,892,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (3653,892,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (3654,892,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (3655,892,69,2,0)
INSERT INTO SalesInvoicedetail VALUES (3656,892,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (3657,892,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (3658,892,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (3659,892,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (3660,892,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (3661,892,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (3662,892,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (3663,892,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (3664,892,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (3665,892,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (3666,893,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (3667,893,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (3668,893,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (3669,893,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (3670,893,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3671,893,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (3672,893,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3673,893,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (3674,893,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (3675,893,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (3676,893,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (3677,893,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (3678,893,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (3679,893,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (3680,893,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (3681,894,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (3682,894,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (3683,894,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (3684,894,48,6,0)
INSERT INTO SalesInvoicedetail VALUES (3685,894,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (3686,894,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (3687,894,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (3688,894,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (3689,894,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (3690,894,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (3691,894,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (3692,894,45,5,0)
INSERT INTO SalesInvoicedetail VALUES (3693,894,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (3694,894,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (3695,894,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (3696,894,39,6,0)
INSERT INTO SalesInvoicedetail VALUES (3697,894,43,1,0)
INSERT INTO SalesInvoicedetail VALUES (3698,894,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (3699,894,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3700,895,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (3701,896,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (3702,897,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (3703,897,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (3704,897,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3705,897,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (3706,897,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3707,897,69,6,0)
INSERT INTO SalesInvoicedetail VALUES (3708,897,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (3709,897,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (3710,897,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (3711,897,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (3712,897,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (3713,897,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3714,897,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (3715,897,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (3716,897,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (3717,897,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (3718,897,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (3719,897,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (3720,897,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (3721,897,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (3722,897,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (3723,897,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (3724,898,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3725,898,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (3726,898,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (3727,898,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (3728,898,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (3729,898,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (3730,898,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (3731,898,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (3732,898,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (3733,898,10,5,0)
INSERT INTO SalesInvoicedetail VALUES (3734,898,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (3735,898,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (3736,898,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (3737,898,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (3738,898,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3739,898,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3740,899,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (3741,899,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (3742,899,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (3743,899,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (3744,899,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (3745,899,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3746,899,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (3747,899,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (3748,899,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (3749,899,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (3750,899,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (3751,899,22,1,0)
INSERT INTO SalesInvoicedetail VALUES (3752,899,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (3753,899,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (3754,899,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (3755,899,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (3756,899,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (3757,899,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (3758,899,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (3759,899,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (3760,899,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (3761,900,65,4,0.13)
INSERT INTO SalesInvoicedetail VALUES (3762,901,8,3,0.28)
INSERT INTO SalesInvoicedetail VALUES (3763,901,7,5,0.13)
INSERT INTO SalesInvoicedetail VALUES (3764,901,62,3,0.1)
INSERT INTO SalesInvoicedetail VALUES (3765,901,26,6,0.06)
INSERT INTO SalesInvoicedetail VALUES (3766,901,56,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (3767,901,60,3,0.25)
INSERT INTO SalesInvoicedetail VALUES (3768,901,30,1,0.34)
INSERT INTO SalesInvoicedetail VALUES (3769,901,54,1,0.07)
INSERT INTO SalesInvoicedetail VALUES (3770,901,65,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (3771,901,14,6,0.21)
INSERT INTO SalesInvoicedetail VALUES (3772,901,16,2,0.31)
INSERT INTO SalesInvoicedetail VALUES (3773,901,49,4,0.24)
INSERT INTO SalesInvoicedetail VALUES (3774,901,22,4,0.12)
INSERT INTO SalesInvoicedetail VALUES (3775,901,15,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (3776,901,68,4,0.25)
INSERT INTO SalesInvoicedetail VALUES (3777,901,25,3,0.15)
INSERT INTO SalesInvoicedetail VALUES (3778,901,58,1,0.15)
INSERT INTO SalesInvoicedetail VALUES (3779,901,66,2,0.04)
INSERT INTO SalesInvoicedetail VALUES (3780,901,38,1,0.23)
INSERT INTO SalesInvoicedetail VALUES (3781,901,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3782,902,36,1,0)
INSERT INTO SalesInvoicedetail VALUES (3783,902,18,5,0)
INSERT INTO SalesInvoicedetail VALUES (3784,903,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (3785,903,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (3786,903,45,6,0)
INSERT INTO SalesInvoicedetail VALUES (3787,903,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (3788,903,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (3789,903,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (3790,903,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3791,903,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (3792,903,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (3793,903,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (3794,904,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (3795,904,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (3796,904,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (3797,904,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (3798,904,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3799,904,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (3800,904,67,1,0)
INSERT INTO SalesInvoicedetail VALUES (3801,904,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (3802,904,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (3803,904,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (3804,904,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (3805,904,30,5,0)
INSERT INTO SalesInvoicedetail VALUES (3806,904,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (3807,904,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (3808,904,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (3809,904,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (3810,904,33,4,0)
INSERT INTO SalesInvoicedetail VALUES (3811,904,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (3812,905,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3813,905,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (3814,905,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (3815,905,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (3816,905,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (3817,905,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (3818,905,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (3819,905,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (3820,905,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (3821,905,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (3822,905,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (3823,905,59,1,0)
INSERT INTO SalesInvoicedetail VALUES (3824,905,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (3825,905,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (3826,905,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (3827,905,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (3828,905,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (3829,905,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (3830,905,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (3831,905,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (3832,905,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (3833,905,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (3834,905,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (3835,905,69,5,0)
INSERT INTO SalesInvoicedetail VALUES (3836,905,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (3837,905,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (3838,905,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3839,905,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (3840,906,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (3841,906,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (3842,906,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (3843,906,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (3844,906,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (3845,906,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (3846,906,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (3847,906,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (3848,906,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3849,906,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (3850,906,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (3851,906,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (3852,906,26,6,0)
INSERT INTO SalesInvoicedetail VALUES (3853,906,22,6,0)
INSERT INTO SalesInvoicedetail VALUES (3854,906,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (3855,906,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (3856,906,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (3857,906,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (3858,906,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (3859,906,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (3860,906,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (3861,906,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (3862,906,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (3863,906,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (3864,907,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (3865,907,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (3866,907,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (3867,907,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (3868,908,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (3869,908,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (3870,908,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (3871,908,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (3872,908,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (3873,908,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (3874,908,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3875,908,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (3876,908,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (3877,908,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (3878,908,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (3879,908,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (3880,908,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (3881,908,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (3882,908,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (3883,909,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (3884,909,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (3885,909,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (3886,909,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3887,909,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (3888,909,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (3889,909,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (3890,909,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (3891,909,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (3892,909,10,5,0)
INSERT INTO SalesInvoicedetail VALUES (3893,909,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (3894,909,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (3895,910,42,4,0.29)
INSERT INTO SalesInvoicedetail VALUES (3896,910,39,2,0.35)
INSERT INTO SalesInvoicedetail VALUES (3897,910,44,3,0.34)
INSERT INTO SalesInvoicedetail VALUES (3898,911,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (3899,911,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (3900,911,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (3901,911,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (3902,911,42,2,0)
INSERT INTO SalesInvoicedetail VALUES (3903,911,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (3904,911,43,3,0)
INSERT INTO SalesInvoicedetail VALUES (3905,911,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (3906,911,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (3907,911,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3908,911,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (3909,911,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (3910,911,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (3911,911,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (3912,911,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (3913,912,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (3914,912,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (3915,912,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (3916,912,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (3917,912,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (3918,912,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (3919,912,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (3920,912,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (3921,912,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3922,912,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (3923,912,64,6,0)
INSERT INTO SalesInvoicedetail VALUES (3924,912,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (3925,912,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (3926,912,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (3927,912,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (3928,912,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (3929,912,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (3930,912,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (3931,912,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (3932,912,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (3933,912,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (3934,912,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (3935,912,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (3936,912,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (3937,912,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (3938,912,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (3939,912,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (3940,912,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (3941,912,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (3942,912,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (3943,912,57,1,0)
INSERT INTO SalesInvoicedetail VALUES (3944,912,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (3945,913,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (3946,914,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (3947,915,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (3948,916,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (3949,917,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (3950,918,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (3951,919,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3952,920,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (3953,921,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (3954,922,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3955,923,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (3956,924,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (3957,925,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (3958,926,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (3959,927,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (3960,928,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (3961,929,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (3962,930,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (3963,931,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (3964,932,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (3965,933,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (3966,934,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (3967,935,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (3968,936,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (3969,937,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (3970,938,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (3971,939,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (3972,940,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (3973,941,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (3974,942,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (3975,943,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (3976,944,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (3977,945,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (3978,946,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (3979,947,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (3980,948,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (3981,949,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (3982,950,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (3983,951,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (3984,952,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (3985,953,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (3986,954,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (3987,955,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (3988,956,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (3989,957,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (3990,958,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (3991,959,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (3992,960,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (3993,961,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (3994,962,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (3995,963,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (3996,964,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (3997,965,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (3998,966,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (3999,967,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (4000,968,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (4001,969,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (4002,970,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (4003,971,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4004,972,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (4005,973,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4006,974,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (4007,975,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (4008,976,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4009,977,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (4010,978,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (4011,979,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4012,980,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (4013,981,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (4014,982,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (4015,983,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4016,984,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (4017,985,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4018,986,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4019,987,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4020,988,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (4021,989,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (4022,990,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4023,991,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (4024,992,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (4025,993,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (4026,994,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (4027,995,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (4028,996,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (4029,997,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (4030,998,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4031,999,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (4032,1000,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4033,1001,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4034,1002,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (4035,1003,67,1,0)
INSERT INTO SalesInvoicedetail VALUES (4036,1004,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (4037,1005,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4038,1006,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4039,1007,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (4040,1008,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4041,1009,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4042,1010,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (4043,1011,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (4044,1012,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (4045,1013,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4046,1014,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4047,1015,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (4048,1016,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (4049,1017,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (4050,1018,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (4051,1019,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4052,1020,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4053,1021,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (4054,1022,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (4055,1023,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (4056,1024,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (4057,1025,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (4058,1026,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (4059,1027,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (4060,1028,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4061,1029,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (4062,1030,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (4063,1031,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (4064,1032,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4065,1033,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (4066,1034,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4067,1035,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4068,1036,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4069,1037,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (4070,1038,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (4071,1039,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (4072,1040,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (4073,1041,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4074,1042,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4075,1043,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (4076,1044,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (4077,1045,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (4078,1046,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (4079,1047,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4080,1048,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4081,1049,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4082,1050,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (4083,1051,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4084,1052,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (4085,1053,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (4086,1054,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (4087,1055,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (4088,1056,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (4089,1057,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4090,1058,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (4091,1059,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (4092,1060,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (4093,1061,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (4094,1062,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (4095,1063,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (4096,1064,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (4097,1065,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (4098,1066,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (4099,1067,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (4100,1068,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (4101,1069,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (4102,1070,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4103,1071,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4104,1072,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4105,1073,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (4106,1074,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (4107,1075,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (4108,1076,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4109,1077,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4110,1078,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (4111,1079,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4112,1080,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (4113,1081,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (4114,1082,15,5,0.26)
INSERT INTO SalesInvoicedetail VALUES (4115,1082,61,5,0.17)
INSERT INTO SalesInvoicedetail VALUES (4116,1082,58,3,0.3)
INSERT INTO SalesInvoicedetail VALUES (4117,1082,63,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (4118,1082,70,3,0.32)
INSERT INTO SalesInvoicedetail VALUES (4119,1082,54,2,0.1)
INSERT INTO SalesInvoicedetail VALUES (4120,1082,25,1,0.21)
INSERT INTO SalesInvoicedetail VALUES (4121,1082,62,3,0.39)
INSERT INTO SalesInvoicedetail VALUES (4122,1082,60,2,0.04)
INSERT INTO SalesInvoicedetail VALUES (4123,1083,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (4124,1083,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (4125,1084,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (4126,1084,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (4127,1084,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (4128,1084,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (4129,1084,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (4130,1084,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (4131,1084,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (4132,1084,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (4133,1084,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (4134,1084,12,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (4135,1084,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (4136,1084,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (4137,1084,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (4138,1084,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (4139,1084,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (4140,1084,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (4141,1084,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (4142,1084,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (4143,1084,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4144,1084,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (4145,1084,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (4146,1084,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (4147,1084,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (4148,1084,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (4149,1084,33,5,0)
INSERT INTO SalesInvoicedetail VALUES (4150,1084,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4151,1084,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (4152,1085,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (4153,1085,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (4154,1085,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (4155,1085,42,6,0)
INSERT INTO SalesInvoicedetail VALUES (4156,1085,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (4157,1085,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (4158,1085,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (4159,1085,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (4160,1086,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4161,1086,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (4162,1086,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (4163,1086,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (4164,1086,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (4165,1086,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (4166,1086,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (4167,1086,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (4168,1086,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (4169,1086,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (4170,1086,69,5,0)
INSERT INTO SalesInvoicedetail VALUES (4171,1086,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (4172,1086,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (4173,1086,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (4174,1086,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (4175,1086,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (4176,1086,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (4177,1086,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (4178,1086,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (4179,1086,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (4180,1086,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (4181,1086,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (4182,1086,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4183,1086,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (4184,1086,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (4185,1087,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (4186,1087,45,6,0)
INSERT INTO SalesInvoicedetail VALUES (4187,1087,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (4188,1087,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (4189,1087,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (4190,1087,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (4191,1087,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4192,1087,48,1,0)
INSERT INTO SalesInvoicedetail VALUES (4193,1087,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (4194,1087,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (4195,1087,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (4196,1087,42,1,0)
INSERT INTO SalesInvoicedetail VALUES (4197,1087,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4198,1087,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (4199,1087,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (4200,1088,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (4201,1088,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (4202,1088,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (4203,1088,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (4204,1088,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (4205,1088,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (4206,1088,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (4207,1089,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (4208,1089,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4209,1089,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (4210,1089,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4211,1089,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (4212,1089,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (4213,1089,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (4214,1089,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4215,1089,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (4216,1090,57,3,0)
INSERT INTO SalesInvoicedetail VALUES (4217,1091,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (4218,1091,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (4219,1091,69,1,0)
INSERT INTO SalesInvoicedetail VALUES (4220,1091,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (4221,1091,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (4222,1091,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (4223,1091,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (4224,1091,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (4225,1091,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (4226,1091,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (4227,1091,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (4228,1091,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (4229,1091,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (4230,1091,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (4231,1091,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (4232,1091,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (4233,1091,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (4234,1091,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (4235,1091,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (4236,1091,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4237,1091,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (4238,1091,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (4239,1091,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (4240,1091,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (4241,1091,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (4242,1091,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (4243,1091,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (4244,1091,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (4245,1091,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (4246,1091,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (4247,1091,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (4248,1091,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4249,1091,64,6,0)
INSERT INTO SalesInvoicedetail VALUES (4250,1092,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (4251,1092,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (4252,1092,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (4253,1092,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (4254,1092,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (4255,1092,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (4256,1092,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (4257,1092,39,2,0)
INSERT INTO SalesInvoicedetail VALUES (4258,1092,45,5,0)
INSERT INTO SalesInvoicedetail VALUES (4259,1092,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (4260,1092,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (4261,1092,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (4262,1092,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4263,1092,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (4264,1092,44,2,0)
INSERT INTO SalesInvoicedetail VALUES (4265,1092,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (4266,1092,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (4267,1092,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (4268,1092,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (4269,1092,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (4270,1092,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (4271,1092,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4272,1092,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (4273,1092,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (4274,1093,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (4275,1093,26,6,0)
INSERT INTO SalesInvoicedetail VALUES (4276,1093,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (4277,1094,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (4278,1094,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (4279,1094,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (4280,1094,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (4281,1094,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4282,1094,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (4283,1094,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4284,1094,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (4285,1094,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (4286,1095,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (4287,1095,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (4288,1095,17,3,0)
INSERT INTO SalesInvoicedetail VALUES (4289,1096,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (4290,1096,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (4291,1096,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (4292,1096,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (4293,1096,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4294,1096,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (4295,1096,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (4296,1096,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (4297,1096,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (4298,1096,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (4299,1096,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (4300,1096,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (4301,1096,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (4302,1096,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (4303,1097,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4304,1097,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4305,1097,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (4306,1097,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4307,1097,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (4308,1097,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (4309,1097,59,1,0)
INSERT INTO SalesInvoicedetail VALUES (4310,1097,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (4311,1097,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (4312,1097,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (4313,1097,69,1,0)
INSERT INTO SalesInvoicedetail VALUES (4314,1097,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (4315,1097,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4316,1097,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (4317,1097,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (4318,1097,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (4319,1097,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4320,1097,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (4321,1097,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (4322,1097,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (4323,1097,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (4324,1097,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (4325,1097,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (4326,1097,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4327,1097,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (4328,1098,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (4329,1098,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4330,1098,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (4331,1098,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (4332,1098,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (4333,1098,33,5,0)
INSERT INTO SalesInvoicedetail VALUES (4334,1098,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (4335,1098,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (4336,1098,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (4337,1098,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (4338,1098,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (4339,1098,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4340,1098,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (4341,1098,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (4342,1098,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (4343,1098,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4344,1098,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (4345,1099,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (4346,1099,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (4347,1099,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (4348,1099,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (4349,1099,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (4350,1099,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (4351,1099,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (4352,1099,45,6,0)
INSERT INTO SalesInvoicedetail VALUES (4353,1099,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (4354,1100,59,4,0)
INSERT INTO SalesInvoicedetail VALUES (4355,1100,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (4356,1100,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (4357,1100,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (4358,1100,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (4359,1100,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (4360,1100,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (4361,1100,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (4362,1100,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (4363,1100,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (4364,1100,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (4365,1100,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (4366,1100,57,6,0)
INSERT INTO SalesInvoicedetail VALUES (4367,1100,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (4368,1100,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (4369,1100,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (4370,1100,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (4371,1100,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4372,1100,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (4373,1100,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (4374,1100,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (4375,1100,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (4376,1100,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (4377,1100,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (4378,1100,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (4379,1100,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (4380,1100,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (4381,1101,77,1,0.06)
INSERT INTO SalesInvoicedetail VALUES (4382,1101,15,6,0.18)
INSERT INTO SalesInvoicedetail VALUES (4383,1101,75,4,0.15)
INSERT INTO SalesInvoicedetail VALUES (4384,1101,74,2,0.32)
INSERT INTO SalesInvoicedetail VALUES (4385,1101,9,2,0.11)
INSERT INTO SalesInvoicedetail VALUES (4386,1102,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (4387,1102,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (4388,1102,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (4389,1102,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (4390,1103,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (4391,1103,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (4392,1103,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (4393,1103,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (4394,1103,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (4395,1103,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (4396,1103,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (4397,1103,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (4398,1103,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (4399,1103,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (4400,1103,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (4401,1103,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (4402,1104,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (4403,1104,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (4404,1104,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (4405,1104,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (4406,1104,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (4407,1104,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (4408,1104,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (4409,1104,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (4410,1104,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (4411,1104,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (4412,1104,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (4413,1104,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (4414,1104,42,1,0)
INSERT INTO SalesInvoicedetail VALUES (4415,1104,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (4416,1104,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (4417,1104,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4418,1104,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (4419,1104,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (4420,1104,47,5,0)
INSERT INTO SalesInvoicedetail VALUES (4421,1104,11,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (4422,1104,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (4423,1105,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (4424,1105,17,2,0)
INSERT INTO SalesInvoicedetail VALUES (4425,1105,36,3,0)
INSERT INTO SalesInvoicedetail VALUES (4426,1105,18,4,0)
INSERT INTO SalesInvoicedetail VALUES (4427,1105,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (4428,1105,27,1,0)
INSERT INTO SalesInvoicedetail VALUES (4429,1105,23,4,0)
INSERT INTO SalesInvoicedetail VALUES (4430,1106,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (4431,1106,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (4432,1106,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4433,1107,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (4434,1107,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (4435,1107,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (4436,1107,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (4437,1107,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4438,1107,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (4439,1107,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (4440,1107,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (4441,1107,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (4442,1107,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4443,1107,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4444,1108,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (4445,1108,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (4446,1108,10,4,0)
INSERT INTO SalesInvoicedetail VALUES (4447,1108,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (4448,1109,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (4449,1109,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (4450,1109,10,6,0)
INSERT INTO SalesInvoicedetail VALUES (4451,1109,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (4452,1109,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (4453,1109,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (4454,1109,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (4455,1109,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (4456,1109,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4457,1109,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (4458,1109,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (4459,1110,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (4460,1110,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (4461,1110,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (4462,1110,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (4463,1110,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (4464,1110,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4465,1110,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (4466,1110,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (4467,1110,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (4468,1110,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (4469,1110,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (4470,1110,36,5,0)
INSERT INTO SalesInvoicedetail VALUES (4471,1110,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (4472,1110,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (4473,1110,27,1,0)
INSERT INTO SalesInvoicedetail VALUES (4474,1110,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (4475,1110,30,6,0)
INSERT INTO SalesInvoicedetail VALUES (4476,1110,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (4477,1110,33,5,0)
INSERT INTO SalesInvoicedetail VALUES (4478,1110,17,3,0)
INSERT INTO SalesInvoicedetail VALUES (4479,1110,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (4480,1110,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4481,1110,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (4482,1110,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (4483,1110,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (4484,1110,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (4485,1111,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (4486,1112,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (4487,1112,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (4488,1112,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4489,1112,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (4490,1112,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4491,1112,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (4492,1112,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (4493,1112,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (4494,1113,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4495,1113,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (4496,1113,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4497,1113,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (4498,1113,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (4499,1113,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4500,1113,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (4501,1113,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (4502,1113,69,1,0)
INSERT INTO SalesInvoicedetail VALUES (4503,1113,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (4504,1113,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (4505,1113,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (4506,1113,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (4507,1113,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (4508,1113,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (4509,1113,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4510,1113,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (4511,1113,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (4512,1113,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (4513,1113,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (4514,1113,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (4515,1113,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (4516,1113,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (4517,1113,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (4518,1113,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (4519,1113,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4520,1113,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (4521,1113,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (4522,1113,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (4523,1113,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (4524,1113,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (4525,1113,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (4526,1114,30,1,0)
INSERT INTO SalesInvoicedetail VALUES (4527,1114,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (4528,1114,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (4529,1114,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4530,1114,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4531,1114,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4532,1114,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (4533,1114,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (4534,1114,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (4535,1114,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (4536,1114,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (4537,1114,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (4538,1114,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (4539,1114,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4540,1114,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (4541,1114,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4542,1114,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (4543,1114,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (4544,1114,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (4545,1114,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (4546,1114,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (4547,1114,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (4548,1114,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (4549,1114,69,1,0)
INSERT INTO SalesInvoicedetail VALUES (4550,1114,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (4551,1114,57,3,0)
INSERT INTO SalesInvoicedetail VALUES (4552,1114,22,4,0)
INSERT INTO SalesInvoicedetail VALUES (4553,1114,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (4554,1114,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (4555,1114,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4556,1114,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (4557,1114,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (4558,1114,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4559,1114,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (4560,1114,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (4561,1115,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (4562,1115,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (4563,1115,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (4564,1115,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (4565,1115,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (4566,1115,68,1,0)
INSERT INTO SalesInvoicedetail VALUES (4567,1115,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (4568,1115,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (4569,1115,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (4570,1115,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (4571,1115,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4572,1115,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (4573,1115,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (4574,1115,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (4575,1115,33,5,0)
INSERT INTO SalesInvoicedetail VALUES (4576,1115,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (4577,1115,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (4578,1115,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (4579,1115,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4580,1115,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (4581,1115,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (4582,1115,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (4583,1115,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (4584,1116,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (4585,1116,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (4586,1116,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (4587,1116,7,1,0)
INSERT INTO SalesInvoicedetail VALUES (4588,1116,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (4589,1116,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (4590,1116,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (4591,1116,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (4592,1116,9,3,0.05)
INSERT INTO SalesInvoicedetail VALUES (4593,1117,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (4594,1117,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4595,1117,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4596,1117,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4597,1118,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (4598,1118,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (4599,1118,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (4600,1118,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (4601,1118,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (4602,1118,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (4603,1118,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (4604,1118,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (4605,1118,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (4606,1118,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (4607,1118,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4608,1118,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (4609,1118,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (4610,1118,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (4611,1118,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (4612,1118,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (4613,1119,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (4614,1119,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (4615,1119,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (4616,1119,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (4617,1119,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (4618,1119,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (4619,1119,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (4620,1119,47,6,0)
INSERT INTO SalesInvoicedetail VALUES (4621,1119,48,1,0)
INSERT INTO SalesInvoicedetail VALUES (4622,1119,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (4623,1119,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (4624,1119,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (4625,1119,43,1,0)
INSERT INTO SalesInvoicedetail VALUES (4626,1119,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (4627,1119,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (4628,1119,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (4629,1119,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (4630,1119,41,6,0)
INSERT INTO SalesInvoicedetail VALUES (4631,1119,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (4632,1119,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (4633,1120,29,4,0.08)
INSERT INTO SalesInvoicedetail VALUES (4634,1120,68,4,0.11)
INSERT INTO SalesInvoicedetail VALUES (4635,1120,49,3,0.15)
INSERT INTO SalesInvoicedetail VALUES (4636,1120,61,5,0.01)
INSERT INTO SalesInvoicedetail VALUES (4637,1120,55,6,0.1)
INSERT INTO SalesInvoicedetail VALUES (4638,1120,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (4639,1120,65,2,0.26)
INSERT INTO SalesInvoicedetail VALUES (4640,1120,64,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (4641,1120,25,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (4642,1120,56,6,0.11)
INSERT INTO SalesInvoicedetail VALUES (4643,1120,60,4,0.31)
INSERT INTO SalesInvoicedetail VALUES (4644,1120,53,1,0.31)
INSERT INTO SalesInvoicedetail VALUES (4645,1120,62,3,0.21)
INSERT INTO SalesInvoicedetail VALUES (4646,1120,54,5,0.01)
INSERT INTO SalesInvoicedetail VALUES (4647,1120,30,5,0.29)
INSERT INTO SalesInvoicedetail VALUES (4648,1120,33,1,0.14)
INSERT INTO SalesInvoicedetail VALUES (4649,1120,66,3,0.25)
INSERT INTO SalesInvoicedetail VALUES (4650,1120,58,3,0.19)
INSERT INTO SalesInvoicedetail VALUES (4651,1120,26,6,0.33)
INSERT INTO SalesInvoicedetail VALUES (4652,1120,38,4,0.16)
INSERT INTO SalesInvoicedetail VALUES (4653,1120,63,2,0.24)
INSERT INTO SalesInvoicedetail VALUES (4654,1121,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (4655,1121,10,2,0)
INSERT INTO SalesInvoicedetail VALUES (4656,1121,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (4657,1121,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (4658,1121,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4659,1121,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (4660,1121,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (4661,1121,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (4662,1121,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (4663,1122,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (4664,1122,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (4665,1122,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (4666,1122,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4667,1122,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (4668,1122,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (4669,1122,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (4670,1122,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (4671,1122,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (4672,1122,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4673,1122,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (4674,1122,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (4675,1122,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (4676,1122,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (4677,1122,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (4678,1122,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (4679,1122,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (4680,1122,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (4681,1122,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (4682,1123,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (4683,1123,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4684,1124,66,2,0.35)
INSERT INTO SalesInvoicedetail VALUES (4685,1124,68,6,0.05)
INSERT INTO SalesInvoicedetail VALUES (4686,1124,64,2,0.27)
INSERT INTO SalesInvoicedetail VALUES (4687,1124,52,4,0.22)
INSERT INTO SalesInvoicedetail VALUES (4688,1124,70,6,0.28)
INSERT INTO SalesInvoicedetail VALUES (4689,1124,53,4,0.34)
INSERT INTO SalesInvoicedetail VALUES (4690,1124,26,2,0.02)
INSERT INTO SalesInvoicedetail VALUES (4691,1124,60,5,0.22)
INSERT INTO SalesInvoicedetail VALUES (4692,1124,54,3,0.09)
INSERT INTO SalesInvoicedetail VALUES (4693,1124,69,5,0.28)
INSERT INTO SalesInvoicedetail VALUES (4694,1124,50,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (4695,1124,30,4,0.07)
INSERT INTO SalesInvoicedetail VALUES (4696,1124,29,1,0.16)
INSERT INTO SalesInvoicedetail VALUES (4697,1124,62,1,0.19)
INSERT INTO SalesInvoicedetail VALUES (4698,1124,61,2,0.26)
INSERT INTO SalesInvoicedetail VALUES (4699,1124,56,3,0.08)
INSERT INTO SalesInvoicedetail VALUES (4700,1124,58,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (4701,1124,22,5,0.38)
INSERT INTO SalesInvoicedetail VALUES (4702,1124,38,2,0.38)
INSERT INTO SalesInvoicedetail VALUES (4703,1124,59,5,0.34)
INSERT INTO SalesInvoicedetail VALUES (4704,1124,57,3,0.01)
INSERT INTO SalesInvoicedetail VALUES (4705,1125,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (4706,1125,48,3,0)
INSERT INTO SalesInvoicedetail VALUES (4707,1125,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (4708,1125,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (4709,1125,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (4710,1125,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (4711,1125,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (4712,1125,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4713,1125,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (4714,1125,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (4715,1125,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (4716,1125,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (4717,1125,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (4718,1125,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (4719,1125,10,1,0)
INSERT INTO SalesInvoicedetail VALUES (4720,1125,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (4721,1126,62,2,0.01)
INSERT INTO SalesInvoicedetail VALUES (4722,1126,70,2,0.29)
INSERT INTO SalesInvoicedetail VALUES (4723,1126,12,5,0.27)
INSERT INTO SalesInvoicedetail VALUES (4724,1126,54,2,0.04)
INSERT INTO SalesInvoicedetail VALUES (4725,1127,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4726,1128,44,3,0)
INSERT INTO SalesInvoicedetail VALUES (4727,1128,39,4,0)
INSERT INTO SalesInvoicedetail VALUES (4728,1129,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (4729,1129,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (4730,1129,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (4731,1129,43,6,0)
INSERT INTO SalesInvoicedetail VALUES (4732,1129,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (4733,1129,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (4734,1129,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4735,1129,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (4736,1129,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (4737,1129,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (4738,1129,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (4739,1129,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (4740,1129,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (4741,1129,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (4742,1129,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (4743,1129,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (4744,1129,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (4745,1130,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (4746,1130,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (4747,1130,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (4748,1130,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (4749,1130,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (4750,1130,42,4,0)
INSERT INTO SalesInvoicedetail VALUES (4751,1130,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (4752,1130,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (4753,1130,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (4754,1130,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (4755,1130,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (4756,1130,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (4757,1130,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (4758,1130,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (4759,1131,32,2,0.12)
INSERT INTO SalesInvoicedetail VALUES (4760,1131,60,5,0.38)
INSERT INTO SalesInvoicedetail VALUES (4761,1132,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (4762,1133,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (4763,1133,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (4764,1133,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (4765,1133,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (4766,1133,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (4767,1133,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4768,1133,22,6,0)
INSERT INTO SalesInvoicedetail VALUES (4769,1133,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (4770,1133,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (4771,1133,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (4772,1133,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4773,1133,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (4774,1133,26,6,0)
INSERT INTO SalesInvoicedetail VALUES (4775,1133,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (4776,1133,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (4777,1133,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (4778,1133,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (4779,1133,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (4780,1133,38,4,0)
INSERT INTO SalesInvoicedetail VALUES (4781,1134,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (4782,1134,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (4783,1134,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (4784,1134,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (4785,1134,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (4786,1134,9,4,0.02)
INSERT INTO SalesInvoicedetail VALUES (4787,1134,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (4788,1134,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (4789,1134,10,6,0)
INSERT INTO SalesInvoicedetail VALUES (4790,1134,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (4791,1134,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (4792,1135,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (4793,1135,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (4794,1135,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (4795,1136,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (4796,1137,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (4797,1137,48,1,0)
INSERT INTO SalesInvoicedetail VALUES (4798,1137,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (4799,1137,9,4,0.18)
INSERT INTO SalesInvoicedetail VALUES (4800,1137,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (4801,1137,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (4802,1137,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (4803,1137,39,6,0)
INSERT INTO SalesInvoicedetail VALUES (4804,1137,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (4805,1137,47,6,0)
INSERT INTO SalesInvoicedetail VALUES (4806,1137,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (4807,1137,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (4808,1137,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (4809,1137,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (4810,1137,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (4811,1137,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (4812,1137,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (4813,1137,73,4,0.04)
INSERT INTO SalesInvoicedetail VALUES (4814,1137,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (4815,1137,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (4816,1138,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (4817,1138,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (4818,1138,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (4819,1138,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (4820,1138,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (4821,1138,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (4822,1138,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (4823,1138,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (4824,1139,65,5,0.26)
INSERT INTO SalesInvoicedetail VALUES (4825,1139,49,5,0.17)
INSERT INTO SalesInvoicedetail VALUES (4826,1139,61,1,0.34)
INSERT INTO SalesInvoicedetail VALUES (4827,1139,11,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (4828,1139,17,5,0.29)
INSERT INTO SalesInvoicedetail VALUES (4829,1139,56,2,0.27)
INSERT INTO SalesInvoicedetail VALUES (4830,1139,68,3,0.36)
INSERT INTO SalesInvoicedetail VALUES (4831,1139,58,2,0.1)
INSERT INTO SalesInvoicedetail VALUES (4832,1139,25,4,0.28)
INSERT INTO SalesInvoicedetail VALUES (4833,1139,18,6,0.03)
INSERT INTO SalesInvoicedetail VALUES (4834,1139,8,3,0.24)
INSERT INTO SalesInvoicedetail VALUES (4835,1139,54,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (4836,1139,26,3,0.05)
INSERT INTO SalesInvoicedetail VALUES (4837,1139,16,1,0.05)
INSERT INTO SalesInvoicedetail VALUES (4838,1139,14,2,0.19)
INSERT INTO SalesInvoicedetail VALUES (4839,1139,12,5,0.37)
INSERT INTO SalesInvoicedetail VALUES (4840,1139,70,4,0.4)
INSERT INTO SalesInvoicedetail VALUES (4841,1139,15,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (4842,1139,62,4,0.23)
INSERT INTO SalesInvoicedetail VALUES (4843,1139,53,6,0.17)
INSERT INTO SalesInvoicedetail VALUES (4844,1139,22,4,0.06)
INSERT INTO SalesInvoicedetail VALUES (4845,1139,64,5,0.18)
INSERT INTO SalesInvoicedetail VALUES (4846,1139,33,6,0.06)
INSERT INTO SalesInvoicedetail VALUES (4847,1139,63,5,0.38)
INSERT INTO SalesInvoicedetail VALUES (4848,1139,29,4,0.33)
INSERT INTO SalesInvoicedetail VALUES (4849,1139,36,1,0.23)
INSERT INTO SalesInvoicedetail VALUES (4850,1139,66,3,0.09)
INSERT INTO SalesInvoicedetail VALUES (4851,1139,60,3,0.36)
INSERT INTO SalesInvoicedetail VALUES (4852,1139,32,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (4853,1139,38,4,0.27)
INSERT INTO SalesInvoicedetail VALUES (4854,1139,30,1,0.32)
INSERT INTO SalesInvoicedetail VALUES (4855,1139,7,5,0.21)
INSERT INTO SalesInvoicedetail VALUES (4856,1140,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (4857,1140,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (4858,1140,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (4859,1140,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (4860,1140,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (4861,1140,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (4862,1140,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (4863,1140,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (4864,1140,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (4865,1140,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (4866,1140,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (4867,1140,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (4868,1140,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (4869,1141,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (4870,1141,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (4871,1141,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (4872,1141,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (4873,1141,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (4874,1141,41,1,0)
INSERT INTO SalesInvoicedetail VALUES (4875,1141,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (4876,1141,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (4877,1141,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (4878,1141,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (4879,1142,75,3,0.23)
INSERT INTO SalesInvoicedetail VALUES (4880,1142,72,1,0.25)
INSERT INTO SalesInvoicedetail VALUES (4881,1142,14,5,0.24)
INSERT INTO SalesInvoicedetail VALUES (4882,1142,74,5,0.04)
INSERT INTO SalesInvoicedetail VALUES (4883,1142,41,4,0.12)
INSERT INTO SalesInvoicedetail VALUES (4884,1142,78,3,0.12)
INSERT INTO SalesInvoicedetail VALUES (4885,1143,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (4886,1143,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (4887,1143,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (4888,1143,30,4,0)
INSERT INTO SalesInvoicedetail VALUES (4889,1143,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4890,1143,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (4891,1143,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4892,1143,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (4893,1143,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (4894,1143,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (4895,1143,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4896,1143,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (4897,1143,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (4898,1143,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (4899,1143,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (4900,1143,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (4901,1143,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (4902,1143,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (4903,1143,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (4904,1143,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (4905,1143,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (4906,1143,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (4907,1143,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (4908,1143,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (4909,1143,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (4910,1143,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (4911,1144,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (4912,1144,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (4913,1144,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (4914,1144,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (4915,1144,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (4916,1144,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (4917,1145,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4918,1146,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (4919,1147,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (4920,1148,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4921,1149,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (4922,1150,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (4923,1151,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (4924,1152,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (4925,1153,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4926,1154,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (4927,1155,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (4928,1156,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (4929,1157,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (4930,1158,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (4931,1159,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (4932,1160,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (4933,1161,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (4934,1162,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (4935,1163,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (4936,1164,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (4937,1165,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (4938,1166,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (4939,1167,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4940,1168,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (4941,1169,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (4942,1170,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (4943,1171,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (4944,1172,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (4945,1173,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (4946,1174,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4947,1175,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (4948,1176,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (4949,1177,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4950,1178,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (4951,1179,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4952,1180,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4953,1181,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (4954,1182,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (4955,1183,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (4956,1184,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4957,1185,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (4958,1186,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (4959,1187,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (4960,1188,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (4961,1189,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (4962,1190,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (4963,1191,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (4964,1192,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (4965,1193,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (4966,1194,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (4967,1195,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (4968,1196,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4969,1197,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (4970,1198,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (4971,1199,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (4972,1200,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (4973,1201,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (4974,1202,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (4975,1203,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (4976,1204,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (4977,1205,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (4978,1206,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (4979,1207,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (4980,1208,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (4981,1209,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (4982,1210,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (4983,1211,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (4984,1212,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (4985,1213,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (4986,1214,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (4987,1215,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (4988,1216,59,4,0)
INSERT INTO SalesInvoicedetail VALUES (4989,1217,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (4990,1218,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (4991,1219,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4992,1220,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (4993,1221,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (4994,1222,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (4995,1223,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (4996,1224,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (4997,1225,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (4998,1226,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (4999,1227,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5000,1228,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5001,1229,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5002,1230,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5003,1231,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (5004,1232,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (5005,1233,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (5006,1234,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5007,1235,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5008,1236,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (5009,1237,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (5010,1238,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (5011,1239,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5012,1240,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5013,1241,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (5014,1242,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5015,1243,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5016,1244,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5017,1245,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5018,1246,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (5019,1247,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5020,1248,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (5021,1249,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (5022,1250,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5023,1251,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5024,1252,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (5025,1253,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5026,1254,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5027,1255,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5028,1256,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5029,1257,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5030,1258,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5031,1259,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5032,1260,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (5033,1261,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5034,1262,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5035,1263,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5036,1264,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (5037,1265,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5038,1266,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5039,1267,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5040,1268,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (5041,1269,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5042,1270,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5043,1271,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5044,1272,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5045,1273,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5046,1274,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5047,1275,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (5048,1276,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5049,1277,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5050,1278,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5051,1279,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5052,1280,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5053,1281,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5054,1282,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5055,1283,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5056,1284,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5057,1285,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (5058,1286,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (5059,1287,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (5060,1288,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (5061,1289,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (5062,1290,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5063,1291,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (5064,1292,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5065,1293,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (5066,1294,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (5067,1295,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5068,1296,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5069,1297,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (5070,1298,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (5071,1299,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5072,1300,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (5073,1301,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5074,1302,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (5075,1303,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (5076,1304,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5077,1305,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (5078,1306,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (5079,1307,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5080,1308,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5081,1309,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5082,1310,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (5083,1311,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5084,1312,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5085,1313,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5086,1314,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (5087,1315,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5088,1316,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5089,1317,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5090,1318,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5091,1319,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5092,1320,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (5093,1321,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5094,1322,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5095,1323,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5096,1324,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5097,1325,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (5098,1326,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5099,1327,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5100,1328,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (5101,1329,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5102,1330,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (5103,1331,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5104,1332,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (5105,1333,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5106,1334,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5107,1335,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (5108,1336,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5109,1337,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5110,1338,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5111,1339,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5112,1340,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (5113,1341,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (5114,1342,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5115,1343,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5116,1344,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5117,1345,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5118,1346,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (5119,1347,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5120,1348,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5121,1349,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5122,1350,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5123,1351,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5124,1352,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5125,1353,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5126,1354,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (5127,1355,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5128,1356,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (5129,1357,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (5130,1358,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5131,1359,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5132,1360,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5133,1361,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5134,1362,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5135,1363,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5136,1364,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (5137,1365,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5138,1366,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (5139,1367,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5140,1368,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (5141,1369,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5142,1370,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5143,1371,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5144,1372,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (5145,1373,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5146,1374,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5147,1375,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5148,1376,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5149,1377,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5150,1378,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (5151,1379,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (5152,1380,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (5153,1380,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (5154,1380,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (5155,1380,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (5156,1380,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (5157,1380,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5158,1380,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (5159,1380,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (5160,1380,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (5161,1380,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (5162,1380,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (5163,1380,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (5164,1380,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (5165,1380,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (5166,1380,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (5167,1381,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (5168,1381,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (5169,1381,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (5170,1381,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (5171,1381,22,1,0)
INSERT INTO SalesInvoicedetail VALUES (5172,1381,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5173,1381,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (5174,1381,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (5175,1381,26,2,0)
INSERT INTO SalesInvoicedetail VALUES (5176,1381,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (5177,1381,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5178,1381,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (5179,1381,30,1,0)
INSERT INTO SalesInvoicedetail VALUES (5180,1381,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (5181,1381,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (5182,1381,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (5183,1381,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (5184,1381,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (5185,1381,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (5186,1382,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (5187,1383,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5188,1384,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (5189,1384,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (5190,1384,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (5191,1384,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (5192,1384,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (5193,1384,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (5194,1384,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5195,1385,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (5196,1385,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (5197,1385,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (5198,1385,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (5199,1385,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (5200,1385,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (5201,1385,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (5202,1385,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (5203,1386,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (5204,1386,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (5205,1386,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (5206,1386,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5207,1386,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (5208,1386,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (5209,1387,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (5210,1387,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (5211,1387,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (5212,1387,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (5213,1387,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (5214,1387,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5215,1388,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (5216,1388,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (5217,1389,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (5218,1389,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5219,1389,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (5220,1389,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (5221,1389,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (5222,1389,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (5223,1389,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (5224,1389,70,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (5225,1389,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (5226,1389,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (5227,1389,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (5228,1389,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (5229,1389,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (5230,1389,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (5231,1389,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (5232,1389,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (5233,1389,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (5234,1389,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (5235,1389,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (5236,1389,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (5237,1389,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5238,1389,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (5239,1389,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (5240,1389,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (5241,1389,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (5242,1389,26,1,0)
INSERT INTO SalesInvoicedetail VALUES (5243,1390,72,2,0.03)
INSERT INTO SalesInvoicedetail VALUES (5244,1390,76,4,0.32)
INSERT INTO SalesInvoicedetail VALUES (5245,1390,74,4,0.04)
INSERT INTO SalesInvoicedetail VALUES (5246,1390,9,2,0.36)
INSERT INTO SalesInvoicedetail VALUES (5247,1391,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (5248,1391,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (5249,1391,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (5250,1391,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (5251,1391,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (5252,1392,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (5253,1392,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (5254,1392,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (5255,1393,70,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (5256,1393,58,6,0.29)
INSERT INTO SalesInvoicedetail VALUES (5257,1393,60,4,0.14)
INSERT INTO SalesInvoicedetail VALUES (5258,1394,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5259,1394,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (5260,1394,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (5261,1394,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (5262,1394,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (5263,1395,66,6,0.09)
INSERT INTO SalesInvoicedetail VALUES (5264,1395,63,5,0.38)
INSERT INTO SalesInvoicedetail VALUES (5265,1395,15,5,0.22)
INSERT INTO SalesInvoicedetail VALUES (5266,1395,12,1,0.22)
INSERT INTO SalesInvoicedetail VALUES (5267,1395,56,2,0.35)
INSERT INTO SalesInvoicedetail VALUES (5268,1395,59,5,0.11)
INSERT INTO SalesInvoicedetail VALUES (5269,1395,64,2,0.08)
INSERT INTO SalesInvoicedetail VALUES (5270,1395,57,1,0.31)
INSERT INTO SalesInvoicedetail VALUES (5271,1395,70,2,0.08)
INSERT INTO SalesInvoicedetail VALUES (5272,1395,50,4,0.38)
INSERT INTO SalesInvoicedetail VALUES (5273,1395,54,2,0.32)
INSERT INTO SalesInvoicedetail VALUES (5274,1395,62,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (5275,1395,58,4,0.26)
INSERT INTO SalesInvoicedetail VALUES (5276,1395,60,4,0.02)
INSERT INTO SalesInvoicedetail VALUES (5277,1395,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5278,1395,69,3,0.17)
INSERT INTO SalesInvoicedetail VALUES (5279,1395,61,2,0.17)
INSERT INTO SalesInvoicedetail VALUES (5280,1396,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (5281,1396,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (5282,1396,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (5283,1396,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (5284,1396,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (5285,1396,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (5286,1396,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (5287,1396,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (5288,1397,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (5289,1397,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (5290,1397,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (5291,1397,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (5292,1397,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5293,1397,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (5294,1397,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (5295,1397,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (5296,1397,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (5297,1397,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (5298,1397,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (5299,1397,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (5300,1397,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (5301,1397,69,6,0)
INSERT INTO SalesInvoicedetail VALUES (5302,1397,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (5303,1397,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5304,1397,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (5305,1398,71,3,0.22)
INSERT INTO SalesInvoicedetail VALUES (5306,1398,77,6,0.37)
INSERT INTO SalesInvoicedetail VALUES (5307,1398,73,6,0.1)
INSERT INTO SalesInvoicedetail VALUES (5308,1398,75,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (5309,1398,74,2,0.32)
INSERT INTO SalesInvoicedetail VALUES (5310,1398,72,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (5311,1398,76,5,0.14)
INSERT INTO SalesInvoicedetail VALUES (5312,1398,9,4,0.02)
INSERT INTO SalesInvoicedetail VALUES (5313,1398,78,5,0.14)
INSERT INTO SalesInvoicedetail VALUES (5314,1399,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (5315,1399,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5316,1399,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (5317,1399,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (5318,1399,59,5,0)
INSERT INTO SalesInvoicedetail VALUES (5319,1399,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5320,1399,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (5321,1399,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (5322,1399,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5323,1399,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5324,1399,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (5325,1399,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (5326,1399,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (5327,1399,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5328,1399,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (5329,1399,57,3,0)
INSERT INTO SalesInvoicedetail VALUES (5330,1399,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (5331,1400,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (5332,1400,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (5333,1400,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (5334,1400,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (5335,1400,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (5336,1400,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (5337,1400,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (5338,1401,69,1,0)
INSERT INTO SalesInvoicedetail VALUES (5339,1401,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (5340,1401,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (5341,1401,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5342,1401,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (5343,1401,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (5344,1401,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (5345,1401,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5346,1401,57,1,0)
INSERT INTO SalesInvoicedetail VALUES (5347,1401,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (5348,1401,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5349,1401,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (5350,1401,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (5351,1401,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (5352,1401,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (5353,1401,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5354,1401,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5355,1402,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (5356,1402,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (5357,1402,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5358,1402,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (5359,1402,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (5360,1402,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (5361,1402,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (5362,1402,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (5363,1402,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (5364,1402,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (5365,1402,67,2,0)
INSERT INTO SalesInvoicedetail VALUES (5366,1402,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5367,1402,69,6,0)
INSERT INTO SalesInvoicedetail VALUES (5368,1402,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (5369,1402,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (5370,1402,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5371,1402,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (5372,1402,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (5373,1402,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (5374,1403,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5375,1403,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5376,1403,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (5377,1403,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (5378,1403,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (5379,1403,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (5380,1403,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (5381,1403,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (5382,1403,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (5383,1403,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (5384,1403,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (5385,1404,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (5386,1404,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (5387,1404,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (5388,1404,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5389,1404,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (5390,1404,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (5391,1404,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (5392,1404,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5393,1404,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (5394,1404,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (5395,1404,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (5396,1404,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (5397,1404,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (5398,1404,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (5399,1404,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (5400,1404,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (5401,1404,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (5402,1404,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (5403,1404,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (5404,1404,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (5405,1405,65,6,0.1)
INSERT INTO SalesInvoicedetail VALUES (5406,1405,61,5,0.17)
INSERT INTO SalesInvoicedetail VALUES (5407,1405,60,4,0.11)
INSERT INTO SalesInvoicedetail VALUES (5408,1405,70,5,0.26)
INSERT INTO SalesInvoicedetail VALUES (5409,1405,62,4,0.31)
INSERT INTO SalesInvoicedetail VALUES (5410,1405,63,2,0.11)
INSERT INTO SalesInvoicedetail VALUES (5411,1405,54,4,0.15)
INSERT INTO SalesInvoicedetail VALUES (5412,1405,58,2,0.31)
INSERT INTO SalesInvoicedetail VALUES (5413,1406,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (5414,1406,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (5415,1406,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5416,1406,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (5417,1406,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (5418,1406,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (5419,1406,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (5420,1406,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (5421,1406,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (5422,1406,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (5423,1407,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5424,1407,67,6,0)
INSERT INTO SalesInvoicedetail VALUES (5425,1407,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5426,1407,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (5427,1407,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (5428,1407,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5429,1407,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (5430,1407,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (5431,1407,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (5432,1407,59,5,0)
INSERT INTO SalesInvoicedetail VALUES (5433,1407,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (5434,1407,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (5435,1407,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (5436,1407,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (5437,1407,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (5438,1408,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (5439,1409,12,6,0.1)
INSERT INTO SalesInvoicedetail VALUES (5440,1409,7,5,0.24)
INSERT INTO SalesInvoicedetail VALUES (5441,1409,26,4,0.1)
INSERT INTO SalesInvoicedetail VALUES (5442,1409,53,3,0.05)
INSERT INTO SalesInvoicedetail VALUES (5443,1409,22,1,0.04)
INSERT INTO SalesInvoicedetail VALUES (5444,1409,30,3,0.2)
INSERT INTO SalesInvoicedetail VALUES (5445,1410,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (5446,1410,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (5447,1410,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (5448,1411,69,5,0.4)
INSERT INTO SalesInvoicedetail VALUES (5449,1411,66,4,0.23)
INSERT INTO SalesInvoicedetail VALUES (5450,1411,53,1,0.03)
INSERT INTO SalesInvoicedetail VALUES (5451,1411,56,4,0.3)
INSERT INTO SalesInvoicedetail VALUES (5452,1411,64,3,0.03)
INSERT INTO SalesInvoicedetail VALUES (5453,1411,55,3,0.03)
INSERT INTO SalesInvoicedetail VALUES (5454,1411,63,2,0.09)
INSERT INTO SalesInvoicedetail VALUES (5455,1411,50,4,0.04)
INSERT INTO SalesInvoicedetail VALUES (5456,1411,57,1,0.07)
INSERT INTO SalesInvoicedetail VALUES (5457,1411,59,4,0.14)
INSERT INTO SalesInvoicedetail VALUES (5458,1411,54,5,0.21)
INSERT INTO SalesInvoicedetail VALUES (5459,1411,61,2,0.38)
INSERT INTO SalesInvoicedetail VALUES (5460,1411,51,2,0.05)
INSERT INTO SalesInvoicedetail VALUES (5461,1411,52,5,0.35)
INSERT INTO SalesInvoicedetail VALUES (5462,1412,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (5463,1412,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (5464,1412,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (5465,1412,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (5466,1412,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (5467,1412,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (5468,1412,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (5469,1412,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (5470,1412,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (5471,1412,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (5472,1412,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (5473,1412,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (5474,1412,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (5475,1412,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (5476,1412,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (5477,1412,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (5478,1412,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (5479,1412,26,3,0)
INSERT INTO SalesInvoicedetail VALUES (5480,1413,54,4,0.07)
INSERT INTO SalesInvoicedetail VALUES (5481,1413,58,3,0.01)
INSERT INTO SalesInvoicedetail VALUES (5482,1413,70,2,0.21)
INSERT INTO SalesInvoicedetail VALUES (5483,1413,60,1,0.36)
INSERT INTO SalesInvoicedetail VALUES (5484,1413,62,4,0.37)
INSERT INTO SalesInvoicedetail VALUES (5485,1414,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (5486,1414,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (5487,1414,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (5488,1415,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (5489,1416,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (5490,1416,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (5491,1416,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (5492,1416,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (5493,1416,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (5494,1416,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (5495,1416,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (5496,1416,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (5497,1416,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (5498,1416,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (5499,1416,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (5500,1416,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (5501,1416,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (5502,1416,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (5503,1416,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (5504,1416,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (5505,1416,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (5506,1416,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (5507,1416,32,2,0)
INSERT INTO SalesInvoicedetail VALUES (5508,1416,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5509,1416,29,1,0)
INSERT INTO SalesInvoicedetail VALUES (5510,1416,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (5511,1416,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (5512,1416,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (5513,1417,75,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (5514,1417,78,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (5515,1417,73,1,0.3)
INSERT INTO SalesInvoicedetail VALUES (5516,1417,9,6,0.35)
INSERT INTO SalesInvoicedetail VALUES (5517,1418,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (5518,1418,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (5519,1418,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (5520,1418,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (5521,1419,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5522,1419,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (5523,1419,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (5524,1419,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (5525,1419,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (5526,1419,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (5527,1419,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (5528,1419,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (5529,1420,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5530,1421,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5531,1422,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5532,1423,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5533,1424,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (5534,1425,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5535,1426,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5536,1427,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5537,1428,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5538,1429,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (5539,1430,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (5540,1431,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (5541,1432,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5542,1433,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5543,1434,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5544,1435,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5545,1436,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5546,1437,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (5547,1438,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5548,1439,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5549,1440,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5550,1441,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (5551,1442,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (5552,1443,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5553,1444,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5554,1445,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5555,1446,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5556,1447,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5557,1448,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (5558,1449,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5559,1450,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5560,1451,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5561,1452,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5562,1453,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (5563,1454,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (5564,1455,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5565,1456,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5566,1457,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5567,1458,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5568,1459,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (5569,1460,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5570,1461,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5571,1462,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (5572,1463,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5573,1464,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5574,1465,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (5575,1466,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5576,1467,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5577,1468,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5578,1469,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5579,1470,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5580,1471,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (5581,1472,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5582,1473,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (5583,1474,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (5584,1475,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5585,1476,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5586,1477,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5587,1478,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5588,1479,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5589,1480,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (5590,1481,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5591,1482,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5592,1483,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5593,1484,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5594,1485,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5595,1486,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (5596,1487,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5597,1488,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5598,1489,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5599,1490,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (5600,1491,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (5601,1492,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (5602,1493,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5603,1494,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5604,1495,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5605,1496,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (5606,1497,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (5607,1498,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (5608,1499,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (5609,1500,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (5610,1501,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (5611,1502,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5612,1503,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5613,1504,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5614,1505,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (5615,1506,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (5616,1507,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (5617,1508,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5618,1509,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5619,1510,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5620,1511,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5621,1512,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (5622,1513,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (5623,1514,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (5624,1515,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5625,1516,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5626,1517,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (5627,1518,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5628,1519,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (5629,1520,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (5630,1521,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (5631,1522,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (5632,1523,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5633,1524,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5634,1525,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (5635,1526,59,5,0)
INSERT INTO SalesInvoicedetail VALUES (5636,1527,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5637,1528,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5638,1529,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5639,1530,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (5640,1531,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5641,1532,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5642,1533,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (5643,1534,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5644,1535,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5645,1536,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5646,1537,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5647,1538,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5648,1539,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5649,1540,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5650,1541,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (5651,1542,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (5652,1543,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5653,1544,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5654,1545,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5655,1546,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (5656,1547,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (5657,1548,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5658,1549,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5659,1550,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (5660,1551,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5661,1552,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5662,1553,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5663,1554,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5664,1555,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (5665,1556,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5666,1557,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5667,1558,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (5668,1559,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5669,1560,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (5670,1561,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5671,1562,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5672,1563,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5673,1564,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (5674,1565,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5675,1566,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (5676,1567,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5677,1568,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (5678,1569,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (5679,1570,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5680,1571,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (5681,1572,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5682,1573,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5683,1574,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5684,1575,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (5685,1576,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (5686,1577,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5687,1578,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5688,1579,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5689,1580,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (5690,1581,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (5691,1582,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5692,1583,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5693,1584,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5694,1585,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (5695,1586,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (5696,1587,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5697,1588,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5698,1589,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (5699,1590,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (5700,1591,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (5701,1592,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5702,1593,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (5703,1594,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (5704,1595,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5705,1596,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5706,1597,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (5707,1598,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (5708,1599,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5709,1600,69,2,0)
INSERT INTO SalesInvoicedetail VALUES (5710,1601,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5711,1602,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (5712,1603,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5713,1604,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5714,1605,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (5715,1606,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (5716,1607,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (5717,1608,77,3,0.21)
INSERT INTO SalesInvoicedetail VALUES (5718,1608,74,6,0.06)
INSERT INTO SalesInvoicedetail VALUES (5719,1608,75,5,0.07)
INSERT INTO SalesInvoicedetail VALUES (5720,1608,43,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (5721,1608,78,3,0.37)
INSERT INTO SalesInvoicedetail VALUES (5722,1608,72,3,0.23)
INSERT INTO SalesInvoicedetail VALUES (5723,1608,48,5,0.35)
INSERT INTO SalesInvoicedetail VALUES (5724,1609,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (5725,1609,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (5726,1609,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (5727,1610,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (5728,1610,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (5729,1611,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (5730,1612,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (5731,1612,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (5732,1612,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (5733,1612,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5734,1612,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5735,1612,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (5736,1612,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (5737,1612,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (5738,1612,69,2,0)
INSERT INTO SalesInvoicedetail VALUES (5739,1612,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (5740,1612,57,3,0)
INSERT INTO SalesInvoicedetail VALUES (5741,1612,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (5742,1612,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (5743,1612,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (5744,1612,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5745,1612,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5746,1612,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (5747,1612,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (5748,1613,60,5,0.08)
INSERT INTO SalesInvoicedetail VALUES (5749,1613,65,5,0.06)
INSERT INTO SalesInvoicedetail VALUES (5750,1613,61,2,0.14)
INSERT INTO SalesInvoicedetail VALUES (5751,1613,62,5,0.24)
INSERT INTO SalesInvoicedetail VALUES (5752,1613,58,6,0.26)
INSERT INTO SalesInvoicedetail VALUES (5753,1614,65,1,0)
INSERT INTO SalesInvoicedetail VALUES (5754,1614,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (5755,1614,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (5756,1614,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (5757,1615,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (5758,1615,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (5759,1615,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (5760,1615,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (5761,1615,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (5762,1615,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (5763,1615,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (5764,1616,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (5765,1616,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (5766,1616,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (5767,1616,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (5768,1616,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (5769,1616,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (5770,1616,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (5771,1616,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (5772,1616,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (5773,1617,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (5774,1617,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (5775,1617,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (5776,1617,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (5777,1617,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (5778,1618,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (5779,1618,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (5780,1618,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (5781,1619,52,3,0.21)
INSERT INTO SalesInvoicedetail VALUES (5782,1619,64,2,0.02)
INSERT INTO SalesInvoicedetail VALUES (5783,1619,55,5,0.24)
INSERT INTO SalesInvoicedetail VALUES (5784,1619,54,3,0.32)
INSERT INTO SalesInvoicedetail VALUES (5785,1619,50,1,0.21)
INSERT INTO SalesInvoicedetail VALUES (5786,1619,57,5,0.25)
INSERT INTO SalesInvoicedetail VALUES (5787,1619,67,5,0.17)
INSERT INTO SalesInvoicedetail VALUES (5788,1619,69,3,0.05)
INSERT INTO SalesInvoicedetail VALUES (5789,1619,68,3,0.03)
INSERT INTO SalesInvoicedetail VALUES (5790,1619,60,2,0.29)
INSERT INTO SalesInvoicedetail VALUES (5791,1619,49,5,0.4)
INSERT INTO SalesInvoicedetail VALUES (5792,1619,61,2,0.36)
INSERT INTO SalesInvoicedetail VALUES (5793,1619,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (5794,1619,53,3,0.28)
INSERT INTO SalesInvoicedetail VALUES (5795,1619,12,4,0.38)
INSERT INTO SalesInvoicedetail VALUES (5796,1619,70,2,0.31)
INSERT INTO SalesInvoicedetail VALUES (5797,1619,66,1,0.05)
INSERT INTO SalesInvoicedetail VALUES (5798,1619,51,5,0.38)
INSERT INTO SalesInvoicedetail VALUES (5799,1620,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (5800,1620,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (5801,1620,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (5802,1620,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5803,1620,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5804,1620,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (5805,1620,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (5806,1620,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5807,1620,67,6,0)
INSERT INTO SalesInvoicedetail VALUES (5808,1620,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (5809,1620,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (5810,1620,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (5811,1620,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (5812,1620,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (5813,1620,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (5814,1620,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (5815,1620,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (5816,1621,30,1,0)
INSERT INTO SalesInvoicedetail VALUES (5817,1621,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (5818,1622,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (5819,1622,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (5820,1622,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (5821,1622,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (5822,1622,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5823,1622,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (5824,1622,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (5825,1622,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (5826,1622,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (5827,1622,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5828,1622,25,4,0)
INSERT INTO SalesInvoicedetail VALUES (5829,1622,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (5830,1623,62,5,0.35)
INSERT INTO SalesInvoicedetail VALUES (5831,1623,58,2,0.26)
INSERT INTO SalesInvoicedetail VALUES (5832,1623,70,6,0.29)
INSERT INTO SalesInvoicedetail VALUES (5833,1624,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (5834,1624,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (5835,1624,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (5836,1624,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (5837,1625,59,4,0)
INSERT INTO SalesInvoicedetail VALUES (5838,1625,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (5839,1625,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (5840,1625,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (5841,1625,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (5842,1625,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (5843,1625,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (5844,1625,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (5845,1625,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (5846,1625,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (5847,1625,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (5848,1625,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (5849,1625,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (5850,1625,66,1,0)
INSERT INTO SalesInvoicedetail VALUES (5851,1625,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (5852,1625,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (5853,1625,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (5854,1625,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (5855,1626,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (5856,1626,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (5857,1626,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (5858,1626,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (5859,1626,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (5860,1626,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (5861,1626,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (5862,1626,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (5863,1626,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (5864,1626,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (5865,1626,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (5866,1626,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (5867,1626,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (5868,1626,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (5869,1626,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (5870,1626,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (5871,1626,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (5872,1626,69,2,0)
INSERT INTO SalesInvoicedetail VALUES (5873,1627,68,6,0.1)
INSERT INTO SalesInvoicedetail VALUES (5874,1627,66,2,0.19)
INSERT INTO SalesInvoicedetail VALUES (5875,1627,61,3,0.23)
INSERT INTO SalesInvoicedetail VALUES (5876,1627,58,4,0.06)
INSERT INTO SalesInvoicedetail VALUES (5877,1627,56,3,0.09)
INSERT INTO SalesInvoicedetail VALUES (5878,1627,54,1,0.34)
INSERT INTO SalesInvoicedetail VALUES (5879,1627,63,2,0.17)
INSERT INTO SalesInvoicedetail VALUES (5880,1627,32,2,0.02)
INSERT INTO SalesInvoicedetail VALUES (5881,1627,53,2,0.3)
INSERT INTO SalesInvoicedetail VALUES (5882,1627,60,4,0.3)
INSERT INTO SalesInvoicedetail VALUES (5883,1627,64,1,0.2)
INSERT INTO SalesInvoicedetail VALUES (5884,1628,54,6,0)
INSERT INTO SalesInvoicedetail VALUES (5885,1628,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (5886,1628,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (5887,1628,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (5888,1628,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (5889,1629,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (5890,1630,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (5891,1630,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (5892,1630,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (5893,1630,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (5894,1630,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (5895,1630,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (5896,1630,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (5897,1630,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (5898,1630,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (5899,1630,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (5900,1630,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (5901,1630,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (5902,1630,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (5903,1630,58,6,0)
INSERT INTO SalesInvoicedetail VALUES (5904,1630,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (5905,1630,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (5906,1630,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (5907,1630,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (5908,1630,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (5909,1630,64,6,0)
INSERT INTO SalesInvoicedetail VALUES (5910,1630,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (5911,1630,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (5912,1630,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (5913,1630,29,6,0)
INSERT INTO SalesInvoicedetail VALUES (5914,1630,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (5915,1630,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (5916,1630,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (5917,1631,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (5918,1631,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (5919,1631,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (5920,1631,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (5921,1631,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (5922,1631,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (5923,1631,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (5924,1631,42,3,0)
INSERT INTO SalesInvoicedetail VALUES (5925,1631,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (5926,1632,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (5927,1632,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (5928,1632,43,6,0)
INSERT INTO SalesInvoicedetail VALUES (5929,1632,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (5930,1632,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (5931,1632,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (5932,1632,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (5933,1632,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (5934,1632,48,6,0)
INSERT INTO SalesInvoicedetail VALUES (5935,1633,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (5936,1633,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (5937,1633,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (5938,1633,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (5939,1633,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (5940,1633,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (5941,1633,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (5942,1633,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (5943,1633,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (5944,1633,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (5945,1633,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (5946,1633,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (5947,1633,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (5948,1633,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (5949,1633,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (5950,1633,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (5951,1633,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (5952,1633,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (5953,1633,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (5954,1633,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (5955,1633,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (5956,1633,57,1,0)
INSERT INTO SalesInvoicedetail VALUES (5957,1633,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (5958,1634,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (5959,1635,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (5960,1635,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (5961,1636,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (5962,1636,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (5963,1636,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (5964,1636,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (5965,1636,43,6,0)
INSERT INTO SalesInvoicedetail VALUES (5966,1636,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (5967,1636,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (5968,1636,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (5969,1637,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (5970,1637,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (5971,1637,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (5972,1637,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (5973,1637,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (5974,1637,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (5975,1637,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (5976,1638,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (5977,1638,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (5978,1638,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (5979,1638,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (5980,1638,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (5981,1638,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (5982,1638,45,1,0)
INSERT INTO SalesInvoicedetail VALUES (5983,1638,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (5984,1638,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (5985,1638,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (5986,1638,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (5987,1638,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (5988,1638,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (5989,1638,8,1,0)
INSERT INTO SalesInvoicedetail VALUES (5990,1639,61,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (5991,1639,65,5,0.07)
INSERT INTO SalesInvoicedetail VALUES (5992,1639,70,4,0.12)
INSERT INTO SalesInvoicedetail VALUES (5993,1639,54,1,0.12)
INSERT INTO SalesInvoicedetail VALUES (5994,1639,62,3,0.18)
INSERT INTO SalesInvoicedetail VALUES (5995,1639,63,4,0.06)
INSERT INTO SalesInvoicedetail VALUES (5996,1639,58,5,0.03)
INSERT INTO SalesInvoicedetail VALUES (5997,1640,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (5998,1640,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (5999,1640,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (6000,1640,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (6001,1640,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (6002,1640,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (6003,1640,67,6,0)
INSERT INTO SalesInvoicedetail VALUES (6004,1640,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (6005,1640,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (6006,1640,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (6007,1640,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (6008,1640,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (6009,1640,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (6010,1640,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (6011,1640,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (6012,1640,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (6013,1641,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (6014,1641,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (6015,1641,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (6016,1641,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (6017,1641,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (6018,1641,63,3,0)
INSERT INTO SalesInvoicedetail VALUES (6019,1641,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (6020,1641,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (6021,1641,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (6022,1641,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6023,1641,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (6024,1641,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (6025,1641,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (6026,1641,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (6027,1641,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (6028,1641,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (6029,1641,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (6030,1641,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (6031,1641,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (6032,1641,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (6033,1642,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (6034,1642,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (6035,1642,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (6036,1642,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (6037,1642,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (6038,1642,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (6039,1642,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (6040,1642,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (6041,1642,41,5,0)
INSERT INTO SalesInvoicedetail VALUES (6042,1642,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (6043,1642,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (6044,1642,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (6045,1642,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (6046,1642,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (6047,1642,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (6048,1642,48,5,0)
INSERT INTO SalesInvoicedetail VALUES (6049,1642,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (6050,1642,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (6051,1642,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (6052,1642,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (6053,1643,30,3,0)
INSERT INTO SalesInvoicedetail VALUES (6054,1643,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (6055,1643,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (6056,1643,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (6057,1643,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (6058,1643,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (6059,1643,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (6060,1643,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (6061,1643,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (6062,1643,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (6063,1643,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (6064,1643,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (6065,1643,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (6066,1643,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (6067,1643,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (6068,1643,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (6069,1643,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (6070,1643,32,3,0)
INSERT INTO SalesInvoicedetail VALUES (6071,1643,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (6072,1643,38,6,0)
INSERT INTO SalesInvoicedetail VALUES (6073,1643,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (6074,1643,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (6075,1643,55,6,0)
INSERT INTO SalesInvoicedetail VALUES (6076,1643,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (6077,1643,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (6078,1643,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (6079,1643,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (6080,1644,56,2,0.23)
INSERT INTO SalesInvoicedetail VALUES (6081,1644,53,3,0.02)
INSERT INTO SalesInvoicedetail VALUES (6082,1644,60,1,0.31)
INSERT INTO SalesInvoicedetail VALUES (6083,1644,66,1,0.38)
INSERT INTO SalesInvoicedetail VALUES (6084,1644,63,5,0.2)
INSERT INTO SalesInvoicedetail VALUES (6085,1644,52,2,0.01)
INSERT INTO SalesInvoicedetail VALUES (6086,1644,65,3,0.11)
INSERT INTO SalesInvoicedetail VALUES (6087,1644,67,2,0.35)
INSERT INTO SalesInvoicedetail VALUES (6088,1644,70,3,0.03)
INSERT INTO SalesInvoicedetail VALUES (6089,1644,62,4,0.31)
INSERT INTO SalesInvoicedetail VALUES (6090,1644,64,5,0.06)
INSERT INTO SalesInvoicedetail VALUES (6091,1644,69,5,0.02)
INSERT INTO SalesInvoicedetail VALUES (6092,1644,51,5,0.09)
INSERT INTO SalesInvoicedetail VALUES (6093,1644,59,4,0.24)
INSERT INTO SalesInvoicedetail VALUES (6094,1644,54,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (6095,1645,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (6096,1645,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (6097,1645,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (6098,1645,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (6099,1645,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (6100,1646,78,3,0.22)
INSERT INTO SalesInvoicedetail VALUES (6101,1646,76,2,0.08)
INSERT INTO SalesInvoicedetail VALUES (6102,1646,75,4,0.31)
INSERT INTO SalesInvoicedetail VALUES (6103,1646,74,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (6104,1646,72,4,0.29)
INSERT INTO SalesInvoicedetail VALUES (6105,1646,73,2,0.06)
INSERT INTO SalesInvoicedetail VALUES (6106,1647,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (6107,1647,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (6108,1647,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (6109,1647,60,2,0)
INSERT INTO SalesInvoicedetail VALUES (6110,1647,11,6,0)
INSERT INTO SalesInvoicedetail VALUES (6111,1647,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (6112,1647,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6113,1647,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (6114,1647,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (6115,1647,29,4,0)
INSERT INTO SalesInvoicedetail VALUES (6116,1647,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (6117,1647,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (6118,1647,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (6119,1647,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (6120,1647,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (6121,1647,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (6122,1647,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (6123,1647,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (6124,1647,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (6125,1647,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (6126,1647,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (6127,1647,16,5,0)
INSERT INTO SalesInvoicedetail VALUES (6128,1647,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (6129,1648,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (6130,1648,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (6131,1648,25,1,0)
INSERT INTO SalesInvoicedetail VALUES (6132,1648,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (6133,1648,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (6134,1648,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6135,1648,62,1,0)
INSERT INTO SalesInvoicedetail VALUES (6136,1649,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (6137,1649,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (6138,1649,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (6139,1649,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (6140,1649,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (6141,1649,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (6142,1649,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (6143,1650,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (6144,1650,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (6145,1650,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (6146,1650,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (6147,1650,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (6148,1650,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (6149,1650,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (6150,1650,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (6151,1650,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (6152,1650,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (6153,1650,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (6154,1650,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (6155,1650,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (6156,1650,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (6157,1650,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (6158,1650,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (6159,1650,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (6160,1650,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (6161,1650,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (6162,1650,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (6163,1650,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (6164,1651,62,1,0.03)
INSERT INTO SalesInvoicedetail VALUES (6165,1651,49,3,0.23)
INSERT INTO SalesInvoicedetail VALUES (6166,1651,63,3,0.18)
INSERT INTO SalesInvoicedetail VALUES (6167,1651,29,6,0.02)
INSERT INTO SalesInvoicedetail VALUES (6168,1651,65,3,0.16)
INSERT INTO SalesInvoicedetail VALUES (6169,1651,30,3,0.28)
INSERT INTO SalesInvoicedetail VALUES (6170,1651,58,1,0.32)
INSERT INTO SalesInvoicedetail VALUES (6171,1651,26,4,0.31)
INSERT INTO SalesInvoicedetail VALUES (6172,1651,22,6,0.28)
INSERT INTO SalesInvoicedetail VALUES (6173,1651,32,6,0.28)
INSERT INTO SalesInvoicedetail VALUES (6174,1651,56,6,0.15)
INSERT INTO SalesInvoicedetail VALUES (6175,1651,55,2,0.12)
INSERT INTO SalesInvoicedetail VALUES (6176,1651,70,6,0.37)
INSERT INTO SalesInvoicedetail VALUES (6177,1651,68,2,0.2)
INSERT INTO SalesInvoicedetail VALUES (6178,1651,54,2,0.02)
INSERT INTO SalesInvoicedetail VALUES (6179,1652,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (6180,1652,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (6181,1652,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (6182,1652,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (6183,1652,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (6184,1653,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (6185,1653,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (6186,1653,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (6187,1653,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (6188,1653,9,6,0)
INSERT INTO SalesInvoicedetail VALUES (6189,1654,22,1,0)
INSERT INTO SalesInvoicedetail VALUES (6190,1654,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (6191,1654,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (6192,1655,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (6193,1655,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (6194,1655,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (6195,1655,26,2,0)
INSERT INTO SalesInvoicedetail VALUES (6196,1655,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (6197,1655,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (6198,1655,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (6199,1655,29,2,0)
INSERT INTO SalesInvoicedetail VALUES (6200,1655,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (6201,1655,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (6202,1655,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (6203,1655,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (6204,1655,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (6205,1655,8,6,0)
INSERT INTO SalesInvoicedetail VALUES (6206,1655,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6207,1655,22,3,0)
INSERT INTO SalesInvoicedetail VALUES (6208,1655,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (6209,1655,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (6210,1655,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6211,1655,32,5,0)
INSERT INTO SalesInvoicedetail VALUES (6212,1655,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (6213,1655,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (6214,1656,26,5,0)
INSERT INTO SalesInvoicedetail VALUES (6215,1656,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (6216,1656,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (6217,1656,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (6218,1656,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (6219,1656,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (6220,1656,32,1,0)
INSERT INTO SalesInvoicedetail VALUES (6221,1656,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (6222,1656,22,2,0)
INSERT INTO SalesInvoicedetail VALUES (6223,1656,38,1,0)
INSERT INTO SalesInvoicedetail VALUES (6224,1656,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (6225,1656,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6226,1656,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (6227,1656,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (6228,1656,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (6229,1656,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (6230,1656,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (6231,1657,41,6,0)
INSERT INTO SalesInvoicedetail VALUES (6232,1657,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (6233,1657,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (6234,1657,48,3,0)
INSERT INTO SalesInvoicedetail VALUES (6235,1657,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (6236,1657,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (6237,1657,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (6238,1657,75,5,0)
INSERT INTO SalesInvoicedetail VALUES (6239,1657,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (6240,1657,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (6241,1657,42,1,0)
INSERT INTO SalesInvoicedetail VALUES (6242,1657,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (6243,1657,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (6244,1657,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (6245,1658,76,4,0)
INSERT INTO SalesInvoicedetail VALUES (6246,1659,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (6247,1659,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (6248,1659,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (6249,1659,56,1,0)
INSERT INTO SalesInvoicedetail VALUES (6250,1659,63,6,0)
INSERT INTO SalesInvoicedetail VALUES (6251,1659,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (6252,1659,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6253,1659,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (6254,1659,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (6255,1659,59,1,0)
INSERT INTO SalesInvoicedetail VALUES (6256,1659,57,3,0)
INSERT INTO SalesInvoicedetail VALUES (6257,1659,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (6258,1659,60,1,0)
INSERT INTO SalesInvoicedetail VALUES (6259,1659,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (6260,1659,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (6261,1659,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (6262,1659,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (6263,1659,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (6264,1659,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (6265,1659,55,1,0)
INSERT INTO SalesInvoicedetail VALUES (6266,1659,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6267,1659,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6268,1660,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (6269,1660,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (6270,1660,42,6,0)
INSERT INTO SalesInvoicedetail VALUES (6271,1660,14,4,0)
INSERT INTO SalesInvoicedetail VALUES (6272,1660,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (6273,1660,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (6274,1660,7,5,0)
INSERT INTO SalesInvoicedetail VALUES (6275,1660,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (6276,1660,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (6277,1660,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (6278,1660,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (6279,1660,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (6280,1660,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (6281,1660,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (6282,1660,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (6283,1660,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (6284,1660,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (6285,1660,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (6286,1660,16,1,0)
INSERT INTO SalesInvoicedetail VALUES (6287,1661,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (6288,1661,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (6289,1661,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (6290,1661,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (6291,1661,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (6292,1662,77,6,0)
INSERT INTO SalesInvoicedetail VALUES (6293,1662,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (6294,1662,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (6295,1662,74,1,0)
INSERT INTO SalesInvoicedetail VALUES (6296,1662,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (6297,1663,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (6298,1663,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (6299,1663,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (6300,1663,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (6301,1663,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (6302,1663,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (6303,1663,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (6304,1663,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (6305,1663,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (6306,1663,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (6307,1663,9,1,0.07)
INSERT INTO SalesInvoicedetail VALUES (6308,1664,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (6309,1664,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (6310,1664,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (6311,1664,54,1,0)
INSERT INTO SalesInvoicedetail VALUES (6312,1664,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (6313,1664,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (6314,1664,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (6315,1664,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (6316,1665,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6317,1665,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (6318,1665,61,6,0)
INSERT INTO SalesInvoicedetail VALUES (6319,1665,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (6320,1665,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (6321,1665,12,5,0.01)
INSERT INTO SalesInvoicedetail VALUES (6322,1665,14,6,0)
INSERT INTO SalesInvoicedetail VALUES (6323,1665,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (6324,1665,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (6325,1665,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (6326,1665,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (6327,1665,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (6328,1665,64,1,0)
INSERT INTO SalesInvoicedetail VALUES (6329,1665,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (6330,1665,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (6331,1665,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (6332,1665,32,6,0)
INSERT INTO SalesInvoicedetail VALUES (6333,1665,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (6334,1665,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (6335,1665,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (6336,1665,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (6337,1665,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (6338,1665,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (6339,1665,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (6340,1665,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (6341,1666,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (6342,1667,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (6343,1667,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (6344,1667,58,1,0)
INSERT INTO SalesInvoicedetail VALUES (6345,1668,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (6346,1668,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (6347,1668,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (6348,1668,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (6349,1668,69,5,0)
INSERT INTO SalesInvoicedetail VALUES (6350,1668,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (6351,1668,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (6352,1668,57,4,0)
INSERT INTO SalesInvoicedetail VALUES (6353,1668,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (6354,1668,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (6355,1668,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6356,1668,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (6357,1668,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (6358,1668,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (6359,1669,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (6360,1669,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (6361,1669,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (6362,1669,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (6363,1669,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (6364,1670,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (6365,1670,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (6366,1670,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (6367,1670,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (6368,1670,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (6369,1670,72,4,0)
INSERT INTO SalesInvoicedetail VALUES (6370,1670,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (6371,1670,77,1,0)
INSERT INTO SalesInvoicedetail VALUES (6372,1670,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (6373,1670,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (6374,1671,43,4,0)
INSERT INTO SalesInvoicedetail VALUES (6375,1671,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (6376,1671,47,1,0)
INSERT INTO SalesInvoicedetail VALUES (6377,1671,78,1,0)
INSERT INTO SalesInvoicedetail VALUES (6378,1671,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (6379,1671,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (6380,1671,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (6381,1671,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (6382,1671,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (6383,1671,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (6384,1671,12,1,0)
INSERT INTO SalesInvoicedetail VALUES (6385,1671,48,1,0)
INSERT INTO SalesInvoicedetail VALUES (6386,1671,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (6387,1671,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (6388,1671,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (6389,1671,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (6390,1671,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (6391,1671,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (6392,1671,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (6393,1671,45,3,0)
INSERT INTO SalesInvoicedetail VALUES (6394,1672,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (6395,1672,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (6396,1673,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6397,1673,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6398,1673,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (6399,1673,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (6400,1673,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (6401,1673,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (6402,1673,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (6403,1673,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (6404,1673,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (6405,1673,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (6406,1673,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6407,1673,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (6408,1673,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (6409,1673,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (6410,1673,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (6411,1674,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6412,1674,60,6,0)
INSERT INTO SalesInvoicedetail VALUES (6413,1674,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (6414,1674,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (6415,1674,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6416,1674,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (6417,1674,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6418,1674,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (6419,1674,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (6420,1674,57,1,0)
INSERT INTO SalesInvoicedetail VALUES (6421,1674,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (6422,1674,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (6423,1674,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (6424,1674,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (6425,1674,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (6426,1675,26,3,0.27)
INSERT INTO SalesInvoicedetail VALUES (6427,1675,55,5,0.32)
INSERT INTO SalesInvoicedetail VALUES (6428,1675,22,5,0.12)
INSERT INTO SalesInvoicedetail VALUES (6429,1675,62,3,0.27)
INSERT INTO SalesInvoicedetail VALUES (6430,1675,49,1,0.2)
INSERT INTO SalesInvoicedetail VALUES (6431,1676,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (6432,1676,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (6433,1676,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (6434,1676,73,5,0)
INSERT INTO SalesInvoicedetail VALUES (6435,1676,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (6436,1676,11,2,0)
INSERT INTO SalesInvoicedetail VALUES (6437,1676,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (6438,1676,76,2,0)
INSERT INTO SalesInvoicedetail VALUES (6439,1676,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (6440,1676,9,1,0)
INSERT INTO SalesInvoicedetail VALUES (6441,1677,11,3,0.24)
INSERT INTO SalesInvoicedetail VALUES (6442,1677,12,2,0.19)
INSERT INTO SalesInvoicedetail VALUES (6443,1677,55,1,0.3)
INSERT INTO SalesInvoicedetail VALUES (6444,1677,58,2,0.24)
INSERT INTO SalesInvoicedetail VALUES (6445,1677,66,2,0.28)
INSERT INTO SalesInvoicedetail VALUES (6446,1677,63,6,0.09)
INSERT INTO SalesInvoicedetail VALUES (6447,1677,56,2,0.16)
INSERT INTO SalesInvoicedetail VALUES (6448,1677,53,4,0.04)
INSERT INTO SalesInvoicedetail VALUES (6449,1677,68,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (6450,1677,16,4,0.01)
INSERT INTO SalesInvoicedetail VALUES (6451,1677,65,5,0.19)
INSERT INTO SalesInvoicedetail VALUES (6452,1677,14,3,0.33)
INSERT INTO SalesInvoicedetail VALUES (6453,1677,25,4,0.04)
INSERT INTO SalesInvoicedetail VALUES (6454,1677,61,2,0.32)
INSERT INTO SalesInvoicedetail VALUES (6455,1677,8,6,0.37)
INSERT INTO SalesInvoicedetail VALUES (6456,1677,15,5,0.02)
INSERT INTO SalesInvoicedetail VALUES (6457,1677,70,2,0.09)
INSERT INTO SalesInvoicedetail VALUES (6458,1678,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (6459,1678,78,5,0)
INSERT INTO SalesInvoicedetail VALUES (6460,1678,48,3,0)
INSERT INTO SalesInvoicedetail VALUES (6461,1678,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (6462,1678,47,3,0)
INSERT INTO SalesInvoicedetail VALUES (6463,1678,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (6464,1678,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (6465,1678,42,2,0)
INSERT INTO SalesInvoicedetail VALUES (6466,1678,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (6467,1678,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (6468,1679,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (6469,1679,66,3,0)
INSERT INTO SalesInvoicedetail VALUES (6470,1679,38,2,0)
INSERT INTO SalesInvoicedetail VALUES (6471,1679,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6472,1679,26,4,0)
INSERT INTO SalesInvoicedetail VALUES (6473,1679,29,3,0)
INSERT INTO SalesInvoicedetail VALUES (6474,1679,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6475,1679,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (6476,1679,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (6477,1679,25,6,0)
INSERT INTO SalesInvoicedetail VALUES (6478,1679,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6479,1679,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (6480,1679,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (6481,1679,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6482,1679,22,5,0)
INSERT INTO SalesInvoicedetail VALUES (6483,1679,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (6484,1679,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (6485,1680,57,2,0)
INSERT INTO SalesInvoicedetail VALUES (6486,1680,56,5,0)
INSERT INTO SalesInvoicedetail VALUES (6487,1680,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (6488,1680,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6489,1680,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (6490,1680,68,3,0)
INSERT INTO SalesInvoicedetail VALUES (6491,1680,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (6492,1680,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (6493,1680,69,3,0)
INSERT INTO SalesInvoicedetail VALUES (6494,1680,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6495,1680,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6496,1680,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (6497,1680,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (6498,1680,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (6499,1680,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (6500,1680,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (6501,1680,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (6502,1680,55,4,0)
INSERT INTO SalesInvoicedetail VALUES (6503,1680,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (6504,1680,59,4,0)
INSERT INTO SalesInvoicedetail VALUES (6505,1681,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (6506,1681,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (6507,1681,67,5,0)
INSERT INTO SalesInvoicedetail VALUES (6508,1681,68,6,0)
INSERT INTO SalesInvoicedetail VALUES (6509,1681,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (6510,1681,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6511,1681,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (6512,1681,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (6513,1681,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (6514,1681,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (6515,1681,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (6516,1681,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (6517,1681,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (6518,1681,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (6519,1681,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (6520,1681,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (6521,1681,12,4,0)
INSERT INTO SalesInvoicedetail VALUES (6522,1681,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6523,1681,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (6524,1682,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (6525,1682,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6526,1682,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (6527,1683,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (6528,1683,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (6529,1683,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (6530,1683,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (6531,1683,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (6532,1683,9,2,0.07)
INSERT INTO SalesInvoicedetail VALUES (6533,1683,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (6534,1683,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (6535,1683,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (6536,1684,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (6537,1684,78,3,0)
INSERT INTO SalesInvoicedetail VALUES (6538,1684,72,6,0)
INSERT INTO SalesInvoicedetail VALUES (6539,1684,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (6540,1684,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (6541,1684,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (6542,1684,74,6,0)
INSERT INTO SalesInvoicedetail VALUES (6543,1684,71,1,0)
INSERT INTO SalesInvoicedetail VALUES (6544,1684,73,4,0)
INSERT INTO SalesInvoicedetail VALUES (6545,1685,41,1,0)
INSERT INTO SalesInvoicedetail VALUES (6546,1685,7,6,0)
INSERT INTO SalesInvoicedetail VALUES (6547,1685,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (6548,1685,15,4,0)
INSERT INTO SalesInvoicedetail VALUES (6549,1685,77,3,0)
INSERT INTO SalesInvoicedetail VALUES (6550,1685,45,5,0)
INSERT INTO SalesInvoicedetail VALUES (6551,1685,8,4,0)
INSERT INTO SalesInvoicedetail VALUES (6552,1685,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (6553,1685,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (6554,1685,16,2,0)
INSERT INTO SalesInvoicedetail VALUES (6555,1685,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (6556,1685,9,2,0)
INSERT INTO SalesInvoicedetail VALUES (6557,1685,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (6558,1685,74,5,0)
INSERT INTO SalesInvoicedetail VALUES (6559,1685,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (6560,1685,43,5,0)
INSERT INTO SalesInvoicedetail VALUES (6561,1686,57,4,0)
INSERT INTO SalesInvoicedetail VALUES (6562,1686,67,4,0)
INSERT INTO SalesInvoicedetail VALUES (6563,1686,70,1,0)
INSERT INTO SalesInvoicedetail VALUES (6564,1686,54,2,0)
INSERT INTO SalesInvoicedetail VALUES (6565,1686,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6566,1686,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (6567,1686,68,4,0)
INSERT INTO SalesInvoicedetail VALUES (6568,1686,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6569,1686,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (6570,1686,59,2,0)
INSERT INTO SalesInvoicedetail VALUES (6571,1686,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6572,1686,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (6573,1686,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (6574,1686,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6575,1686,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (6576,1686,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (6577,1686,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (6578,1686,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (6579,1686,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (6580,1686,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (6581,1686,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (6582,1686,65,6,0)
INSERT INTO SalesInvoicedetail VALUES (6583,1687,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6584,1688,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6585,1689,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (6586,1690,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6587,1691,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6588,1692,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (6589,1693,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6590,1694,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6591,1695,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (6592,1696,69,2,0)
INSERT INTO SalesInvoicedetail VALUES (6593,1697,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (6594,1698,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6595,1699,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (6596,1700,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (6597,1701,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6598,1702,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (6599,1703,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6600,1704,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (6601,1705,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6602,1706,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6603,1707,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6604,1708,64,3,0)
INSERT INTO SalesInvoicedetail VALUES (6605,1709,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (6606,1710,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (6607,1711,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (6608,1712,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (6609,1713,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6610,1714,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (6611,1715,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (6612,1716,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (6613,1717,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6614,1718,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (6615,1719,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (6616,1720,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6617,1721,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6618,1722,61,5,0)
INSERT INTO SalesInvoicedetail VALUES (6619,1723,71,5,0)
INSERT INTO SalesInvoicedetail VALUES (6620,1724,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6621,1725,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (6622,1726,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (6623,1727,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (6624,1728,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6625,1729,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6626,1730,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (6627,1731,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6628,1732,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6629,1733,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6630,1734,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (6631,1735,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (6632,1736,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (6633,1737,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (6634,1738,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (6635,1739,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (6636,1740,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (6637,1741,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (6638,1742,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6639,1743,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6640,1744,71,2,0)
INSERT INTO SalesInvoicedetail VALUES (6641,1745,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (6642,1746,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6643,1747,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (6644,1748,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (6645,1749,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6646,1750,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6647,1751,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6648,1752,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6649,1753,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6650,1754,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (6651,1755,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6652,1756,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (6653,1757,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (6654,1758,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (6655,1759,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (6656,1760,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6657,1761,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (6658,1762,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6659,1763,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6660,1764,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6661,1765,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (6662,1766,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (6663,1767,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6664,1768,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (6665,1769,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (6666,1770,73,3,0)
INSERT INTO SalesInvoicedetail VALUES (6667,1771,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6668,1772,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (6669,1773,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6670,1774,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6671,1775,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6672,1776,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (6673,1777,67,1,0)
INSERT INTO SalesInvoicedetail VALUES (6674,1778,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (6675,1779,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6676,1780,49,6,0)
INSERT INTO SalesInvoicedetail VALUES (6677,1781,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (6678,1782,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6679,1783,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6680,1784,53,2,0)
INSERT INTO SalesInvoicedetail VALUES (6681,1785,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6682,1786,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6683,1787,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6684,1788,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (6685,1789,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6686,1790,61,2,0)
INSERT INTO SalesInvoicedetail VALUES (6687,1791,49,4,0)
INSERT INTO SalesInvoicedetail VALUES (6688,1792,51,2,0)
INSERT INTO SalesInvoicedetail VALUES (6689,1793,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (6690,1794,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (6691,1795,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (6692,1796,51,3,0)
INSERT INTO SalesInvoicedetail VALUES (6693,1797,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6694,1798,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6695,1799,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6696,1800,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (6697,1801,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6698,1802,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (6699,1803,50,3,0)
INSERT INTO SalesInvoicedetail VALUES (6700,1804,49,1,0)
INSERT INTO SalesInvoicedetail VALUES (6701,1805,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (6702,1806,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (6703,1807,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (6704,1808,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (6705,1809,72,1,0)
INSERT INTO SalesInvoicedetail VALUES (6706,1810,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6707,1811,77,2,0)
INSERT INTO SalesInvoicedetail VALUES (6708,1812,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6709,1813,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (6710,1814,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6711,1815,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6712,1816,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (6713,1817,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (6714,1818,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6715,1819,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6716,1820,52,1,0)
INSERT INTO SalesInvoicedetail VALUES (6717,1821,52,3,0)
INSERT INTO SalesInvoicedetail VALUES (6718,1822,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6719,1823,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6720,1824,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6721,1825,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (6722,1826,52,4,0)
INSERT INTO SalesInvoicedetail VALUES (6723,1827,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6724,1828,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (6725,1829,52,2,0)
INSERT INTO SalesInvoicedetail VALUES (6726,1830,50,6,0)
INSERT INTO SalesInvoicedetail VALUES (6727,1831,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (6728,1832,52,6,0)
INSERT INTO SalesInvoicedetail VALUES (6729,1833,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (6730,1834,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (6731,1835,59,6,0)
INSERT INTO SalesInvoicedetail VALUES (6732,1836,49,2,0)
INSERT INTO SalesInvoicedetail VALUES (6733,1837,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (6734,1838,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (6735,1839,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (6736,1840,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6737,1841,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (6738,1842,51,6,0)
INSERT INTO SalesInvoicedetail VALUES (6739,1843,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (6740,1844,53,4,0)
INSERT INTO SalesInvoicedetail VALUES (6741,1845,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6742,1846,69,5,0)
INSERT INTO SalesInvoicedetail VALUES (6743,1847,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6744,1848,50,5,0)
INSERT INTO SalesInvoicedetail VALUES (6745,1849,53,5,0)
INSERT INTO SalesInvoicedetail VALUES (6746,1850,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6747,1851,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6748,1852,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6749,1853,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6750,1854,51,1,0)
INSERT INTO SalesInvoicedetail VALUES (6751,1855,75,6,0)
INSERT INTO SalesInvoicedetail VALUES (6752,1856,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (6753,1857,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6754,1858,70,5,0)
INSERT INTO SalesInvoicedetail VALUES (6755,1858,65,4,0)
INSERT INTO SalesInvoicedetail VALUES (6756,1858,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (6757,1858,63,5,0)
INSERT INTO SalesInvoicedetail VALUES (6758,1858,64,5,0)
INSERT INTO SalesInvoicedetail VALUES (6759,1858,56,6,0)
INSERT INTO SalesInvoicedetail VALUES (6760,1858,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (6761,1858,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (6762,1858,53,3,0)
INSERT INTO SalesInvoicedetail VALUES (6763,1858,49,5,0)
INSERT INTO SalesInvoicedetail VALUES (6764,1858,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (6765,1858,25,5,0)
INSERT INTO SalesInvoicedetail VALUES (6766,1858,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (6767,1858,30,2,0)
INSERT INTO SalesInvoicedetail VALUES (6768,1858,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (6769,1858,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (6770,1858,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (6771,1858,12,2,0)
INSERT INTO SalesInvoicedetail VALUES (6772,1858,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (6773,1858,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (6774,1858,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (6775,1859,65,4,0.2)
INSERT INTO SalesInvoicedetail VALUES (6776,1859,60,2,0.2)
INSERT INTO SalesInvoicedetail VALUES (6777,1859,53,3,0.07)
INSERT INTO SalesInvoicedetail VALUES (6778,1859,54,1,0.15)
INSERT INTO SalesInvoicedetail VALUES (6779,1859,70,5,0.03)
INSERT INTO SalesInvoicedetail VALUES (6780,1859,63,5,0.37)
INSERT INTO SalesInvoicedetail VALUES (6781,1860,78,6,0)
INSERT INTO SalesInvoicedetail VALUES (6782,1860,73,2,0)
INSERT INTO SalesInvoicedetail VALUES (6783,1860,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (6784,1860,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (6785,1860,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (6786,1861,71,6,0)
INSERT INTO SalesInvoicedetail VALUES (6787,1861,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (6788,1862,64,2,0)
INSERT INTO SalesInvoicedetail VALUES (6789,1862,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (6790,1862,32,4,0)
INSERT INTO SalesInvoicedetail VALUES (6791,1862,62,4,0)
INSERT INTO SalesInvoicedetail VALUES (6792,1862,55,3,0)
INSERT INTO SalesInvoicedetail VALUES (6793,1862,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (6794,1862,58,5,0)
INSERT INTO SalesInvoicedetail VALUES (6795,1862,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (6796,1862,16,3,0)
INSERT INTO SalesInvoicedetail VALUES (6797,1862,60,5,0)
INSERT INTO SalesInvoicedetail VALUES (6798,1862,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (6799,1862,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (6800,1862,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (6801,1862,15,1,0)
INSERT INTO SalesInvoicedetail VALUES (6802,1862,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (6803,1862,53,1,0)
INSERT INTO SalesInvoicedetail VALUES (6804,1862,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (6805,1862,56,2,0)
INSERT INTO SalesInvoicedetail VALUES (6806,1862,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (6807,1862,66,5,0)
INSERT INTO SalesInvoicedetail VALUES (6808,1862,7,3,0)
INSERT INTO SalesInvoicedetail VALUES (6809,1862,65,3,0)
INSERT INTO SalesInvoicedetail VALUES (6810,1862,38,3,0)
INSERT INTO SalesInvoicedetail VALUES (6811,1862,25,3,0)
INSERT INTO SalesInvoicedetail VALUES (6812,1863,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (6813,1863,41,2,0)
INSERT INTO SalesInvoicedetail VALUES (6814,1863,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (6815,1863,71,3,0)
INSERT INTO SalesInvoicedetail VALUES (6816,1863,43,1,0)
INSERT INTO SalesInvoicedetail VALUES (6817,1863,48,3,0)
INSERT INTO SalesInvoicedetail VALUES (6818,1863,75,3,0)
INSERT INTO SalesInvoicedetail VALUES (6819,1863,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (6820,1863,9,4,0)
INSERT INTO SalesInvoicedetail VALUES (6821,1864,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (6822,1864,63,4,0)
INSERT INTO SalesInvoicedetail VALUES (6823,1864,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (6824,1864,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6825,1864,12,3,0)
INSERT INTO SalesInvoicedetail VALUES (6826,1864,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (6827,1864,50,4,0)
INSERT INTO SalesInvoicedetail VALUES (6828,1864,51,4,0)
INSERT INTO SalesInvoicedetail VALUES (6829,1864,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6830,1864,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (6831,1864,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (6832,1864,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6833,1864,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (6834,1864,57,5,0)
INSERT INTO SalesInvoicedetail VALUES (6835,1864,68,5,0)
INSERT INTO SalesInvoicedetail VALUES (6836,1864,66,6,0)
INSERT INTO SalesInvoicedetail VALUES (6837,1864,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (6838,1864,67,3,0)
INSERT INTO SalesInvoicedetail VALUES (6839,1865,47,4,0)
INSERT INTO SalesInvoicedetail VALUES (6840,1866,76,3,0)
INSERT INTO SalesInvoicedetail VALUES (6841,1866,78,2,0)
INSERT INTO SalesInvoicedetail VALUES (6842,1866,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (6843,1866,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (6844,1866,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (6845,1866,75,4,0)
INSERT INTO SalesInvoicedetail VALUES (6846,1866,72,2,0)
INSERT INTO SalesInvoicedetail VALUES (6847,1866,74,3,0)
INSERT INTO SalesInvoicedetail VALUES (6848,1866,16,4,0)
INSERT INTO SalesInvoicedetail VALUES (6849,1866,8,3,0)
INSERT INTO SalesInvoicedetail VALUES (6850,1866,11,5,0)
INSERT INTO SalesInvoicedetail VALUES (6851,1866,7,2,0)
INSERT INTO SalesInvoicedetail VALUES (6852,1866,14,3,0)
INSERT INTO SalesInvoicedetail VALUES (6853,1866,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (6854,1867,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (6855,1867,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6856,1867,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (6857,1867,58,3,0)
INSERT INTO SalesInvoicedetail VALUES (6858,1867,54,4,0)
INSERT INTO SalesInvoicedetail VALUES (6859,1867,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (6860,1868,75,2,0)
INSERT INTO SalesInvoicedetail VALUES (6861,1868,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (6862,1868,76,1,0)
INSERT INTO SalesInvoicedetail VALUES (6863,1868,74,2,0)
INSERT INTO SalesInvoicedetail VALUES (6864,1869,61,4,0)
INSERT INTO SalesInvoicedetail VALUES (6865,1869,51,5,0)
INSERT INTO SalesInvoicedetail VALUES (6866,1869,29,5,0)
INSERT INTO SalesInvoicedetail VALUES (6867,1869,49,3,0)
INSERT INTO SalesInvoicedetail VALUES (6868,1869,15,5,0)
INSERT INTO SalesInvoicedetail VALUES (6869,1869,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (6870,1869,55,2,0)
INSERT INTO SalesInvoicedetail VALUES (6871,1869,70,6,0)
INSERT INTO SalesInvoicedetail VALUES (6872,1869,53,6,0)
INSERT INTO SalesInvoicedetail VALUES (6873,1869,65,5,0)
INSERT INTO SalesInvoicedetail VALUES (6874,1869,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6875,1869,69,4,0)
INSERT INTO SalesInvoicedetail VALUES (6876,1869,52,5,0)
INSERT INTO SalesInvoicedetail VALUES (6877,1869,57,3,0)
INSERT INTO SalesInvoicedetail VALUES (6878,1869,62,5,0)
INSERT INTO SalesInvoicedetail VALUES (6879,1869,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (6880,1869,56,3,0)
INSERT INTO SalesInvoicedetail VALUES (6881,1869,54,3,0)
INSERT INTO SalesInvoicedetail VALUES (6882,1869,58,4,0)
INSERT INTO SalesInvoicedetail VALUES (6883,1869,68,2,0)
INSERT INTO SalesInvoicedetail VALUES (6884,1869,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (6885,1869,66,2,0)
INSERT INTO SalesInvoicedetail VALUES (6886,1869,59,3,0)
INSERT INTO SalesInvoicedetail VALUES (6887,1869,50,1,0)
INSERT INTO SalesInvoicedetail VALUES (6888,1869,38,5,0)
INSERT INTO SalesInvoicedetail VALUES (6889,1870,50,2,0)
INSERT INTO SalesInvoicedetail VALUES (6890,1871,77,5,0)
INSERT INTO SalesInvoicedetail VALUES (6891,1871,76,6,0)
INSERT INTO SalesInvoicedetail VALUES (6892,1871,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (6893,1871,78,4,0)
INSERT INTO SalesInvoicedetail VALUES (6894,1871,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (6895,1871,73,6,0)
INSERT INTO SalesInvoicedetail VALUES (6896,1871,72,5,0)
INSERT INTO SalesInvoicedetail VALUES (6897,1871,9,5,0)
INSERT INTO SalesInvoicedetail VALUES (6898,1871,45,4,0)
INSERT INTO SalesInvoicedetail VALUES (6899,1871,43,6,0)
INSERT INTO SalesInvoicedetail VALUES (6900,1871,42,5,0)
INSERT INTO SalesInvoicedetail VALUES (6901,1871,15,2,0)
INSERT INTO SalesInvoicedetail VALUES (6902,1871,41,3,0)
INSERT INTO SalesInvoicedetail VALUES (6903,1871,47,2,0)
INSERT INTO SalesInvoicedetail VALUES (6904,1871,71,4,0)
INSERT INTO SalesInvoicedetail VALUES (6905,1871,48,2,0)
INSERT INTO SalesInvoicedetail VALUES (6906,1871,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (6907,1871,11,3,0)
INSERT INTO SalesInvoicedetail VALUES (6908,1871,14,1,0)
INSERT INTO SalesInvoicedetail VALUES (6909,1871,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (6910,1871,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (6911,1872,11,1,0)
INSERT INTO SalesInvoicedetail VALUES (6912,1873,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6913,1873,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (6914,1873,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (6915,1873,60,3,0)
INSERT INTO SalesInvoicedetail VALUES (6916,1873,63,1,0)
INSERT INTO SalesInvoicedetail VALUES (6917,1873,61,1,0)
INSERT INTO SalesInvoicedetail VALUES (6918,1874,16,6,0)
INSERT INTO SalesInvoicedetail VALUES (6919,1874,14,5,0)
INSERT INTO SalesInvoicedetail VALUES (6920,1874,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (6921,1874,62,2,0)
INSERT INTO SalesInvoicedetail VALUES (6922,1874,61,3,0)
INSERT INTO SalesInvoicedetail VALUES (6923,1874,8,5,0)
INSERT INTO SalesInvoicedetail VALUES (6924,1874,54,5,0)
INSERT INTO SalesInvoicedetail VALUES (6925,1874,15,3,0)
INSERT INTO SalesInvoicedetail VALUES (6926,1874,12,5,0)
INSERT INTO SalesInvoicedetail VALUES (6927,1874,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (6928,1874,70,4,0)
INSERT INTO SalesInvoicedetail VALUES (6929,1874,7,4,0)
INSERT INTO SalesInvoicedetail VALUES (6930,1875,70,2,0)
INSERT INTO SalesInvoicedetail VALUES (6931,1875,62,3,0)
INSERT INTO SalesInvoicedetail VALUES (6932,1875,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (6933,1876,73,1,0)
INSERT INTO SalesInvoicedetail VALUES (6934,1876,76,5,0)
INSERT INTO SalesInvoicedetail VALUES (6935,1876,9,3,0)
INSERT INTO SalesInvoicedetail VALUES (6936,1876,75,1,0)
INSERT INTO SalesInvoicedetail VALUES (6937,1876,43,2,0)
INSERT INTO SalesInvoicedetail VALUES (6938,1876,77,4,0)
INSERT INTO SalesInvoicedetail VALUES (6939,1876,45,2,0)
INSERT INTO SalesInvoicedetail VALUES (6940,1876,72,3,0)
INSERT INTO SalesInvoicedetail VALUES (6941,1876,48,4,0)
INSERT INTO SalesInvoicedetail VALUES (6942,1876,41,4,0)
INSERT INTO SalesInvoicedetail VALUES (6943,1876,74,4,0)
INSERT INTO SalesInvoicedetail VALUES (6944,1877,25,2,0)
INSERT INTO SalesInvoicedetail VALUES (6945,1877,58,2,0)
INSERT INTO SalesInvoicedetail VALUES (6946,1877,62,6,0)
INSERT INTO SalesInvoicedetail VALUES (6947,1877,14,2,0)
INSERT INTO SalesInvoicedetail VALUES (6948,1877,65,2,0)
INSERT INTO SalesInvoicedetail VALUES (6949,1877,12,6,0)
INSERT INTO SalesInvoicedetail VALUES (6950,1877,66,4,0)
INSERT INTO SalesInvoicedetail VALUES (6951,1877,56,4,0)
INSERT INTO SalesInvoicedetail VALUES (6952,1877,15,6,0)
INSERT INTO SalesInvoicedetail VALUES (6953,1877,70,3,0)
INSERT INTO SalesInvoicedetail VALUES (6954,1877,55,5,0)
INSERT INTO SalesInvoicedetail VALUES (6955,1877,63,2,0)
INSERT INTO SalesInvoicedetail VALUES (6956,1877,11,4,0)
INSERT INTO SalesInvoicedetail VALUES (6957,1877,8,2,0)
INSERT INTO SalesInvoicedetail VALUES (6958,1877,64,4,0)
INSERT INTO SalesInvoicedetail VALUES (6959,1877,60,4,0)
INSERT INTO SalesInvoicedetail VALUES (6960,1877,16,5,0)


USE JProCo
GO

CREATE TABLE [StateList]
(StateID Char(2) NOT NULL,
StateName varchar(50) NOT NULL,
RegionName varchar(50) NULL,
LandMass int NULL)
GO

INSERT INTO [StateList] VALUES ('AK', 'Alaska', 'USA', 656425)
INSERT INTO [StateList] VALUES ('AL', 'Alabama', 'USA-Continental', 52423)
INSERT INTO [StateList] VALUES ('AR', 'Arkansas', 'USA-Continental', 53182)
INSERT INTO [StateList] VALUES ('AZ', 'Arizona', 'USA-Continental', 114006)
INSERT INTO [StateList] VALUES ('CA', 'California', 'USA-Continental', 163707)
INSERT INTO [StateList] VALUES ('CO', 'Colorado', 'USA-Continental', 104100)
INSERT INTO [StateList] VALUES ('CO', 'Connecticut', 'USA-Continental', 5544)
INSERT INTO [StateList] VALUES ('DC', 'District of Columbia', 'USA-Continental', 68)
INSERT INTO [StateList] VALUES ('DE', 'Delaware', 'USA-Continental', 2489)
INSERT INTO [StateList] VALUES ('FL', 'Florida', 'USA-Continental', 65758)
INSERT INTO [StateList] VALUES ('GA', 'Georgia', 'USA-Continental', 59441)
INSERT INTO [StateList] VALUES ('HI', 'Hawaii', 'USA', 10932)
INSERT INTO [StateList] VALUES ('IA', 'Iowa', 'USA-Continental', 56276)
INSERT INTO [StateList] VALUES ('ID', 'Idaho', 'USA-Continental', 83574)
INSERT INTO [StateList] VALUES ('IL', 'Illinois', 'USA-Continental', 57918)
INSERT INTO [StateList] VALUES ('IN', 'Indiana', 'USA-Continental', 36420)
INSERT INTO [StateList] VALUES ('KS', 'Kansas', 'USA-Continental', 82282)
INSERT INTO [StateList] VALUES ('KY', 'Kentucky', 'USA-Continental', 40411)
INSERT INTO [StateList] VALUES ('LA', 'Louisiana', 'USA-Continental', 51843)
INSERT INTO [StateList] VALUES ('MA', 'Massachusetts', 'USA-Continental', 10555)
INSERT INTO [StateList] VALUES ('MD', 'Maryland', 'USA-Continental', 12407)
INSERT INTO [StateList] VALUES ('ME', 'Maine', 'USA-Continental', 35387)
INSERT INTO [StateList] VALUES ('MI', 'Michigan', 'USA-Continental', 96810)
INSERT INTO [StateList] VALUES ('MN', 'Minnesota', 'USA-Continental', 86943)
INSERT INTO [StateList] VALUES ('MO', 'Missouri', 'USA-Continental', 69709)
INSERT INTO [StateList] VALUES ('MS', 'Mississippi', 'USA-Continental', 48434)
INSERT INTO [StateList] VALUES ('MT', 'Montana', 'USA-Continental', 147046)
INSERT INTO [StateList] VALUES ('NC', 'North Carolina', 'USA-Continental', 53821)
INSERT INTO [StateList] VALUES ('ND', 'North Dakota', 'USA-Continental', 70704)
INSERT INTO [StateList] VALUES ('NE', 'Nebraska', 'USA-Continental', 77358)
INSERT INTO [StateList] VALUES ('NH', 'New Hampshire', 'USA-Continental', 9351)
INSERT INTO [StateList] VALUES ('NJ', 'New Jersey', 'USA-Continental', 8722)
INSERT INTO [StateList] VALUES ('NH', 'New Hampshire', 'USA-Continental', 9351)
INSERT INTO [StateList] VALUES ('NM', 'New Mexico', 'USA-Continental', 121593)
INSERT INTO [StateList] VALUES ('NV', 'Nevada', 'USA-Continental', 110567)
INSERT INTO [StateList] VALUES ('NY', 'New York', 'USA-Continental', 54475)
INSERT INTO [StateList] VALUES ('OK', 'Oklahoma', 'USA-Continental', 69903)
INSERT INTO [StateList] VALUES ('OH', 'Ohio', 'USA-Continental', 44828)
INSERT INTO [StateList] VALUES ('OR', 'Oregon', 'USA-Continental', 98386)
INSERT INTO [StateList] VALUES ('PA', 'Pennsylvania', 'USA-Continental', 46058)
INSERT INTO [StateList] VALUES ('RI', 'Rhode Island', 'USA-Continental', 1545)
INSERT INTO [StateList] VALUES ('SC', 'South Carolina', 'USA-Continental', 32007)
INSERT INTO [StateList] VALUES ('SD', 'South Dakota', 'USA-Continental', 77121)
INSERT INTO [StateList] VALUES ('TN', 'Tennessee', 'USA-Continental', 42146)
INSERT INTO [StateList] VALUES ('TX', 'Texas', 'USA-Continental', 268601)
INSERT INTO [StateList] VALUES ('UT', 'Utah', 'USA-Continental', 84904)
INSERT INTO [StateList] VALUES ('VA', 'Virginia', 'USA-Continental', 42769)
INSERT INTO [StateList] VALUES ('VI', 'US Virgin Islands', 'Other', 1545)
INSERT INTO [StateList] VALUES ('VT', 'Vermont', 'USA-Continental', 9615)
INSERT INTO [StateList] VALUES ('WA', 'Washington', 'USA-Continental', 71303)
INSERT INTO [StateList] VALUES ('WI', 'Wisconsin', 'USA-Continental', 65503)
INSERT INTO [StateList] VALUES ('WV', 'West Virginia', 'USA-Continental', 24231)
INSERT INTO [StateList] VALUES ('WY', 'Wyoming', 'USA-Continental', 97818)


UPDATE MgmtTraining 
SET ApprovedDate = '1/1/2007' WHERE ClassID = 1

UPDATE MgmtTraining 
SET ApprovedDate = '1/15/2007' WHERE ClassID = 2

UPDATE MgmtTraining 
SET ApprovedDate = '2/12/2008' WHERE ClassID = 3

INSERT INTO MgmtTraining
VALUES ('Dummy1',1,CURRENT_TIMESTAMP)


INSERT INTO MgmtTraining
VALUES ('Dummy2',1,CURRENT_TIMESTAMP)

DELETE MgmtTraining WHERE ClassName like '%Dummy%'


INSERT INTO Employee
VALUES (13,null,'Phil',null,'001',4,'Pending Hire')

--Updating Phils nulls to the actual values
UPDATE Employee
SET LastName = 'Wilconkinski'
WHERE EmpID = 13

UPDATE Employee
SET HireDate = '6/11/2009'
WHERE EmpID = 13

UPDATE Employee
SET [Status] = 'Active'
WHERE EmpID = 13


UPDATE Employee
SET [Status] = 'Active'
WHERE [Status] IS NULL


UPDATE Customer
SET CustomerType = 'Business'
WHERE CompanyName IS NOT NULL

INSERT INTO CurrentProducts 
(ProductName, RetailPrice, OriginationDate, ToBeDeleted, Category) 
VALUES ('Yoga Mtn Getaway 5 Days',875.00,CURRENT_TIMESTAMP,0,'Medium-Stay')
GO

INSERT INTO CurrentProducts 
( ProductName, RetailPrice, OriginationDate, ToBeDeleted, Category) 
VALUES ('Yoga Mtn Getaway 1 Week', 995.00, CURRENT_TIMESTAMP , 0, 'LongTerm-Stay')

INSERT INTO CurrentProducts 
( ProductName, RetailPrice, OriginationDate, ToBeDeleted, Category) 
VALUES ('Yoga Mtn Getaway 2 Weeks',1695.00,CURRENT_TIMESTAMP ,0,'LongTerm-Stay')
GO

SET IDENTITY_INSERT MgmtTraining ON
GO

INSERT INTO MgmtTraining
(ClassID,ClassName,ClassDurationHours, ApprovedDate)
VALUES (4,'Empowering Others',18,CURRENT_TIMESTAMP)

SET IDENTITY_INSERT MgmtTraining OFF
GO



CREATE VIEW vSales
AS
SELECT CustomerID,OrderDate,RetailPrice, Quantity, CP.ProductID,CP.ProductName  
FROM CurrentProducts CP
INNER JOIN dbo.SalesInvoiceDetail SVD
ON CP.ProductID = SVD.ProductID
INNER JOIN dbo.SalesInvoice SD
ON SVD.InvoiceID = SD.InvoiceID
GO

UPDATE CP SET ToBeDeleted = 1
FROM CurrentProducts CP
WHERE ProductName LIKE '%2 weeks%'
GO





ALTER TABLE CurrentProducts ADD SupplierID INT NULL
GO

CREATE TABLE Supplier
(SupplierID INT PRIMARY KEY IDENTITY (1,1) ,
SupplierName VARCHAR(max),
ContactFullName VARCHAR(max) )
GO

INSERT INTO Supplier VALUES ('Stay Way Away and Save','Aaron Jeffries')
INSERT INTO Supplier VALUES ('LaVue Connect','Lou LaFleur')
INSERT INTO Supplier VALUES ('More Shores Amigo','Jose Cruz')
GO

UPDATE CurrentProducts SET SupplierID = 2 WHERE ProductName LIKE '%Canada%'
UPDATE CurrentProducts SET SupplierID = 3 WHERE ProductName LIKE '%Mexico%'
UPDATE CurrentProducts SET SupplierID = 0 WHERE SupplierID IS NULL AND ProductName LIKE '%West%'
UPDATE CurrentProducts SET SupplierID = 1 WHERE SupplierID IS NULL
GO

CREATE TABLE Contractor
(
CtrID int IDENTITY PRIMARY KEY,
LastName varchar(30) NOT NULL,
FirstName varchar(30) NOT NULL,
HireDate datetime NOT NULL,
LocationID INT NULL
)
GO

INSERT INTO Contractor VALUES('Barker','Bill','1/7/2006',1)
INSERT INTO Contractor VALUES('Ogburn','Maurice','10/27/2006',1)
INSERT INTO Contractor VALUES('Fortner','Linda','11/22/2009',2)
INSERT INTO Contractor VALUES('Johnson','Davey','3/7/2009',1)
GO

CREATE PROC ResetLocationTables
AS
BEGIN
	TRUNCATE TABLE Location
	TRUNCATE TABLE LocationChanges
	TRUNCATE TABLE LocationChanges2
	INSERT INTO Location
		VALUES	(1,'545 Pike','Seattle', 'WA'),
				(2,'222 Second AVE', 'Boston','MA'),
				(3,'333 Third PL','Chicago','IL'),
				(4,'444 Ruby ST','Spokane', 'WA'),
				(5,'1595 Main', 'Philadelphia', 'PA')
END
GO



INSERT INTO Contractor
VALUES ('Anderson','Vern',GetDate(),1)
GO


INSERT INTO CurrentProducts
VALUES	('Baja 3 Day', 595, GETDATE(),0,'Medium-Stay',0)

INSERT INTO CurrentProducts 
VALUES ('Baja 5 Day', 795, GETDATE(),0,'Medium-Stay',0)
GO
			

USE JProco
GO

INSERT INTO SalesInvoice
VALUES (1878,GETDATE()-60,  GETDATE()- 55,27, NULL) 
INSERT INTO SalesInvoice
VALUES (1879,GETDATE()-55.5,GETDATE()- 50,122,NULL)
INSERT INTO SalesInvoice
VALUES (1880,GETDATE()-41,  GETDATE()- 22,2,  NULL)
INSERT INTO SalesInvoice
VALUES (1881,GETDATE()-29.1,GETDATE()- 22,2,  NULL)
INSERT INTO SalesInvoice
VALUES (1882,GETDATE()-15.2,GETDATE()- 14,25, NULL)
INSERT INTO SalesInvoice
VALUES (1883,GETDATE()-11.3,GETDATE()-  1,91, NULL)
INSERT INTO SalesInvoice
VALUES (1884,GETDATE()-5.7, GETDATE()-1.5,212,NULL)
INSERT INTO SalesInvoice
VALUES (1885,GETDATE()-1,   GETDATE()-  0,104,NULL)
GO



USE [JProCo];

-- following tables built just for the CTE demo.
CREATE TABLE [Departments] (
	id int,  --would normally be an INT IDENTITY
	department VARCHAR (200),
	parent int,
	archived bit default 0
	);
	
-- insert top level departments
insert into [Departments] (id, department, parent) values (1, 'Camping', null);
insert into [Departments] (id, department, parent) values (2, 'Cycle', null);
insert into [Departments] (id, department, parent) values (3, 'Snowsports', null);
insert into [Departments] (id, department, parent) values (4, 'Fitness', null);
      
-- now some sub-departments for camping
insert into [Departments] (id, department, parent) values (5, 'Tents', 1);
insert into [Departments] (id, department, parent) values (6, 'Backpacks', 1);
insert into [Departments] (id, department, parent) values (7, 'Sleeping Bags', 1);
insert into [Departments] (id, department, parent) values (8, 'Cooking', 1);
       
-- now some sub-departments for cycle
insert into [Departments] (id, department, parent) values (9, 'Bikes', 2);
insert into [Departments] (id, department, parent) values (10, 'Helmets', 2);
insert into [Departments] (id, department, parent) values (11, 'Locks', 2);

-- now some sub-departments for snowsports
insert into [Departments] (id, department, parent) values (12, 'Ski', 3);
insert into [Departments] (id, department, parent) values (13, 'Snowboard', 3);
insert into [Departments] (id, department, parent, archived) values (14, 'Snowshoe', 3, 1);
       
-- now some sub-departments for fitness
insert into [Departments] (id, department, parent) values (15, 'Running', 4);
insert into [Departments] (id, department, parent) values (16, 'Swimming', 4);
insert into [Departments] (id, department, parent, archived) values (17, 'Yoga', 4, 1);


GO

CREATE PROCEDURE FillMoreDepartments
AS
BEGIN
	SET NOCOUNT ON;
	delete from Departments where id > 17; 
	 --now add 2 more levels of depth
	insert into [Departments] (id, department, parent) values (18, '1 Person', 5);
	insert into [Departments] (id, department, parent) values (19, '2 Person', 5);
	insert into [Departments] (id, department, parent) values (20, '3 Person', 5);
	insert into [Departments] (id, department, parent) values (21, '4 Person', 5);

	insert into [Departments] (id, department, parent) values (22, 'Backpacking', 19);
	insert into [Departments] (id, department, parent) values (23, 'Family Camping', 19);
	insert into [Departments] (id, department, parent) values (24, 'Mountaineering', 19);

	insert into [Departments] (id, department, parent) values (25, 'Ultra-lightweight', 24);
	insert into [Departments] (id, department, parent) values (26, 'Lightweight', 24);
	insert into [Departments] (id, department, parent) values (27, 'Standard', 24);

	insert into [Departments] (id, department, parent) values (28, 'Gifts', null);
	insert into [Departments] (id, department, parent) values (29, 'Clearance', null);

END
GO
--execute FillMoreDepartments; 



GO
USE [JProCo];


CREATE TABLE [Royalty] (
	id int,  --would normally be an INT IDENTITY
    name VARCHAR (200),
	mother int,
	father int,
	);
	
insert into [Royalty] (id, name, mother, father) values (1, 'George V, King of England', null, null);
insert into [Royalty] (id, name, mother, father) values (2, 'Mary, Princess of Teck', null, null);
insert into [Royalty] (id, name, mother, father) values (3, 'George VI Windsor, King of England', 2, 1);
insert into [Royalty] (id, name, mother, father) values (4, 'Claude George Bowes-Lyon', null, null);
insert into [Royalty] (id, name, mother, father) values (5, 'Nina Cecilia Cavendish-Bentinck', null, null);
insert into [Royalty] (id, name, mother, father) values (6, 'Elizabeth Angela Marguerite Bowes-Lyon', 5, 4);
insert into [Royalty] (id, name, mother, father) values (7, 'William George I of the Hellenes', null, null);
insert into [Royalty] (id, name, mother, father) values (8, 'Olga Konstantinovna Romanova', null, null);
insert into [Royalty] (id, name, mother, father) values (9, 'Louis Alexander von Battenburg', null, null);
insert into [Royalty] (id, name, mother, father) values (10, 'Victoria von Hessen und bei Rhein', null, null);
insert into [Royalty] (id, name, mother, father) values (11, 'Andreas, Prince of Greece', 8, 7);
insert into [Royalty] (id, name, mother, father) values (12, 'Alice, Princess of Battenbugr', 10, 9);
insert into [Royalty] (id, name, mother, father) values (13, 'Phillip Mountbatten, Duke of Edinburgh', 12, 11);
insert into [Royalty] (id, name, mother, father) values (14, 'Elizabeth II Windsor, Queene of England', 6, 3);
insert into [Royalty] (id, name, mother, father) values (15, 'Charles Philip Arthur Windsor', 14, 13);
insert into [Royalty] (id, name, mother, father) values (16, 'Diana Frances (Lady) Spencer', 18, 19);
insert into [Royalty] (id, name, mother, father) values (17, 'William Arthur Phillip Windsor', 16, 15);
insert into [Royalty] (id, name, mother, father) values (18, 'Frances Ruth Burke Roche', null, null);
insert into [Royalty] (id, name, mother, father) values (19, 'Edward John Spencer', null, null);



GO
USE [JProCo];

CREATE TABLE [Users] (
	id INT IDENTITY,
    FirstName VARCHAR (200),
	MiddleName VARCHAR (200),
	LastName VARCHAR (200),
	LoginName VARCHAR (200)
	);


GO
CREATE VIEW [dbo].[DeptView] AS 
 SELECT id, department, parent
   FROM Departments;
 GO

CREATE PROCEDURE ReloadDepartments
AS 
BEGIN
	SET NOCOUNT ON;
	TRUNCATE TABLE [dbo].[Departments];	
	-- insert top level departments
	insert into [Departments] (id, department, parent) values (1, 'Camping', null);
	insert into [Departments] (id, department, parent) values (2, 'Cycle', null);
	insert into [Departments] (id, department, parent) values (3, 'Snowsports', null);
	insert into [Departments] (id, department, parent) values (4, 'Fitness', null);
      
	-- now some sub-departments for camping
	insert into [Departments] (id, department, parent) values (5, 'Tents', 1);
	insert into [Departments] (id, department, parent) values (6, 'Backpacks', 1);
	insert into [Departments] (id, department, parent) values (7, 'Sleeping Bags', 1);
	insert into [Departments] (id, department, parent) values (8, 'Cooking', 1);
       
	-- now some sub-departments for cycle
	insert into [Departments] (id, department, parent) values (9, 'Bikes', 2);
	insert into [Departments] (id, department, parent) values (10, 'Helmets', 2);
	insert into [Departments] (id, department, parent) values (11, 'Locks', 2);

	-- now some sub-departments for snowsports
	insert into [Departments] (id, department, parent) values (12, 'Ski', 3);
	insert into [Departments] (id, department, parent) values (13, 'Snowboard', 3);
	insert into [Departments] (id, department, parent, archived) values (14, 'Snowshoe', 3, 1);
       
	-- now some sub-departments for fitness
	insert into [Departments] (id, department, parent) values (15, 'Running', 4);
	insert into [Departments] (id, department, parent) values (16, 'Swimming', 4);
	insert into [Departments] (id, department, parent, archived) values (17, 'Yoga', 4, 1);
END
GO

--EXEC FillMoreDepartments
GO